# $Date: 1995/08/25 18:59:56 $ $Author: kg $ $Revision: 1.4 $ #
#++
Ax::distributive -- the axiom that two operations are Ax::distributive

Ax::distributive(o1, o2)

o1,o2 - names of the operations (string)

The axiom states that o1(x,o2(y,z)) = o2(o1(x,y),o1(x,z)) and
o1(o2(x,y),z) = o2(o1(x,z),o1(y,z)) for all x,y,z.
++#

Ax::distributive:= AxiomConstructor(
    Ax::distributive,
    [ op1, op2 ],
    [ ],
    (if args(0) <> 2 then error("wrong no of args") end_if;
     if domtype(op1) <> DOM_STRING then
        error("wrong operator name")
     end_if;
     if domtype(op2) <> DOM_STRING then
        error("wrong operator name")
     end_if;
     if op1 = op2 then
	 error("operators are equal")
     end_if)
):

