# $Date: 1997/03/05 12:08:05 $ $Author: olli $ $Revision: 1.15 $ #
#++
Cat::AbelianGroup -- the category of abelian groups

An Cat::AbelianGroup is a Cat::CancellationAbelianMonoid where the operation '+'
is invertible.

Methods:-
_negate(x)     - returns the (additive) inverse of x
_subtract(x,y) - returns z such that y+z = x
equal(x,y)     - returns TRUE iff x = y
++#

Cat::AbelianGroup:= CategoryConstructor(
    Cat::AbelianGroup,
    [],
    [],
    NIL,
    [ Cat::CancellationAbelianMonoid ],
    [],

    "_negate",
    
    "_subtract" = proc(x,y) begin this::_plus(x, this::_negate(y)) end_proc,

    "equal" = proc(x,y) begin
	this::iszero(this::_subtract(x, y))
    end_proc,

    "intmult" = domains::repeatedSquaring(this, "_plus", "zero", "_negate")

)():

