# $Date: 1995/08/25 19:00:55 $ $Author: kg $ $Revision: 1.7 $ #
#++
Cat::AbelianSemiGroup -- the category of abelian semi-groups

An Cat::AbelianSemiGroup is a Cat::SetCat with an associative and commutative
operation '+'.

Methods:
_plus(x1,x2,...) - returns the sum of x1+x2+...
intmult(x,i)     - returns x+x+...+x (i times) for a positive integer i
++#

Cat::AbelianSemiGroup:= CategoryConstructor(
    Cat::AbelianSemiGroup,
    [],
    [],
    NIL,
    [ Cat::SetCat ],
    [],

    "_plus",

    "intmult" = domains::repeatedSquaring(this, "_plus")

)():

