# $Date: 1996/09/17 08:03:48 $ $Author: kg $ $Revision: 1.8 $ #
#++
Cat::DifferentialRing -- the category of ordinary differential rings

Cat::DifferentialRing

A differential ring is a commutative ring with a single derivation
operator D. The derivation is written as follows:

	D(f)		derivation of f

or as

	diff(f, x)	differentiation of f with respect to x

where x is the only one indeterminate of the ring.
++#

Cat::DifferentialRing:= CategoryConstructor(
    Cat::DifferentialRing,
    [ ],
    [ ],
    ( if args(0) <> 0 then error("wrong no of args") end_if ),

    [ Cat::PartialDifferentialRing ],
    [ ]

)():

