# $Date: 1996/09/17 08:03:12 $ $Author: kg $ $Revision: 1.8 $ #
#++
Cat::HomogeneousFiniteCollectionCat -- the category of homogeneous finite collections

Cat::HomogeneousFiniteCollectionCat(Set)

A homogeneous finite collection is a finite collection where each element is
from the same domain Set.

Entries:-
elemDom - the domain where the elements are from
++#

Cat::HomogeneousFiniteCollectionCat:= CategoryConstructor(
    Cat::HomogeneousFiniteCollectionCat,
    [ Set ],
    [ ],
    ( if args(0) <> 1 then error("wrong no of args") end_if;
      if Set::hasProp(Cat::SetCat) <> TRUE then error("not a set") end_if ),
    [ Cat::FiniteCollectionCat,
      ( if Set::hasProp(Cat::OrderedSet) then Cat::OrderedSet end_if ) ],
    [ ],
    
    "elemDom" = Set,
    
    "_less" = (if Set::hasProp(Cat::OrderedSet) then
	    # order elements lexicographically #
	    proc(x,y) local i; begin
	    	for i from 1 to min(this::nops(x), this::nops(y)) do
	    	    if not Set::equal(this::_index(x,i), this::_index(y,i)) then
	    	    	return(bool(Set::_less(this::_index(x,i), this::_index(y,i))))
	    	    end_if
	    	end_for;
	    	bool(this::nops(x) < this::nops(y))
	    end_proc
    end_if)
    
):

