# $Date: 1997/07/14 10:15:26 $ $Author: wseiler $ $Revision: 1.11 $ #
#++
Cat::Monoid -- the category of monoids

A Cat::Monoid is a Cat::SemiGroup with a neutral element "one" according to the
operation '*'.

Entries:-
one         - the neutral element according to '_mult'

Methods:-
_invert(x)  - returns FAIL or a y such that x*y = y*x = 1
_power(x,i) - returns x*x*...*x (i times) for a positive integer i,
	      one for i=0 and _power(_invert(x), -i) if x is a negative integer
isone(x)    - returns TRUE, if x is the neutral element
++#

Cat::Monoid:= CategoryConstructor(
    Cat::Monoid,
    [],
    [],
    NIL,
    [ Cat::SemiGroup ],
    [],

    "one", "_invert",

    "isone" = (if this::hasProp(Ax::normalRep) then
		   fun(bool(args(1)=this::one))
	       else
		   fun(bool(this::equal(x,this::one)))
	       end_if),

    "_power" = domains::repeatedSquaring(this, "_mult", "one", "_invert")

)():

