# $Date: 1997/03/05 12:08:10 $ $Author: olli $ $Revision: 1.14 $ #
#++
Cat::QuotientField -- the category of quotient fields over R

Cat::QuotientField(R)

R - integral domain

Methods:
numer(x)     - returns the numerator of x
denom(x)     - returns the denominator of x
retract(x)   - returns numer(x)/denom(x) if this is an element of R and
	       FAIL otherwise
++#

Cat::QuotientField:= CategoryConstructor(
    Cat::QuotientField,
    [ R ],
    [ ],
    ( if args(0) <> 1 then error("wrong no of args") end_if;
      if R::hasProp(Cat::IntegralDomain) <> TRUE then
	error("no integral domain")
      end_if ),
    [ Cat::Field, Cat::Algebra(R),
      ( if R::hasProp(Cat::OrderedSet) then Cat::OrderedSet end_if ) ],
    [ ],

    "numer", "denom",

    "characteristic" = R::characteristic,
    
    "iszero" = R::iszero @ this::numer,

    "_less" = ( if R::hasProp(Cat::OrderedSet) then
	if not this::hasProp(Ax::canonicalOrder) then
	    proc(x,y) begin
		R::_less(R::_mult(this::numer(x), this::denom(y)),
			 R::_mult(this::numer(y), this::denom(x)))
	    end_proc
	end_if
    end_if ),

    "equal" = proc(x,y) begin
	R::equal(R::_mult(this::numer(x), this::denom(y)),
		 R::_mult(this::numer(y), this::denom(x)))
    end_proc,

    "retract" = proc(x) begin
	R::_divide(this::numer(x), this::denom(x))
    end_proc

):

# end of file #
