# $Date: 1995/08/25 19:01:30 $ $Author: kg $ $Revision: 1.7 $
#
#++
Cat::Rng -- the category of rings without unit

A Cat::Rng is a ring without a unit, ie. an Cat::AbelianGroup and a Cat::SemiGroup with
the distributive laws a*(b+c) = a*b + a*c and (a+b)*c = a*c + b*c for
each a, b, c.

Use the axiom Ax::noZeroDivisors to state that there are no zero divisors, ie.
that the product of non-zero elements is always non-zero.
++#

Cat::Rng:= CategoryConstructor(
    Cat::Rng,
    [],
    [],
    NIL,
    [ Cat::AbelianGroup, Cat::SemiGroup ],
    []

)():

