# #
# $Date: 1996/02/26 14:18:39 $ $Author: frankp $ $Revision: 1.18 $ #
# #
# frankp, 13/06/94 #

#++
Cat::SquareMatrixCat -- the category of square matrices

Cat::SquareMatrixCat(R)

R - coefficient domain (a Cat::Rng)

The category Cat::SquareMatrixCat(R) represents the Cat::Rng
of square matrices (of fixed order) over the coefficient domain 
Cat::Rng R.

The super-category of Cat::SquareMatrixCat(R) is Cat::MatrixCat(R).
This ensures that a method for Cat::MatrixCat(R) may be used by
Cat::SquareMatrixCat(R).
++#

Cat::SquareMatrixCat := CategoryConstructor(

# name #
    Cat::SquareMatrixCat,
# arguments #
    [ R ],
# local variables #
    [ ],
# initialisation #
    (if args(0) <> 1 then error("wrong no of args") end_if;
     if R::hasProp(Cat::Rng) <> TRUE then
	error("coefficients must be from a Cat::Rng")
    end_if),
# super categories #
    [ (if R::hasProp(Cat::Ring) then Cat::Ring else Cat::Rng end_if),
      Cat::MatrixCat(R) 
    ],
# axioms #
    [ ],
# #
"characteristic" = (if R::hasProp(Cat::Ring) then
    R::characteristic
end_if)
    
):

