# $Date: 1995/08/25 19:01:37 $ $Author: kg $ $Revision: 1.9 $ #
#++
Cat::UnivariatePolynomialCat -- the category of univariate polynomials

Cat::UnivariatePolynomialCat(R)

R - coefficient ring

Methods:
pdivide(p,q) - returns a sequence b,s,r such that b*p = q*s + r,
	       degree(r) < degree(q) and b = lcoeff(q)^k
pquo(p,q)    - returns pdivide(p,q)[2]
prem(p,q)    - returns pdivide(p,q)[3]
++#

Cat::UnivariatePolynomialCat:= CategoryConstructor(
    Cat::UnivariatePolynomialCat,
    [ R ],
    [ ],
    ( if args(0) <> 1 then error("wrong no of args") end_if;
      if R::hasProp(Cat::CommutativeRing) <> TRUE then
	error("no commutative ring")
      end_if ),
    [ ( if R::hasProp(Cat::Field) then Cat::EuclideanDomain end_if ),
      Cat::PolynomialCat(R), Cat::DifferentialRing ],
    [ ],

    "pdivide", "pquo", "prem"

):

