# $Date: 1997/10/10 15:55:12 $ $Author: tonner $ $Revision: 1.12 $ #

#++
new -- create a new axiom constructor

new(name, params, locals, precomp)

name        - name of constructor (ident)
params      - list of formal parameters (list of ident's)
locals      - list of local variables (list of ident's)
precomp     - expression to test actual parameters and compute locals

The arg's are not evaluated. Later on, when a new axiom is to be
constructed via 'func_call', the actual parameters of the axiom are
substituted for the formal parameters in the expression given by
'test_params'. After the substitution the expression is evaluated.
++#

AxiomConstructor::new:= proc(nam, params, locals)
    local X, Y;
    option noDebug, hold;
begin
    if testargs() then
        if args(0) <> 4 then error("wrong no of args") end_if;
        if domtype(nam) <> DOM_IDENT and type(nam)<>"domattr" then
            error("invalid name")
        end_if;
	if not testtype(params, Type::ListOfIdents()) then
            error("invalid parameter list")
        end_if;
	if not testtype(locals, Type::ListOfIdents()) then
            error("invalid parameter list")
        end_if;
    end_if;

    new(AxiomConstructor, nam, params.locals,
        subsop(proc() begin X; Y end_proc,
            (if nops(params) = 0 then null() else 1=op(params) end_if),
            (if nops(locals) = 0 then null() else 2=op(locals) end_if),
            [4,1]=args(4), [4,2]=params.locals, 6=nam),
        domain(hold(instances)(nam)), nops(params));
end_proc:

# end of file #
