# $Date: 1997/10/10 15:55:16 $ $Author: tonner $ $Revision: 1.4 $ #

#++
getNamedEntry -- get entry of category, changing it into domain entry

getNamedEntry(C,e)

C - category
e - entry name

Called by 'Category::_index' to get a domain entry which is used
explicitly in a category constructor definition. This method may
not be called in any other context!

The global variable 'this' is used as the actual domain to create the
entry for (too bad). It ist defined in CategoryConstructor::getEntry.
++#

CategoryConstructor::getNamedEntry:= proc(#C, e#)
    option noDebug;
begin
    if testargs() then
        if args(0) <> 2 then error("wrong no of args") end_if;
        if domtype(args(2)) <> DOM_STRING then
            error("invalid operator name")
        end_if;
        if domtype(this) <> DOM_DOMAIN then
            error("wrong context")
        end_if;
        if not contains(extop(extop(args(1),1),6), args(2)) then
            error("missing direct domain entry \"".args(2)."\"")
        end_if;
    end_if;

    # substitute domain 'this' and category args into entry, return result;
      use index_val to avoid early evaluation of entry definition #
    CategoryConstructor::subsArgs(
            index_val(extop(extop(args(1),1),6), args(2)),
            args(1), this);
end_proc:

# end of file #
