# $Date: 1997/10/10 15:55:18 $ $Author: tonner $ $Revision: 1.8 $ #

#++
allEntries -- get all entries of category

allEntries(this,defined,undefined)

this      - domain to create entries for
defined   - set with defined entries
undefined - set with 'to be defined' entries

Searches for entries in line with getEntry. The names of the
entries are inserted in the set 'undefined' and 'defined'.
A list with the two sets is returned.
++#

CategoryConstructor::allEntries:= proc(this,_0_d,_0_u)
    option noDebug;
    local _0_r, _0_e, _0_i, _0_C;
begin
    _0_i:= 1;
    while (_0_C:= DomainConstructor::getCategory(args(1), _0_i)) <> FAIL do
    	_0_i:= _0_i+1;
	# search for entries in category constructor #
	for _0_e in extop(extop(_0_C,1),6) do
	    _0_e:= op(_0_e,1);
	    if contains(_0_d, _0_e) then next end_if;
	    if contains(_0_u, _0_e) then next end_if;

	    # substitute category args into entry, return result;
	      use index_val to avoid early evaluation of entry definition #
	    _0_r:= CategoryConstructor::subsArgs(
			    index_val(extop(extop(_0_C,1),6), _0_e),
			    _0_C, args(1));

	    # toBeDefined means: entry should have been defined elsewhere #
	    if _0_r = hold(toBeDefined) then
		_0_u:= _0_u union {_0_e}
	    elif _0_r <> hold(_0_r) then
		_0_d:= _0_d union {_0_e}
	    end_if;
	end_for;
    end_while;
    [ _0_d, _0_u ]
end_proc:

# end of file #
