# $Date: 1997/10/10 15:55:18 $ $Author: tonner $ $Revision: 1.3 $ #

#++
entryOrigins -- get list of all categories which define entry as 'toBeDefined'

entryOrigins(this,e)

this - domain of entry
e    - entry name

Returns either a list containing all categories of 'this' which define
entry 'e' as 'toBeDefined' or the last category which defines the
entry if there is no category which defines it as 'toBeDefined'.
(These are the categories supposed to define the meaning of the entry.)

The domain 'this' is used as a global variable by 'getNamedEntry' in
order to get the domain for which to create the entry in that method
(too bad, but hides the details to the category implementor).
++#

CategoryConstructor::entryOrigins:= proc(this#,e#)
    option noDebug;
    local _0_C, _0_r, _0_i, _0_CL, _0_Cd;
begin
    _0_CL:= [];
    _0_i:= 1;
    while (_0_C:= DomainConstructor::getCategory(args(1), _0_i)) <> FAIL do
    	_0_i:= _0_i+1;
	# search for entry in category constructor #
	if contains(extop(extop(_0_C,1),6), args(2)) then

	    # substitute category args into entry, return result;
	      use index_val to avoid early evaluation of entry definition #
	    _0_r:= CategoryConstructor::subsArgs(
			    index_val(extop(extop(_0_C,1),6), args(2)),
			    _0_C, args(1));

	    if _0_r = hold(toBeDefined) then
		_0_CL:= append(_0_CL, _0_C)
	    elif _0_r <> hold(_0_r) then
	        _0_Cd:= _0_C
	    end_if
	end_if;
    end_while;
    if _0_CL = [] then
        if _0_Cd = hold(_0_Cd) then [] else [_0_Cd] end_if
    else
        _0_CL
    end_if
end_proc:

# end of file #
