# $Date: 1997/10/10 15:55:19 $ $Author: tonner $ $Revision: 1.9 $ #

#++
getEntry -- get entry of category and change it into domain entry

getEntry(this,e)

this - domain to create entry for
e    - entry name

If the entry is found it is changed into an entry for domain
this and returned: To create a domain entry the formal category
parameters and the ident 'this' in the entry are substituted against
the actual category parameters and the domain this. getEntry returns
[FAIL,FAIL] if no entry with name e is found.

The domain 'this' is used as a global variable by 'getNamedEntry' in
order to get the domain for which to create the entry in that method
(too bad, but hides the details to the category implementor).
++#

CategoryConstructor::getEntry:= proc(this#,e#)
    option noDebug;
    local _0_C, _0_r, _0_i;
begin
    _0_i:= 1;
    while (_0_C:= DomainConstructor::getCategory(args(1), _0_i)) <> FAIL do
    	_0_i:= _0_i+1;
	# search for entry in category constructor #
	if contains(extop(extop(_0_C,1),6), args(2)) then

	    # substitute category args into entry, return result;
	      use index_val to avoid early evaluation of entry definition #
	    _0_r:= CategoryConstructor::subsArgs(
			    index_val(extop(extop(_0_C,1),6), args(2)),
			    _0_C, args(1));

	    if _0_r <> hold(_0_r) then
		return([_0_r, _0_C])
	    end_if;
	end_if;
    end_while;
    [FAIL, FAIL]
end_proc:

# end of file #
