# $Date: 1997/10/10 15:55:21 $ $Author: tonner $ $Revision: 1.3 $ #

#++
printInfo -- print information about constructor

printInfo(CC)

CC - category constructor

printInfo prints some information about CC onto the screen.
++#

CategoryConstructor::printInfo:= proc(CC)
    option noDebug;
    local PRETTY_PRINT, p, t;
begin
    PRETTY_PRINT:= FALSE;
    p:= fun(print(Unquoted, args()));
    p("-- Category Constructor:");
    if CC["info_str"] = FAIL then
	p(extop(CC,1))
    else
	p(expr2text(extop(CC,1))." -- ".CC["info_str"])
    end_if;
    p("");
    if extop(CC,8) = 0 then
	p("-- No Parameters.");
    else
	p("-- Formal Parameters:");
	p(op(extop(CC,2), 1..extop(CC,8)));
    end_if;
    p("");
    p("-- Direct Super-Categories:");
    p(op(extop(CC,4)));
    p("");
    if extop(CC,5) = [] then
	p("-- No Direct Axioms.");
    else
	p("-- Direct Axioms:");
	p(op(extop(CC,5)));
    end_if;
    p("");
    t:= extop(CC,6);
    case nops(t)
    of 0 do
        p("-- No Entries.");
        break;
    of 1 do
	p("-- Entry:");
	p(op(t, [1,1]));
	break;
    otherwise
	p("-- Entries:");
	p(op(sort([map(op(t), op, 1)])));
    end_case;
end_proc:

# end of file #
