# $Date: 1997/10/10 15:55:26 $ $Author: tonner $ $Revision: 1.8 $ #

#++
allDomainEntries -- return sets of all entries of domain

allDomainEntries(this)

this      - domain

Searches for entries in line with makeEntry. Returns a list of 2 sets:
1- the defined entries
2- the entries which have to be defined
++#

DomainConstructor::allDomainEntries:= proc(this)
    option noDebug;
    local _0_r, _0_e, _0_d, _0_u;
begin
    _0_u:= {};
    _0_d:= {};
    # search for entries in constructor #
    for _0_e in extop((args(1))::constructor,7) do
        _0_e:= op(_0_e,1);
	if contains(_0_d, _0_e) then next end_if;
	if contains(_0_u, _0_e) then next end_if;

        # substitute actual domain and its param's and return evaluated result,
          use 'index_val' to get table entries in order to avoid early
          evaluation #
        _0_r:= DomainConstructor::subsArgs(
                    index_val(extop((args(1))::constructor,7), _0_e), 
                    args(1), args(1));

        # toBeDefined means: this entry should have been defined elsewhere #
        if _0_r = hold(toBeDefined) then
	    _0_u:= _0_u union {_0_e}
        elif _0_r <> hold(_0_r) then
	    _0_d:= _0_d union {_0_e}
        end_if;
    end_for;

    # search for entries in super-domains #
    _0_d:= DomainConstructor::allSuperDomainEntries(args(1), _0_d, _0_u);

    # search for entries in categories #
    CategoryConstructor::allEntries(args(1), op(_0_d));
end_proc:

# end of file #
