# $Date: 1997/10/10 15:55:27 $ $Author: tonner $ $Revision: 1.10 $ #

#++
getSuperDomainEntry -- get entry of super-domain

getSuperDomainEntry(this, e)

this - domain for which to create entry
e    - name of entry

Creates super-domain entry e for 'target' domain 'this' on the fly.
Categories of the super-domains are not involved!
++#

DomainConstructor::getSuperDomainEntry:= proc(this#,e#)
    option noDebug;
    local _0_SD, _0_r;
begin
    for _0_SD in (args(1))::super_domains do

	# search for entry in super-domain constructor #
	if contains(extop(_0_SD::constructor,7), args(2)) then

	    # substitute actual domain and super-domain param's and return
	      evaluated result, use 'index_val' to get table entries in order
	      to avoid early evaluation #
	    _0_r:= DomainConstructor::subsArgs(
			index_val(extop(_0_SD::constructor,7),args(2)),
			_0_SD, args(1));

	    if _0_r <> hold(_0_r) then
		return([_0_r, _0_SD])
	    end_if;
	end_if;
    end_for;
    [FAIL, FAIL]
end_proc:

# end of file #
