# $Date: 1997/10/10 15:55:35 $ $Author: tonner $ $Revision: 1.3 $ #

#++
printInfo -- print information about constructor

printInfo(DC)

DC - domain constructor

printInfo prints some information about DC onto the screen.
++#

DomainConstructor::printInfo:= proc(DC)
    option noDebug;
    local PRETTY_PRINT, p, t;
begin
    PRETTY_PRINT:= FALSE;
    p:= fun(print(Unquoted, args()));
    p("-- Domain Constructor:");
    if DC["info_str"] = FAIL then
	p(extop(DC,1))
    else
	p(expr2text(extop(DC,1))." -- ".DC["info_str"])
    end_if;
    p("");
    if extop(DC,9) = 0 then
	p("-- No Parameters.");
    else
	p("-- Formal Parameters:");
	p(op(extop(DC,2), 1..extop(DC,9)));
    end_if;
    p("");
    p("-- Super-Domain:");
    p(extop(DC,4));
    p("");
    p("-- Direct Categories:");
    p(op(extop(DC,5)));
    p("");
    if extop(DC,6) = [] then
	p("-- No Direct Axioms.");
    else
	p("-- Direct Axioms:");
	p(op(extop(DC,6)));
    end_if;
    p("");
    t:= extop(DC,7);
    case nops(t)
    of 0 do
        p("-- No Entries.");
        break;
    of 1 do
	p("-- Entry:");
	p(op(t, [1,1]));
	break;
    otherwise
	p("-- Entries:");
	p(op(sort([map(op(t), op, 1)])));
    end_case;
end_proc:

# end of file #
