# $Date: 1997/08/27 13:34:46 $ $Author: stefanw $ $Revision: 1.3 $ #

#++
Dom::Ideal -- domain of ideals over a ring 

Dom::Ideal(R)

R - ring


++#

Dom::Ideal:= DomainConstructor(
    Dom::Ideal,
    [ R ],
    [ ],
    (  if args(0)<>1 then 
		error("Wrong number of arguments")
       elif (args(1))::hasProp=FAIL or 
		(args(1))::hasProp(Cat::Ring)=FALSE then
		error("Argument must be a ring")
	end_if
    ), 

    Dom::BaseDomain,
    [ Cat::Monoid ],
    [ ],

    "convert" = proc(x) 
	begin
	 if type(x)<>DOM_LIST and type(x)<>DOM_SET then
		error("Argument must be list or set of ring elements");
	 end_if;
	 x:=map(x,R::coerce);
	 if has(x,FAIL) then FAIL else new(this,{op(x)}) end_if
        end_proc,

    "expr" = fun(extop(args(1),1)),

    "zero" = new(this,{R::zero}),

    "one" = new(this,{R::one}),

    "iszero" = fun((if map(extop(args(1),1),iszero)={TRUE} then
		TRUE else FALSE end_if)),    

    "_mult" = proc(x,y)
	 begin
	 case args(0) of 0 do return(this::one)
		      of 1 do return(args(1))
		      of 2 do return(new(this,
			    _union(op(map(extop(x,1),
				func(map(extop(y,1),_mult,u),u)))) ))
	              otherwise 
			return(this::_mult(
				this::_mult(args(1..args(0) div 2)),
				this::_mult(args(args(0) div 2 +1 ..args(0)))))
		      end_case
	end_proc,

    "_plus" = fun(new(this,_union(map(args(),extop,1)))),

    "print"=fun("<".expr2text(extop(args(1),1)).">"),

    "normal"=(if R::hasProp(Cat::PolynomialCat) then
	      fun( extsubsop(args(1),1={op(groebner::gbasis
			([op(extop(args(1),1))]))}) )
	      end_if)					

):

