# #
# frankp, 2.04.1995 #
# #

#++
	Dom::Real  --  the field of real numbers

	The elements of Real are numbers of type DOM_INT, DOM_RAT, 
	DOM_FLOAT or DOM_EXPR. The test whether an expression is real is 
	performed by calling 'rectform'.

	The domain has category Cat::Field, which is very optimistic 
	(indeed false, because for example bool(1.0 = float(3) / float(3))
	FALSE. The category is assumed only because of pragmatism.
	Note that elements may not have an unic representation, for example
	bool( 0 = sin(2)^2 + cos(2)^2 - 1 ) returns FALSE.

	Note: Unknowns defined in "globalReal" of 'rectform' do not 
        influence the process of the testing of Real, i.e. the set is 
        redefined to the empty set during the test.
++#

Dom::Real := DomainConstructor::new(

# Name = # Dom::Real,

# Args = # [ ],

# Local Paramameters = # [ ],

# Init = # (
    if args(0) <> 0 then
	error("no arguments expected")
    end_if),

# Super Domains = # Dom::Complex,

# Categories = # [ Cat::OrderedSet, Cat::DifferentialRing, Cat::Field ],

# Axioms = # [ ],

# Methods = #

"_less" = fun(bool(_less(op(map([args()],extop,1)))) ),

"convert" = proc(x)
    local d, t;
begin
    case domtype(x)
    of DOM_INT do
    of DOM_RAT do
    of DOM_FLOAT do
        return( new( this,x ) )
    of DOM_COMPLEX do
        return( FAIL )
    end_case;
 
    d:= rectform::globalReal({});
    t:= rectform( x,{} );
    rectform::globalReal(d);

    if op(t,2) = 0 and op(t,3) = 0 and not has(t,{hold(Re),hold(Im)}) then new( this,x )
    else FAIL
    end_if
end_proc,

"convert_to" = proc(x,T)
begin
    if domtype(T) <> DOM_DOMAIN then T:= domtype(T) end_if;

    case T
    of this              do
    of Dom::Numeric      do
    of DOM_INT           do
    of DOM_RAT           do
    of COM_COMPLEX       do
    of Dom::Complex      do
    of DOM_EXPR          do return( T::convert(extop(x,1)) )
    of Dom::Float        do
    of DOM_FLOAT         do return( float(extop(x,1)) )
    otherwise
	if T::constructor = Dom::ExpressionField then
	    return( T::new(extop(x,1)) )
	else
	    return( FAIL )
	end_if
    end_case
end_proc,

"Im" = new( this,0 ),

"Re" = id,

"random" = proc()
begin
    if args(0) = 0 then new(this,random())
    else 
        subsop( proc() begin new(this,X()) end_proc,[4,2,0]=random(args()) )
    end_if
end_proc

)():				

# end of file #
