# test whether f is primitive mod p, i.e. x^i, i=1..p^k-1, are all the non-zero
   elements of Fp[x]/f where k=deg(f).
Examples:
>> faclib::primitive(poly(x^4+x^3+x^2+x+1,IntMod(2)));

                                   FALSE

>> faclib::primitive(poly(x^4+x+1,IntMod(2)));

                                   TRUE

>> faclib::primitive(x^4+x+1,43);

                                   FALSE
#
faclib::primitive := proc(f,p) local F,k;
begin
   if nops(f)=3 and op(f,[3,0])=IntMod then p:=op(f,[3,1]) else f:=poly(f,IntMod(p)) end_if;
   if not irreducible(f) then return(FALSE) end_if;
   k:=degree(f);
   F:=Dom::GaloisField(p,k,f);
   bool(F::order(F(op(f,[2,1])))=p^k-1)
end_proc:
