# $Date: 1996/07/05 15:04:40 $ $Author: snoo $ $Revision: 1.3 $ #
# kg, 19/09/95 #

#++
fp::curry -- curry n-ary function

fp::curry(f, [n])
f - function
n - non-negative integer (default is 2)

Given the funtion f: (x1,...,xn) +-> f(x1,...,xn) curry(f,n) returns 
the function
	() +-> f()    if n = 0,
	x1 +-> (x2 +-> ... (xn +-> f(x1, x2,... xn))...)    if n > 0.
++#
fp::curry:= fun((
    if testargs() then
        case args(0)
        of 1 do break;
        of 2 do
	    if not testtype(args(2), Type::NonNegInt) then
		error("no arity")
	    end_if;
	    break;
	otherwise
            error("wrong no of args");
	end_case;
    end_if;
    if args(0) = 1 then
	newpurefunc("fun(...)", NIL,
	    subsop(hold(subsop(fun(f(x,args())), [5,1]=args())),
		   [1,1,0]=args(1)))
    else
	case args(2)
	of 0 do
	of 1 do
	    args(1);
	    break;
	of 2 do
	    newpurefunc("fun(...)", NIL,
		subsop(hold(subsop(fun(f(x,args())), [5,1]=args())),
		       [1,1,0]=args(1)));
	    break;
	otherwise
	    newpurefunc("fun(...)", NIL,
		subsop(hold(fp::curry(fp::fix1st(f, args()), n)),
		       [1,1]=args(1), 2=args(2)-1))
	end_case
    end_if
)):


#--
fp::fix1st -- fix the first argument of a function

fp::fix1st(f, e)
f - function
e - expression

Given f: (x,y1,...yn) +-> f(x,y1,...yn) and e, fp::fix1st(f, e) 
returns the function
	(y1,...yn) +-> f(e,y1,...yn)
--#

fp::fix1st:= fun((
    newpurefunc("fun(...)", NIL,
        subsop(hold(f(a1, args())), 
               0=args(1), 1=args(2..args(0))))
)):

# end of file #
