# $Date: 1996/07/05 15:04:41 $ $Author: snoo $ $Revision: 1.3 $ #
# kg, 19/09/95 #

#++
fp::fixargs -- create function by fixing all but one argument

fp::fixargs(f, n, [e...])
f - function
n - positive integer <= args(0)-1
e - expression

fixargs curries f and then applies the curried version to the arguments
e[i]. The resulting function is returned.

fixargs(f,n,e[1],...,e[m]) returns the function 
	x +-> f(x)    if m=0
	x +-> f(e[1],..., e[n-1], x, e[n],... e[m])    if m > 0
++#

fp::fixargs:= fun((
    if testargs() then
        if args(0) < 2 then error("wrong no of args") end_if;
        if not testtype(args(2), Type::PosInt) then
	    error("no argument position")
        end_if;
        if args(2) > args(0)-1 then
	    error("illegal argument position")
        end_if;
    end_if;
    if args(0) = 2 then
        args(1)
    else
	newpurefunc("fun(...)", NIL,
	    subsop(hold(f)(args(3..(args(2)+1)),
			   hold(args(1)),
			   args((args(2)+2)..args(0))),
		   0=args(1)))
    end_if
)):

# end of file #
