# $Date: 1996/07/05 15:04:44 $ $Author: snoo $ $Revision: 1.3 $ #
# kg, 19/09/95 #

#++
fp::nestvals -- repeated composition returning intermediate values

fp::nestvals(f, n)
f - function
n - non-negative integer

nestvals(f,n) returns the function x +-> [x, f(x),...f(f(...f(x)...))]
where the composition of f is 0- to n-fold repeated. I.e. nestvals is the 
function
	(f,n) +-> [nest(f,i) $ i=0..n]
++#

fp::nestvals:= fun((
    if testargs() then
        if args(0) <> 2 then error("wrong no of args") end_if;
        if not testtype(args(2), Type::NonNegInt) then
            error("illegal power")
        end_if
    end_if;
    case args(2)
    of 0 do
        return(newpurefunc("fun(...)", NIL, hold([args()])));
    of 1 do
        return(newpurefunc("fun(...)", NIL, 
    		   subsop(hold([args(), f(args())]),
    		   	  [2,0]=args(1))));
    end_case;
    newpurefunc("fun(...)", NIL,
	subsop(hold((1;
		     f(args());
		     [args(), %];
		     while %3 < n do
		         %3+1;
		         f(%3);
		         append(%3, %)
		     end_while)),
		[2,0]=args(1), [4,2,2,0]=args(1), [4,1,2]=args(2)))
)):

# end of file #
