# $Date: 1997/08/07 13:01:34 $ $Author: stefanw $ $Revision: 1.5 $ #

# kg, 30/07/94 #

#--
gcdlib::udom_gcd -- compute gcd of 2 univariate polynomials over a domain

gcdlib::udom_gcd(p1, p2)

p1,p2 - non-zero univariate polynomials over a domain

--#

gcdlib::udom_gcd:= proc(a, b)
    local c, gc, n, m, d, s, h, l, t, DD;
begin
    DD:= op(a,3);
    if DD::hasProp<>FAIL and
        DD::hasProp(Dom::AlgebraicExtension) and 
	DD::constructor_args[1]=Dom::Rational and
	(max(degree(a),degree(b)) >= 20 or
          max(map(map((coeff(a),coeff(b)),coeff@expr),abs)) > 10^10)
    then
         # use Langemyr's algorithm #
         # crossover point is only roughly true #
            return(gcdlib::langemyr(a,b))
    end_if;

    # make polynomials primitive #
    c:= content(a);
    a:= mapcoeffs(a, DD::_divide, c);
    gc:= content(b);
    b:= mapcoeffs(b, DD::_divide, gc);
    gc:= DD::gcd(c, gc);

    # subresultant gcd #
    n:= degree(a);
    m:= degree(b);
    if n < m then
	t:= a; a:= b; b:= t;
	t:= n; n:= m; m:= t;
    end_if;
    s:= DD::one;
    h:= s;
    l:= s;

    while not iszero(b) do
	d:= n - m;
	s:= DD::_mult(l, DD::_power(h, d));
	if ((d mod 2) = 0) then s:= DD::_negate(s) end_if;
	t:= mapcoeffs(pdivide(a, b, Rem), DD::_divide, s);
	a:= b;
	b:= t;
	n:= m;
	m:= degree(b);
	l:= lcoeff(a);
	case d
	of 0 do break;
	of 1 do h:= l; break;
	otherwise h:= DD::_divide(DD::_power(l, d), DD::_power(h, d-1));
	end_case;
    end_while;

    # make result primitive #
    multcoeffs(mapcoeffs(a, DD::_divide, content(a)), gc);
end_proc:

# end of file #
