# generate::gb(l,vars) prints a GB form to the standard output
  generate::gb(l,vars,f) prints in the file f

  Input: l is a list of polynomials 
#
alias(GB=generate::gb):
alias(cutLine=generate::gb_cutLine):

GB := proc(l,vars,f) local i,PRETTY_PRINT,s;
begin
   if type(l)=DOM_SET then l:=[op(l)]
   elif type(l)<>DOM_LIST then error("list or set expected")
   end_if;
   if type(vars)=DOM_STRING then f:=vars; vars:=[op(indets(l))]
   elif args(0)<2 then vars:=[op(indets(l))]
   end_if;
   PRETTY_PRINT:=FALSE;
   l:=map(l,expr);
   s:=_concat(
   cutLine(_concat("l:List(HDMP(",expr2text(vars),",INT)):= _")),
   cutLine("[ _"),
   cutLine(expr2text(l[i]).", _")$i=1..nops(l)-1,
   cutLine(expr2text(l[nops(l)])."];"),
   cutLine("g:=tgroebner(l)"),
   cutLine("T:=RSInitTable(g,1);"),
   cutLine("first(RSGSL(T))"));
   if type(f)=DOM_STRING then fprint(Unquoted,Text,f,s)
   else print(Unquoted,s)
   end_if
end_proc:

cutLine := proc(s) local i;
begin
   if strlen(s)<=TEXTWIDTH-2 then s."\n"
   else
      for i from TEXTWIDTH-2 downto 1 do
         if contains({"*","+"," ","-"},substring(s,i,1)) then
            return(substring(s,0,i-1)." _\n".
		   cutLine(substring(s,i,strlen(s)-i)))
         end_if
      end_for;
      error("found not charecter to cut line")
   end_if
end_proc:
