alias(Lisp=generate::lisp): 
alias(Seq=stdlib::lisp_seq):

Lisp := proc(e) option remember;
begin
   (domtype(e))::lisp;
   if %<>FAIL then return(%::lisp(args())) end_if;
   expr2text(e)
end_proc:
Lisp(acos):="ARCCOS":

# method "lisp" for other domains #
DOM_INT::lisp:=expr2text:

DOM_EXPR::lisp:=proc(e) local _t,i;
begin
   _t:=op(e,0);
   if type((_t:=level(_t,2)))=DOM_FUNC_ENV then
      funcattr(_t,"lisp");
      if %<>FAIL then return(%(op(args()))) end_if
   elif type(e)="function" then return("(".Lisp(op(e,0)).Seq(e," ").")")
   end_if;
   expr2text(e)
end_proc:

# Seq([a,b,c]," ") -> " a b c" #
Seq:=fun((if nops(args(1))=0 then ""
   else (args(2).Lisp(op(args(1),i))$hold(i)=1..nops(args(1)))
   end_if)):

# function attributes #
_plus:=funcattr(_plus,"lisp",fun("(+".Seq([args()]," ").")")):

_mult:=funcattr(_mult,"lisp",fun("(*".Seq([args()]," ").")")):

_power:=funcattr(_power,"lisp",fun("(EXPT ".Lisp(args(1))." ".Lisp(args(2)).")")):
