alias(Maple=generate::maple): 
alias(Seq=stdlib::maple_seq):

Maple := proc(e) option remember;
begin
   if e::maple<>FAIL then return(e::maple(args())) end_if;
#   case domtype(e)
   end_case; #
   expr2text(e)
end_proc:
Maple(PI):="Pi":
Maple(EULER):="gamma":

# method "maple" for other domains #
DOM_INT::maple:=fun((expr2text(args(1)); if args(1)>=0 then % else "(".%.")" end_if)):

DOM_EXPR::maple:=proc(e) local _t,i;
begin
   _t:=op(e,0);
   if type((_t:=level(_t,2)))=DOM_FUNC_ENV then
      funcattr(_t,"maple");
      if %<>FAIL then return(%(op(args()))) end_if
   elif type(e)="function" then return(Maple(op(e,0))."(".Seq(e,",").")")
   end_if;
   expr2text(e)
end_proc:

# Seq([a,b,c],",") -> "a,b,c"
   Seq([a,b,c],";") -> "a;b;c" #
Seq:=fun((if nops(args(1))=0 then ""
   else Maple(op(args(1),1)).(args(2).Maple(op(args(1),i))$hold(i)=2..nops(args(1)))
   end_if)):

DOM_PROC::maple:=proc(p)
begin
   "proc(".(if op(p,1)=NIL then "" else Seq([op(p,1)],",") end_if).") ".
   (if op(p,2)=NIL then "" else "local ".Seq([op(p,2)],",")."; " end_if).
   (if op(p,3)=NIL then "" else "option ".Seq([op(p,3)],",")."; " end_if).
   Maple(op(p,4)).
   " end"
end_proc:

# function attributes #
_plus:=funcattr(_plus,"maple",fun("(".Seq([args()],"+").")")):

_mult:=funcattr(_mult,"maple",fun("(".Seq([args()],"*").")")):

_power:=funcattr(_power,"maple",fun(Maple(args(1))."^(".Maple(args(2)).")")):

_stmtseq:=funcattr(_stmtseq,"maple",fun(Seq([args()],"; "))):

_if:=funcattr(_if,"maple",fun("if ".Maple(args(1))." then ".Maple(args(2)).
   (if args(3)=NIL then "" else " else ".Maple(args(3)) end_if)." fi")):
