# $ Date $ $ Author $ $ Revision $  #

#++

	groebner::MixedOrder -  general ''mixed'' orders for monomials

        MixedOrder([f1,...,fk]) 

        f1, ..., fk   -    functions N^n -> real numbers                  

        
        returns the following monomial ordering:
 
        m1 < m2 iff there exists i, 1 <= i <= k, such that
        fl(m1)=fl(m2) for l < i and
        fi(m1)<fi(m2)

++#


groebner::MixedOrder:=proc(f)
local dummy,dummy2;

begin
subsop(
fun(block([i,vals],(i:=1;  repeat vals:=map(args(),dummy[i]);
     i:=i+1 until i>dummy2 or vals[1]<>vals[2] end_repeat; bool(_less(op(vals)))))),  
     [5,2,2,1,1,2,2,1]=f, [5,2,2,2,1,1]=nops(f))
end_proc:	





#++

        groebner::WeightedDegreeFunction([w1,...,wk]) - assigns to each degree vector
        [n1,...,nk] the number w1*n1 + .... + wk*nk

++#

 
groebner::WeightedDegreeFunction:=proc(w)
local dummy;

begin
subsop(fun(_plus(op(zip(dummy,args(1),_mult)))),[5,1,1,1]=w)
end_proc:




