# $Date: 1999/04/28 09:41:00 $ $Author: fakler $ $Revision: 1.13.2.1 $ #
#--
The input for the procedure intlib::rlti (Rioboo-Lazard-Trager Improvement) is 
the simple function f in the fieldextension k[n] splitted into numerator and 
denominator of the special part and the normal part of f respectively.
rlti(f_sNum,f_sDen,f_nNum,f_nNum,n) - computes g and h, which is n-reduced, so
that g'+h=f.
M. Bronstein, A Unification of Liouvillian Extension, AAECC 1990, 1
--#
intlib::rlti:=proc(f_sNum,f_sDen,A,B,n)
  local x,z,S,R,i,j,s,c,integral,zz;
# global k,k_deg,Q_sub; #
begin
  if iszero(A) then return(f_sNum,f_sDen,0) end_if;
  x:=op(A,2);
  integral:=0;
  z:=genident();
  A:=A-poly(z,x)*intlib::diffs(B,n);
  S:=intlib::subres(A,B);
  userinfo(3,"subres prs:",S);
  S[0]:=intlib::primpart(poly(S[0],[z]))[1];
#tt
  if test then print("Resultante:",S[0]); end_if;
  if indets(expr(S[0])) intersect {op(k_sub)} <> {}
    then _proof(expr(A)/expr(B),
                "is not elementary integrable because",
                "the resultant contains non constant coefficients");
  end_if;
tt#
  if indets(expr(S[0])) intersect {op(k_sub)} <> {} then return(FAIL); end_if;
#  R:=intlib::sqffTab(multcoeffs(S[0],1/lcoeff(S[0])));#
  R:=intlib::sqffTab(S[0]);
  userinfo(3,"R=",R);
  for i from 1 to nops(R) do
    if R[i]=poly(1,[z]) then next; end_if;
    s:=gcdex(poly(lcoeff(S[i]),[z]),R[i])[2]; # instead of intlib::gcdex #
    s:=intlib::sim(poly(divide(s*poly(S[i],[z]),R[i],Rem),x));
    userinfo(3,"s=",s);
    if traperror((j:=factor(R[i])))=0
      then R[i]:=[];
           for c from 2 to nops(j) step 2 do
             j[c]:=poly(j[c],[z]);
             R[i]:=append(R[i],multcoeffs(j[c],1/lcoeff(j[c])));
           end_for;
      else R[i]:=[R[i]];
    end_if;
    userinfo(3,"factors of resultant: ",R[i]);
    for j from 1 to nops(R[i]) do
      case degree(R[i][j])
        of 1 do   c:=-coeff(R[i][j],0);
                  integral:=integral-c*degree(s)*op(k[n])*k_deg[n]
                            +c*ln(normal(expr(subs(s,z=c))));
                  break;
        of 2 do   -coeff(R[i][j],1)/2;
                  sqrt(%^2-coeff(R[i][j],0));
                  %2+%1,%2-%1;
                  integral:=integral+op(%1,1)*ln(normal(expr(subs(s,z=op(%1,1)))))
                            +op(%1,2)*ln(normal(expr(subs(s,z=op(%1,2)))))
                            -(op(%1,1)+op(%1,2))*degree(s)*op(k[n])*k_deg[n];
                  break;
        otherwise zz:=genident(); # for RootOf #
		  integral:=_plus(integral,sum(z*(ln(normal(expr(s)))
                                                  -k_deg[n]*degree(s)
                       *op(k[n])),z=RootOf(subs(expr(R[i][j]),z=zz),zz)))
      end_case;
    end_for;
  end_for;
  return(f_sNum,f_sDen,integral);
end_proc:
