# $Date: 1997/10/10 15:55:50 $ $Author: tonner $ $Revision: 1.5 $ #
#++
Ax -- a library of basic axiom constructors
++#

proc()
    option noDebug;
    local path;
begin

domains: # force loading 'domains' #

Ax:= domain("Ax"):
Ax::info:= "Library 'Ax': Basic axiom constructors":
Ax::interface:= {
    hold(canonicalRep), 
    hold(canonicalOrder),
    hold(systemRep),
    hold(normalRep),
    hold(noZeroDivisors),
    hold(canonicalUnitNormal),
    hold(closedUnitNormals),
    hold(effectiveOperation)
}:

path := pathname("DOMAINS", "AXIOM"):

Ax::canonicalRep:= loadproc(Ax::canonicalRep, path, "canonRep"):
Ax::canonicalOrder:= loadproc(Ax::canonicalOrder, path, "canonOrd"):
Ax::systemRep:= loadproc(Ax::systemRep, path, "sysRep"):
Ax::normalRep:= loadproc(Ax::normalRep, path, "normForm"):
Ax::noZeroDivisors:= loadproc(Ax::noZeroDivisors, path, "noZerDiv"):
Ax::canonicalUnitNormal:= loadproc(Ax::canonicalUnitNormal, path, "canUNorm"):
Ax::closedUnitNormals:= loadproc(Ax::closedUnitNormals, path, "clUNorm"):
Ax::effectiveOperation:= loadproc(Ax::effectiveOperation, path, "effectOp"):

stdlib::LoadlibState["Ax"]:= TRUE:

end_proc():

# end of file #
