# $Date: 1997/10/28 10:18:14 $ $Author: wseiler $ $Revision: 1.13 $ #
#++
Cat -- a library of basic category constructors
++#

proc()
    option noDebug;
    local path;
begin

domains: # force loading 'domains' #

Cat:= domain("Cat"):
Cat::info:= "Library 'Cat': Basic category constructors":
Cat::interface:= {
    hold(SetCat),
    hold(OrderedSet),
    hold(FiniteCollectionCat),
    hold(HomogeneousFiniteCollectionCat),
    hold(SemiGroup),
    hold(Monoid),
    hold(Group),
    hold(AbelianSemiGroup),
    hold(AbelianMonoid),
    hold(CancellationAbelianMonoid),
    hold(AbelianGroup),
    hold(Rng),
    hold(LeftModule),
    hold(RightModule),
    hold(Ring),
    hold(EntireRing),
    hold(CommutativeRing),
    hold(Module),
    hold(Algebra),
    hold(PartialDifferentialRing),
    hold(DifferentialRing),
    hold(IntegralDomain),
    hold(GcdDomain),
    hold(FactorialDomain),
    hold(PrincipalIdealDomain),
    hold(EuclideanDomain),
    hold(SkewField),
    hold(HomogeneousFiniteProductCat),
    hold(Field),
    hold(QuotientField),
    hold(PolynomialCat),
    hold(UnivariatePolynomialCat),
    hold(MatrixCat),
    hold(SquareMatrixCat),
    hold(VectorSpace),
    hold(UnivariateSkewPolynomialCat),
    hold(OrderedAbelianMonoid),
    hold(OrderedMonoid),
    hold(MonoidRing),
    hold(FiniteMonoidRing),
    hold(DifferentialVariableCat),
    hold(DifferentialFunctionCat),
    hold(RestrictedDifferentialFunctionCat)
}:

path := pathname("DOMAINS", "CATEGORY");

Cat::SetCat:= loadproc(Cat::SetCat, path, "SetCat"):
Cat::OrderedSet:= loadproc(Cat::OrderedSet, path, "OrdSet"):
Cat::FiniteCollectionCat:= loadproc(Cat::FiniteCollectionCat, path, "FinCollC"):
Cat::HomogeneousFiniteCollectionCat:= loadproc(Cat::HomogeneousFiniteCollectionCat, path, "HFinColC"):
Cat::SemiGroup:= loadproc(Cat::SemiGroup, path, "SemiGrp"):
Cat::Monoid:= loadproc(Cat::Monoid, path, "Monoid"):
Cat::Group:= loadproc(Cat::Group, path, "Group"):
Cat::AbelianSemiGroup:= loadproc(Cat::AbelianSemiGroup, path, "AbSemGrp"):
Cat::AbelianMonoid:= loadproc(Cat::AbelianMonoid, path, "AbMonoid"):
Cat::CancellationAbelianMonoid:= loadproc(Cat::CancellationAbelianMonoid, path, "CanAbMon"):
Cat::AbelianGroup:= loadproc(Cat::AbelianGroup, path, "AbGroup"):
Cat::Rng:= loadproc(Cat::Rng, path, "Rng"):
Cat::LeftModule:= loadproc(Cat::LeftModule, path, "LeftMod"):
Cat::RightModule:= loadproc(Cat::RightModule, path, "RightMod"):
Cat::Ring:= loadproc(Cat::Ring, path, "Ring"):
Cat::EntireRing:= loadproc(Cat::EntireRing, path, "EntRing"):
Cat::CommutativeRing:= loadproc(Cat::CommutativeRing, path, "CommRing"):
Cat::Module:= loadproc(Cat::Module, path, "Module"):
Cat::Algebra:= loadproc(Cat::Algebra, path, "Algebra"):
Cat::PartialDifferentialRing:= loadproc(Cat::PartialDifferentialRing, path, "PDiffRng"):
Cat::DifferentialRing:= loadproc(Cat::DifferentialRing, path, "DiffRing"):
Cat::IntegralDomain:= loadproc(Cat::IntegralDomain, path, "IntegDom"):
Cat::GcdDomain:= loadproc(Cat::GcdDomain, path, "GcdDom"):
Cat::FactorialDomain:= loadproc(Cat::FactorialDomain, path, "FactDom"):
Cat::PrincipalIdealDomain:= loadproc(Cat::PrincipalIdealDomain, path, "PrIdDom"):
Cat::EuclideanDomain:= loadproc(Cat::EuclideanDomain, path, "EuclDom"):
Cat::SkewField:= loadproc(Cat::SkewField, path, "SkewFld"):
Cat::HomogeneousFiniteProductCat:= loadproc(Cat::HomogeneousFiniteProductCat, path, "HFiProdC"):
Cat::Field:= loadproc(Cat::Field, path, "Field"):
Cat::QuotientField:= loadproc(Cat::QuotientField, path, "QuoField"):
Cat::PolynomialCat:= loadproc(Cat::PolynomialCat, path, "PolyCat"):
Cat::UnivariatePolynomialCat:= loadproc(Cat::UnivariatePolynomialCat, path, "UPolyCat"):
Cat::MatrixCat:= loadproc(Cat::MatrixCat, path, "MatCat"):
Cat::SquareMatrixCat:= loadproc(Cat::SquareMatrixCat, path, "SqMatCat"):
Cat::VectorSpace:= loadproc(Cat::VectorSpace, path, "Vspace"):

Cat::UnivariateSkewPolynomialCat:= loadproc(Cat::UnivariateSkewPolynomialCat, path, "OrePolyC"):
Cat::OrderedAbelianMonoid:=loadproc(Cat::OrderedAbelianMonoid,path,"OrdAbMon"):
Cat::OrderedMonoid:=loadproc(Cat::OrderedMonoid,path,"OrdMon"):
Cat::MonoidRing:=loadproc(Cat::MonoidRing,path,"MonRing"):
Cat::FiniteMonoidRing:=loadproc(Cat::FiniteMonoidRing,path,"FinMonRing"):
Cat::DifferentialVariableCat:=loadproc(Cat::DifferentialVariableCat,path,"DVarCat"):
Cat::DifferentialFunctionCat:=loadproc(Cat::DifferentialFunctionCat,path,"DFunCat"):
Cat::RestrictedDifferentialFunctionCat:=loadproc(Cat::RestrictedDifferentialFunctionCat,path,"RestDFunCat"):


stdlib::LoadlibState["Cat"]:= TRUE:

end_proc():

# end of file #
