# $Date: 1997/10/28 10:17:43 $ $Author: wseiler $ $Revision: 1.31 $ #
#++
Dom -- a library of basic domain constructors
++#

proc()
  option noDebug;
  local path;
begin

domains: # force loading 'domains' #

Dom:= domain("Dom"):
Dom::info:= "Library 'Dom': Basic domain constructors":
Dom::interface:= {
    hold(BaseDomain),
    hold(Expression),
    hold(ArithmeticalExpression),
    hold(Numerical),
    hold(Float),
    hold(Rational),
    hold(Integer),
    hold(IntegerMod),
    hold(ExpressionField),
    hold(Fraction),
    hold(Polynomial),
    hold(DistributedPolynomial),
    hold(Product),
    hold(Matrix),
    hold(SquareMatrix),
    hold(TruncatedPowerSeries),
    hold(AlgebraicExtension),
    hold(Interval),
    hold(GaloisField),
    hold(IntervalSet),
    hold(Multiset),
    hold(DiscreteSet),
    hold(MatrixGroup),
    hold(Pade),
    hold(PermutationGroup),
    hold(DihedralGroup),
    hold(FreeModule),
    hold(Real),
    hold(Complex),
    hold(Quaternion),
    hold(Ideal),
    hold(PolynomialExplicit),
    hold(MultivariatePolynomial),
    hold(UnivariatePolynomial),
    hold(UnivariateSkewPolynomial),
    hold(LinearOrdinaryDifferentialOperator),
    hold(PowerProduct),
    hold(MonoidAlgebra),
    hold(ExteriorProduct),
    hold(ExteriorAlgebra),
    hold(DerivativeProduct),
    hold(MonoidOperatorAlgebra),
    hold(LinearDifferentialOperator),
    hold(SparseMatrix),
    hold(DifferentialVariable),
    hold(LinearFunction),
    hold(DifferentialProduct),
    hold(DifferentialPolynomial),
    hold(DifferentialExpression),
    hold(LinearDifferentialFunction),
    hold(IndependentDifferentialExpression),
    hold(UnivariateRationalFunctions)
}:

path := pathname("DOMAINS", "DOMAIN");

Dom::BaseDomain:= loadproc(Dom::BaseDomain, path, "BaseDom"):
Dom::Expression:= loadproc(Dom::Expression, path, "Expr"):
Dom::ArithmeticalExpression:= loadproc(Dom::ArithmeticalExpression, path, "AritExpr"):
Dom::Numerical:= loadproc(Dom::Numerical, path, "Numeric"):
Dom::Float:= loadproc(Dom::Float, path, "Float"):
Dom::Rational:= loadproc(Dom::Rational, path, "Rational"):
Dom::Integer:= loadproc(Dom::Integer, path, "Integer"):
Dom::IntegerMod:= loadproc(Dom::IntegerMod, path, "IntMod"):
Dom::ExpressionField:= loadproc(Dom::ExpressionField, path, "ExprFld");
Dom::Fraction:= loadproc(Dom::Fraction, path, "Fraction");
Dom::Polynomial:= loadproc(Dom::Polynomial, path, "Polynom");
Dom::DistributedPolynomial:= loadproc(Dom::DistributedPolynomial, path, "DistPoly");
Dom::Product:= loadproc(Dom::Product, path, "Product"):
Dom::Matrix:= loadproc(Dom::Matrix, path, "Matrix"):
Dom::SquareMatrix:= loadproc(Dom::SquareMatrix, path, "SqMatrix"):
Dom::TruncatedPowerSeries:= loadproc(Dom::TruncatedPowerSeries, path, "TrPowSer"):
Dom::AlgebraicExtension:= loadproc(Dom::AlgebraicExtension, path, "AlgebExt"):
Dom::Interval:= loadproc(Dom::Interval, path, "Interval"):
Dom::GaloisField:= loadproc(Dom::GaloisField, path, "GaloisF"):
Dom::IntervalSet:= loadproc(Dom::IntervalSet, path, "IntSet"):
Dom::Multiset:= loadproc(Dom::Multiset, path, "Multiset"):
Dom::DiscreteSet:= loadproc(Dom::DiscreteSet, path, "DiscrSet"):
Dom::MatrixGroup:= loadproc(Dom::MatrixGroup, path, "Mat"):
Dom::Pade:= loadproc(Dom::Pade, path, "Pade"):
Dom::PermutationGroup:= loadproc(Dom::PermutationGroup, path, "PermGrp"):
Dom::DihedralGroup:= loadproc(Dom::DihedralGroup, path, "Dihedral"):
Dom::FreeModule:= loadproc(Dom::FreeModule, path, "FreeMod"):
Dom::Real:= loadproc(Dom::Real, path, "Real"):
Dom::Complex:= loadproc(Dom::Complex, path, "Complex"):
Dom::Quaternion:= loadproc(Dom::Quaternion, path, "Quatern"):
Dom::MultivariatePolynomial:= loadproc(Dom::MultivariatePolynomial,path,"MultPoly"):
Dom::UnivariatePolynomial:=loadproc(Dom::UnivariatePolynomial,path,"UniPoly"):
Dom::PolynomialIdeal:=loadproc(Dom::PolynomialIdeal,path,"PolIdeal"):
Dom::Ideal:=loadproc(Dom::Ideal, path, "Ideal"):

Dom::PolynomialExplicit:= loadproc(Dom::PolynomialExplicit,path,"PolyExp"):
Dom::UnivariateSkewPolynomial:= loadproc(Dom::UnivariateSkewPolynomial,path,"OrePoly"):
Dom::LinearOrdinaryDifferentialOperator:= loadproc(Dom::LinearOrdinaryDifferentialOperator,path,"Lodo"):
Dom::PowerProduct:=loadproc(Dom::PowerProduct,path,"PowProd"):
Dom::MonoidAlgebra:=loadproc(Dom::MonoidAlgebra,path,"MonAlg"):
Dom::ExteriorProduct:=loadproc(Dom::ExteriorProduct,path,"ExtProd"):
Dom::ExteriorAlgebra:=loadproc(Dom::ExteriorAlgebra,path,"ExtAlg"):
Dom::DerivativeProduct:=loadproc(Dom::DerivativeProduct,path,"DerivProd"):
Dom::MonoidOperatorAlgebra:=loadproc(Dom::MonoidOperatorAlgebra,path,"MonOpAlg"):
Dom::LinearDifferentialOperator:=loadproc(Dom::LinearDifferentialOperator,
		path,"LinDiffOp"):
Dom::SparseMatrix:=loadproc(Dom::SparseMatrix,path,"Sparse"):
Dom::LinearFunction:=loadproc(Dom::LinearFunction,path,"LinFun"):
Dom::DifferentialProduct:=loadproc(Dom::DifferentialProduct,path,"DiffProd"):
Dom::DifferentialPolynomial:=loadproc(Dom::DifferentialPolynomial,path,"DiffPoly"):
Dom::DifferentialExpression:=loadproc(Dom::DifferentialExpression,path,"DiffExpr"):
Dom::IndependentDifferentialExpression:=loadproc(Dom::IndependentDifferentialExpression,path,"IndDExpr"):
Dom::LinearDifferentialFunction:=loadproc(Dom::LinearDifferentialFunction,path,"LinFun"):
Dom::DifferentialVariable:=loadproc(Dom::DifferentialVariable,path,"DiffVar"):
Dom::UnivariateRationalFunctions:=loadproc(Dom::UnivariateRationalFunctions,path,"UniRatF"):

stdlib::LoadlibState["Dom"]:= TRUE:

end_proc():

# end of file #
