# series.mu--library for series expansions #

#++

User functions:

series -- return a Taylor/Laurent/Puiseux/generalized series expansion

++#

proc()
    option noDebug;
    local path;
begin

Series:=domain("series"):
Series::info:="Library 'series': series expansions":
Series::interface:={}:

path := pathname("SERIES"):

Puiseux:=domain("Puiseux"):

Series::series:= loadproc(Series::series, path, "series"):
Puiseux::create:= loadproc(Puiseux::create, path, "laurent"):
Puiseux::frompoly:= loadproc(Puiseux::frompoly, path, "laurent"):
Puiseux::_power:= loadproc(Puiseux::_power, path, "laurent"):
Puiseux::ldegree:= loadproc(Puiseux::ldegree, path, "laurent"):
Puiseux::set_var:= loadproc(Puiseux::set_var, path, "laurent"):

# generalized series expansions #
gseries:= loadproc(gseries, path, "gseries"):

stdlib::LoadlibState["Series"]:= TRUE:

null():
end_proc():

