# #

# Trans.mu  --  library for transformations #

proc()
    option noDebug;
    local path;
begin

    # force loading #

    transform:= domain("transform"):
    transform::info := "Library 'transform': library for transformations":
    transform::interface := { hold(laplace),hold(ilaplace),
                              hold(fourier),hold(ifourier),
			      hold(mellin)
			   }:

    transform::IntTrans:= domain("transform::IntTrans"):
    ((transform::IntTrans)::info):= 
	"transform::IntTrans  -- a library for integral transformations":
    ((transform::IntTrans)::FREEVARIABLE):=TRUE:
 
    path := pathname("TRANS");

    ((transform::IntTrans)::c1):=new((transform::IntTrans), "c1", TRUE, TRUE):
    ((transform::IntTrans)::c2):=new((transform::IntTrans), "c2", TRUE, TRUE):
    ((transform::IntTrans)::c3):=new((transform::IntTrans), "c3", TRUE, TRUE):
    ((transform::IntTrans)::c4):=new((transform::IntTrans), "c4", TRUE, TRUE):
    ((transform::IntTrans)::c5):=new((transform::IntTrans), "c5", TRUE, TRUE):
    ((transform::IntTrans)::c6):=new((transform::IntTrans), "c6", TRUE, TRUE):
    ((transform::IntTrans)::c7):=new((transform::IntTrans), "c7", TRUE, TRUE):
    ((transform::IntTrans)::c8):=new((transform::IntTrans), "c8", TRUE, TRUE):

    ((transform::IntTrans)::linear):= 
	loadproc( (transform::IntTrans)::linear, path, "IntTrans" ):
    ((transform::IntTrans)::Minus):= 
	loadproc( (transform::IntTrans)::Minus, path, "IntTrans" ):
    ((transform::IntTrans)::built_in):= 
	loadproc( (transform::IntTrans)::built_in, path, "IntTrans" ):
    ((transform::IntTrans)::D2diff):= 
	loadproc( (transform::IntTrans)::D2diff, path, "IntTrans" ):

    path := pathname("TRANS","LAPLACE");
    transform::laplace:= loadproc( transform::laplace, path, "laplace" ):
    transform::ilaplace:= loadproc( transform::ilaplace, path, "ilaplace" ):


#    path := pathname("TRANS","FOURIER"); #
# use Paul's version from STDLIB until Dirk has fixed/written it. #
    path := pathname("TRANS");
    transform::fourier:= loadproc( transform::fourier, path, "fourier" ):
    transform::ifourier:= loadproc( transform::ifourier, path, "ifourier" ):
    transform::mellin:= loadproc( transform::mellin, path, "mellin" ):


    stdlib::LoadlibState["transform"]:= TRUE:
    null()
end_proc():

# end of file #
