# $Date: 1997/10/10 15:55:58 $ $Author: tonner $ $Revision: 1.38 $ #

# faclib.mu--library for polynomial factorization #

#++

User functions:

factor--return the factorization of rational multivariate polynomial in Z or 
        factorization of univariate polynomial in Zp

++#

proc()
    option noDebug;
    local path;
begin

faclib:=domain("faclib"):
faclib::info:="Library 'faclib': \
Factorization of multivariate polynomials over the rationals or \
univariate polynomials over IntMod(p)":

faclib::interface:={}:

path := pathname("FACLIB"):

faclib::algfactor:= loadproc(faclib::algfactor, path, "algfac"):
faclib::pfactor:= loadproc(faclib::pfactor, path, "pfactor"):
faclib::homo:= loadproc(faclib::homo, path, "homo"):
faclib::binomial:= loadproc(faclib::binomial, path, "binomial"):
faclib::mfactor:= loadproc(faclib::mfactor, path, "mfactor"):
faclib::ufactor:= loadproc(faclib::ufactor, path, "ufactor"):
faclib::linear:= loadproc(faclib::linear, path, "linear"):
faclib::irr_test:= loadproc(faclib::irr_test, path, "irr_test"):
faclib::ddf:= loadproc(faclib::ddf, path, "ddf"):
faclib::eval_root:= loadproc(faclib::eval_root, path, "evalroot"):
faclib::canzas_2:= loadproc(faclib::canzas_2, path, "canzas_2"):
faclib::plift:= loadproc(faclib::plift, path, "plift"):
faclib::combine:= loadproc(faclib::combine, path, "combine"):

faclib::primpart:= loadproc(faclib::primpart, path, "primpart"):
faclib::true_fs:= loadproc(faclib::true_fs, path, "true_fs"):
faclib::rb:= loadproc(faclib::rb, path, "rb"):
faclib::rr:= loadproc(faclib::rr, path, "rr"):
faclib::bound:= loadproc(faclib::bound, path, "bound"):
faclib::getprime:= loadproc(faclib::getprime, path, "getprime"):
faclib::mod_gcd_ex:= loadproc(faclib::mod_gcd_ex, path, "modgcdex"):

faclib::mhensel:= loadproc(faclib::mhensel, path, "mhensel"):
faclib::pdeg2:= loadproc(faclib::pdeg2, path, "pdeg2"): 
faclib::monomial:= loadproc(faclib::monomial, path, "monomial"): 
faclib::quafree:= loadproc(faclib::quafree, path, "quafree"):
faclib::pfs:= loadproc(faclib::pfs, path, "pfs"):
faclib::set_x:= loadproc(faclib::set_x, path, "set_x"): 
faclib::set_b:= loadproc(faclib::set_b, path, "set_b"):
faclib::mrestore:= loadproc(faclib::mrestore, path, "mrestore"):
faclib::diophant:= loadproc(faclib::diophant, path, "diophant"):

faclib::factor_mod_composite:= loadproc(faclib::factor_mod_composite,
 path, "fac_mod"):
faclib::factor_mod:= loadproc(faclib::factor_mod, path, "fact_mod"):
faclib::sqrfreeff:= loadproc(faclib::sqrfreeff, path, "sqrfree"):

faclib::indsort:= loadproc(faclib::indsort, path, "indsort"):
faclib::psqrfree:= loadproc(faclib::psqrfree, path, "psqrfree"):
faclib::reform:= loadproc(faclib::reform, path, "reform"):

faclib::univ_mod_gcd:= loadproc(faclib::univ_mod_gcd,path,"univmgcd"):
faclib::powermod_poly:= loadproc(faclib::powermod_poly,path,"powermod"):
faclib::canzas_lin:= loadproc(faclib::canzas_lin, path, "canzas"):
faclib::canzas:= loadproc(faclib::canzas, path, "canzas"):
faclib::ddf_shoup:= loadproc(faclib::ddf_shoup, path, "shoup"):
faclib::lll:= loadproc(faclib::lll, path, "lll"):
faclib::kronecker_factor:= loadproc(faclib::kronecker_factor, path,
				"kroneck"):

# for sqrfree: #
faclib::factor_expr:= loadproc(faclib::factor_expr,path, "fac_expr"):
faclib::pre_factor:= loadproc(faclib::pre_factor, path, "pre_fact"):
faclib::sqrfree_poly:= loadproc(faclib::sqrfree_poly,path, "sqfr_pol"):
faclib::sqrfree_yun:= loadproc(faclib::sqrfree_yun,path, "sqfr_yun"):
faclib::sqrfree_ffield:= loadproc(faclib::sqrfree_ffield,path, "sqfr_ff"):
faclib::sqrfrmv:= loadproc(faclib::sqrfrmv,path, "sqfr_ff"):

faclib::roots:= loadproc(faclib::roots, path, "roots"):
faclib::primitive := loadproc(faclib::primitive, path, "primitiv"):

# for bivariate and multivariate factorization over domains #
faclib::bifactor:= loadproc(faclib::bifactor, path, "bifactor"):
faclib::udfactor:= loadproc(faclib::udfactor, path, "bifactor"):
faclib::domfact:= loadproc(faclib::domfact, path, "domfact"):
faclib::multifactor:= loadproc(faclib::multifactor, path, "mufactor"):
faclib::tryall:= loadproc(faclib::tryall, path, "mufactor"):
faclib::truncate:= loadproc(faclib::truncate, path, "mufactor"):
faclib::quadfactor:= loadproc(faclib::quadfactor, path, "quadfact"):
faclib::findfactor:= loadproc(faclib::findfactor, path, "findfact"):

# for GaloisField: #
faclib::is_irred_gf:= loadproc(faclib::is_irred_gf, path, "irred_gf"):
faclib::random_irred_gf:= loadproc(faclib::random_irred_gf, path, "irred_gf"):
faclib::factorgf:= loadproc(faclib::factorgf, path, "factorgf"):
faclib::eqdegr:= loadproc(faclib::eqdegr, path, "equaldeg"):
faclib::distdegr:= loadproc(faclib::distdegr, path, "distdegr"):
faclib::verify_irred_gf:= loadproc(faclib::verify_irred_gf, path, "irred_gf"):

stdlib::LoadlibState["faclib"]:= TRUE:

null();
end_proc():

