# $Date: 1997/10/10 15:56:03 $  $Author: tonner $  $Revision: 1.8 $ #

# kg, 18/06/93 #

#++
isa -- library of type checking procedures

NOTE: This procedures don's check their arguments. They are intended
to be called from other procedures, not from the user.
++#

proc()
    option noDebug;
    local path;
begin

isa:= domain("isa"):

isa::info:= "Library 'isa': Type checking procedures, V.1.0":
isa::interface:= {
    hold(posint), hold(negint), hold(nonegint), hold(real),
    hold(rational), hold(list_of), hold(set_of),
    hold(string_list), hold(ident_list), hold(string_set),
    hold(ident_set), hold(domain_element),
    hold(integer_poly), hold(rational_poly), hold(real_poly),
    hold(number_poly), hold(poly_of)
}:

path := pathname("ISA"):

isa::posint:= loadproc(isa::posint, path, "posint"):
isa::negint:= loadproc(isa::negint, path, "negint"):
isa::nonegint:= loadproc(isa::nonegint, path, "nonegint"):
isa::rational:= loadproc(isa::rational, path, "rational"):
isa::real:= loadproc(isa::real, path, "real"):

isa::domain_element:= loadproc(isa::domain_element, path, "dom_elem"):

isa::list_of:= loadproc(isa::list_of, path, "list_of"):
isa::string_list:= loadproc(isa::string_list, path, "str_list"):
isa::ident_list:= loadproc(isa::ident_list, path, "id_list"):

isa::set_of:= loadproc(isa::set_of, path, "set_of"):
isa::string_set:= loadproc(isa::string_set, path, "str_set"):
isa::ident_set:= loadproc(isa::ident_set, path, "id_set"):

isa::poly_of:= loadproc(isa::poly_of, path, "poly_of"):
isa::integer_poly:= loadproc(isa::integer_poly, path, "int_poly"):
isa::rational_poly:= loadproc(isa::rational_poly, path, "rat_poly"):
isa::real_poly:= loadproc(isa::real_poly, path, "rea_poly"):
isa::number_poly:= loadproc(isa::number_poly, path, "num_poly"):

stdlib::LoadlibState["isa"]:= TRUE:

end_proc():

