# $Date: 1997/10/10 15:56:06 $ $Author: tonner $ $Revision: 1.13 $ #

# andi, 30/06/97 #

# module.mu -- the 'module' library for module management #

#++
User Functions:

load     - load modules (refer to 'loadmod')
displace - unload modules (refer to 'unloadmod')
func     - create DOM_FUNC_ENV of a mod.-func. (refer to 'external')

age      - get/set maximum age for loaded modules (module-aging)
max      - get/set maximum number of simultaneously loaded modules
stat     - prints out the state of module management
which    - get fullname (path) of a module

clean    - remove recursions in module domains
++#

proc()
    option noDebug;
    local path;
begin

module:= domain("module"):

module::info:= "Library 'module': Utilities for module management":
module::interface:= {	hold(func), hold(load), hold(displace), 
			hold(age),  hold(help), hold(max), 
			hold(stat), hold(which)
}:

path:= pathname("MODULE"):

module::load:=     loadproc(module::load, path,"load"):
module::displace:= loadproc(module::displace, path,"displace"):
module::unload:=   loadproc(module::unload, path,"unload"):
module::func:=     loadproc(module::func, path,"func"):

module::age:=    loadproc(module::age, path,"age"):
module::help:=   loadproc(module::help, path,"help"):
module::max:=    loadproc(module::max, path,"max"):
module::stat:=   loadproc(module::stat, path,"stat"):
module::which:=  loadproc(module::which, path,"which"):

module::clean:=  loadproc(module::clean, path,"clean"):

module::expr2text:= loadproc(module::expr2text, path,"expr2txt"):

module::new:= proc()
local READ_PATH;
local _n_,_a_,_o_;
begin
    if( (_n_:=args(0)) = 0 ) then 
        error( "Wrong number of arguments" );
    end_if;
    _a_:= args();
    _o_:= args(1);
    
    if( type(_o_) = "_equal" ) then
        if( op(_o_,1) <> hold(Path) ) then
            error( "Unknown option ".expr2text(op(_o_,1)) );
        end_if;
        if( domtype(op(_o_,2)) <> DOM_STRING ) then
            error( "String expected for option ".expr2text(op(_o_,1)) );
        else
            if( domtype(READ_PATH) = DOM_LIST ) then
                READ_PATH:= _o_, READ_PATH;
            else
                READ_PATH:= op(_o_,2);
            end_if;
        end_if;
        _a_:=subsop(_a_,1=null());
        _n_:=_n_-1;
    end_if;

    if  ( _n_ = 2 ) then
       	module::func( _a_ );
    elif( _n_ = 1 ) then
       	module::load( _a_ );
    else
       	error( "Wrong number of arguments" );
    end_if;
end_proc:

stdlib::LoadlibState["module"]:= TRUE:

end_proc():

# end of file #
