# $Date: 1997/10/13 10:56:23 $ $Author: olli $ $Revision: 1.17 $ #

#++
	numeric -- functions for numerical mathematics
++#

proc()
    option noDebug;
    local path;
begin

numeric:= domain("numeric"):
numeric::info:= "Library 'numeric': functions for numerical mathematics":
numeric::interface:= { 
    hold(bairstow), hold(bisect), hold(butcher), hold(det), hold(eigenvalues), 
    hold(eigenvectors), hold(factorLU), hold(factorQR), hold(factorCholesky),
    hold(fint), hold(fsolve), hold(gldata), hold(gtdata), hold(inverse), 
    hold(minpoly), hold(ncdata), hold(newton), hold(odesolve), hold(quadrature),
    hold(singularvalues), hold(singularvectors), hold(vonMises)
}:

path := pathname("NUMERIC");

numeric::complex_round:= loadproc(numeric::complex_round,path,"cmplxrnd"):
numeric::fsolve:= loadproc(numeric::fsolve,path,"fsolve"):
numeric::bisect:= loadproc(numeric::bisect, path, "bisect"):
numeric::newton:= loadproc(numeric::newton,path,"newton"):
numeric::bairstow:= loadproc(numeric::bairstow, path, "Bairstow"):
numeric::fsolve_Sqrfpoly:= loadproc(numeric::fsolve_Sqrfpoly,path,"solvepol"):
numeric::minpoly:= loadproc(numeric::minpoly, path, "minpoly"):
numeric::quadrature:= loadproc(numeric::quadrature, path, "Quad"):
numeric::gldata:= loadproc(numeric::gldata, path, "GLData"):
numeric::gtdata:= loadproc(numeric::gtdata, path, "GTData"):
numeric::ncdata:= loadproc(numeric::ncdata, path, "NCData"):
numeric::eigenvalues:= loadproc(numeric::eigenvalues, path, "eigenval"):
numeric::eigenvectors:= loadproc(numeric::eigenvectors, path, "eigenvec"):
numeric::vonMises:= loadproc(numeric::vonMises, path, "vonMises"):
numeric::fint:= loadproc(numeric::fint, path, "fint" ):
numeric::butcher:= loadproc(numeric::butcher, path, "butcher" ):
numeric::factorLU:= loadproc(numeric::factorLU, path, "factorLU" ):
numeric::factorQR:= loadproc(numeric::factorQR, path, "factorQR" ):
numeric::factorCholesky:= loadproc(numeric::factorCholesky, path, "factorCh" ):
numeric::det:= loadproc(numeric::det, path, "det" ):
numeric::inverse:= loadproc(numeric::inverse, path, "inverse" ):
numeric::odesolve:= loadproc(numeric::odesolve, path, "odesolve" ):
numeric::singularvalues:= loadproc(numeric::singularvalues, path, "singval" ):
numeric::singularvectors:= loadproc(numeric::singularvectors, path, "singvec" ):

stdlib::LoadlibState["numeric"]:= TRUE:

end_proc():

# end of file #
