proc()
  option noDebug;
  local dir;
begin
  ode:=domain("ode"):
  ode::info:="Library 'ode':  ordinary differential equations":
  ode::interface:={
#        hold(expsols),#
        hold(exponentialSolutions),
        hold(liouvillianSolutions), 
        hold(polynomialSolutions),
	hold(rationalSolutions),
        hold(symmetricPower),
        hold(dAlembert), 
        hold(evalOde),
        hold(isLODE),
        hold(isFuchsian),
        hold(Wronskian),
        hold(normalize),
        hold(vectorize),
        hold(unimodular) 
  }:
  ode::new:=proc(eq,x) begin new(ode,rewrite(eq,diff),x) end_proc;
  ode::print:=proc(o) begin hold(ode)(extop(o)) end_proc;
  ode::maxDepth:=2: # maximal nesting of methods #
  ode::depth:=0: # current depth #

  ode::isReducibleFlag:= FALSE: # necessary for printing correct warnings #

  dir:= pathname("ODE"):

ode::adjoint:= loadproc(ode::adjoint,dir,"adjoint"):
ode::autonomous:= loadproc(ode::autonomous,dir,"autonom"):
ode::Bernoulli:= loadproc(ode::Bernoulli,dir,"bernoull"):
ode::Clairaut:= loadproc(ode::Clairaut,dir,"clairaut"):
ode::contact:= loadproc(ode::contact,dir,"contact"):
ode::dAlembert:= loadproc(ode::dAlembert,dir,"dAlember"):
ode::differentiation:= loadproc(ode::differentiation,dir,"diff"):
ode::diffvars:= loadproc(ode::diffvars,dir,"diffvars"):
ode::equidimensional_in_x:= loadproc(ode::equidimensional_in_x,dir,"equidimx"):
ode::equidimensional_in_y:= loadproc(ode::equidimensional_in_y,dir,"equidimy"):
ode::euler:= loadproc(ode::euler,dir,"equidimx"):

ode::evalOde:= loadproc(ode::evalOde,dir,"tools"): 

ode::exact_first_order:= loadproc(ode::exact_first_order,dir,"exact1st"):
ode::exact_second_order:= loadproc(ode::exact_second_order,dir,"exact2nd"):
ode::exact_nth_order:= loadproc(ode::exact_nth_order,dir,"exactnth"):
#ode::expsols:= loadproc(ode::expsols,dir,"expsols"):#

ode::expsols:= loadproc(ode::expsols,dir,"ExpSol"):
ode::exponentialSolutions:= loadproc(ode::exponentialSolutions,dir,"ExpSol"):
ode::exponents:= loadproc(ode::exponents,dir, "fuchsian"):

ode::factor:= loadproc(ode::factor,dir,"factor"):
ode::firstord:= loadproc(ode::firstord,dir,"firstord"):

ode::generalReduction:= loadproc(ode::generalReduction,dir,"dAlember"):
ode::getOrder:= loadproc(ode::getOrder,dir,"tools"):

ode::indets:= loadproc(ode::indets,dir,"indets"):
ode::indicialEquation:= loadproc(ode::indicialEquation,dir, "fuchsian"):
ode::isLODE:= loadproc(ode::isLODE,dir,"isLODE"):
ode::isFuchsian:= loadproc(ode::isFuchsian,dir, "fuchsian"):
ode::linsys:= loadproc(ode::linsys,dir,"linsys"):
ode::mapsol:= loadproc(ode::mapsol,dir,"mapsol"):
ode::mkODE:= loadproc(ode::mkODE,dir,"mkODE"):

ode::mkUnimodular:=loadproc(ode::mkUnimodular,dir,"mkUnimod"): 

ode::normalize:= loadproc(ode::normalize,dir,"normal"):
ode::ode2poly:= loadproc(ode::ode2poly,dir,"ode2poly"):
ode::order:= loadproc(ode::order,dir,"order"):
ode::polysols:= loadproc(ode::polysols,dir,"PolySol"):
ode::polynomialSolutions:= loadproc(ode::polynomialSolutions,dir,"PolySol"):

ode::printMinPol:= loadproc(ode::printMinPol,dir,"tools"):
ode::ratsols:= loadproc(ode::ratsols,dir,"RatSol"):
ode::ratInvars:= loadproc(ode::ratInvars,dir,"RatSol"):
ode::rationalInvariants:= loadproc(ode::rationalInvariants,dir,"RatSol"):

ode::rationalSolutions:= loadproc(ode::rationalSolutions,dir,"RatSol"):
ode::secondOrderReduction:= loadproc(ode::secondOrderReduction,dir,"dAlember"):
ode::separate:= loadproc(ode::separate,dir,"separate"):
ode::solve:= loadproc(ode::solve,dir,"solve"):
ode::solve_eq:= loadproc(ode::solve_eq,dir,"solve_eq"):
ode::solve_linear:= loadproc(ode::solve_linear,dir,"solvelin"):
ode::solve_sys:= loadproc(ode::solve_sys,dir,"solvesys"):
ode::split:= loadproc(ode::split,dir,"split"):
ode::subsvars:= loadproc(ode::subsvars,dir,"subsvars"):

ode::symPower:= loadproc(ode::symPower,dir,"sympower"):
ode::symmetricPower:= loadproc(ode::symmetricPower,dir,"sympower"):
ode::undet:= loadproc(ode::undet,dir,"undet"):
ode::unimodular:=loadproc(ode::unimodular,dir,"mkUnimod"): 
ode::vectorize:= loadproc(ode::vectorize,dir,"vectoriz"):
ode::vspace:= loadproc(ode::vspace,dir,"vspace"):
ode::Wronskian:= loadproc(ode::Wronskian,dir,"wronsk"):
ode::ymissing:= loadproc(ode::ymissing,dir,"ymissing"):

# Liouvillian solutions #
dir:= pathname("ODE","LIOUVILL"):
ode::firstOrder:= loadproc(ode::firstOrder,dir,"ifReduc"):
ode::ifReducible:= loadproc(ode::ifReducible,dir,"ifReduc"):
ode::liouvillianSolutions:= loadproc(ode::liouvillianSolutions,dir,"LiouvSol"):
ode::combineSolutionsOfFactors:= 
                     loadproc(ode::combineSolutionsOfFactors,dir,"ifReduc"):
ode::reducibleCase:= loadproc(ode::reducibleCase,dir,"ifReduc"):
ode::secondOrder:= loadproc(ode::secondOrder,dir,"2ndOrder"):
ode::solveIfReducible:= loadproc(ode::solveIfReducible,dir,"ifReduc"):
ode::thirdOrder:= loadproc(ode::thirdOrder,dir,"3rdOrder"):

#~ NOTE: printMinPol, ExponentialSolutions, expsols, rationalSolutions,
         ratsols, polynomialSolutions, polysols, mkUnimodular
   should be in this directory! WF  ~#

stdlib::LoadlibState["ode"]:= TRUE:

  null():
end_proc():

