proc()
    option noDebug;
    local    path;
begin
    plotlib:=domain("plotlib"):
    plotlib::info:="Library 'plotlib': Library routines for two- and three-dimensional plots.":
    plotlib::interface:={hold(contourplot), hold(cylindricalplot), hold(dataplot), 
                         hold(densityplot), hold(fieldplot), hold(implicitplot),
                         hold(polarplot), hold(polygonplot), hold(sphericalplot),
                         hold(xrotate), hold(yrotate)}:

    path:= pathname("PLOTLIB"):

    plotlib::cylindricalplot := loadproc(plotlib::cylindricalplot, path, "pl_cylin"):
    plotlib::fieldplot       := loadproc(plotlib::fieldplot,       path, "pl_field"):
    plotlib::implicitplot    := loadproc(plotlib::implicitplot,    path, "implicit"):
    plotlib::arrayplot       := loadproc(plotlib::arrayplot,       path, "pl_array"):
    plotlib::polarplot       := loadproc(plotlib::polarplot,       path, "pl_polar"):
    plotlib::sphericalplot   := loadproc(plotlib::sphericalplot,   path, "pl_spher"):
    plotlib::vector          := loadproc(plotlib::vector,          path, "pl_vecto"):
    plotlib::xrotate         := loadproc(plotlib::xrotate,         path, "pl_xrota"):
    plotlib::yrotate         := loadproc(plotlib::yrotate,         path, "pl_yrota"):
    plotlib::polygonplot     := loadproc(plotlib::polygonplot,     path, "pl_polpl"):
    plotlib::dataplot        := loadproc(plotlib::dataplot,        path, "dataplot"):
    plotlib::contourplot     := loadproc(plotlib::contourplot,     path, "contplot"):
    plotlib::densityplot     := loadproc(plotlib::densityplot,     path, "density"):
    plotlib::clip2d          := loadproc(plotlib::clip2d,          path, "clip2d"):
    plotlib::combine         := loadproc(plotlib::combine,         path, "combine"):
    plotlib::conv2d          := loadproc(plotlib::conv2d,          path, "conv2d"):
    plotlib::show            := loadproc(plotlib::show,            path, "show"):

    stdlib::LoadlibState["plotlib"]:= TRUE:
    
    null():

end_proc():

