
#(
   property - Functionallity to compute Properties

   September 1997 - J"urgen Billing
)#


property:= domain("property"):
property::info:= "Library 'property': dealing with properties of identifiers":
property::name:= "property":
property::type:= "property":

property::tabPropertyEntry:= table():
sysassign( properties,
    fun(( 
        case args(0)
        of 1 do
            if not contains( property::tabPropertyEntry,args(1) ) then
                return( FAIL )
            else
                return( property::tabPropertyEntry[args(1)] )
            end_if;
        of 2 do
            if not contains( property::tabPropertyEntry,args(1) ) then
                FAIL
            else
                property::tabPropertyEntry[args(1)]
            end_if;
            sysassign( property::tabPropertyEntry[args(1)], args(2) );
            return( %2 )
        otherwise
            error("wrong no of args")
        end_case
    ))
):

property::interface:=
	{
	  hold(is),
	  hold(unassume),
	  hold(getprop),
	  hold(assume),
	  hold(delrule),
	  hold(getrule),
	  hold(setrule)#,#
	  #hold(loadrule),#
	  #hold(saverule)#
	}:  
	    
#( Konvertierungs-Hierarchie )#
property::incl:= table("NRange" = {},
	               #"Divs"   = {"EO"},#
	               #"Rel"    = {"NRange"},#
	               "IV"     = {"NRange", "Rel"},
	               #"NAdj"   = {"NRange"},#
	               #"Prop"   = {},#
	               #"Test"   = {},#
	               "EO"     = {}):

alias(POp = (property::POp)):

property::aliases:= table():

property::gdef:= null():

#( 0 = first old assume, then new assume )#
#( 1 = only old assume )#
#( 2 = only new assume )#
property::PROPLEVEL:= 0:

alias(pt = pathname("PROP")):
#( Domain )#
property::NRange:= loadproc(property::NRange, pt, "NRange"):
property::NAdj  := loadproc(property::NAdj  , pt, "NAdj"  ):
property::Rel   := loadproc(property::Rel   , pt, "Rel"   ):
property::IV    := loadproc(property::IV    , pt, "IV"    ):
property::Prop  := loadproc(property::Prop  , pt, "Prop"  ):
property::Divs  := loadproc(property::Divs  , pt, "Divs"  ):
property::POp   := loadproc(property::POp   , pt, "POp"   ):
#( Funktion )#
property::assume    := loadproc(property::assume    , pt, "Propset" ):
property::getprop   := loadproc(property::getprop   , pt, "Propget" ):
property::_getprop  := loadproc(property::_getprop  , pt, "Propget" ):
property::unassume  := loadproc(property::unassume  , pt, "Propdel" ):
property::is        := loadproc(property::is        , pt, "Propis"  ):
property::_is       := loadproc(property::_is       , pt, "Propis"  ):
property::__Is      := loadproc(property::__Is      , pt, "Propis"  ):
property::setrule   := loadproc(property::setrule   , pt, "Proprule"):
property::_setrule  := loadproc(property::_setrule  , pt, "Proprule"):
property::getrule   := loadproc(property::getrule   , pt, "Proprule"):
property::_getrule  := loadproc(property::_getrule  , pt, "Proprule"):
property::_getfunc  := loadproc(property::_getfunc  , pt, "Proprule"):
property::delrule   := loadproc(property::delrule   , pt, "Proprule"):
property::saverule  := loadproc(property::saverule  , pt, "Proprule"):
property::loadrule  := loadproc(property::loadrule  , pt, "Proprule"):
property::autoload  := loadproc(property::autoload  , pt, "Proprule"):
property::_Op       := loadproc(property::_Op       , pt, "Propeval"):
property::convert_to:= loadproc(property::convert_to, pt, "Propeval"):
property::expr      := loadproc(property::expr      , pt, "Propeval"):
property::lzeval    := loadproc(property::lzeval    , pt, "Propeval"):
property::mapr      := loadproc(property::mapr      , pt, "Propeval"):
property::mapp      := loadproc(property::mapp      , pt, "Propeval"):
property::path      := loadproc(property::path      , pt, "Propetc" ):
property::divis     := loadproc(property::divis     , pt, "Propetc" ):
property::constant  := loadproc(property::constant  , pt, "Propetc" ):

DOM_INT::NRange     := loadproc(DOM_INT::NRange     , pt, "DOM_INT" ):
DOM_INT::Divs       := loadproc(DOM_INT::Divs       , pt, "DOM_INT" ):
DOM_INT::IV         := loadproc(DOM_INT::IV         , pt, "DOM_INT" ):
DOM_INT::Rel        := loadproc(DOM_INT::Rel        , pt, "DOM_INT" ):
DOM_RAT::NRange     := loadproc(DOM_RAT::NRange     , pt, "DOM_RAT" ):
DOM_RAT::Divs       := loadproc(DOM_RAT::Divs       , pt, "DOM_RAT" ):
DOM_RAT::IV         := loadproc(DOM_RAT::IV         , pt, "DOM_RAT" ):
DOM_RAT::Rel        := loadproc(DOM_RAT::Rel        , pt, "DOM_RAT" ):
DOM_FLOAT::NRange   := loadproc(DOM_FLOAT::NRange   , pt, "DOM_FLO" ):
DOM_FLOAT::IV       := loadproc(DOM_FLOAT::IV       , pt, "DOM_FLO" ):
DOM_FLOAT::Rel      := loadproc(DOM_FLOAT::Rel      , pt, "DOM_FLO" ):
DOM_COMPLEX::NRange := loadproc(DOM_COMPLEX::NRange , pt, "DOM_COM" ):

unalias(pt):

property::Null:= 
	new(property, hold(Null)):

#( Operationen, die nicht definiert sind - /0 )#
property::Undefined:= 
	new(property, hold(Undefined)):

#( f"ur Undefined, Unknown etc. )#
property::print:=
	proc()
	begin
	  op(args())
	end_proc:

#(  )#
property::Unknown:=
	new(property, hold(Unknown)):

property::Nul:= (property::POp)::Pid("??"):

property::Fail:=
	proc()
	begin
	  contains({property::Undefined, property::Unknown, property::Null},
	           args())
	end_proc:

#( Beschr"ankung der Evaluierungstiefe )#
property::RECLEVEL:= 0:
property::MAXREC:= 50:

#( Remember f"ur is )#
property::reset:=
	proc()
	begin
	  userinfo(10, "--> reset: remove remember table"):
	  sysassign(property::_is, subsop(property::_is, 5 = NIL)):
	  sysassign(property::_getprop, subsop(property::_getprop, 5 = NIL)):
	  sysassign(property::isrel, subsop(property::isrel, 5 = NIL)):
	  sysassign(property::isprop, subsop(property::isprop, 5 = NIL)):
	  sysassign(property::RECLEVEL, 0):
	  null()
	end_proc:

stdlib::LoadlibState["property"]:= TRUE:
