# $Date: 1997/10/10 15:56:12 $ $Author: tonner $ $Revision: 1.17 $ #

# kg, 03/02/94 #

# sharelib.mu -- the MuPAD share library pckage #

#++
User Functions:

help_edit - interactive editor for help pages
SGML      - translates an expression into SGML output
trace     - traces a procedure or function environment
untrace   - remove the trace mode
++#

proc()
    option noDebug;
    local path;
begin

sharelib:= domain("sharelib"):
sharelib::info:= "Library 'sharelib': \
utilities contributed by the users":

sharelib::interface:= { 
                        hold(iroots),
                        hold(SGML), hold(help_edit),
                        hold(edit), hold(plotsetup),
                        hold(subdirs), hold(rational),
                        hold(trace), hold(untrace),
                        hold(animate2d), hold(animate3d),
                        hold(animate), hold(show_animation),
                        hold(delete_frames)
                      }:

path:= pathname("SHARE"):

sharelib::help_edit:= loadproc(sharelib::help_edit, path,"helpedit"):
sharelib::SGML:= loadproc(sharelib::SGML, path,"SGML"):
sharelib::iroots:= loadproc(sharelib::iroots, path,"iroots"):
sharelib::plotsetup:= loadproc(sharelib::plotsetup, path,"setup"):
sharelib::edit:= loadproc(sharelib::edit, path,"edit"):
sharelib::subdirs:= loadproc(sharelib::subdirs, path,"subdirs"):
sharelib::rational:= loadproc(sharelib::rational, path,"rational"):
sharelib::trace:= loadproc(sharelib::trace, path,"trace"):
sharelib::untrace:= loadproc(sharelib::untrace, path,"trace"):
sharelib::animate2d:= loadproc(sharelib::animate2d, path,"animate"):
sharelib::animate3d:= loadproc(sharelib::animate3d, path,"animate"):
sharelib::animate:= loadproc(sharelib::animate, path,"animate"):
sharelib::show_animation:= loadproc(sharelib::show_animation, path,"animate"):
sharelib::delete_frames:= loadproc(delete_frames, path,"animate"):

stdlib::LoadlibState["sharelib"]:= TRUE:

end_proc():

# end of file #
