# #
# $Date: 1997/03/19 11:20:50 $  $Author: frankp $   $Revision: 1.5 $ #
# #
# frankp, 2/03/94 #

#++
  col.mu

     linalg::col(A,i)           -- return column i of A
     linalg::col(A,i..j)        -- return the list of columns i to j of A
     linalg::col(A,[i1,i2,...]) -- return columns i1,i2, ... of A
++#

linalg::col := proc(A,l)
    name linalg::col;
    local k, i;
begin
    if testargs() then
	if args(0) <> 2 then error("expecting 2 arguments") end_if;
	if A::hasProp( Cat::MatrixCat ) <> TRUE then
	    error("first argument is not of 'Cat::MatrixCat'")
	end_if;
	k := op( A::dimen(A),2 );
	if testtype( l,Type::PosInt ) then
	    if l > k then error("index out of range") end_if
	elif type(l) = "_range" then
	    if not testtype( op(l,1),Type::PosInt ) 
	    or not testtype( op(l,2),Type::PosInt )
	    then
		error("expecting range of positive integers")
	    end_if;
	    if op(l,1) > k or op(l,2) > k then
		error("range larger than upper matrix bound")
	    end_if
	elif testtype(l,Type::ListOf(Type::PosInt,1)) then
	    if max(op(l)) > k then
		error("indices in list larger than upper matrix bound")
	    end_if
	else 
	    error("invalid 2nd argument")
	end_if
    end_if;
	
    if domtype(l) = DOM_INT then return( A::col(A,l) ) end_if;
    if domtype(l) = DOM_LIST then
	return( [A::col(A,l[i]) $ i=1..nops(l)] )
    end_if;
    k := op(l,1);
    if k > op(l,2) then return( NIL ) end_if;
    if k = op(l,2) then return( A::col( A,k ) ) end_if;
    [ A::col( A,i ) $ i=k..op(l,2) ]
end_proc:

# end of file #
