# #
# $Date: 1997/03/19 11:20:51 $  $Author: frankp $   $Revision: 1.16 $ #
# #
# frankp, 24/02/94 #

#++
  concat.mu

	linalg::concatMatrix  --  inserts matrices horizontally

	concatMatrix(A [,B,C,...])

	Appends matrices B,C,.. to A horizontally. The matrices
	B,C,... are converted to matrices of type of A.
	If A is of type SquareMatrix then A is converted to Matrix.
++#

linalg::concatMatrix := proc(A)
    name linalg::concatMatrix;
    local r, B, t, p;
begin
    if testargs() then
	if args(0) < 1 then error("expecting at least one argument") end_if;
	if A::hasProp( Cat::MatrixCat ) <> TRUE then
	    error("first argument is not of 'Cat::MatrixCat'")
	end_if;
	if A::hasProp( Cat::SquareMatrixCat ) then
	    B := A::getSuperDomain(A)
	else
	    B := type(A)
	end_if;
	r := op(A::dimen(A),1);
        for p in [args(2..args(0))] do
	    if not testtype( p,B ) then
		error("types of matrices don't match")
	    end_if;
            if op(p::dimen(p),1) <> r then
                error("order of matrices are not compatible")
            end_if
        end_for
    end_if;

    if args(0) = 1 then return( A ) end_if;

    if A::hasProp( Cat::SquareMatrixCat ) then
	A := A::convert_to( A,A::getSuperDomain(A) )
    end_if;

    r:= A::concatMatrix;
    t:= A::coerce;
    ( A:= r( A,t(p) ) ) $ p in [args(2..args(0))];

    A
end_proc:

# end of file #
