# #
# $Date: 1997/03/19 11:20:52 $  $Author: frankp $   $Revision: 1.11 $ #
# #
# frankp, 1/08/94 #

#++
  delcol.mu

     linalg::delCol(A,p)           -- delete column p of A
     linalg::delCol(A,i..j)        -- delete columns i to j of A 
     linalg::delCol(A,[i1,i2,...]) -- delete columns i1,i2,... of A
++#

linalg::delCol := proc(A,p)
    name linalg::delCol;
    local c;
begin
    if testargs() then
	if args(0) <> 2 then error("expecting 2 arguments") end_if;
	if A::hasProp( Cat::MatrixCat ) <> TRUE then
	    error("first argument is not of 'Cat::MatrixCat'")
	end_if;
	c := op( A::dimen(A),2 );
	if testtype( p,Type::PosInt ) then
	    if p > c then
		error("index out of range")
	    end_if
	elif type(p) = "_range" then
	    if not testtype( op(p,1),Type::PosInt )
	    or not testtype( op(p,2),Type::PosInt )
	    then
		error("expecting range of positive integers")
	    end_if;
	    if op(p,1) > c or op(p,2) > c then
		error("range larger than upper matrix bound")
	    end_if
        elif testtype(p,Type::ListOf(Type::PosInt,1)) then
            if max(op(p)) > c then
                error("indices in list larger than upper matrix bound")
            end_if
	else
	    error("invalid 2nd argument")
	end_if
    end_if;

    if type(p) = "_range" then
	if op(p,1) >= op(p,2) then return( A ) end_if;
	if op(p,2) - op(p,1) = op( A::dimen(A),2 ) - 1 then
	    return( NIL )
	end_if;

	for c from op(p,1) to op(p,2) do
	    A := A::delCol(A,op(p,1))
	end_for
    elif domtype(p) = DOM_LIST then
	p := sort(p,_not@_less);
	for c in p do
	    A := A::delCol(A,c);
	    if domtype(A) = DOM_IDENT then break end_if
	end_for;
	if domtype(A) = DOM_IDENT then NIL else A end_if
    else
	A::delCol(A,p)
    end_if
end_proc:

# end of file #
