# #
# $Date: 1997/03/19 11:20:58 $  $Author: frankp $   $Revision: 1.16 $ #
# #
# frankp, 21/02/94 #

#++
  gausselim.mu

    linalg::gaussElim  --  two-step fraction-free Gaussian elimination

    gaussElim(A)     - returns A in upper triangular form
    gaussElim(A,All) - returns [A,rank(A),det(A),ci] where A is in
		       upper triangular form and ci is the set of
		       characteristic column indices of A.
++#

linalg::gaussElim := proc(A)
    name linalg::gaussElim;
begin
    if testargs() then
	if args(0) < 1 or args(0) > 2 then 
	    error("expecting 1 or 2 arguments")
	end_if;
	if A::hasProp( Cat::MatrixCat ) <> TRUE then
	    error("first argument is not of 'Cat::MatrixCat'")
	end_if;
        if not (A::coeffRing)::hasProp( Cat::IntegralDomain ) then
            error("expecting matrix over 'Cat::IntegralDomain'")
        end_if;
	if args(0) = 2 then
	    if args(2) <> hold(All) then
		error("expecting 'All' as option")
	    end_if
	end_if
    end_if;
    
    if args(0) = 2 then A::gaussElim(A) else op( A::gaussElim(A),1 ) end_if
end_proc:

# end of file #
