# #
# $Date: 1997/05/23 13:44:27 $  $Author: frankp $   $Revision: 1.1 $ #
# #
# keady #

#++
  hessian.mu

        linalg::hessian -- computes the hessian of a scalar function over fields

        hessian(x,m)

        x       : expression (the scalar function)
        m       : list or vector of variables 

	This function computes the hessian of 'x'.
        'linalg::hessian' operates on the cartesian coordinate system. 
        Hence the result is the matrix
	jacobian(grad(x,m)[i],m[j]) as i,j range over the length of 'm'.

	If 'x' is in R then R has to provide a method "diff".
++#

linalg::hessian:= proc( x,m )
    name linalg::hessian;
begin
    if testargs() then
        if args(0) <> 2 then error("expecting 2 arguments") end_if;
        if not testtype( m,Type::ListOfIdents() ) and not testtype( m,linalg::VectorOf(Type::AnyType) ) then
            error("2nd argument must be a list or vector of variables")
        end_if
    end_if;

    linalg::jacobian( linalg::grad(x,m),m )
end_proc:

# end of file #

