# #
# $Date: 1997/09/08 13:33:59 $  $Author: frankp $   $Revision: 1.1 $ #
# #

#++
       inverseLU(A) -- computes the inverse of A using an LU decomposition.


Authors: Eduard Niess, Werner M. Seiler, Uni Karlsruhe
Date created: May 23rd, 1996
Last update: August 10th, 1997
++#

linalg::inverseLU:= proc(A)
    local Alu,dim,maxR,maxC,v,res,i,Mat,DOne;
begin
    if A::hasProp(Cat::MatrixCat) then
        if not (A::coeffRing)::hasProp(Cat::Field) then
            error("expecting matrix over Cat::Field")
        end_if;
	dim := A::dimen(A);
	maxR := dim[1];
	maxC := dim[2];
    else 
        error("expecting argument of category Cat::MatrixCat")
    end_if;

    DOne:= (A::coeffRing)::one;
    Mat:= A::newThis;
    res := Mat(maxC,maxC);
    Alu := linalg::factorLU(A);

    for i from 1 to maxR do
	v := Mat(maxC, 1);
	v[i,1]:=DOne;
	res := res::setCol(res,i,linalg::linearSolveLU(op(Alu,1),op(Alu,2),v));
    end_for;

    (res, op(Alu, 3));
end_proc:

# end of file #
