# #
# $Date: 1997/03/19 11:21:00 $  $Author: frankp $   $Revision: 1.6 $ #
# #
# frankp, 06/02/95 #

#++
  isherm.mu

        linalg::isHermitian -- test for Hermitian matrices

        isHermitian(A)

        A: square matrix

	This function returns TRUE if A is Hermitian and FALSE otherwise.
	A is a Hermitian matrix iff conjugate(transpose(A)) = A.

	When the domain of \Mpar{A} does not provide the 
	method \Mfunc{conjugate}, then \Mpar{A} will be tested to be 
	symmetric.
++#

linalg::isHermitian := proc(x)
    local d;
begin
    if testargs() then
	if args(0) <> 1 then error("expecting 1 argument") end_if;
	if x::hasProp( Cat::MatrixCat ) <> TRUE then
	    error("argument is not of 'Cat::MatrixCat'")
	end_if;
	d:= x::dimen(x);
	if op(d,1) <> op(d,2) then
	    error("expecting a square matrix")
	end_if
    end_if;
   
    d:= x::conjugate;
    if d = FAIL then
	x::equal( x,x::transpose(x) )
    else
        x::equal( x, x::transpose(d(x)) )
    end_if
end_proc:

# end of file #
