# #
# $Date: 1997/03/19 11:21:05 $  $Author: frankp $   $Revision: 1.12 $ #
# #
# frankp, 28/10/94 #

#++
  normaliz.mu

	linalg::normalize -- normalizes vectors over fields
			     using the 2-norm


	normalize(v)

	v: vector

	This function normalizes v.
	An error occurs if v::norm(v,2) returns FAIL.
++#

linalg::normalize:= proc(x)
    local n;
begin
    if testargs() then
	if args(0) <> 1 then error("expecting 1 argument") end_if;
	if not testtype( x,linalg::VectorOf(Type::AnyType) ) then
	    error("expecting a vector")
	end_if;
	if not (x::coeffRing)::hasProp( Cat::Field ) then
	    error("expecting vector over 'Cat::Field'")
	end_if
    end_if;

    n:= x::norm(x,2);
    if n = FAIL then
 	error("unable to normalize the vector over ".expr2text(x::coeffRing))	
    else
	x::_mult(x,1/n)
    end_if
end_proc:

# end of file #
