# #
# $Date: 1997/03/19 11:21:10 $  $Author: frankp $   $Revision: 1.16 $ #
# #
# frankp, 21/06/94 #

#++
  setcol.mu

	linalg::setCol(A,p,c)  --  sets column p of A to column c

	A: matrix
	c: expression
	p: positive integer
++#

linalg::setCol := proc(A,p,c)
    name linalg::setCol;
    local T, t;
begin
    if testargs() then
	if args(0) <> 3 then error("expecting 3 arguments") end_if;
	if A::hasProp( Cat::MatrixCat ) <> TRUE then
	    error("first argument is not of 'Cat::MatrixCat'")
	end_if;
	if not testtype( p,Type::PosInt ) then
	    error("index must be a positive integer")
	end_if;
	if p > op( A::dimen(A),2 ) then
	    error("index out of range")
	end_if;
	if A::hasProp( Cat::SquareMatrixCat ) then
	    T := Dom::Matrix(A::coeffRing)
	else
	    T := domtype(A)
	end_if;
	if T <> domtype(c) then
	    if (c:= T::coerce(c)) = FAIL then
	        error("3rd argument is not a valid column")
	    end_if
	end_if;
	t := c::dimen(c);
	if op(t,2) <> 1 or op(t,1) > op(A::dimen(A),1) then
	    error("wrong size of column vector")
	end_if
    end_if;

    if A::hasProp( Cat::SquareMatrixCat ) then T := Dom::Matrix(A::coeffRing)
    else T := domtype(A)
    end_if;
    if T <> domtype(c) then c:= T::coerce(c) end_if;
	
    A::setCol( A,p,c )
end_proc:

# end of file #
