# #
# $Date: 1997/03/19 11:21:11 $  $Author: frankp $   $Revision: 1.15 $ #
# #
# frankp, 17/08/94 #

#++
  stack.mu

	linalg::stackMatrix  --  inserts matrices vertically 

	stackMatrix(A [,B,C,...])

	Appends matrices B,C,.. to A vertically. The matrices
        B,C,... are converted to matrices of type of A.
        If A is of type SquareMatrix then A is converted to Matrix.

++#

linalg::stackMatrix := proc(A)
    name linalg::stackMatrix;
    local c, B, t, p;
begin
    if testargs() then
        if args(0) < 1 then error("expecting at least one argument") end_if;
        if A::hasProp( Cat::MatrixCat ) <> TRUE then
            error("first argument is not of 'Cat::MatrixCat'")
        end_if;
       if A::hasProp( Cat::SquareMatrixCat ) then
            B:= A::getSuperDomain(A)
        else
            B:= type(A)
        end_if;
        c:= op(A::dimen(A),2);
        for t in [args(2..args(0))] do
            if not testtype( t,B ) then
                error("types of matrices don't match")
            end_if;
            if op(t::dimen(t),2) <> c then
                error("order of matrices are not compatible")
            end_if
        end_for
    end_if;

    if args(0) = 1 then return( A ) end_if;

    if A::hasProp( Cat::SquareMatrixCat ) then
        A:= A::convert_to( A,A::getSuperDomain(A) )
    end_if;

    c:= A::stackMatrix;
    t:= A::coerce;
    ( A:= c( A,t(p) ) ) $ p in [args(2..args(0))];

    A
end_proc:

# end of file #
