# $ Author: $ $ Date: $ $ Revision: $ #

#++ linalg::wiedemann(A,b,mult)           
  
    solves linear system Ax=b 

    A -- square matrix 
    b -- column vector
    mult -- function that returns A*x for each column vector x 

++#

 
linalg::reverse:=fun
(
	_plus(multcoeffs(poly(op(args(1),[2,1])^(args(2)-j),
	op(args(1),2..3)),coeff(args(1),j) ) $ hold(j)=0..degree(args(1)))
	
):




linalg::minpoly:=proc(sequence,x,F)
local n,r,rnew,t,tnew,aux,q,e;
begin
if not contains({op(map(sequence,iszero))},FALSE) then 

	userinfo(1,"Result not reliable because zero sequence passed");
	return(poly(0,[x],F));
 end_if;
n:=nops(sequence) div 2;
r:=poly(x^(2*n),F);
rnew:=_plus(poly(sequence[j+1],[x],F)*poly(x^j,[x],F) $ hold(j)=0..2*n-1);
t:=poly(0,[x],F); 
tnew:=poly(1,[x],F);
repeat
	aux:=divide(r,rnew);   # gives quotient and remainder #
	r:=rnew;
	rnew:=op(aux,2);
	q:=op(aux,1);
	aux:=t;
	t:=tnew;
	tnew:=aux-q*t;
until degree(rnew)<n end_repeat;
e:=max(degree(rnew)+1-degree(linalg::reverse(tnew,degree(tnew))),0);
return(poly(x^e,[x],F)*linalg::reverse(tnew,degree(tnew)));
end_proc:
	




linalg::minpolyAb:=proc(A,b,lambda,K,n,abpow)
local i,M,j,u,bb,a,fu;

begin
M:=Dom::Matrix(K);
a:=array(0..2*n-1);
while TRUE do
	u:=M(1,n,[[K::random() $ hold(j)=1..n]]);
	userinfo(3,"Trying u=",u);
	# compute all uA^ib #
	for j from 0 to 2*n-1 do
		# here abpow=A^j b #
		a[j]:=op(u*abpow[j],[1,1]);   # gives a field element #
				   # u*abpow is a 1x1-Matrix #
	end_for;


	fu:=linalg::minpoly([a[i] $ hold(i)=0..2*n-1],lambda,K);
	if degree(fu)=n then return(fu); end_if;

	bb:=_plus(coeff(fu,j)*abpow[j] $ hold(j)=0..degree(fu)); 
	if iszero(bb) then return(fu); end_if;
# next try #
end_while	
end_proc:




 


linalg::wiedemann:=proc(A,b,mult)
local m,x,abpow,F,d,M,j;

begin
M:=domtype(A);
F:=A::coeffRing;
if F::hasProp=FAIL or F::hasProp(Cat::Field)=FALSE then
	error("coefficient ring must be a field")
end_if;
d:=op(M::dimen(A),1);
if iszero(b) then return(b); end_if;
abpow:=array(0..2*d-1);
abpow[0]:=b;
for j from 0 to 2*d-2 do
        # here abpow=A^j b #
        abpow[j+1]:=mult(A,abpow[j]); 
end_for;

m:=linalg::minpolyAb(A,b,hold(x),F,d,abpow);
if iszero(coeff(m,0)) then 
	userinfo(2,"No solution exists");
	return(FAIL);
end_if;
return(-F::_invert(coeff(m,0))*
    _plus(coeff(m,k)*abpow[k-1] $ hold(k)=1..degree(m) ) );
end_proc:

