
linopt::Land_Doig := proc(f, cons, cond, int_cons)
   local all_add, best_int, cnt1, cnt2, cnt3, cnt4,
         status, pool, execute_task, L1, L2;
begin

   # Lokale Prozeduren in linopt::Land_Doig #

   execute_task := proc(int_cons)
      local added, add_cons, add_tasks, c, cmp,
            new_tasks, create_task, eqn, i, j,
            non_int, s, task, task2, v, x;     
    
   begin 

      # Lokale Prozeduren in execute_task #

      cmp := proc(a, b) 
          begin bool( a[5] < b[5] ) end_proc:

      create_task := proc(f, cons, cond, add_cons, v, new_con)
          local eqn, op_new_con, x;
      begin
          x := op(new_con, 1); op_new_con := op(new_con, 0);
          for eqn in add_cons do
             if op(eqn, 1) = x and op(eqn, 0) = op_new_con then
                add_cons := add_cons minus {eqn};
                break;
             end_if
          end_for;
          [ f, cons, cond, add_cons union {new_con}, v ]
      end_proc:

      add_tasks := proc(all_add, add_cons, v)
      begin 
          if not contains(all_add, add_cons) then
             if best_int[1] <> {} then
                if v > best_int[2] then
                   cnt4 := cnt4 + 1;
                   return(FALSE)
                end_if
             end_if;
             TRUE
          else
             cnt4 := cnt4 + 1;
             FALSE
          end_if;
      end_proc:
   
      # Hauptprogramm #

       
      Lock::lock(L1);

         if pool = [] then Lock::unlock(L1); return() end_if;

         cnt1 := cnt1 + 1;

         task := pool[1]; # Aufgabe mit kleinstem Zielfunktionswert #
         pool[1] := NIL; # Loesche die Aufgabe aus dem Pool #

      Lock::unlock(L1);

      f    := task[1]; cons := task[2];
      cond := task[3]; add_cons := task[4];

      s := linopt::minimize_generic(f, cons union add_cons, cond);

      if s  = {} or s = hold(UNBOUNDED) or s = FAIL then 
         return( s )
      end_if;

      # s <> {} #

      # Speichere nicht ganzzahlige Komponenten, die auch in #
      # der Menge 'int_cons' vorhanden sind, der Loesung 's' #
      # in der Liste 'non_int'.                              #

      non_int := [];
      for eqn in s do 
          # eqn: x = c #
          x := op(eqn, 1); c := op(eqn, 2);
          if type(c) <> DOM_INT and contains(int_cons, x) then
             non_int := append(non_int, [x,c])
          end_if
      end_for;

      v := subs(f, s); # Zielfunktionswert dieser Aufgabe #

      if non_int = [] then

         # Ganzzahlige Loesung bzgl. der Variablen #
         # 'int_cons' gefunden                     #

         userinfo(2, "Integer solution found: ".expr2text(s));

         Lock::lock(L2);

            if best_int[1] = {} then
               # Erste ganzzahlige Loesung gefunden #
               best_int := [ s, v ]
            elif v < best_int[2] then
               # Diese ganzzahlige Loesung ist die bisher Beste #
               best_int := [ s, v ]
            else
               # Ist v >= best_int[2], so ist der Zielfunktionswert v #
               # dieser ganzzahligen Loesung s groesser und somit     #
               # schlechter als der bislang beste, d.h. kleinste Ziel-#
               # funktionswert best_int[2] der ganzahligen Loesung    #
               # best_int[1]. Diese Aufgabe wird daher nicht weiter   #
               # aufgeteilt.                                          #
               Lock::unlock(L2); return()
            end_if;

         Lock::unlock(L2);


         Lock::lock(L1);

            # Streichung aller Aufgaben im Pool, deren Zielfunk-   #
            # tionswert groesser ist als best_int[2]               #
   
            j := 0;
            for i from 1 to nops(pool) do
                task := pool[i-j]; 
                if task[5] > best_int[2] then

                   pool[i-j] := NIL; j := j + 1;

                   userinfo(4, "The following task with the additional constraints");
                   userinfo(4, task[4]);
                   userinfo(4, "is rejected, because the value of the objective");
                   userinfo(4, "function is greater than the value of the integer");
                   userinfo(4, "solution found so far.");
                   cnt3 := cnt3 + 1;

                end_if
            end_for;

         Lock::unlock(L1);

     else # non_int <> [], d.h. Loesung s ist nicht-ganzzahlig. #

         
         new_tasks := 0;

         for eqn in non_int do
 
             x := eqn[1]; c := floor(eqn[2]); 

             Lock::lock(L2);
                added := add_tasks(all_add, add_cons union {x <= c}, v);
             Lock::unlock(L2);

             if added then

                task := create_task( f, cons, cond, add_cons, v, x <= c);
                task2 := create_task( f, cons, cond, add_cons, v, x >= c+1);

                Lock::lock(L1);

                   pool := insert_ordered(task, pool, cmp);
                   pool := insert_ordered(task2, pool, cmp);

                   cnt2 := cnt2 + 2; 

                Lock::unlock(L1);

                new_tasks := new_tasks + 2;

                Lock::lock(L2);

                   all_add := all_add union { add_cons union {x <= c  } };
                   all_add := all_add union { add_cons union {x >= c+1} };

                Lock::unlock(L2);

                userinfo(4, "Generating 2 tasks with additional constraints");
                userinfo(4, add_cons union {x <= c  }, add_cons union {x >= c+1});
             else

                userinfo(4, "The following tasks with the additional constraints");
                userinfo(4, add_cons union {x <= c  }, add_cons union {x >= c+1});
                userinfo(4, "are rejected, because they are already computed");
                userinfo(4, "or the value of the objective function is greater");
                userinfo(4, "than value of the integer solution found so far.");

                Lock::lock(L2); cnt4 := cnt4 + 2; Lock::unlock(L2);

             end_if

         end_for;

         for i from 1 to new_tasks parallel
             private status;

             status := execute_task(int_cons);
             if status = hold(UNBOUNDED) or status = FAIL then
                return(status)
             end_if

         end_for

     end_if

   end_proc;

   # Hauptprogramm #
 
   userinfo(1, "Searching for an integer solution.");
   userinfo(1, "Entering Land/Doig algorithm.");
 
   # Der exklusive Zugriff auf die globalen Variablen pool, cnt1,   #
   # cnt2 und cnt3 wird durch den Lock L1 realisiert, der exklusive #
   # Zugriff auf die globalen Variablen all_add, best_int und cnt4  #
   # wird durch den Lock L2 realisiert.                             #

   # Initialisiere den Aufgaben-Pool #
  
   pool := [ [ f, cons, cond, {} ] ];
 
   # Bislang beste ganzzahlige Loesung #
 
   best_int := [ {} ];
 
   # Menge aller bisherigen zusaetzlichen Restriktionen #
 
   all_add := {};
 
   # Task-Counter fuer statistische Zwecke #
 
   cnt1 := 0; cnt2 := 1; cnt3 := 0; cnt4 := 0;

   # Initialisiere die Locks #

   L1 := Lock::linit(); L2 := Lock::linit();  
 
   status := execute_task(int_cons);

   userinfo(3, "Tasks generated: ".cnt2);
   userinfo(3, "Tasks executed : ".cnt1);
   userinfo(3, "Tasks rejected");
   userinfo(3, "- from the pool           : ".cnt3);
   userinfo(3, "- before entering the pool: ".cnt4);

   if status = hold(UNBOUNDED) or status = FAIL then
      status
   else
      best_int[1]
   end_if;

end_proc:
