# #
# $Date: 1997/10/07 08:29:25 $  $Author: wseiler $   $Revision: 1.3 $ #
# #
#
Merging of two ordered list.
If third argument is given, it is used for comparing elements.
Otherwise _less is used.

Authors: Eduard Niess, Werner M. Seiler, Uni Karlsruhe
Date created: May 23rd, 1996
Last update: September 27th, 1997
#

listtools::merge:= proc(l1:DOM_LIST,l2:DOM_LIST):DOM_LIST
    local comp,res,i,k;
begin
    case args(0)
    of 2 do
	comp := _less;
        break;
    of 3 do
        comp := args(3);
        break;
    otherwise error("wrong number of arguments");
    end_case;

    # trivial cases #
    i := nops(l1);
    k := nops(l2);
    if l1=[] then return(l2)
    elif l2=[] then return(l1)
    elif comp(l1[i],l2[1]) then return(l1.l2)
    elif comp(l2[k],l1[1]) then return(l2.l1)
    end_if;

    res := [ 0 $ i+k];
    i := 0;
    while l1<>[] do
        if l2=[] then
            return([op(res,1..i)].l1);
        end_if;
        while l2<>[] and comp(l2[1],l1[1]) do
	    i := i+1;
            res[i] := l2[1];
            l2[1] := NIL;
        end_while;
        if l2=[] then next end_if;
	i := i+1;
        res[i] := l1[1];
        l1[1] := NIL;
    end_while;
    if l2<>[] then [op(res,1..i)].l2 else res end_if;
end_proc:

# end of file #
