# $Date: 1995/08/03 15:07:40 $ $Author: kamo $ $Revision: 1.1 $ #
# kamo, 1995/08/03 #
#++
 misc::CheckExample - checks automatically generated input and output files

 misc::checkexample("manual.tstin", "manual.tstout")

 Gives TRUE, if the examples in "manual.tstin" return the corresponding 
 entry in "manual.tstout". Otherwise FALSE.
++#

misc::checkexample := proc(Infile, Outfile)
local i,j,Iin,Iout,Del,fin,fout,line,Tin,Tout,errlist;
begin
if args(0) <> 2 then
   error("Wrong number of arguments (two expected)!")
end_if;

if not testtype(Infile, DOM_STRING) or not testtype(Infile, DOM_STRING) then
   error("Arguments must be strings!");
end_if;

if (fin := fopen(Infile)) = FAIL or (fout := fopen(Outfile)) = FAIL then
   error("Can't open file!");
end_if;

Del := "<<<>>>";
i := 1;

while (line := ftextinput(fin)) <> null() do
   if strmatch(line,Del) then next end_if;
   Tin[i] := substring(line, 0, strlen(line)-1);
   i := i+1;
end_while;
fclose(fin);
Iin := i-1:

i := 1;
while (line := ftextinput(fout)) <> null() do
   if strmatch(line, Del) then next end_if;
   Tout[i] := line;
   i := i+1;
end_while;
fclose(fout);
Iout := i-1;

if Iin <> Iout then
   error("Number of input and output examples differ!");
end_if;

errlist := []:
for j from 1 to i-1 do 
   if eval(text2expr(Tin[j])) <> text2expr(Tout[j]) then
	errlist := append(errlist, j);
	print(Unquoted, "Error in example ".j.":\n".Tin[j]." = ".expr2text(eval(text2expr(Tin[j])))." <> ".Tout[j]);
   end_if;
end_for;
if errlist = [] then
   return(TRUE)
else
   return(FALSE)
end_if;
end_proc:
