# $Date: 1997/08/20 13:08:17 $ $Author: stefanw $ $Revision: 1.1 $ #

numeric::bisect:=proc(f, range:"_range")
local a,b,s,midpoint,signleft,signright;

begin
a:=float(op(range,1));
b:=float(op(range,2));
if iszero((signleft:=sign(f(a)))) then 
	return(a)
end_if;
if iszero((signright:=sign(f(b)))) then
	return(b)
end_if;
if signleft*signright=1 then 
	error("Function values have the same sign")
elif signleft*signright<>-1 then
	error("Function could not be evaluated")
end_if;
repeat
	midpoint:=a+(b-a)/2;
	s:=sign(f(midpoint));
	if iszero(s) then return(midpoint) end_if;
	if s=signleft then
		a:=midpoint
	elif s=signright then
		b:=midpoint
        else 
		error("Function could not be evaluated")
	end_if;
	userinfo(3, "Working on interval [".expr2text(a).",".expr2text(b)."]");
until abs(b-a) < 10^(-DIGITS) end_repeat;
midpoint
end_proc:



