# #
# $Date: 1997/10/13 10:44:42 $  $Author: olli $   $Revision: 1.10 $ #
# #

#++
	returns an approximation of *all* roots of p in a..b up to
	precision eps where a and b are DOM_FLOAT with a<=b

>> numeric::fsolve((x^2 - 1)^2,x,-6,6,0.01);

                   -513/512..-255/256, 255/256..513/512

>> numeric::fsolve(5*x-20*x^3+16*x^5, x,-6,6,0.01);

-249/256..-237/256, -309/512..-147/256, -3/512..3/512, 147/256..309/512,

237/256..249/256
++#

numeric::fsolve := proc(p,x,a,b)
begin
   # if type(eval(subs(p,x=Dom::Interval(a..b))))<>Dom::Interval then #
   if type(subs(p,x=Dom::Interval(a..b),Simplified))<>Dom::Interval then
      error("cannot evaluate to interval")
   end_if;
   p:=[numeric::fsolve2(args())];
   # now merges intervals with common bounds #
   a:=1; while a<nops(p) do
      for b from a+1 to nops(p) do
         if op(p[b-1],2)<>op(p[b],1) then break end_if
      end_for;
      p[a]:=op(p[a],1)..op(p[b-1],2);
      for b from a+1 to b-1 do p[a+1]:=NIL end_for;
      a:=a+1
   end_while;
   op(p)
end_proc:

numeric::fsolve2 := proc(p,x,a,b,eps)
   local c,i;
begin
   if abs(b-a)<eps then
      # if eval(subs(p,x=a)*subs(p,x=b))<=0 then a else null() end_if #

      # i:=eval(subs(p,x=Dom::Interval(a..b))); #
      i:=subs(p,x=Dom::Interval(a..b),Simplified);
      if sign(i)=0 then a..b else null() end_if
   else
      # i:=eval(subs(p,x=Dom::Interval(a..b))); #
      i:=subs(p,x=Dom::Interval(a..b),Simplified);
      if sign(i)=0 then
         c:=(a+b)/2; 
         numeric::fsolve2(p,x,a,c,eps),numeric::fsolve2(p,x,c,b,eps)
      else null()
      end_if
   end_if
end_proc:

# end of file #
