# 
numeric::minpoly(a,n) finds a polynomial of degree n which has one root
	near from a (up to DIGITS digits)

Examples:
>> numeric::minpoly(PI,3);

                                    2       3
                   poly(36 x + 114 x  - 37 x  - 91, [x])

>> float(sqrt(2)+sqrt(3));

                                3.146264369


>> numeric::minpoly(%,4);

                               4       2
                         poly(x  - 10 x  + 1, [x])
#

numeric::minpoly:=proc(a,n) local i,x; begin		
   a:=float(a);
   if type(a)<>DOM_FLOAT then error("float expected") end_if;
   lllint([[0$i,1,0$(n-i)]$i=0..n,[round(a^(i-1)*10^DIGITS)$i=0..n]],All)[2];
   poly(_plus(%[i+1][1]*x^i$i=0..n))
end_proc:
