#++ ---------------- mkODE.mu ---------------------
(extracted from tools.mu by Paul Zimmermann)

Author: Winfried Fakler,  University of Karlsruhe
Date Created: 13 September 1996
Last Update :  8 November  1996

 - ode::mkODE([a_i], y, x)
    ++ returns a linear homogenous differential equation Ly in y(x), 
    ++ where the last element of the list [a_i] corresponds to
    ++ the leading coefficient of Ly.

>> ode::mkODE([-1,4*x,4*x^2], y, x);

                                            2
            - y(x) + 4 x diff(y(x), x) + 4 x  diff(y(x), x, x)
#

ode::mkODE := proc(coef, y, x)
  begin
    _plus( coef[i+1]*diff(y(x), x$i) $hold(i)=0..nops(coef)-1 )  
  end_proc:


