#++ ---------------- normal.mu ---------------------

Author: Winfried Fakler,  University of Karlsruhe
Date Created: 13 September 1996
Last Update :  8 November  1996

Description:
 - ode::normalize(Ly, y, x, n)
    ++ returns Ly normalized, i.e. the leading coefficient is 1.

 - used Parameter:
    ++ Ly, y(x)   :DOM_EXPR
    ++ y, x       :DOM_IDENT
    ++ n          :DOM_INT

>> ode::normalize(-diff(y(x),x,x)/x+y(x)/4/x^3-diff(y(x),x)/x^2,y,x,2);

                                     y(x)   diff(y(x), x)
                  diff(y(x), x, x) - ---- + -------------
                                        2         x
                                     4 x
++#

ode::normalize:= proc(eq, y, x, n)
  begin
    ode::ode2poly(eq, y, x, n);
    expr(multcoeffs(%, 1/expr(coeff(%, diff(y(x),x$n), 1))))
  end_proc:

