#++ ---------------- ode2poly.mu ---------------------

Author: Winfried Fakler,  University of Karlsruhe
Date Created: 13 September 1996
Last Update :  8 November  1996

Description:
 - ode::ode2poly(Ly, y, x, n)
    ++ converts Ly in a polynomial in the derivations of y(x).

 - used Parameter:
    ++ Ly, y(x)   :DOM_EXPR
    ++ y, x       :DOM_IDENT
    ++ n          :DOM_INT

>> ode::ode2poly(-diff(y(x),x,x)/x+y(x)/4/x^3-diff(y(x),x)/x^2,y,x,2);

    / y(x)   diff(y(x), x)   diff(y(x), x, x)
poly| ---- - ------------- - ----------------,
    |    3         2                x
    \ 4 x         x

                                        \
[y(x), diff(y(x), x), diff(y(x), x, x)] |
                                        |
                                        /
++#

ode::ode2poly:= proc(eq, y, x, n)
  begin
     poly(eq, [diff(y(x), x$k) $hold(k)=0..n ])
  end_proc:     

