#++ ---------------- vectorize.mu ---------------------
(extracted from tools.mu by Paul Zimmermann)

Author: Winfried Fakler,  University of Karlsruhe
Date Created: 13 September 1996
Last Update :  8 November  1996

 - ode::vectorize(Ly, y, x, n)
    ++ returns a list of *all* coefficients of Ly: [a_0, a_1, ... a_n].

Examples:

>> eq := 4*x^2*diff(y(x), x$2)+4*x*diff(y(x),x)-y(x):
>> ode::vectorize(eq,y,x,2);   
                                           2
                              [-1, 4 x, 4 x ]
#

ode::vectorize := proc(eq, y, x, n)
  local k, vars;
  begin
    vars := [diff(y(x), x$k) $hold(k)=0..n ];
    eq := poly(eq, vars);
    [expr(coeff(eq, vars[k], 1)) $hold(k)=1..n+1 ]
  end_proc:

