

#(
   IV     - Domain of numerical property 'Intervall'

   op(IV) - lower border,
            lower border in-/ex-clusion, (0=offen 1=geschlossen)
            upper border,
            lower border in-/ex-clusion, (0=offen 1=geschlossen)
	    NRange: Range of numbers in IV
)#

alias(IV = property::IV):
alias(Arg(x, y) = op(extop(x, 5), y)):
alias(Ar(x) = [5, x]):
alias(Nul = property::Nul):

IV:= domain("property::IV"):
IV::info:= "Domain of numerical property 'Interval of a number'":
IV::domtype:= fun(Type):
IV::type:= "IV":
IV::prop:= TRUE:
IV::propdom:= domattr(property, "IV"):
IV::autoload:= TRUE:
IV::testtype:= Type::testtype:

IV::ax:= []:

IV::new:= 
	proc()
	  local _UG, _UGT, _OG, _OGT, _RG;
	begin
	  if type(args()) = "id" then
	    return(domattr(Type, "Interval")(args()))
	  end_if;
	  _RG:= Type::RealNum;
	  case args(0)
	    of 0 do
	      _UG:= -infinity;
	      _UGT:= 0;
	      _OG:= infinity;
	      _OGT:= 0;
	      break
	    of 1 do
	      if domtype(args(1)) = DOM_LIST then
		if nops(args(1)) = 2 then
		  _UG:= op(args(1), 1); _UGT:= 1;
		  _OG:= op(args(1), 2); _OGT:= 1
		else
		  error("two borders expected")
		end_if
	      else
		error("two borders expected")
	      end_if;
	      break
	    of 2 do
	      if domtype(args(1)) = DOM_LIST then
		if nops(args(1)) = 2 then
		  _UG:= op(args(1), 1); _UGT:= 1;
		  _OG:= op(args(1), 2); _OGT:= 1;
	          _RG:= args(2)
	        else
	          if domtype(args(2)) = DOM_LIST then
	            if nops(args(1)) = 1 and nops(args(2)) = 1 then
	              _UG:= op(args(1)); _UGT:= 1;
	              _OG:= op(args(2)); _OGT:= 1
	            else
	              error("two borders expected")
	            end_if
	          else
	            if nops(args(1)) = 1 then
	              _UG:= op(args(1)); _UGT:= 1;
	              _OG:= args(2); _OGT:= 0
	            else
	              error("two borders expected")
	            end_if
	          end_if
	        end_if
	      else
	        _UG:= args(1); _UGT:= 0;
	        if domtype(args(2)) = DOM_LIST then
	          if nops(args(2)) = 1 then
	            _OG:= op(args(2)); _OGT:= 1
	          else
	            error("two borders expected")
		  end_if
	        else
	          _OG:= args(2); _OGT:= 0
	        end_if
	      end_if;
	      break
	    of 3 do
	      if domtype(args(1)) = DOM_LIST then
	        _UG:= op(args(1), 1); _UGT:= 1
	      else
	        _UG:= args(1); _UGT:= 0
	      end_if;
	      if domtype(args(2)) = DOM_LIST then
	        _OG:= op(args(2), 1); _OGT:= 1
	      else
	        _OG:= args(2); _OGT:= 0
	      end_if;
	      _RG:= args(3);
	      break
	    otherwise
	      error("illegal arguments")
	  end_case;
	  if property::_is(_UG > _OG) = TRUE then
	    error("illegal arguments")
	  end_if;
	  if _UG = -infinity then _UGT:= 0 end_if;
	  if _OG = infinity then _OGT:= 0 end_if;
	  domattr(Type, "Interval")(hold(id)([_UG, _UGT, _OG, _OGT, _RG]))
	end_proc:

#( IV::is((a, b, rg), (a', b', rg')) )#
#( TRUE, wenn a' < a und  b < b';   FALSE, wenn b < a' oder b' < a )#
#(            [[ <=                            [[ <                )#
#(            [( <=                            [( <=               )#
#(            (( <=                            (( <=               )#
#(            ([ <                             ([ <=               )#
IV::is:=
	proc()
	  local __op1, __op2;
	begin
	  if type(args(1)) <> "IV" or type(args(2)) <> "IV" then
	    return(UNKNOWN)
	  end_if;

	  __op1:= op(_leequal(_less),
		   Arg(args(1), 2)*Arg(args(2), 4));
	  __op2:= op(_leequal(_less),
		   Arg(args(1), 4)*Arg(args(2), 2));

	  #( falsche Grenzen )#
	  if property::_is(Arg(args(2), 3) &__op1 Arg(args(1), 1)) = TRUE
	     or property::_is(Arg(args(1), 3) &__op2 Arg(args(2), 1)) = TRUE then
	    return(FALSE)
	  end_if;

	  __op1:= op(_leequal(_less),
		   min(Arg(args(1), 2), 1 - Arg(args(2), 2)));
	  __op2:= op(_leequal(_less),
		   min(Arg(args(1), 4), 1 - Arg(args(2), 4)));

	  #( nur f"ur numerische Typen )#
	  #return((UNKNOWN or (bool(Arg(args(2), 1) &__op1 Arg(args(1), 1))#
		              #and bool(Arg(args(1), 3) &__op2 Arg(args(2), 3))))#
		 #and property::isprop(Arg(args(1), 5), Arg(args(2), 5)));#

	  return((UNKNOWN or
	          ((property::_is(Arg(args(2), 1) &__op1 Arg(args(1), 1))) and
	           (property::_is(Arg(args(1), 3) &__op2 Arg(args(2), 3))))
	          )
	         and property::isprop(Arg(args(1), 5), Arg(args(2), 5)))
	end_proc:

#( Type::Constant )#
IV::constant:=
	proc()
	begin
	  if Arg(args(), 2)*Arg(args(), 4) = 1 then
	    if property::_is(Arg(args(), 1) = Arg(args(), 3)) then
	      property::_is(Arg(args(), 1), Type::Constant)
	    end_if
	  else
	    UNKNOWN
	  end_if;
	end_proc:

#( Schnitt beider Mengen )#
IV::_and:=
	proc()
	begin
	  property::_Op(IV, _and,
	    proc()
	      local _UG, _UGT, _OG, _OGT, _i;
	    begin
	      #( nur zwei Grenzen )#
	      if Arg(args(1), 1) = -infinity and Arg(args(2), 3) = infinity then
	        return(subsop(args(1), Ar(1) = Arg(args(2), 1),
	                               Ar(2) = Arg(args(2), 2),
	                      Ar(5) = _and(Arg(args(1), 5), Arg(args(2), 5))))
	      end_if;
	      if Arg(args(2), 1) = -infinity and Arg(args(1), 3) = infinity then
	        return(subsop(args(2), Ar(1) = Arg(args(1), 1),
	                               Ar(2) = Arg(args(1), 2),
	                      Ar(5) = _and(Arg(args(1), 5), Arg(args(2), 5))))
	      end_if;
	      #( Schnitt leer )#
	      if property::_is(_if(Arg(args(2), 4)*Arg(args(1), 2) = 0,
	                           _leequal, _less)(Arg(args(2), 3),
	                           Arg(args(1), 1))) = TRUE or
	         property::_is(_if(Arg(args(2), 2)*Arg(args(1), 4) = 0,
	                           _leequal, _less)(Arg(args(1), 3),
	                           Arg(args(2), 1))) = TRUE then
	        return(hold(_and)(args()))
	      end_if;
	      #( infinity gr"o"ser als Obergrenze )#
	      if (_i:= contains([Arg(args(1), 1),
	                         Arg(args(2), 1)], infinity)) > 0 then
	        _UG:= Arg(args(3 - _i), 1);
	        _UGT:= Arg(args(3 - _i), 2)
	      #( -infinity kleiner als Untergrenze )#
	      elif (_i:= contains([Arg(args(1), 1),
	                           Arg(args(2), 1)], -infinity)) > 0 then
	        _UG:= Arg(args(3 - _i), 1);
	        _UGT:= Arg(args(3 - _i), 2)
	      #( max der UG )#
	      else
	        if property::_is(Arg(args(1), 1)
	                         < Arg(args(2), 1), "<") = TRUE then
	          _UG:= Arg(args(2), 1);
	          _UGT:= Arg(args(2), 2)
	        elif property::_is(Arg(args(2), 1)
	                           < Arg(args(1), 1), "<") = TRUE then
	          _UG:= Arg(args(1), 1);
	          _UGT:= Arg(args(1), 2)
	        elif property::_is(Arg(args(1), 1)
	                           = Arg(args(2), 1), "<") = TRUE then
	          _UG:= Arg(args(1), 1);
	          _UGT:= Arg(args(1), 2)*Arg(args(2), 2)
	        else
	          _UG:= UNKNOWN
	        end_if
	      end_if;
	      #( min der OG )#
	      if (_i:= contains([Arg(args(1), 3),
	                         Arg(args(2), 3)], -infinity)) > 0 then
	        _OG:= Arg(args(_i), 3);
	        _OGT:= Arg(args(_i), 4)
	      #(  )#
	      elif (_i:= contains([Arg(args(1), 3),
	                           Arg(args(2), 3)], infinity)) > 0 then
	        _OG:= Arg(args(3 - _i), 3);
	        _OGT:= Arg(args(3 - _i), 4)
	      #(  )#
	      else
	        if property::_is(Arg(args(1), 3)
	                         < Arg(args(2), 3), "<") = TRUE then
	          _OG:= Arg(args(1), 3);
	          _OGT:= Arg(args(1), 4)
	        elif property::_is(Arg(args(2), 3)
	                           < Arg(args(1), 3), "<") = TRUE then
	          _OG:= Arg(args(2), 3);
	          _OGT:= Arg(args(2), 4)
	        elif property::_is(Arg(args(1), 3)
	                           = Arg(args(2), 3), "<") = TRUE then
	          _OG:= Arg(args(1), 3);
	          _OGT:= Arg(args(1), 4)*Arg(args(2), 4)
	        else
	          _OG:= UNKNOWN
	        end_if
	      end_if;
	      #(  )#
	      if contains({_UG, _OG}, UNKNOWN) then
	        return(hold(_and)(args()))
	      elif property::_is((_if(_UGT*_OGT = 0,
	                            _less, _leequal))(_UG, _OG)) = FALSE then
	        return(hold(_and)(args()))
	      else
	        return(IV(hold(id)([_UG, _UGT, _OG, _OGT,
		                   _and(Arg(args(1), 5), Arg(args(2), 5))])))
	      end_if
	    end_proc, args())
	end_proc:

#( Vereinigung beider Mengen )#
IV::_or:=
	proc()
	begin
	  property::_Op(IV, _or,
	    proc()
	      local _UG, _UGT, _OG, _OGT, _i;
	    begin
	      if property::_is(_if(Arg(args(2), 4)*Arg(args(1), 2) = 0,
	                           _leequal, _less)(Arg(args(2), 3),
	                           Arg(args(1), 1))) = TRUE or
	         property::_is(_if(Arg(args(2), 2)*Arg(args(1), 4) = 0,
	                           _leequal, _less)(Arg(args(1), 3),
	                           Arg(args(2), 1))) = TRUE then
	        return(hold(_or)(args()))
	      end_if;

	      if (_i:= contains([Arg(args(1), 1),
	                         Arg(args(2), 1)], infinity) > 0) then
	        _UG:= Arg(args(3 - _i), 1);
	        _UGT:= Arg(args(3 - _i), 2)
	      elif contains([Arg(args(1), 1),
	                     Arg(args(2), 1)], -infinity) > 0 then
	        _UG:= -infinity;
	        _UGT:= 0
	      else
	        #( min der UG )#
	        if property::_is(Arg(args(1), 1)
	                         < Arg(args(2), 1), "<") = TRUE then
	          _UG:= Arg(args(1), 1);
	          _UGT:= Arg(args(1), 2)
	        elif property::_is(Arg(args(2), 1)
	                           < Arg(args(1), 1), "<") = TRUE then
	          _UG:= Arg(args(2), 1);
	          _UGT:= Arg(args(2), 2)
	        elif property::_is(Arg(args(1), 1)
	                           = Arg(args(2), 1), "<") = TRUE then
	          _UG:= Arg(args(1), 1);
	          _UGT:= Arg(args(1), 2)*Arg(args(2), 2)
	        else
	          _UG:= UNKNOWN
	        end_if
	      end_if;
	      if (_i:= contains([Arg(args(1), 3),
	                         Arg(args(2), 3)], -infinity)) > 0 then
	        _OG:= Arg(args(3 - _i), 3);
	        _OGT:= Arg(args(3 - _i), 4)
	      elif contains([Arg(args(1), 3),
	                     Arg(args(2), 3)], infinity) > 0 then
	        _OG:= infinity;
	        _OGT:= 0
	      else
	        #( max der OG )#
	        if property::_is(Arg(args(1), 3)
	                         < Arg(args(2), 3), "<") = TRUE then
	          _OG:= Arg(args(2), 3);
	          _OGT:= Arg(args(2), 4)
	        elif property::_is(Arg(args(2), 3)
	                           < Arg(args(1), 3), "<") = TRUE then
	          _OG:= Arg(args(1), 3);
	          _OGT:= Arg(args(1), 4)
	        elif property::_is(Arg(args(1), 3)
	                           = Arg(args(2), 3), "<") = TRUE then
	          _OG:= Arg(args(1), 3);
	          _OGT:= 1 - Arg(args(1), 4)*Arg(args(2), 4)
	        else
	          _OG:= UNKNOWN
	        end_if
	      end_if;
	      #(  )#
	      if contains({_UG, _OG}, UNKNOWN) then
	        return(hold(_or)(args()))
	      elif property::_is((_if(_UGT*_OGT = 0,
	                            _less, _leequal))(_UG, _OG)) = FALSE then
	        return(hold(_or)(args()))
	      else
	        return(IV(hold(id)([_UG, _UGT, _OG, _OGT,
		                   _or(Arg(args(1), 5), Arg(args(2), 5))])))
	      end_if
	    end_proc, args())
	end_proc:

IV::_opsort:=
	proc()
	  local _OP, _i;
	begin
	  _OP:= sort(args(), IV::_s1);
	  for _i from nops(_OP) - 1 downto 1 do
	    #if op(_OP, [_i + 1, 1]) = -infinity then
	      _OP:= subsop(_OP, 1 = [-infinity, 0])
	    el#if op(_OP, [_i + 1, 1]) = op(_OP, [_i, 1]) then
	      _OP:= subsop(_OP, nops(_OP) = op(_OP, _i))
	    else
	      break
	    end_if
	  end_for;
	  return([op(_OP, 1), op(_OP, nops(_OP))])
	end_proc:

IV::_s1:=
	proc()
	begin
	  if property::_is(op(args(1), 1) < op(args(2), 1), "<") = TRUE then
	    return(TRUE)
	  elif property::_is(op(args(2), 1) < op(args(1), 1), "<") = TRUE then
	    return(FALSE)
	  else
	    return(bool(op(args(1), 2) > op(args(2), 2)))
	  end_if
	end_proc:

IV::sign:=
	proc()
	begin
	  if property::_is(_if(Arg(args(), 4) = 0, _leequal, _less)
	                      (Arg(args(), 3), 0)) = TRUE then
	    -1
	  elif property::_is(_if(Arg(args(), 2) = 0, _leequal, _less)
	                        (0, Arg(args(), 1))) = TRUE then
	    1
	  else
	    0
	  end_if
	end_proc:

IV::_plus:=
	proc()
	begin
	  property::_Op(IV, _plus,
	                proc()
	                begin
	                  IV(hold(id)
	                     ([Arg(args(1), 1) + Arg(args(2), 1),
		               Arg(args(1), 2) * Arg(args(2), 2),
		               Arg(args(1), 3) + Arg(args(2), 3),
		               Arg(args(1), 4) * Arg(args(2), 4),
		               _plus(Arg(args(1), 5), Arg(args(2), 5))]))
	                end_proc, args())
	end_proc:

IV::_subtract:=
	proc()
	begin
	  property::_Op(IV, _subtract,
	                proc()
	                  local _MOP;
	                begin
	                  _MOP:= [[Arg(args(1), 1) - Arg(args(2), 1),
	                           Arg(args(1), 2)],
	                          [Arg(args(1), 1) - Arg(args(2), 3),
	                           Arg(args(1), 2)],
	                          [Arg(args(1), 3) - Arg(args(2), 1),
	                           Arg(args(1), 4)],
	                          [Arg(args(1), 3) - Arg(args(2), 3),
	                           Arg(args(1), 4)]];
	                  _MOP:= IV::_opsort(_MOP);
	                  IV(hold(id)
	                     ([op(_MOP, [1, 1]),
	                       op(_MOP, [1, 2]),
		               op(_MOP, [2, 1]),
		               op(_MOP, [2, 2]),
		              _subtract(Arg(args(1), 5), Arg(args(2), 5))]))
	                end_proc, args())
	end_proc:

IV::_negate:=
	proc()
	begin
	  IV(hold(id)
	     ([-Arg(args(1), 3),
	       Arg(args(1), 4),
	       -Arg(args(1), 1),
	       Arg(args(1), 2),
	       -Arg(args(1), 5)]))
	end_proc:

IV::_mult:=
	proc()
	  local _MOP;
	begin
	  property::_Op(IV, _mult,
	                proc()
	                begin
	                  _MOP:= [[Arg(args(1), 1)*Arg(args(2), 1),
	                           Arg(args(1), 2)*Arg(args(2), 2)],
	                          [Arg(args(1), 1)*Arg(args(2), 3),
	                           Arg(args(1), 2)*Arg(args(2), 4)],
	                          [Arg(args(1), 3)*Arg(args(2), 1),
	                           Arg(args(1), 4)*Arg(args(2), 2)],
	                          [Arg(args(1), 3)*Arg(args(2), 3),
	                           Arg(args(1), 4)*Arg(args(2), 4)]];
	                  if IV::sign(args(1)) = 0 or IV::sign(args(2)) = 0 then
	                    _MOP:= append(_MOP, [0, 0])
	                  end_if;
	                  _MOP:= IV::_opsort(_MOP);
	                  IV(hold(id)
	                     ([op(_MOP, [1, 1]),
	                       op(_MOP, [1, 2]),
		               op(_MOP, [2, 1]),
		               op(_MOP, [2, 2]),
		               _mult(Arg(args(1), 5), Arg(args(2), 5))]))
	                end_proc, args())
	end_proc:

IV::_divide:=
	proc()
	begin
	  property::_Op(IV, _divide,
	    proc()
	      local _MOP, _s1, _s3;
	    begin
	      if IV::sign(args(2)) <> 0 then
	        _s1:= sign(Arg(args(1), 1));
	        _s3:= sign(Arg(args(1), 3));
	        _MOP:= [
  
	                [_if(property::_is(Arg(args(2), 1) = 0) = TRUE,
	                     infinity*_s1, Arg(args(1), 1)/Arg(args(2), 1)),
	                 Arg(args(1), 2)*Arg(args(2), 2)],
	                [_if(property::_is(Arg(args(2), 1) = 0) = TRUE,
	                     infinity*_s3, Arg(args(1), 3)/Arg(args(2), 1)),
	                 Arg(args(1), 4)*Arg(args(2), 2)],
  
	                [_if(property::_is(Arg(args(2), 3) = 0) = TRUE,
	                     infinity*_s1, Arg(args(1), 1)/Arg(args(2), 3)),
	                 Arg(args(1), 2)*Arg(args(2), 4)],
	                [_if(property::_is(Arg(args(2), 3) = 0) = TRUE,
	                     infinity*_s3, Arg(args(1), 3)/Arg(args(2), 3)),
	                 Arg(args(1), 4)*Arg(args(2), 4)]
	               ];
	        _MOP:= IV::_opsort(_MOP);
	        IV(hold(id)
	           ([op(_MOP, [1, 1]),
	             op(_MOP, [1, 2]),
		     op(_MOP, [2, 1]),
		     op(_MOP, [2, 2]),
		     _divide(Arg(args(1), 5), Arg(args(2), 5))]))
	      else
	        property::Undefined
	      end_if
	    end_proc, args())
	end_proc:

IV::_invargs:=
	proc()
	begin
	  if iszero(args(1)) then
	    infinity*args(2)
	  else
	    _invert(args(1))
	  end_if
	end_proc:

IV::_invert:=
	proc()
	  local s;
	begin
	if (s:= IV::sign(args())) <> 0 then
	    IV(hold(id)
	       ([IV::_invargs(Arg(args(1), 3), s),
	         Arg(args(1), 4),
	         IV::_invargs(Arg(args(1), 1), s),
	         Arg(args(1), 2),
	         _invert(Arg(args(1), 5))]))
	  else
	    property::Null
	  end_if
	end_proc:

IV::_power:=
	proc()
	  local _ret, _MOP;
	begin
	  if type(args(2)) <> "IV" then
	    _ret:= property::convert_to(args(2)); #( ?? kein Ziel )#
	    if property::Fail(_ret) then return(_ret) end_if;
	    return(IV::_power(args(1), property::convert_to(args(2), IV)))
	  end_if;
	  _MOP:= [[Arg(args(1), 1)^Arg(args(2), 1),
	           Arg(args(1), 2)],
	          [Arg(args(1), 1)^Arg(args(2), 3),
	           Arg(args(1), 2)],
	          [Arg(args(1), 3)^Arg(args(2), 1),
	           Arg(args(1), 4)],
	          [Arg(args(1), 3)^Arg(args(2), 3),
	           Arg(args(1), 4)]];
	  _MOP:= IV::_opsort(_MOP);
	  IV(hold(id)
	     ([op(_MOP, [1, 1]),
	       op(_MOP, [1, 2]),
	       op(_MOP, [2, 1]),
	       op(_MOP, [2, 2]),
	       _power(Arg(args(1), 5), Arg(args(2), 5))]))
	end_proc:

IV::NRange:=
	proc()
	begin
	  if property::_is(Arg(args(), 1) >= 0) = TRUE then
	    if Arg(args(), 2) = 1 then
	      return(property::NRange("NonNegative") and Arg(args(), 5))
	    else
	      return(property::NRange("Positive") and Arg(args(), 5))
	    end_if
	  elif property::_is(Arg(args(), 3) <= 0) = TRUE
	       and Arg(args(), 4) = 0 then
	    return(property::NRange("Negative") and Arg(args(), 5))
	  else
	    return(Arg(args(1), 5))
	  end_if
	end_proc:

IV::Rel:=
	proc()
	begin
	  if (Arg(args(1), 2) + Arg(args(1), 4) = 0) and
	     (Arg(args(1), 1) = Arg(args(1), 3)) then
	    return(property::Rel(Nul, hold(_equal), Arg(args(1), 1)))
	  elif Arg(args(1), 1) = -infinity then
	    if Arg(args(1), 4) = 0 then #( "<" )#
	      return(property::Rel(Nul, hold(_less), Arg(args(1), 3)))
	    else #( <= )#
	      return(property::Rel(Nul, hold(_leequal), Arg(args(1), 3)))
	    end_if
	  elif Arg(args(1), 3) = infinity then
	    if Arg(args(1), 2) = 0 then #( ">" )#
	      return(property::Rel(Nul, (-1)*hold(_less), Arg(args(1), 1)))
	    else #( >= )#
	      return(property::Rel(Nul, (-1)*hold(_leequal), Arg(args(1), 1)))
	    end_if
	  else
	    if args(0) > 1 then
	      if args(2) = ">" then
	        return(_if(Arg(args(1), 2) = 0,
	               property::Rel(Nul, (-1)*hold(_less), Arg(args(1), 1)), #( > )#
	               property::Rel(Nul, (-1)*hold(_leequal), Arg(args(1), 1))
	               ))
	      elif args(2) = "<" then
	        return(_if(Arg(args(1), 4) = 0,
	                   property::Rel(Nul, hold(_less), Arg(args(1), 3)), #( < )#
	                   property::Rel(Nul, hold(_leequal), Arg(args(1), 3))))
	      end_if
	    else
	      return(hold(_and)(_if(Arg(args(1), 4) = 0,
	             property::Rel(Nul, hold(_less), Arg(args(1), 3)), #( < )#
	             property::Rel(Nul, hold(_leequal), Arg(args(1), 3))),
	             _if(Arg(args(1), 2) = 0,
	             property::Rel(Nul, (-1)*hold(_less), Arg(args(1), 1)), #( > )#
	             property::Rel(Nul, (-1)*hold(_leequal), Arg(args(1), 1))
	             )))
	    end_if
	  end_if
	end_proc:

IV::print:=
	proc()
	  local _ret;
	begin
	  if (_ret:= expr2text(op(args(), 1))) <> "Interval" then
	    _ret
	  else
	    if Arg(args(1), 2) = 1 then
	      if Arg(args(1), 4) = 1 then
	        _ret:= [Arg(args(1), 1), Arg(args(1), 3)]
	      else
	        _ret:= [Arg(args(1), 1)], Arg(args(1), 3)
	      end_if
	    else
	      if Arg(args(1), 4) = 1 then
	        _ret:= Arg(args(1), 1), [Arg(args(1), 3)]
	      else
	        _ret:= Arg(args(1), 1), Arg(args(1), 3)
	      end_if
	    end_if;
	    "IV(".expr2text(_ret).", " . expr2text(Arg(args(1), 5)) .")"
	    #"IV(".expr2text(_ret).") of " . expr2text(Arg(args(1), 5))#
	  end_if
	end_proc:

unalias(Nul):
unalias(Ar):
unalias(Arg):
unalias(IV):
