

#(
   NAdj     - Domain of numerical property 'Range of a number with adjunction'

   op(NAdj) - range,
              adjoint

)#

alias(NAdj = property::NAdj):

NAdj:= domain("property::NAdj"):
NAdj::info:=
	"Domain of numerical property 'Range of a number with adjunction'":
NAdj::domtype:= fun(Type):
NAdj::type:= "NAdj":
NAdj::prop:= TRUE:
NAdj::propdom:= fun(property::NAdj):
NAdj::autoload:= TRUE:
NAdj::testtype:= Type::testtype:

NAdj::ax:= []:

NAdj::new:= 
	proc(range, adj)
	begin
          if args(0) < 2 then adj:= I end_if;
	  if args(0) < 1 then range:= property::NRange("real") end_if;
	  if (TRUE) <> TRUE then
	    userinfo(1, "Adjunction not possible: " . expr2text(adj));
	    return(FAIL)
          end_if;
          # NAdj::adj:= adj; #
	  new(NAdj, range, adj)
        end_proc:

NAdj::is:=
	proc()
        begin
	  return(property::isprop(op(args(1), 1), op(args(2), 1)) and
	         bool(op(args(1), 2) = op(args(2), 2)))
	         #property::isprop(op(args(1), 2),#
	                          #op(args(2), 2)))#
	end_proc:

NAdj::adj:=
        proc(nadj)
	begin
	  if type(nadj) = "NAdj" then return(op(nadj, 2)) end_if
	end_proc:

NAdj::range:=
        proc(nadj)
	begin
	  if type(nadj) = "NAdj" then return(op(nadj, 1)) end_if
	end_proc:
	  
NAdj::elem:=
	proc(nadj)
	begin
	  case type(nadj)
	  of "NRange" do
	    return((property::NRange)::elem(nadj))
	  end_case;
	  if type(nadj) = "_and" then
	    return(NAdj::elem(_plus(op(nadj))))
	  end_if;
	  if type(nadj) = "_or" then
	    return(NAdj::elem(_or(map(op(nadj),
	                              property::convert_to,
	                              property::NRange))))
	  end_if;
	  return(NRange::elem(property::convert_to(nadj, property::NRange)))
	end_proc:

NAdj::Op:=
	proc()
	  local __Op, Args, _no, _yes;
	begin
	  __Op:= args(1);
	  if args(0) = 2 then return (args(2)) end_if;
	  if args(0) = 3 then
	    Args:= property::convertArgs(NAdj, args(2..args(0)));

	    if op(Args, 0) = _no then
	      return(hold(_and)(op(Args)))
	    end_if;
	    if op(Args, 0) = _yes then
	      
	      return(NAdj(__Op(op(args(2), 1), op(args(3), 1)), 
	                  NAdj::elem(__Op(op(args(2), 2),  op(args(3), 2)))))
	    else
	      return(__Op(op(Args)))
	    end_if
	  else
	    property::Op(__Op, (args(2..args(0))))
	  end_if
	end_proc:

NAdj::_and:=
	proc()
	begin
	  return(NAdj::Op(_and, args()))
	end_proc:

NAdj::_or:=
	proc()
	begin
	  return(NAdj::Op(_or, args()))
	end_proc:

NAdj::convert_to:=
	proc(NAdj, _to)
	begin
	  case _to
	  of property::NRange do
	    return(_and(map(op(NAdj), property::convert_to, property::NRange)))
	  of property::IV do
	    return(IV(-infinity, infinity,
	              (property::NRange)::range(op(NAdj, 1))
		      and (property::NRange)::range(op(NAdj, 2))))
	  end_case
	end_proc:

NAdj::print:=
	proc(ad)
	begin
          #"NAdj(" . expr2text(op(ad, 1)) . ")(" . expr2text(op(ad, 2)) .")"#
	  expr2text(op(ad, 1)) . "(" . expr2text(op(ad, 2)) .")"
        end_proc:

unalias(NAdj):
stdlib::LoadlibState["property::NAdj"]:= TRUE:

userinfo(1, "Loading 'NAdj' done ..."):
