
#(
   NRange - Domain of numerical property 'Range of a number'
)#

alias(NRange = property::NRange):
#( Arg gibt das Argument -String- zur"uck )#
alias(Arg(x) = extop(x, 5)):
alias(Nul = property::Nul):

NRange:= domain("property::NRange"):
NRange::info:= "Domain of numerical property 'Range of a number'":
NRange::domtype:= fun(Type):
NRange::type:= "NRange":
NRange::prop:= TRUE:
NRange::propdom:= domattr(property, "NRange"):
NRange::autoload:= TRUE:
NRange::testtype:= Type::testtype:

NRange::ax:= []:

NRange::new:= 
	proc(prop)
	begin
	  if args(0) = 0 then
	    return(domattr(Type, "Zero"))
	  end_if;
	  if domtype(prop) <> DOM_STRING then
	    error("Illegal argument")
	  end_if;
	  if args(0) = 0 then prop:= "Complex" end_if;
	  if (contains(NRange::child, prop) 
	     or contains(NRange::parent, prop)) <> TRUE then
	    error("Unknown 'Range of a number': ".prop)
	  end_if;
	  domattr(Type, prop)
	  #new(NRange, prop)#
	end_proc:

NRange::child:=
	table(
	  "Complex"     = {"Imaginary", "RealNum", "Imaginary"},
	  "Imaginary"   = {"IntImaginary"},
	  "IntImaginary"= {"IntImaginary"},
	  "RealNum"     = {"Rational", "Irrational", "NonNegative", "Negative"},
	  "Irrational"  = {"Irrational"},
	  "Negative"    = {"NegRat"},
	  "NonNegative" = {"Positive", "NonNegRat"},
	  "Positive"    = {"PosRat"},
	  "Rational"    = {"Integer", "Fraction", "NonNegRat", "NegRat"},
	  "Fraction"    = {"Fraction"},
	  "NegRat"      = {"NegInt"},
	  "NonNegRat"   = {"PosRat", "NonNegInt"},
	  "PosRat"      = {"PosInt"},
	  "Integer"     = {"NegInt", "NonNegInt"},
	  "NegInt"      = {"NegInt"},
	  "NonNegInt"   = {"PosInt", "Zero"},
	  "PosInt"      = {"Prime"},
	  "Prime"       = {"Prime"},
	  "Zero"        = {"Zero"#, "FAIL"#},
	  "FAIL"        = {"FAIL"}
	):

NRange::parent:=
	table(
	  "Zero"        = {"NonNegInt"},
	  "Prime"       = {"PosInt"},
	  "PosInt"      = {"NonNegInt", "HELP1"},
	  "HELP1"       = {"PosRat"},
	  "NonNegInt"   = {"Integer", "NonNegRat"},
	  "NegInt"      = {"Integer", "NegRat"},
	  "Integer"     = {"Rational"},
	  "PosRat"      = {"NonNegRat", "HELP2"},
	  "HELP2"       = {"Positive"},
	  "NonNegRat"   = {"Rational", "NonNegative"},
	  "NegRat"      = {"Rational", "Negative"},
	  "Fraction"    = {"Rational"},
	  "Rational"    = {"RealNum"},
	  "Positive"    = {"NonNegative"},
	  "NonNegative" = {"RealNum"},
	  "Negative"    = {"RealNum"},
	  "RealNum"     = {"Complex"},
	  "Irrational"  = {"RealNum"},
	  "IntImaginary"= {"Imaginary"},
	  "Imaginary"   = {"Complex"},
	  "Complex"     = {"Complex"#, "FAIL"#},
	  "FAIL"        = {"FAIL"}
	):

#( gibt die Ordnung zur"uck )#
NRange::_o:= fun(contains(NRange::order, Arg(args()))):

#( interne Ordnung )#
NRange::order:=
#( 1 )#	["Zero",
#( 2 )#	 "Prime",
#( 3 )#	 "PosInt",
#( 4 )#	 "NonNegInt",
#( 5 )#	 "NegInt",
#( 6 )#	 "Integer",
#( 7 )#	 "PosRat",
#( 8 )#	 "NonNegRat",
#( 9 )#	 "NegRat",
#(10 )#	 "Rational",
#(11 )#	 "Fraction",
#(12 )#	 "Positive",
#(13 )#	 "NonNegative",
#(14 )#	 "Negative",
#(15 )#	 "Irrational",
#(16 )#	 "RealNum",
#(17 )#	 "IntImaginary",
#(18 )#	 "Imaginary",
#(19 )#	 "Complex",
#(20 )#  "FAIL"]:

#( info   mult,-rg,neg,inv,pow )#
NRange::_info:=
#( 1 )#	[[   0,  1,  1, 20,  1], #( mult: negativ/beides/positiv )#
#( 2 )#	 [   1,  3,  5,  7,  3], #(  -rg: (mult) - mal -)#
#( 3 )#	 [   1,  3,  5,  7,  3], #(  neg: negatives )#
#( 4 )#	 [   1,  4,  5,  8,  3], #(  inv: inverses )#
#( 5 )#	 [  -1,  3,  3,  9,  7], #(  pow: ^ bei Exponent positiv )#
#( 6 )#	 [   0,  6,  6, 10,  7],
#( 7 )#	 [   1,  7,  9,  7, 12],
#( 8 )#	 [   1,  8,  9,  8, 12],
#( 9 )#	 [  -1,  7,  7,  9, 12],
#(10 )#	 [   0, 10, 10, 10, 12],
#(11 )#	 [   1, 11, 11, 11, 12],
#(12 )#	 [   1, 12, 14, 12, 12],
#(13 )#	 [   1, 13, 14, 13, 12],
#(14 )#	 [  -1, 12, 12, 14, 12],
#(15 )#	 [   0, 15, 15, 15, 12],
#(16 )#	 [   0, 16, 16, 16, 19],
#(17 )#	 [   0, 17, 17, 18, 19],
#(18 )#	 [   0, 18, 18, 18, 19],
#(19 )#	 [   0, 19, 19, 19, 19],
#(20 )#  [   0, 20, 20, 20, 20]]:

NRange::elem:=
	proc()
	begin
	  if type(args(1)) = "NRange" then
	    case Arg(args(1))
	    of "Zero" do return([0])
	    of "Prime" do return([2])
	    of "PosInt" do return([1])
	    of "NonNegInt" do return([0, 1])
	    of "NegInt" do return([-1])
	    of "Integer" do return([1, -1])
	    of "PosRat" do return([1/2])
	    of "NonNegRat" do return([1/2])
	    of "NegRat" do return([-1/2])
	    of "Fraction" do return([1/2, -1/2])
	    of "Rational" do return([1/2, -1/2])
	    of "Positive" do return([1.2])
	    of "NonNegative" do return([1.2])
	    of "Negative" do return([-1.2])
	    of "Irrational" do return([2.7, -2.7])
	    of "RealNum" do return([2.3, -2.3])
	    of "IntImaginary" do return([I])
	    of "Imaginary" do return([1.2*I])
	    of "Complex" do return([1.2 + 1.3*I])
	    otherwise return([NRange("FAIL")])
	    end_case
	  end_if
	end_proc:

NRange::is:=
	proc()
	begin
	  if type(args(1)) <> "NRange" or type(args(2)) <> "NRange" then
	    return(UNKNOWN)
	  else
	    if property::path(NRange::child, Arg(args(2)), Arg(args(1))) then
	      return(TRUE)
	    elif NRange::_and(args()) <> property::Null then
	      return(UNKNOWN);
	    end_if
	  end_if;
	  return(FALSE)
	end_proc:

#( Type::Constant )#
NRange::constant:=
	proc()
	begin
	  if Arg(args()) = "Zero" then
	    TRUE
	  else
	    UNKNOWN
	  end_if;
	end_proc:

#( _rg1 or _rg2 --> Vereinigung )#
NRange::_or:=
	proc()
	begin
	  property::_Op(NRange, _or,
	    proc()
	      local _rg1, _rg2, _ret, _s1, _las, _alt, _neu, __i;
	    begin
	      _rg1:= Arg(args(1));
	      _rg2:= Arg(args(2));

	      #( direkter Vorfahre )#
	      _ret:= (property::path(NRange::child, _rg2, _rg1));
	      if _ret then
	        return(NRange(_rg2));
	      end_if;
	      _ret:= (property::path(NRange::parent, _rg2, _rg1));
	      if _ret then
	        return(NRange(_rg1));
	      end_if;

	      _s1:= {_rg1};
	      _neu:= _s1;
	      _alt:= _neu;
	      _las:= 0;
	      while (_las <> nops(_s1)) do
	        _las:= nops(_s1);
	        for __i from 1 to nops(_neu) do
	          if property::path(NRange::parent, _rg2, op(_neu, __i)) then
	            return(NRange(op(_neu, __i)))
	          end_if;
	          _s1:= _s1 union NRange::parent[op(_neu, __i)];
	        end_for;
	        _neu:= _s1 minus _alt;
	        _alt:= _alt union _s1;
	      end_while;
	      return(property::Null)
	    end_proc, args())
	end_proc:

#( _rg1 and _rg2 --> Schnitt )#
NRange::_and:=
	proc()
	begin
	  property::_Op(NRange, _and,
	    proc()
	      local _rg1, _rg2, _ret, _s1, _las, _alt, _neu, __i;
	    begin
	      _rg2:= Arg(args(1));
	      _rg1:= Arg(args(2));

	      _ret:= (property::path(NRange::parent, _rg2, _rg1));
	      if _ret then
	        return(NRange(_rg2));
	      end_if;
	      _ret:= (property::path(NRange::child, _rg2, _rg1));
	      if _ret then
	        return(NRange(_rg1));
	      end_if;

	      _s1:= {_rg1};
	      _neu:= _s1;
	      _alt:= _neu;
	      _las:= 0;
	      while (_las <> nops(_s1)) do
	        _las:= nops(_s1);
	        for __i from 1 to nops(_neu) do
	          if property::path(NRange::child, _rg2, op(_neu, __i)) then
	            return(NRange(op(_neu, __i)))
	          end_if;
	          _s1:= _s1 union NRange::child[op(_neu, __i)];
	        end_for;
	        _neu:= _s1 minus _alt;
	        _alt:= _alt union _s1;
	      end_while;
	      return(property::Null)
	    end_proc, args())
	end_proc:

NRange::_not:=
	proc()
	begin
	  return(hold(_not)(args()))
	end_proc:

NRange::_plus:= 
	proc()
	begin
	property::_Op(NRange, _plus,
	  proc()
	    local __i1, __i2;
	  begin
	    __i1:= NRange::_o(args(1));
	    __i2:= NRange::_o(args(2));
	    #( NonNegative )#
	    if contains({4, 8, 13}, __i1) then
	      if not(contains({4, 8, 13}, __i2)) then
	        if op(NRange::_info, [__i2, 1]) > 0 then
	          return(NRange::_or(NRange(op(NRange::order, __i1 - 1)),
	                             args(2)))
	        end_if
	      end_if
	    elif contains({4, 8, 13}, __i2) then
	      if op(NRange::_info, [__i1, 1]) > 0 then
	        return(NRange::_or(args(1),
	                           NRange(op(NRange::order, __i2 - 1))))
	      end_if
	    end_if;
	    #( Sonderfall Primzahl )#
	    if (__i1:= contains([__i1, __i2], 2)) > 0 then
	      return(NRange::_or(NRange(op(NRange::order, 3), args(3 - __i1))))
	    end_if;
	    return(NRange::_or(args(1), args(2)))
	  end_proc, args())
	end_proc:

NRange::_subtract:= 
	proc()
	begin
	property::_Op(NRange, _subtract,
	  proc()
	  begin
	    return(NRange::_or(args(1), NRange::_negate(args(2))))
	  end_proc, args())
	end_proc:

NRange::_negate:= 
	proc()
	begin
	  return(NRange(op(NRange::order,
	                   op(NRange::_info, [NRange::_o(args(1)), 3]))))
	end_proc:

NRange::_mult:=
	proc()
	begin
	  property::_Op(NRange, _mult,
	    proc()
	      local _ret, __o;
	    begin
	      __o:= _mult(op(NRange::_info, [NRange::_o(args(1)), 1]),
	                  op(NRange::_info, [NRange::_o(args(2)), 1]));
	      if __o = 0 then
	        return(NRange::_or(args()))
	      else
	        _ret:= NRange::_or(NRange(op(NRange::order,
	                                     op(NRange::_info,
	                                        [NRange::_o(args(1)), 2]))),
	                           NRange(op(NRange::order,
	                                     op(NRange::_info,
	                                        [NRange::_o(args(2)), 2]))));
	        if __o > 0 then return(_ret)
	        else return(NRange::_negate(_ret))
	        end_if
	      end_if
	    end_proc, args())
	end_proc:

NRange::_divide:=
	proc()
	begin
	property::_Op(NRange, _divide,
	  proc()
	    local _ret;
	  begin
	    return(NRange::_mult(args(1), NRange::_invert(args(2))));
	    _ret:= NRange::_or(NRange(op(NRange::order,
	                                 op(NRange::_info,
	                                    [NRange::_o(args(1)), 3]))),
	                       NRange(op(NRange::order,
	                                 op(NRange::_info,
	                                    [NRange::_o(args(2)), 3]))));
	    return(NRange::_or(_ret, NRange::_mult(args())))
	  end_proc, args())
	end_proc:

NRange::_invert:= 
	proc()
	begin
	  return(NRange(op(NRange::order,
	                   op(NRange::_info, [NRange::_o(args(1)), 4]))))
	end_proc:

NRange::_power:=
	proc()
	begin
          if property::_is(args(2), Type::Even) = TRUE then
	    return(domattr(Type, op(["Zero",
                                     "PosInt",
                                     "PosInt",
                                     "NonNegInt",
                                     "PosInt",
                                     "NonNegInt",
                                     "PosRat",
                                     "NonNegRat",
                                     "PosRat",
                                     "NonNegRat",
                                     "Fraction",
                                     "Positive",
                                     "NonNegative",
                                     "Positive",
                                     "Irrational",
                                     "NonNegative",
                                     "Integer",
                                     "RealNum",
                                     "Complex",
                                     "FAIL"], NRange::_o(args(1)))))
	  end_if;
	  property::_Op(NRange, _power,
	    proc()
	    begin
  
	    return(NRange::_or(args(1),
	             NRange(op(NRange::order,
	                    op(NRange::_info, [NRange::_o(args(2)), 5])))))
	  end_proc, args())
	end_proc:

NRange::Rel:=
	proc()
	begin
	  case Arg(args())
	  of "Zero" do
	    return(property::Rel(Nul, hold(_equal), 0))
	  of "NonNegInt" do
	  of "NonNegRat" do
	  of "NonNegative" do
	    return(property::Rel(Nul, (-1)*hold(_leequal), 0))
	  of "Prime" do
	    return(property::Rel(Nul, (-1)*hold(_leequal), 2))
	  of "PosInt" do
	  of "PosRat" do
	  of "Positive" do
	    return(property::Rel(Nul, (-1)*hold(_less), 0))
	  of "NegInt" do
	  of "NegRat" do
	  of "Negative" do
	    return(property::Rel(Nul, hold(_less), 0))
	  of "IntImaginary" do
	  of "Imaginary" do
	  of "Complex" do
	    return(FAIL)
	  end_case;
	  return(NRange::IV(args()))
	end_proc:

NRange::IV:=
	proc()
	begin
	  case Arg(args())
	  of "Zero" do
	    return(IV([0], [0], args()))
	  of "PosInt" do
	    return(IV(0, infinity, args()))
	  of "Prime" do
	    return(IV(2, infinity, args()))
	  of "NonNegInt" do
	    return(IV([0], infinity, args()))
	  of "NegInt" do
	    return(IV(-infinity, 0, args()))
	  of "PosRat" do
	    return(IV(0, infinity, args()))
	  of "NonNegRat" do
	    return(IV([0], infinity, args()))
	  of "NegRat" do
	    return(IV(-infinity, 0, args()))
	  of "Positive" do
	    return(IV(0, infinity, args()))
	  of "NonNegative" do
	    return(IV([0], infinity, args()))
	  of "Negative" do
	    return(IV(-infinity, 0, args()))
	  of "IntImaginary" do
	  of "Imaginary" do
	  of "Complex" do
	    return(FAIL)
	  end_case;
	  return(property::IV(-infinity, infinity, args()))
	end_proc:

NRange::Divs:=
	proc()
	begin
	  return(FAIL)
	end_proc:

NRange::NAdj:=
	proc()
	begin
	  return(property::NAdj(args(), op(NRange::elem(args()), 1)))
	end_proc:

NRange::Type:=
	proc()
	begin
	  if contains(Type, Arg(args())) then
	    return(domattr(Type, Arg(args())))
	  end_if;
	  return(FAIL)
	end_proc:

NRange::print:=
	proc()
	begin
	  expr2text(op(args(), 1))
	  #"NRange(\"" . Arg(args()) . "\")"#
	end_proc:

//property::autoload(NRange):

unalias(Nul):
unalias(Arg):
unalias(NRange):
