

#( POp - Domain of 'Operators of Properties' )#

alias(POp = property::POp):

POp:= domain("property::POp"):
POp::info:= "Operators of Properties":
POp::type:= "POp":

POp::interface:=
	{ hold(Ptype),
	  hold(Pand),
	  hold(Por),
	  hold(Pnot),
	  hold(Pplus),
	  hold(Pmult),
	  hold(Ppower),
	  hold(Pnegate),
	  hold(Psubtract),
	  hold(Pinvert),
	  hold(Pdivide),
	  hold(Prule),
	  hold(Pid)
	}:

#( gibt bool zur"uck, ob args() vom Typ "P..." ist )#
POp::Ptype:=
	proc()
	begin
	  bool((args(1))::Ptype = _if(args(0) = 1, "Ptype", args(2)))
	end_proc:

#( gibt bool zur"uck, ob args() vom Typ "_..." ist )#
POp::Otype:=
	proc()
	begin
	  bool(substring(_if(domtype(type(args())) = DOM_STRING,
	                     type(args()),
	                     expr2text(type(args()))),
	                 0) = "_")
	end_proc:

#( wandelt einen Ausdruck vom Typ "_..." in den Typ "P..." um )#
POp::POp:=
	proc()
	begin
	  if domtype(args()) = DOM_EXPR then
	    domattr(POp, "P".substring(type(args()),
		                       1..strlen(type(args())) - 1))(op(args()))
	  else
	    args()
	  end_if
	end_proc:

#( wandelt einen Ausdruck vom Typ "P..." in den Typ "_..." um )#
POp::OPp:=
	proc()
	begin
	  if POp::Ptype(domtype(args())) then
	    text2expr("_".substring(type(args()),
		          1..strlen(type(args())) - 1))(op(args()))
	  else
	    args()
	  end_if
	end_proc:

#( wandelt einen P-Ausdruck in einen Ausdruck um )#
#( -> automatische Evaluierung )#
POp::expr:=
	proc()
	begin
	  if POp::Ptype(args(), "Ptype") or POp::Ptype(args(), "Pbool") then
	    (args())::expr(args());
	  else
	    expr(args())
	  end_if
	end_proc:

#( wandelt einen P-Ausdruck in einen Ausdruck um )#
#( -> automatische Evaluierung )#
POp::_expr:=
	proc(__op)
	  local __f;
	begin
	  if (__f:= contains(map([op(args(2..args(0)))], property::Fail),
	      TRUE)) > 0 then
	    args(__f + 1)
	  else
	    __op:= __op(map(op(args(2..args(0))), POp::expr));
	    if (__f:= contains(map([op(__op)], property::Fail), TRUE)) > 0 then
	      op(__op, __f)
	    else
	      __op
	    end_if
	  end_if
	end_proc:

#( f"uhrt _op des Domains _dom aus (ein Domain aller Operanden, das _op besitzt) )#
POp::_Op:=
	proc()
	  local _dom;
	begin
	  _dom:= op([select(map(args(2..args(0)), domtype),
			    contains, expr2text(args(1)))], 1);
	  return(_dom::args(1)(args(2..args(0))))
	end_proc:

#( macht aus einem Ausdruck einen P-Ausdruck )#
POp::mapr:=
	proc(_ex)
	  local __i;
	begin
	  if not(POp::Otype(_ex)) then return(_ex) end_if;
	  __i:= contains([map(op(_ex), POp::Otype)], TRUE);
	  while __i > 0 do
	    _ex:= subsop(_ex, __i = POp::mapr(op(_ex, __i)));
	    __i:= contains([map(op(_ex), POp::Otype)], TRUE)
	  end_while;
	  return(POp::POp(_ex));
	end_proc:

#( macht aus einem P-Ausdruck einen Ausdruck )#
POp::mapu:=
	proc(_ex)
	  local __i;
	begin
	  if not(POp::Ptype(_ex)) then return(_ex) end_if;
	  __i:= contains([map(op(_ex), POp::Ptype)], TRUE);
	  while __i > 0 do
	    _ex:= subsop(_ex, __i = POp::mapu(op(_ex, __i)));
	    __i:= contains([map(op(_ex), POp::Ptype)], TRUE)
	  end_while;
	  return(POp::OPp(_ex));
	end_proc:

#( wie mapr, ohne simplify (f"ur _and, _or, _not) )#
POp::maph:=
	proc(_ex)
	  local __i;
	begin
	  if not(POp::Otype(_ex)) then return(_ex) end_if;
	  __i:= contains([map(op(_ex), POp::Otype)], TRUE);
	  while __i > 0 do
	    _ex:= subsop(_ex, __i = POp::mapr(op(_ex, __i)), Unsimplified);
	    __i:= contains([map(op(_ex), POp::Otype)], TRUE)
	  end_while;
	  return(POp::POp(_ex));
	end_proc:

#( gibt den _k-ten Operanden zur"uck )#
POp::opr:=
	proc(_exp, __k, _type)
	  local __i;
	begin
	  if type(__k) = "_range" then
	    return(POp::opr(_exp, __i, _type) $ __i=__k)
	  end_if;
	  if POp::Ptype(_exp, _type) then
	    return(op(POp::_opr(_exp, __k, _if(args(0)<3, null(),_type)), 2))
	  else
	    return(_exp)
	  end_if
	end_proc:

#( gibt den __k-ten Operanden und die zugeh"orige Verkn"upfung zur"uck )#
POp::_opr:=
	proc(_exp, __k, _type)
          local __i, ret, add;
        begin
	  if args(0) < 3 then _type:= null() end_if;
          ret:=0;
          for __i from 1 to nops(_exp) do
	    if POp::Ptype(op(_exp, __i), _type) then
	      add:= POp::_opr(op(_exp, __i), __k - ret, _type)
	    else
	      add:= [1]
	    end_if;
	    if op(add, 1) > 0 then
              ret:= ret + op(add, 1)
	    else
	      return(add)
	    end_if;
	    if ret = __k then
	      return([0, op(_exp, __i), type(_exp)])
	    end_if
          end_for;
          return([ret])
        end_proc:

#( ersetzt den __k-ten Operanden )#
POp::subsopr:=
	proc(_exp, _eq, _type)
	begin
	  if POp::Ptype(_exp, _type) then
	    return(op(POp::_subsopr(_exp, _eq, _if(args(0)<3, null(),_type)), 2))
	  else
	    return(op(_eq, 2))
	  end_if
	end_proc:

#( intern - ersetzt den __k-ten Operanden  )#
POp::_subsopr:=
	proc(_exp, _eq, _type)
          local __i, ret, add, __k, _subs;
        begin
	  if args(0) < 3 then _type:= null() end_if;
          ret:=0;
	  if type(_eq) = "_equal" then
	    __k:= op(_eq, 1);
	    _subs:= op(_eq, 2)
	  else
	    return(FAIL)
	  end_if;
          for __i from 1 to nops(_exp) do
	    if POp::Ptype(op(_exp, __i), _type) then
	      add:= POp::_subsopr(op(_exp, __i), (__k - ret) = _subs, _type)
	    else
	      add:= [1]
	    end_if;
	    if op(add, 1) > 0 then
              ret:= ret + op(add, 1)
	    else
	      return(subsop(add, 2 = subsop(_exp, __i = op(add, 2))))
	    end_if;
	    if ret = __k then
	      return([0, subsop(_exp, __i = _subs)])
	    end_if
          end_for;
          return([ret])
        end_proc:

#( gibt die Anzahl aller Operanden (auch von Teilausdr"ucken) zur"uck )#
POp::nopsr:=
	proc(_exp, _type)
          local __i, ret;
        begin
	  if args(0) < 2 then _type:= null() end_if;
	  if not(POp::Ptype(_exp, _type)) then return(1) end_if;
          ret:=0;
          for __i from 1 to nops(_exp) do
            ret:= ret +
	          (if POp::Ptype(op(_exp, __i), _type) then
                     POp::nopsr(op(_exp, __i), _type)
                   else
                     1
                   end_if)
          end_for;
          return(ret)
        end_proc:

#( P-Prop-Ausdruck aus _exp mit _X_-Operanden )#
#( Struktur der Eigenschaften der Operanden von _exp )#
POp::mkPprop:=
	proc(_exp, _to)
          local __i, ret, _Y_;
        begin
	  if _to = hold(_to) then _to:= null() end_if;
          _Y_:= hold(_Y_);
	  ret:= _Y_;
          for __i from 1 to POp::nopsr(_exp) do
	    ret:= subs(ret, _Y_ =
		       property::getprop(POp::opr(_exp, __i, "Ptype")#, _to#),
		       Unsimplified);
	    ret:= property::mapp("Pbool", ret, fun(hold(_Y_)));
          end_for;
          return(ret)
        end_proc:

#( Liste mit Anzahl der Eigenschaften jedes Operanden)#
POp::mkComb:=
	proc(_exp, _expP)
	  local __i, __l;
	begin
	  __l:= [1 $__i=1..POp::nopsr(_exp)];
	  for __i from 1 to nops(__l) do
	    __l:= subsop(__l, __i = POp::nopsr(POp::opr(_expP, __i, "Ptype"), "Pbool"))
	  end_for;
	  return(__l)
	end_proc:

#( __k-te oder n"achste M"oglichkeit )#
#( (_list, __k | _list2) )#
POp::mkNext:=
	proc(_list)
	  local __i, __n, __k, __l;
	begin
	  __n:= nops(_list) + 1;
	  if domtype(args(2)) = DOM_LIST then
	    if _mult(op(_list)) = _mult(op(args(2))) then return(_list) end_if;
	    __i:= 1;
	    __l:= subsop(args(2), __n - __i = op(args(2), __n - __i) + 1);
	    while (op(_list, __n - __i) < op(__l, __n - __i)) and (__n - __i > 1) do
	      __l:= subsop(__l, __n - __i = 1,
	                        __n - __i - 1 = op(__l, __n - __i - 1) + 1);
	      __i:= __i + 1
	    end_while
	  else
	    __k:= args(2);
	    __l:= [1 $ __i=1..nops(_list)];
	    for __i from 1 to __k - 1 do
	      __l:= Step(_list, __l)
	    end_for
	  end_if;
	  return(__l)
	end_proc:

#( erstellt aus einem P-Ausdruck _exp den vollst"andigen A-Ausdruck _expA )#
POp::mkEval:=
	proc(_exp, _expX, _expP, _expY)
	  local __i, __k, _Xi, _x, _mk, _nk, _vk;
	begin
	  _mk:= POp::mkComb(_exp, _expP);
	  _nk:= [1 $__i=1..nops(_mk)];
	  for __i from 1 to POp::nopsr(_expY, "Pbool") do
	    _Xi:= _expX;
	    _vk:= 0;
	    for __k from 1 to POp::nopsr(_expX, "Ptype") do
	      _x:= POp::opr(POp::opr(_expP, __k, "Ptype"),
			    op(_nk, __k),
			    "Pbool" );
	      _Xi:= POp::subsopr(_Xi, __k = _x, "Ptype");
	      _vk:= _vk + op(_mk, __k);
	    end_for;
	    _nk:= POp::mkNext(_mk, _nk);
	    _expY:= POp::subsopr(_expY, __i = _Xi, "Pbool")
	  end_for;
	  return(_expY)
	end_proc:

#( Hilfsfunktion )#
POp::getprop:=
	proc()
	begin
	  return(POp::mapr(property::_getprop(args(1)#,#
	                                     #_if(args(0) = 2, args(2), null())#)))
	end_proc:

#( gesamte Ersetzungsstrategie - Argument Ausdruck _ex )#
POp::mkAll:=
	proc(_ex, _to, _stop)
	  local _exp, _expX, _expP, _expY, _expA;
	begin
	  if contains({NIL, hold(_to)}, _to) then _to:= null() end_if;
	  _exp:= POp::mapr(_ex);
	  _expP:= property::mapp("Ptype", _exp, POp::getprop#, _to#);
	  if _stop = TRUE then return(_expP) end_if;
	  if {op(POp::mkComb(_exp, _expP))} = {1} then
	    return(_expP)
	  end_if;
	  _expX:= property::mapp("Ptype", _exp, fun(hold(_X_)));
	  _expY:= POp::mkPprop(_expP#, _to#);
	  _expA:= POp::mkEval(_exp, _expX, _expP, _expY);
	  return(_expA)
	end_proc:

alias(pt = pathname("PROP")):
POp::Pand:=      loadproc(POp::Pand,      pt, "Pand"     ):
POp::Por:=       loadproc(POp::Por,       pt, "Por"      ):
POp::Pnot:=      loadproc(POp::Pnot,      pt, "Pnot"     ):
POp::Pnot:=      loadproc(POp::Pnot,      pt, "Pnot"     ):
POp::Pplus:=     loadproc(POp::Pplus,     pt, "Pplus"    ):
POp::Pmult:=     loadproc(POp::Pmult,     pt, "Pmult"    ):
POp::Ppower:=    loadproc(POp::Ppower,    pt, "Ppower"   ):
POp::Pnegate:=   loadproc(POp::Pnegate,   pt, "Pnegate"  ):
POp::Psubtract:= loadproc(POp::Psubtract, pt, "Psubtract"):
POp::Pinvert:=   loadproc(POp::Pinvert,   pt, "Pinvert"  ):
POp::Pdivide:=   loadproc(POp::Pdivide,   pt, "Pdivide"  ):

POp::Prule:=     loadproc(POp::Prule,     pt, "Prule"    ):
POp::Pid:=       loadproc(POp::Pid,       pt, "Pid"      ):
unalias(pt):

unalias(POp):