

#( Pdivide - Domain of 'Divide of Properties' )#

alias(POp = property::POp):
alias(Pdivide = POp::Pdivide):

Pdivide:= domain("POp::Pdivide"):
Pdivide::info:= "Division of Properties":
Pdivide::type:= "Pdivide":
Pdivide::Ptype:= "Ptype":
  
Pdivide::new:=
	proc()
	begin
	  if args(0) > 2 then
	    return(new(Pdivide, args(1), POp::Pmult(args(2..args(0)))));
	  end_if;
	  if args(0) = 2 then
	    if type(args(2)) = "Pinvert" then
	      return(new(POp::Pmult, args(1), op(args(2))))
	    elif args(1) = 1 then
	      return(new(POp::Pinvert, args(2)))
	    else
	      return(new(Pdivide, args()))
	    end_if
	  else
	    return(args())
	  end_if
	end_proc:

Pdivide::expr:=
	proc()
	begin
	  POp::_expr(_divide, args())
	end_proc:
	
Pdivide::print:=
	proc()
	  local l;
	begin
	  if nops(args()) > 0 then
	    if nops(op(args(), 1)) > 1 then
	      l:= "(".expr2text(op(args(), 1)).")"
	    else
	      l:= expr2text(op(args(), 1))
	    end_if;
	    if nops(op(args(), 2)) > 1 then
	      l:= l." / "."(".expr2text(op(args(), 2)).")"
	    else
	      l:= l." / ".expr2text(op(args(), 2))
	    end_if;
	    l
	  end_if
	end_proc:

unalias(Pdivide):
unalias(POp):
