

#( Pinvert - Domain of 'Inversion of Properties' )#

alias(POp = property::POp):
alias(Pinvert = POp::Pinvert):

Pinvert:= domain("POp::Pinvert"):
Pinvert::info:= "Inversion of Properties":
Pinvert::type:= "Pinvert":
Pinvert::Ptype:= "Ptype":
  
Pinvert::new:=
	proc()
	begin
	  if args(0) > 1 then
	    return(map(args(), Pinvert))
	  end_if;
	  if type(args()) = "Pinvert" then
	    op(args())
	  else
	    new(Pinvert, args())
	  end_if
	end_proc:

Pinvert::expr:=
	proc()
	begin
	  POp::_expr(_invert, args())
	end_proc:
	
Pinvert::print:=
	proc()
	begin
	  "_invert(" . expr2text(op(args())) .")"
	end_proc:

unalias(Pinvert):
unalias(POp):
