

#( Pmult - Domain of 'Multiplication of Properties' )#

alias(POp = property::POp):
alias(Pmult = POp::Pmult):

Pmult:= domain("POp::Pmult"):
Pmult::info:= "Multiplication of Properties":
Pmult::type:= "Pmult":
Pmult::Ptype:= "Ptype":
  
Pmult::new:=
	proc()
	  local i, ret;
	begin
	  if args(0) > 2 then
	    ret:= new(Pmult, args(1), Pmult(args(2..args(0))));
	    for i from 1 to nops(ret) do
	      if type(extop(ret, i)) = "Pmult" then
	        ret:= extsubsop(ret, i = op(op(ret, i)))
	      end_if
	    end_for;
	    return(ret)
	  end_if;
	  if args(0) = 2 then
	    i:= contains([args()], -1);
	    if i > 0 then
	      return(new(POp::Pnegate, args(3 - i)))
	    end_if;
	    i:= contains([args()], 1);
	    if i > 0 then
	      return(args(3 - i))
	    end_if;
	    i:= contains([map(op(args()), domtype)], DOM_RAT);
	    if i > 0 then
	      return(POp::Pdivide(Pmult(args(3 - i), op(args(i), 1)),
	                          op(args(i), 2)))
	    end_if;
	    i:= contains([map(op(args()), type)], "Pinvert");
	    if i > 0 then
	      return(POp::Pdivide(args(3 - i), op(args(i))))
	    end_if;
	    return(new(Pmult, args()))
	  else
	    return(args())
	  end_if
	end_proc:

Pmult::expr:=
	proc()
	begin
	  POp::_expr(_mult, args())
	end_proc:
	
Pmult::print:=
	proc()
	  local i, l;
	begin
	  if nops(args()) > 0 then
	    if nops(op(args(), 1)) > 1 and nops(args()) > 1 then
	      l:= "(" . expr2text(op(args(), 1)) . ")"
	    else
	      l:= expr2text(op(args(), 1))
	    end_if;
	    i:= 2;
	    while i <= nops(args()) do
	      if nops(op(args(), i)) > 1 then
	        l:= l . " (" . expr2text(op(args(), i)) . ")"
	      else
		l:= l . " " . expr2text(op(args(), i))
	      end_if;
	      i:= i + 1
	    end_while;
	    l
	  end_if
	end_proc:

unalias(Pmult):
unalias(POp):