

#( Pnot - Domain of 'Logic Negation of Properties' )#

alias(POp = property::POp):
alias(Pnot = POp::Pnot):

Pnot:= domain("POp::Pnot"):
Pnot::info:= "Logic Negation of Properties":
Pnot::type:= "Pnot":
Pnot::Ptype:= "Pbool":
  
Pnot::new:=
	proc()
	begin
	  if type(args()) = "Pnot" then
	    op(args())
	  else
	    new(Pnot, args())
	  end_if
	end_proc:

Pnot::expr:=
	proc()
	begin
	  if map(op(args()), POp::expr) = FALSE then
	    TRUE
	  else
	    FALSE
	  end_if
	end_proc:
	
Pnot::_plus:=
	proc()
	begin
	  return(Pnot(_plus(op(args(1), 1), op(args(2), 1))))
	end_proc:
Pnot::_mult:=
	proc()
	begin
	  return(Pnot(_mult(op(args(1), 1), op(args(2), 1))))
	end_proc:

Pnot::_divide:=
	proc()
	begin
	  return(Pnot(_divide(op(args(1), 1), op(args(2), 1))))
	end_proc:

Pnot::_power:=
	proc()
	begin
	  return(Pnot(_power(op(args(1), 1), op(args(2), 1))))
	end_proc:

Pnot::print:=
	proc()
	begin
	  "not(" . expr2text(op(args())) . ")"
	end_proc:


unalias(Pnot):
unalias(POp):
