

#( Pplus - Domain of 'Plus of Properties' )#

alias(POp = property::POp):
alias(Pplus = POp::Pplus):

Pplus:= domain("POp::Pplus"):
Pplus::info:= "Addition of Properties":
Pplus::type:= "Pplus":
Pplus::Ptype:= "Ptype":

Pplus::new:=
	proc()
	  local i, ret;
	begin
	  if args(0) > 2 then
	    ret:= new(Pplus, args(1), Pplus(args(2..args(0))));
	    for i from 1 to nops(ret) do
	      if type(extop(ret, i)) = "Pplus" then
	        ret:= extsubsop(ret, i = op(op(ret, i)))
	      end_if
	    end_for;
	    return(ret)
	  end_if;
	  if args(0) = 2 then
	    i:= contains([args()], 0);
	    if i > 0 then
	      return(args(3 - i))
	    end_if;
	    i:= contains([map(op(args()), type)], "Pnegate");
	    if i > 0 then
	      return(POp::Psubtract(args(3 - i), op(args(i))))
	    end_if;
	    return(new(Pplus, args()))
	  else
	    return(args())
	  end_if
	end_proc:

Pplus::expr:=
	proc()
	begin
	  POp::_expr(_plus, op(args()))
	end_proc:
	
Pplus::print:=
	proc()
	  local i, l;
	begin
	  if nops(args()) > 0 then
	    if nops(op(args(), 1)) > 1 and nops(args()) > 1 then
	      l:= "(" . expr2text(op(args(), 1)) . ")"
	    else
	      l:= expr2text(op(args(), 1))
	    end_if;
	    i:= 2;
	    while i <= nops(args()) do
	      if nops(op(args(), i)) > 1 then
	        l:= l . " + (" . expr2text(op(args(), i)) . ")"
	      else
		l:= l . " + " . expr2text(op(args(), i))
	      end_if;
	      i:= i + 1
	    end_while;
	    l
	  end_if
	end_proc:

unalias(Pplus):
unalias(POp):