

#( Ppower - Domain of 'And of Properties' )#

alias(POp = property::POp):
alias(Ppower = POp::Ppower):

Ppower:= domain("POp::Ppower"):
Ppower::info:= "Inversion of Properties":
Ppower::type:= "Ppower":
Ppower::Ptype:= "Ptype":
  
Ppower::new:=
	proc()
	begin
	  if args(0) > 2 then
	    return(new(Ppower, args(1), Pmult(args(2..args(0)))))
	  end_if;
	  if args(0) = 2 then
	    if args(2) = -1 then
	      return(new(POp::Pinvert, args(1)))
	    end_if;
	    if args(2) = 1 then
	      return(args(1))
	    end_if;
	    if args(1) = 1 then
	      return(1)
	    end_if;
	    return(new(Ppower, args()))
	  else
	    return(args())
	  end_if
	end_proc:

Ppower::expr:=
	proc()
	begin
	  POp::_expr(_power, args())
	end_proc:
	
Ppower::print:=
	proc()
	  local i, l;
	begin
	  if nops(args()) > 0 then
	    l:= expr2text(op(args(), 1));
	    i:= 2;
	    while i <= nops(args()) do
	      l:= l . "^" . expr2text(op(args(), i));
	      i:= i + 1
	    end_while;
	    l
	  end_if
	end_proc:

unalias(Ppower):
unalias(POp):