

#( Psubtract - Domain of 'Subtraction of Properties' )#

alias(POp = property::POp):
alias(Psubtract = POp::Psubtract):

Psubtract:= domain("POp::Psubtract"):
Psubtract::info:= "Subtraction of Properties":
Psubtract::type:= "Psubtract":
Psubtract::Ptype:= "Ptype":
  
Psubtract::new:=
	proc()
	begin
	  if args(0) > 2 then
	    return(new(Psubtract, args(1), POp::Pplus(args(2..args(0)))));
	  end_if;
	  if args(0) = 2 then
	    if type(args(2)) = "Pnegate" then
	      return(POp::Pplus(args(1), op(args(2))))
	    end_if;
	    return(new(Psubtract, args()))
	  else
	    return(args())
	  end_if
	end_proc:

Psubtract::expr:=
	proc()
	begin
	  POp::_expr(_subtract, args())
	end_proc:
	
Psubtract::print:=
	proc()
	  local l;
	begin
	  if nops(args()) > 0 then
	    if nops(op(args(), 1)) > 1 then
	      l:= "(".expr2text(op(args(), 1)).")"
	    else
	      l:= expr2text(op(args(), 1))
	    end_if;
	    if nops(op(args(), 2)) > 1 then
	      l:= l." - "."(".expr2text(op(args(), 2)).")"
	    else
	      l:= l." - ".expr2text(op(args(), 2))
	    end_if;
	    l
	  end_if
	end_proc:

unalias(Psubtract):
unalias(POp):
