

#(
   Rel     - Domain of Relations

   op(Rel) - Identifier
             Relation:   1 = "_less"
                         2 = "_leequal"
                         3 = "_unequal"
                         4 = "_equal"
                         5 = "_moequal"
                         6 = "_more"
             Border
)#

alias(Rel = property::Rel):
alias(Ar(x) = [1, x]):
alias(Arg(x, y) = op(extop(x, 1), y)):
alias(Nul = property::Nul):

Rel:= domain("property::Rel"):
Rel::info:= "Domain of algebraic property 'Relations of Identifiers'":
Rel::domtype:= fun(Type):
Rel::type:= "Rel":
Rel::prop:= TRUE:
Rel::propdom:= domattr(property, "Rel"):
Rel::autoload:= TRUE:
Rel::testtype:= Type::testtype:

Rel::ax:= []:

Rel::__op:= [hold(_less),        #( 1 )#
             hold(_leequal),     #( 2 )#
             hold(_unequal),     #( 3 )#
             hold(_equal),       #( 4 )#
             hold(_moequal),     #( 5 )#
             hold(_more)]:       #( 6 )#

Rel::__po:= [" < ",              #( 1 )#
             " <= ",             #( 2 )#
             " <> ",             #( 3 )#
             " = ",              #( 4 )#
             " >= ",             #( 5 )#
             " > "]:             #( 6 )#

#( Ergebnis-Tabelle f"ur Operatoren, wenn `Border' gleich sind )#
#(            "<"       "<="      "<>"      "="       ">="      ">"     )#
Rel::__xx:= [[TRUE,     TRUE,     TRUE,     FALSE,    FALSE,    FALSE   ],
#( "<=" )#   [UNKNOWN,  TRUE,     UNKNOWN,  UNKNOWN,  UNKNOWN,  FALSE   ],
#( "<>" )#   [UNKNOWN,  UNKNOWN,  TRUE,     FALSE,    UNKNOWN,  UNKNOWN ],
#( "="  )#   [FALSE,    TRUE,     FALSE,    TRUE,     TRUE,     FALSE   ],
#( ">=" )#   [FALSE,    UNKNOWN,  UNKNOWN,  UNKNOWN,  TRUE,     UNKNOWN ],
#( ">"  )#   [FALSE,    FALSE,    TRUE,     FALSE,    TRUE,     TRUE    ]]:

#( Verkn"upfungs-Tabelle f"ur Operatoren, wenn `Border' ungleich sind )#
#(            "<"       "<="      "<>"      "="       ">="      ">"     )#
Rel::__xy:= [[_leequal, _leequal, _leequal, UNKNOWN,  UNKNOWN,  UNKNOWN ],
#( "<=" )#   [_less,    _leequal, _less,    UNKNOWN,  UNKNOWN,  UNKNOWN ],
#( "<>" )#   [UNKNOWN,  UNKNOWN,  _equal,   UNKNOWN,  UNKNOWN,  UNKNOWN ],
#( "="  )#   [_less,    _leequal, _unequal, _equal,   _leequal, _less   ],
#( ">=" )#   [UNKNOWN,  UNKNOWN,  _less,    UNKNOWN,  _leequal, _leequal],
#( ">"  )#   [UNKNOWN,  UNKNOWN,  _leequal, UNKNOWN,  _leequal, _less   ]]:

#( ident, operator, border )#
Rel::new:= 
	proc()
	begin
	  #if args(0) = 0 then#
	    #return(domattr(Type, "Relation")([0, hold(_equal), 0]))#
	  #end_if;#

	  if type(args(2)) = "_mult" then
	    if contains({hold(_equal), hold(_unequal)},
			op(args(2), 3 - contains([op(args(2))], -1))) then
	      #domattr(Type, "Relation")#
	      new(Rel,
	             ([args(1), contains(Rel::__op, op(args(2),
		       3 - contains([op(args(2))], -1))), args(3)]))
	    else
	      #domattr(Type, "Relation")#
	      new(Rel,
	             ([args(1), 7 - contains(Rel::__op, op(args(2),
		       3 - contains([op(args(2))], -1))), args(3)]))
	    end_if
	  else
	    if contains(Rel::__op, args(2)) > 2 then
	      #domattr(Type, "Relation")#
	      new(Rel,
	             ([args(1), contains(Rel::__op, args(2)), args(3)]))
	    else
	      #domattr(Type, "Relation")#
	      new(Rel,
	             ([args(1), contains(Rel::__op, args(2)), args(3)]))
	    end_if
	  end_if
	end_proc:

Rel::is:=
	proc()
	  local __o;
	begin
	  if args(0) < 2 then return(UNKNOWN) end_if;

	  #if type(args(1)) <> "Rel" and type(args(2)) <> "Rel" then#
	    #return(UNKNOWN)#
	  #end_if;#

	  #( numerisch )#
	  #if Arg(args(1), 2) = 4 and#
	     #((map({Arg(args(1), 1), Arg(args(2), 1)}, domtype) minus#
	      #{DOM_INT, DOM_FLOAT, DOM_RAT}) = {}) then#
	    #return(bool(_if((__o:= Arg(args(2), 2)) > 4,#
	                    #Arg(Rel::__op, 7 - __o)#
	                      #(Arg(args(2), 3), Arg(args(1), 3)),#
	                    #Arg(Rel::__op, __o)#
	                      #(Arg(args(1), 3), Arg(args(2), 3)))))#
	  #end_if;#

	  #( Intervall )#
	  if type(args(1)) = "IV" then
	    __o:= 1;
	    if Arg(args(3 - __o), 2) > 4 then
	      return(Rel::is(_if(__o = 1,
	                         (property::IV)::Rel(args(1), ">"), args(1)),
	                     _if(__o = 2,
	                         (property::IV)::Rel(args(2), ">"), args(2))))
	    else
	      return(Rel::is(_if(__o = 1,
	                         (property::IV)::Rel(args(1), "<"), args(1)),
	                     _if(__o = 2,
	                         (property::IV)::Rel(args(2), "<"), args(2))))
	    end_if
	  end_if;

	  #( numerisch )#
	  if type(args(1)) <> "Rel" then
	    #( eval notwendig? )#
	    __o:= map([#eval#(args(1)), #eval#(Arg(args(2), 3))], float);
	    if map({op(__o)}, fun(bool(type(args()) = DOM_FLOAT) or
	               contains({infinity, -infinity}, args()))) = {TRUE} then
	      if Arg(args(2), 2) < 5 then
	        return(bool(op(Rel::__op, Arg(args(2), 2))
	                      (op(__o, 1), op(__o, 2))))
	      else
	        return(bool(op(Rel::__op, Rel::inv(Arg(args(2), 2)))
	                      (op(__o, 2), op(__o, 1))))
	      end_if
	    end_if;
	    return(UNKNOWN)
	  end_if;

	  #( Ident ohne property )#

	  #(  )#
	  if type(args(2)) <> "Rel" then return(UNKNOWN) end_if;

	  if Arg(args(1), 3) <> Arg(args(2), 3) then
	    __o:= op(op(Rel::__xy, Arg(args(1), 2)), Arg(args(2), 2));
	    if __o <> UNKNOWN then
	      if (Arg(args(1), 2) > 4) or (Arg(args(2), 2) > 4) then
	        return(property::_is(Arg(args(2), 3) &__o Arg(args(1), 3))
		       or UNKNOWN)
	      else
	        return(property::_is(Arg(args(1), 3) &__o Arg(args(2), 3))
	               or UNKNOWN)
	      end_if
	    elif contains({5, 6, 10, 12}, Arg(args(1), 2)*Arg(args(2), 2)) then
	      __o:= eval(op(Rel::__op, Arg(args(2), 2)));
	      if Arg(args(2), 2) > 4 then
	        __o:= eval(op(Rel::__op, 7 - Arg(args(2), 2)));
	        return(not(property::_is(Arg(args(1), 3) &__o Arg(args(2), 3)))
	               and UNKNOWN)
	      else
	        return(not(property::_is(Arg(args(2), 3) &__o Arg(args(1), 3)))
	               and UNKNOWN)
	      end_if
	    #elif Arg(args(2), 2) <> 4 then#
	      #return(property::_is(#
		           #(op(Rel::__op, Arg(args(2), 2)))#
		              #(Arg(args(2), 3), Arg(args(1), 3))))#
	    end_if;
	    return(UNKNOWN)
	  end_if;
	  return(op(op(Rel::__xx, Arg(args(1), 2)), Arg(args(2), 2)))
	end_proc:

#( indets )#
Rel::indets:=
	proc()
	begin
	  indets(Arg(args(), 3))
	end_proc:

#( Type::Constant )#
Rel::constant:=
	proc()
	begin
	  if Arg(args(), 2) = 4 then
	    property::_is(Arg(args(), 3), Type::Constant)
	  else
	    UNKNOWN
	  end_if;
	end_proc:

Rel::float:=
	proc()
	begin
	  if Arg(args(), 2) = 4 then
	    return(float(Arg(args(), 3)))
	  end_if;
	  hold(float)(args())
	end_proc:

#( TRUE, wenn </<= .. >=/> oder >=/> .. </<= )#
Rel::neq:=
	proc()
	begin
	  bool(args(1) < 3 and args(2) > 4) or
	  bool(args(1) > 4 and args(2) < 3)
	  #bool(Arg(args(1), 2) < 3 and Arg(args(2), 2) > 4) or#
	  #bool(Arg(args(1), 2) > 4 and Arg(args(2), 2) < 3)#
	end_proc:

#( TRUE, wenn </<= .. >=/> oder >=/> .. </<= )#
Rel::inv:=
	proc()
	begin
	  op([6, 5, 3, 4, 2, 1], args())
	end_proc:

#( Signum analog zu Intervallen )#
Rel::sign:=
	proc()
	begin
	  if property::_is(Arg(args(), 3) = 0) = TRUE then
	    op([-1, -0.5, 0, 0, 0.5, 1], Arg(args(), 2))
	  elif property::_is(Arg(args(), 3) > 0) = TRUE then
	    op([0, 0, 0, 1, 1, 1], Arg(args(), 2))
	  elif property::_is(Arg(args(), 3) < 0) = TRUE then
	    op([-1, -1, 0, -1, 0, 0], Arg(args(), 2))
	  else
	    0
	  end_if;
	end_proc:

Rel::_not:=
	proc()
	begin
	  case Arg(args(1), 2)
	  of 4 do
	    return(subsop(args(1), Ar(2) = 3))
	  of 3 do
	    return(subsop(args(1), Ar(2) = 4))
	  end_case;
	  return(subsop(args(1), Ar(2) = modp((Arg(args(1), 2) + 4), 8)))
	end_proc:

#( Verkn"upfungs-Tabelle f"ur _and, wenn `Border' gleich sind )#
#(            "<"   "<="  "<>"  "="   ">="  ">" )#
Rel::__ax:= [[1,    1,    1,    FAIL, FAIL, FAIL],
#( "<=" )#   [1,    2,    1,    4,    4,    FAIL],
#( "<>" )#   [1,    1,    3,    FAIL, 6,    6   ],
#( "="  )#   [FAIL, 4,    FAIL, 4,    4,    FAIL],
#( ">=" )#   [FAIL, 4,    6,    4,    5,    6   ],
#( ">"  )#   [FAIL, FAIL, 6,    FAIL, 6,    6   ]]:

Rel::_and:=
	proc()
	begin
	  property::_Op(Rel, _and,
	    proc()
	      local __op, __pq, __ar;
	    begin
	      if property::isprop(args(1), args(2)) = TRUE then
	        return(args(1))
	      end_if;
	      __ar:= Arg(args(1), 3), Arg(args(2), 3);
	      if _equal(__ar) then
	        if (__op:= op(Rel::__ax, [Arg(args(1), 2), Arg(args(2), 2)]))
	           <> FAIL then
	          return(subsop(args(1), _if(Arg(args(1), 1) = Arg(args(2), 1),
	                        null(), Ar(1) = Nul), Ar(2) = __op))
	        else
	          return(property::Null)
	        end_if
	      end_if;
	      __pq:= {Arg(args(1), 2), Arg(args(2), 2)};
	      if __pq intersect {1, 2} = {} then
	        if type((__op:= max(__ar))) <> "max" then
	          return(subsop(args(contains([__ar], __op)), Ar(1) = Nul))
	        end_if
	      end_if;
	      if __pq intersect {5, 6} = {} then
	        if type((__op:= min(__ar))) <> "min" then
	          return(subsop(args(contains([__ar], __op)), Ar(1) = Nul))
	        end_if
	      end_if;
	      #if (__op:= property::_is(Arg(args(1), 3) < Arg(args(2), 3)))#
	         #= TRUE then#
	        #if (__op:= property::_is(Arg(args(1), 3) <= Arg(args(2), 3)))#
	           #= TRUE then#
	          
	        #end_if#
	      #elif (__op:= property::_is()) = TRUE then#
	        #if (__op:= property::_is()) = TRUE then#
	          
	        #end_if#
	      #end_if;#
	      #if (Arg(args(1), 2) > 4 and Arg(args(2), 2) < 3) then#
	        #return()#
	      #elif (Arg(args(1), 2) > 4 and Arg(args(2), 2) < 3) then#
	        #return()#
	      #end_if;#
	      #return(_and(Rel::IV(args(1)), Rel::IV(args(2))))#
	      return(hold(_and)(args()))
	    end_proc, args())
	end_proc:

#( Verkn"upfungs-Tabelle f"ur _and, wenn `Border' gleich sind )#
#(            "<"   "<="  "<>"  "="   ">="  ">" )#
Rel::__ox:= [[1,    2,    3,    2,    FAIL, 3   ],
#( "<=" )#   [2,    2,    FAIL, 2,    FAIL, FAIL],
#( "<>" )#   [3,    FAIL, 3,    FAIL, FAIL, 3   ],
#( "="  )#   [2,    2,    FAIL, 4,    5,    5   ],
#( ">=" )#   [FAIL, FAIL, FAIL, 5,    5,    5   ],
#( ">"  )#   [3,    FAIL, 3,    5,    5,    6   ]]:

Rel::_or:=
	proc()
	begin
	  property::_Op(Rel, _or,
	    proc()
	      local __op, __pq, __ar;
	    begin
	      if property::isprop(args(1), args(2)) = TRUE then
	        return(args(2))
	      end_if;
	      __ar:= Arg(args(1), 3), Arg(args(2), 3);
	      if _equal(__ar) then
	        if (__op:= op(Rel::__ox, [Arg(args(1), 2), Arg(args(2), 2)]))
	           <> FAIL then
	          return(subsop(args(1), _if(Arg(args(1), 1) = Arg(args(2), 1),
	                                 null(), Ar(1) = Nul), Ar(2) = __op))
	        else
	          return(property::IV(-infinity, infinity))
	        end_if
	      end_if;
	      __pq:= {Arg(args(1), 2), Arg(args(2), 2)};
	      if __pq intersect {1, 2} = {} then
	        if type((__op:= min(__ar))) <> "min" then
	          return(subsop(args(contains([__ar], __op)), Ar(1) = Nul))
	        end_if
	      end_if;
	      if __pq intersect {5, 6} = {} then
	        if type((__op:= max(__ar))) <> "max" then
	          return(subsop(args(contains([__ar], __op)), Ar(1) = Nul))
	        end_if
	      end_if;
	      #return(_or(Rel::IV(args(1)), Rel::IV(args(2))))#
	      return(hold(_or)(args()))
	    end_proc, args())
	end_proc:

Rel::_plus:=
	proc()
	begin
	  property::_Op(Rel, _plus,
	    proc()
	    begin
	      if Arg(args(1), 2) = Arg(args(2), 2) then
	        if Arg(args(1), 2) <> 3 then
	          return(subsop(args(1), Ar(1) = Arg(args(1), 1) + Arg(args(2), 1),
			                 Ar(3) = Arg(args(1), 3) + Arg(args(2), 3)))
	        end_if
	      #( 1+2=3,1*2=2; 5+6mod8=3,5*6mod25=5 )#
	      elif modp(Arg(args(1), 2) + Arg(args(2), 2), 8) = 3 then
	        return(subsop(args(1), Ar(1) = Arg(args(1), 1) + Arg(args(2), 1),
			               Ar(2) = _if(Arg(args(1), 2) < 3, 1, 6),
			               Ar(3) = Arg(args(1), 3) + Arg(args(2), 3)))
	      elif Arg(args(1), 2) = 4 then
	        return(subsop(args(2), Ar(1) = Arg(args(1), 1)+Arg(args(2), 1),
			               Ar(3) = Arg(args(1), 3)+Arg(args(2), 3)))
	      elif Arg(args(2), 2) = 4 then
	        return(subsop(args(1), Ar(1) = Arg(args(1), 1)+Arg(args(2), 1),
			               Ar(3) = Arg(args(1), 3)+Arg(args(2), 3)))
	      end_if;
	      return(Type::RealNum)
	      #return(hold(_plus)(args()))#
	    end_proc, args())
	end_proc:

Rel::_subtract:=
	proc()
	begin
	  property::_Op(Rel, _subtract,
	    proc()
	    begin
	      if Rel::neq(Arg(args(1), 2), Arg(args(2), 2)) then
	        return(subsop(args(1), Ar(1) = Arg(args(1), 1) - Arg(args(2), 1),
			               Ar(3) = Arg(args(1), 3) - Arg(args(2), 3)))
	      #( < > )#
	      elif Arg(args(1), 2) = 4 then
	        return(subsop(args(2), Ar(1) = Arg(args(1), 1) - Arg(args(2), 1),
			               Ar(2) = Rel::inv(Arg(args(2), 2)),
			               Ar(3) = Arg(args(1), 3) - Arg(args(2), 3)))
	      elif Arg(args(2), 2) = 4 then
	        return(subsop(args(1), Ar(1) = Arg(args(1), 1) - Arg(args(2), 1),
			               Ar(3) = Arg(args(1), 3) - Arg(args(2), 3)))
	      end_if;
	      return(Type::RealNum)
	      #return(hold(_subtract)(args()))#
	    end_proc, args())
	end_proc:

Rel::_negate:=
	proc()
	begin
	  return(subsop(args(1), Ar(1) = -(Arg(args(1), 1)),
		                 Ar(2) = Rel::inv(Arg(args(1), 2)),
		                 Ar(3) = -(Arg(args(1), 3))))
	end_proc:

#( _leequal eines Nulloperanden )#
#( sign_1, sign_2, op_1, op_2, op_alt )#
Rel::__muop:=
	proc()
	begin
	  if args(1) = 0.5 and (args(3) mod 5) <> 1 then args(3)
	  elif args(1) = -0.5 and (args(3) mod 5) <> 1 then Rel::inv(args(3))
	  elif args(2) = 0.5 and (args(4) mod 5) <> 1 then args(4)
	  elif args(2) = -0.5 and (args(4) mod 5) <> 1 then Rel::inv(args(4))
	  else args(5)
	  end_if
	end_proc:

Rel::_mult:=
	proc()
	begin
	  property::_Op(Rel, _mult,
	    proc()
	      local __ar, __s1, __s2;
	    begin
	      __s1:= Rel::sign(args(1));
	      __s2:= Rel::sign(args(2));
	      __ar:= [Arg(args(1), 2), Arg(args(2), 2)];

	      if Arg(args(1), 2) = 4 then
	        return(subsop(args(2), Ar(1) = Arg(args(1), 1)*Arg(args(2), 1),
	                               _if(__s1 = 0, Ar(2) = 4, null()),
		                       Ar(3) = Arg(args(1), 3)*Arg(args(2), 3)))
	      elif Arg(args(2), 2) = 4 then
	        return(subsop(args(1), Ar(1) = Arg(args(1), 1)*Arg(args(2), 1),
	                               _if(__s2 = 0, Ar(2) = 4, null()),
			               Ar(3) = Arg(args(1), 3)*Arg(args(2), 3)))
	      end_if;

	      if __s1 > 0 then
	        if __s2 > 0 then
	          if {op(__ar)} minus {5, 6} = {} then
	            return(subsop(args(1),
	                   Ar(1) = Arg(args(1), 1)*Arg(args(2), 1),
	                   Ar(2) = Rel::__muop(__s1, __s2, op(__ar), max(op(__ar))),
			   Ar(3) = Arg(args(1), 3)*Arg(args(2), 3)))
	          end_if
	        elif __s2 < 0 then
	          if {op(__ar, 1)} minus {5, 6} = {} and
	             {op(__ar, 2)} minus {1, 2} = {} then
	            return(subsop(args(2),
	                   Ar(1) = Arg(args(1), 1)*Arg(args(2), 1),
	                   Ar(2) = Rel::__muop(__s1, __s2, op(__ar),
	                             min(Rel::inv(op(__ar, 1)), op(__ar, 2))),
			   Ar(3) = Arg(args(1), 3)*Arg(args(2), 3)))
	          end_if
	        end_if
	      elif __s1 < 0 then
	        if __s2 > 0 then
	          if {op(__ar, 2)} minus {5, 6} = {} and
	             {op(__ar, 1)} minus {1, 2} = {} then
	            return(subsop(args(1),
	                   Ar(1) = Arg(args(1), 1)*Arg(args(2), 1),
	                   Ar(2) = Rel::__muop(__s1, __s2, op(__ar),
	                             max(Rel::inv(op(__ar, 2)), op(__ar, 1))),
			   Ar(3) = Arg(args(1), 3)*Arg(args(2), 3)))
	          end_if
	        elif __s2 < 0 then
	          if {op(__ar)} minus {1, 2} = {} then
	            return(subsop(args(1),
	                   Ar(1) = Arg(args(1), 1)*Arg(args(2), 1),
	                   Ar(2) = Rel::__muop(__s1, __s2, op(__ar),
	                             Rel::inv(min(op(__ar)))),
			   Ar(3) = Arg(args(1), 3)*Arg(args(2), 3)))
	          end_if
	        end_if
	      end_if;

	      return(Type::RealNum)
	      #return(hold(_mult)(args()))#
	    end_proc, args())
	end_proc:

Rel::_divide:=
	proc()
	begin
	  property::_Op(Rel, _divide,
	    proc()
	      local __ar, __s1, __s2;
	    begin
	      __s2:= Rel::sign(args(2));
	      #( Null Teiler )#
	      if abs(__s2) < 1 then
	        if contains({2, 4, 5}, Arg(args(2), 2)) then
	          return(property::Undefined)
	        elif Arg(args(2), 2) = 3 and
	             property::_is(Arg(args(2), 3) <> 0) = TRUE then
	          return(property::Undefined)
	        end_if
	      end_if;

	      __s1:= Rel::sign(args(1));
	      __ar:= [Arg(args(1), 2), Arg(args(2), 2)];
	      #( =x )#
	      if Arg(args(1), 2) = 4 then
	        if abs(__s2) = 1 then
	          if sign(__s1*__s2) < 0 then
	            return(subsop(args(2), Ar(1) = Arg(args(1), 1)/Arg(args(2), 1),
	                                   Ar(2) = 1, Ar(3) = 0))
	          elif sign(__s1*__s2) > 0 then
	            return(subsop(args(2), Ar(1) = Arg(args(1), 1)/Arg(args(2), 1),
	                                   Ar(2) = 6, Ar(3) = 0))
	          elif property::_is(Arg(args(1),3) = 0) = TRUE then
	            return(subsop(args(1), Ar(1) = Arg(args(1), 1)/Arg(args(2), 1),
	                                   Ar(3) = 0))
	          end_if
	        end_if
	      elif Arg(args(2), 2) = 4 then
	        if abs(__s1) = 1 then
	          if sign(__s1*__s2) < 0 then
	            return(subsop(args(1), Ar(1) = Arg(args(1), 1)/Arg(args(2), 1),
	                                   Ar(2) = 1, Ar(3) = 0))
	          elif sign(__s1*__s2) > 0 then
	            return(subsop(args(1), Ar(1) = Arg(args(1), 1)/Arg(args(2), 1),
	                                   Ar(2) = 6, Ar(3) = 0))
	          elif property::_is(Arg(args(1),3) = 0) = TRUE then
	            return(subsop(args(2), Ar(1) = Arg(args(1), 1)/Arg(args(2), 1),
	                                   Ar(3) = 0))
	          end_if
	        end_if
	      end_if;

	      if __s1 > 0 then
	        if __s2 > 0 then
	          if {op(__ar)} minus {5, 6} = {} then
	            return(subsop(args(1),
	                   Ar(1) = Arg(args(1), 1)/Arg(args(2), 1),
	                   Ar(2) = 6, Ar(3) = 0))
	          end_if
	        elif __s2 < 0 then
	          if {op(__ar, 1)} minus {5, 6} = {} and
	             {op(__ar, 2)} minus {1, 2} = {} then
	            return(subsop(args(2),
	                   Ar(1) = Arg(args(1), 1)/Arg(args(2), 1),
	                   Ar(2) = 1, Ar(3) = 0))
	          end_if
	        end_if
	      elif __s1 < 0 then
	        if __s2 > 0 then
	          if {op(__ar, 2)} minus {5, 6} = {} and
	             {op(__ar, 1)} minus {1, 2} = {} then
	            return(subsop(args(1),
	                   Ar(1) = Arg(args(1), 1)/Arg(args(2), 1),
	                   Ar(2) = 1, Ar(3) = 0))
	          end_if
	        elif __s2 < 0 then
	          if {op(__ar)} minus {1, 2} = {} then
	            return(subsop(args(1),
	                   Ar(1) = Arg(args(1), 1)/Arg(args(2), 1),
	                   Ar(2) = 6, Ar(3) = 0))
	          end_if
	        end_if
	      end_if;

	      #( genau (un)gleich )#
	      if {op(__ar)} minus {3, 4} = {} then
	        if {op(__ar)} = {4} then
	          return(subsop(args(1), Ar(1) = Arg(args(1), 1)/Arg(args(2), 1),
	                                 Ar(3) = Arg(args(1), 3)/Arg(args(2), 3)))
	        elif {op(__ar)} = {3, 4} then
	          return(subsop(args(1), Ar(1) = Arg(args(1), 1)/Arg(args(2), 1),
	                 Ar(2) = 3, Ar(3) = Arg(args(1), 3)/Arg(args(2), 3)))
	        end_if
	      end_if;

	      return(Type::RealNum)
	      #return(hold(_divide)(args()))#
	    end_proc, args())
	end_proc:

Rel::_invert:=
	proc()
	begin
	  if property::_is(Arg(args(), 3) > 0) = TRUE then
	    if Arg(args(), 2) = 4 then
	      return(subsop(args(), Ar(1) = 1/Arg(args(), 1),
	                            Ar(3) = 1/Arg(args(), 3)))
	    elif Arg(args(), 2) > 4 then
	      if property::_is(Arg(args(), 3) <= 1) = TRUE then
	        return(property::IV(0, [1]))
	      else
	        return(subsop(args(), Ar(1) = 1/Arg(args(), 1),
	                              Ar(2) = 6, Ar(3) = 0))
	      end_if
	    end_if
	  elif property::_is(Arg(args(), 3) < 0) = TRUE then
	    if Arg(args(), 2) = 4 then
	      return(subsop(args(), Ar(1) = 1/Arg(args(), 1),
	                            Ar(3) = 1/Arg(args(), 3)))
	    elif Arg(args(), 2) < 3 then
	      if property::_is(Arg(args(), 3) >= -1) = TRUE then
	        return(property::IV([-1], 0))
	      else
	        return(subsop(args(), Ar(1) = 1/Arg(args(), 1),
	                              Ar(2) = 1, Ar(3) = 0))
	      end_if
	    end_if
	  end_if;
	  if property::_is(Arg(args(), 3) = 0) = FALSE then
	    return(subsop(args(), Ar(1) = 1/Arg(args(), 1),
	                          Ar(3) = 1/Arg(args(), 3)))
	  elif property::_is(Arg(args(), 3) = 0) = TRUE then
	    if Arg(args(), 2) = 3 then
	      return(subsop(args(), Ar(1) = 1/Arg(args(), 1),
	                            Ar(3) = 0))
	    end_if
	  end_if;
	  return(property::Undefined)
	end_proc:

Rel::_power:=
	proc()
	begin
	  #property::_Op(Rel, _power,#
	    #proc()#
	    #begin#
	      if type(args(1)) <> "Rel" then
	        return(hold(_power)(args()))
	      end_if;

	      if type(args(2)) <> "Rel" then
	        #( Quadrat einer Relation )#
	        if property::_is(args(2), Type::Even) = TRUE then
	          #( > 0 )#
	          if property::_is(Arg(args(1), 3) >= 0, ">") = TRUE then
	            if Arg(args(1), 2) > 2 then
	              return(subsop(args(1), Ar(1) = Arg(args(1), 1)^args(2),
	                                     Ar(3) = Arg(args(1), 3)^args(2)))
	            else
	              return(subsop(args(1), Ar(1) = Arg(args(1), 1)^args(2),
		                             Ar(2) = 7 - Arg(args(1), 2),
	                                     Ar(3) = 0))
	            end_if
	          #( < 0 )#
	          elif property::_is(Arg(args(1), 3) <= 0, "<") = TRUE then
	            if Arg(args(1), 2) < 5 then
	              return(subsop(args(1), Ar(1) = Arg(args(1), 1)^args(2),
		                             _if(Arg(args(1), 2) < 3,
		                                 Ar(2) = 7 - Arg(args(1), 2),
	                                             null()),
	                                     Ar(3) = Arg(args(1), 3)^args(2)))
	            else
	              return(subsop(args(1), Ar(1) = Arg(args(1), 1)^args(2),
	                                     Ar(3) = 0))
	            end_if
	          end_if
	        end_if;
	        #( hoch Null )#
	        if property::_is(args(2) = 0) = TRUE then
	          return(subsop(args(1), Ar(1) = Arg(args(1), 1)^0,
	                                 Ar(3) = Arg(args(1), 3)^0))
	        elif property::_is(args(2) < 0) = TRUE then
	          return(Rel::_invert(Rel::_power(args(1), -args(2))))
	        end_if;
	        if type(args(2)) <> "Rel" then
	          return(property::_Op(domattr(args(2), "propdom"),
	                               _power, _power, args()))
	        end_if
	      else
	        if Arg(args(1), 2) = Arg(args(2), 2) then
	          return(subsop(args(1), Ar(1) = Arg(args(1), 1)^Arg(args(2), 1),
			                 Ar(3) = Arg(args(1), 3)^Arg(args(2), 3)))
	        end_if
	      end_if;
	      return(hold(_power)(args()))
	    #end_proc, args())#
	end_proc:

Rel::NRange:=
	proc()
	begin
	  #userinfo(10, "Rel::NRange: args - ".expr2text(Arg(args())));#
	  case Arg(args(1), 2)
	  of 4 do
	    return((Arg(args(1), 3))::NRange(Arg(args(1), 3)))
	  of 1 do #( < )#
	    if property::_is(Arg(args(1), 3) <= 0) = TRUE then
	      return(property::NRange("Negative"))
	    end_if
	  of 2 do #( <= )#
	    if property::_is(Arg(args(1), 3) < 0) = TRUE then
	      return(property::NRange("Negative"))
	    end_if
	  of 3 do return(FAIL)
	  of 5 do #( >= )#
	    if property::_is(Arg(args(1), 3) > 0) = TRUE then
	      return(property::NRange("Positive"))
	    elif property::_is(Arg(args(1), 3) >= 0) = TRUE then
	      return(property::NRange("NonNegative"))
	    end_if
	  of 6 do #( > )#
	    if property::_is(Arg(args(1), 3) >= 0) = TRUE then
	      return(property::NRange("Positive"))
	    end_if
	  end_case;
	  if domtype(Arg(args(1), 3)) = DOM_IDENT then return(FAIL) end_if;
	  #return(FAIL);#
	  return(property::NRange("RealNum"))
	end_proc:

Rel::IV:=
	proc()
	begin
	  case Arg(args(1), 2)
	  of 1 do return(property::IV(-infinity, Arg(args(1), 3)))
	  of 2 do return(property::IV(-infinity, [Arg(args(1), 3)]))
	  of 3 do return(hold(_or)(property::IV(-infinity, Arg(args(1), 3)),
	                           property::IV(Arg(args(1), 3), infinity)))
	  of 4 do return(property::IV([Arg(args(1), 3)], [Arg(args(1), 3)]))
	  of 5 do return(property::IV([Arg(args(1), 3)], infinity))
	  of 6 do return(property::IV(Arg(args(1), 3), infinity))
	  end_case
	end_proc:

Rel::print:=
	proc()
	begin
	  if type(args()) <> "Rel" then return("not a Rel") end_if; 
	  "("._if(domtype(Arg(args(1), 1)) = DOM_STRING, id, expr2text)
	         (Arg(args(1), 1)).
	   _if(contains({1,2,3,4,5,6}, Arg(args(1), 2)),
	                               op(Rel::__po, Arg(args(1), 2)), " ? ").
	   expr2text(Arg(args(1), 3)).")"
	end_proc:

unalias(Nul):
unalias(Ar):
unalias(Arg):
unalias(Rel):
