# given a linear recurrence with polynomial coefficients for u(n),
  returns the recurrence for u(n)/n!.
  Example:

>> rec::borel(2*u(n)+2*(n+1)*u(n+1)+(n+1)*(n+2)*u(n+2),u,n);

                      2 u(n) + 2 u(n + 1) + u(n + 2)
#
rec::borel := proc(r,u,n)
begin
   r:=expand(numer(r));
   if type(r)="_plus" then r:=map(r,rec::borel2,u,n)
   else r:=rec::borel2(r,u,n)
   end_if;
   numer(r)
end_proc:

# t should be c*n^k*u(n+i) #
rec::borel2 := proc(t,u,n) local v,i,j;
begin
   v:=select(t,has,u);
   i:=op(v)-n;
   _mult(n+j$j=1..i);
   subs(t,v=v/%)
end_proc:
