# $Date: 1997/08/07 13:43:26 $ $Author: tonner $ $Revision: 1.5 $ #

#--
	Si/Series -- the function attribut "series" for Si
--#

Si:= funcattr(Si, "series", proc(e,x,n)
   local l,k,f,g,sg;
begin
   l:=limit(e,x,Right);
   if l=0 then # formula 5.2.14 #
      f:=series(_plus((-1)^k*x^(2*k+1)/(2*k+1)/fact(2*k+1)
	    $ k=0..(n-2) div 2),x,n);
      if e=x then f else f @ series(e,x,n) end_if
   elif l=infinity or l=-infinity then
      sg:=(if l=infinity then 1 else e:=-e; -1 end_if);
      # Si(-x)=-Si(x) #
      # 5.2.34 #
      f:=series(_plus((-1)^k*fact(2*k)*x^(2*k+1)$k=0..(n-2) div 2),x,n);
      # 5.2.35 #
      g:=series(_plus((-1)^k*fact(2*k+1)*x^(2*k+2)$k=0..(n-3) div 2),x,n);
      if e<>1/x then l:=series(1/e,x,n); f:=f @ l; g:=g @ l end_if;
      # 5.2.8 #
      PI/2-f*cos(e); %-g*sin(e); if sg=1 then % else -% end_if
   else Series::unknown(Si(e),x,n)
   end_if
end_proc):

# end of file #
