# $Date: 1999/02/03 13:43:55 $ $Author: fakler $ $Revision: 1.5.2.1 $ #

#--
	cos/Series -- the function attribut "series" for cos
--#

cos:=funcattr(cos,"series",proc(f,x,n) local t,k,a;
begin
   if f=x then Puiseux::create(1,0,n,Series::gen["cos"](n),x)
   else
      t:=Series::Puiseux(f,x,n);
      if type(t)<>Puiseux then return(FAIL) end_if;
      k:=ldegree(t);
      if k>0 then Puiseux::_fconcat(
          Puiseux::create(1,0,n,Series::gen["cos"](n),x),t)
      elif k=0 then
         a:=lcoeff(t);
         t:=f-a;
         cos(a)*series(cos(t),x,n)-sin(a)*series(sin(t),x,n)
      else userinfo(2,"unable to compute series expansion");
         FAIL
      end_if
   end_if
end_proc):

Series::gen["cos"]:=proc(n) local i,t;
begin
   t:=1; 
   [1,(0,(t:=-t/(2*i-1)/(2*i)))$i=1..(n-1) div 2]
end_proc:
Series::gen["cos"](0):=[]:

# end of file #
