# $Date: 1999/02/03 13:43:57 $ $Author: fakler $ $Revision: 1.3.2.1 $ #

#--
	eint/Series -- the function attribut "series" for eint
--#

eint:=funcattr(eint,"series",proc(f,x,n) # series(eint(f),x=0,n) #
    local s,t,i,k;
begin
   if f=x then # expansion of eint(x) for x = 0 #
     Puiseux::create(1,0,n,[-ln(x)-EULER,(-1)^(i+1)/i/fact(i)$i=1..n-1],x)
   else
     t:=Series::series(f,x,n);
     if type(t) = Puiseux then
       k:=t::ldegree(t);
       if k>0 then # f goes to zero #
         t:=series((exp(-f)-1)/f*diff(f,x),x,n);
         if not testtype(t,Type::Series(Taylor)) then
           userinfo(2,"unable to compute series expansion");
           FAIL
         end_if;
         k:=series(ln(f),x,n+k);
         if type(k) <> Puiseux then
           userinfo(2,"unable to compute series expansion");
           FAIL
         end_if;
         Series::series(-EULER-expr(k)-int(expr(t),x),x,n+1)
       elif k<0 then # f goes to +/-infinity #
         t:=1;
         s:=Puiseux::create(1,1,n+1,[1,(t:=-t*i)$i=1..n-1],x);
         s:=Puiseux::_fconcat(s,Series::series(1/f,x,n));
         s:=gseries::convert(extsubsop(s,5=x));
         gseries::scalmult(s,1,exp(-f))
       else
         Series::unknown(eint(f),x,n)
       end_if
     else
        userinfo(2,"unable to compute series expansion");
        FAIL
     end_if
  end_if
end_proc):

# end of file #
