# $Date: 1997/08/07 13:43:30 $ $Author: tonner $ $Revision: 1.3 $ #

#--
	erfc/Series -- the function attribut "series" for erfc
--#

# erf(x) is automatically expanded into 1-erfc(x) #
erfc:=funcattr(erfc,"series",
proc(f,x,n)
  local t,s;
begin
   t:=Series::series(f,x,n);
   if ldegree(t)<0 then # f goes to +/-infinity #
      s:=sign(lcoeff(t));
      if s=1 then # +infinity #
         s:=Puiseux::create(1,1,n+1,Series::gen["erfc"](n),x);
         s:=Puiseux::_fconcat(s,Series::series(1/f,x,n));
         s:=gseries::convert(extsubsop(s,5=x));
         gseries::scalmult(s,1,exp(-f^2))
      elif s=-1 then # -infinity #
         s:=Puiseux::create(1,1,n+1,Series::gen["erfc"](n),x);
         s:=Puiseux::_fconcat(s,Series::series(-1/f,x,n));
         s:=gseries::convert(extsubsop(s,5=x));
         -1+gseries::scalmult(s,1,exp(-f^2))
      else error("unable to compute expansion")
      end_if
   else Series::unknown(erfc(f),x,n)
   end_if
end_proc):

Series::gen["erfc"]:=proc(n) local t,i;
begin
   t:=1/sqrt(PI);
   [t,(0,(t:=-t*(2*i-1)/2))$i=1..(n-1) div 2]
end_proc:

# end of file #
