#--
	exp/Series -- the function attribut "series" for exp
--#

exp:=funcattr(exp,"series",proc(f,x,n)
local s,f0,t,v,K,a;
begin
   s:=Puiseux::create(1,0,n,Series::gen["exp"](n),x);
   if f=x then s
   else
      t:=Series::Puiseux(f,x,n);
      if t=FAIL then return(FAIL) end_if;
      v:=Puiseux::ldegree(t);
      if v=FAIL then # exp(O(...)) #
         if (v:=Puiseux::order(t))>0 then 1+t	# exp(O(x))=1+O(x) #
         elif v=0 then t			# exp(O(1))=O(1) #
         else gseries::new(exp(-x),x,1)
         end_if
      elif v<0 then # exp(1/x^a) #
         gseries::new(exp(f),x,n) # try MRVasympt #
      elif v=0 then # exp(f0+(f-f0)) = exp(f0)*exp(f-f0) #
	 f0:=Puiseux::lcoeff(t);
         # try to recognize a+K*ln(x) #
         if has(f0,ln(x)) then
	    if not has(f0/ln(x),x) then a:=0
            else
               if type(f0)="_mult" then f0:=expand(f0) end_if;
               if type(f0)="_plus" then ([f0,a,K]):=split(f0,has,x)
               else a:=0 end_if;
            end_if;
            if not has((K:=f0/ln(x)),x) then
               t:=Puiseux::_fconcat(s,Puiseux::lmonomial(t,Rem)[2]);
               if type(K)=DOM_INT then t:=Puiseux::scalmult(t,exp(a),K)
               else # generalized series #
                  t:=gseries::convert(t); # extsubsop(t,5=x)); #
                  t:=gseries::scalmult(t,exp(a),x^K);
               end_if;
               return(t)
            end_if;
            error("invalid expansion") # to avoid exp(ln(x)^2) #
         end_if;
         Puiseux::scalmult(Puiseux::_fconcat(s,Puiseux::lmonomial(t,Rem)[2]),exp(f0))
      else # v>0 #
         Puiseux::_fconcat(s,t)
      end_if;
   end_if
end_proc):

Series::gen["exp"]:=proc(n) local t,i;
begin
   t:=1; [1,(t:=t/i)$i=1..n-1]
end_proc:
Series::gen["exp"](0):=[]:

# end of file #
