# $Date: 1997/08/07 13:43:32 $ $Author: tonner $ $Revision: 1.4 $ #

#--
	gamma/Series -- the function attribut "series" for gamma
--#

gamma:= funcattr( gamma, "series", proc(f,x,_n,dir)
   local l,i,p,a;
begin
   l:=limit(f,x,(if args(0)>=4 then dir else null() end_if));
   if l=0 or testtype(l,Type::NegInt) then # simple pole #
      # use gamma(x+1)=x*gamma(x), formula 6.1.15 #
      p:=_mult(f+i $ i=0..-l);
      series(gamma(f-l+1)/p,x,_n)
   elif l=infinity then # Stirling formula, see 6.1.40 #
      a:=new(gseries,[[1,f^f*exp(-f)*(2*PI/f)^(1/2)]],0,1/x);
      l:=bernoulli(2*i)/2/i/(2*i-1)/f^(2*i-1)$i=1..max(1,_n-2);
      gseries::_mult(a,Series::series(exp(_plus(l)),x,_n))
   else Series::unknown(gamma(f),x,_n)
   end_if
end_proc):

# end of file #
