# $Date: 1997/08/07 13:43:33 $ $Author: tonner $ $Revision: 1.5 $ #

#--
	ln/Series -- the function attribut "series" for ln
--#

ln:=funcattr(ln,"series",proc(f,x,n) local s,t,a,k;
begin
   s:=Puiseux::create(1,1,n,Series::gen["ln"](n),x);
   if f=1+x then s
   else
      t:=Series::Puiseux(f,x,n);
      if type(t)<>Puiseux then return(FAIL) end_if;
      k:=Puiseux::ldegree(t);
      a:=Puiseux::lcoeff(t);
      if k=0 then
         if a<>1 then t:=Puiseux::scalmult(t,1/a) end_if;
         # better than t - 1 which does not work for floating-points #
         ln(a)+Puiseux::_fconcat(s,t::lmonomial(t,Rem)[2])
      else
         t:=Puiseux::lmonomial(t,Rem)[2];
         t:=Puiseux::scalmult(t,1/a,-k); # t <- t/(a*x^k) #
         t:=Puiseux::_fconcat(s,t);
         t+Puiseux::create(1,0,Puiseux::order(t),[ln(a)+k*ln(x)],x)
      end_if
   end_if
end_proc):

# expansion for ln(1+x) #
Series::gen["ln"]:=proc(n) local t,i;
begin
   t:=-1; [((t:=-t)/i$i=1..n-1)]
end_proc:

# end of file #
