# $Date: 1997/08/07 13:43:33 $ $Author: tonner $ $Revision: 1.3 $ #

#--
	psi/Series -- the function attribut "series" for psi
--#

psi:=funcattr(psi,"series",proc(f,n,x,ord) # series(psi(f,n),x,ord) #
  local l,k,s,f0;
begin
   if type(n)<>DOM_INT then # usual Psi function, not its derivatives #
      ord:=x; x:=n; n:=0;
   end_if;
   if limit(f,x=0,Right)=infinity then # expansion at infinity #
      if n=0 then # formula 6.3.18 in Abramowitz & Stegun #
         f0:=lmonomial(Series::series(f,x,2));
         # ln(f) = ln(f0+(f-f0)) = ln(f0)+ln(1+(f-f0)/f0) #
         l:=[-1/2/f,-bernoulli(2*k)/2/k*f^(-2*k)$k=1..(ord-1) div 2];
         if nops(l)>ord then l[ord+1]:=NIL end_if;
         s:=Series::series(_plus(ln(1+(f-f0)/f0),op(l)),x,ord);
         s:=gseries::convert(s);
         extsubsop(s,1=[[1,ln(f0)],op(extop(s,1))])
      else # formula 6.4.11 in Abramowitz & Stegun #
         s:=(-1)^(n-1);
         l:=[s*fact(n-1),s*fact(n)/2,
                (s*bernoulli(2*k)*fact(2*k+n-1)/fact(2*k),0)
		    $ k=1..(ord-1) div 2];
         if nops(l)>ord then l[ord+1]:=NIL end_if;
         Puiseux::create(1,n,n+ord,l,x)
      end_if
   else
      s:=Series::Puiseux(f,x,ord);
      if ldegree(s)>0 then # expansion in zero #
         # use formula 6.4.6 of Abramowitz & Stegun #
         series(-(-1)^n*fact(n)/f^(n+1)+psi(f+1,n),x,ord)
      else
         Series::unknown(psi(f,n),x,ord)
      end_if
   end_if
end_proc):

# end of file #
