#--
	sin/Series -- the function attribut "series" for sin
--#

sin:=funcattr(sin,"series",proc(f,x,n)
   local t,k,a;
begin
   if f=x then Puiseux::create(1,1,n,Series::gen["sin"](n),x)
   else
      t:=Series::Puiseux(f,x,n);
      if type(t)<>Puiseux then return(FAIL)
      end_if;
      k:=ldegree(t);
      if k=FAIL then k:=t::order(t) end_if;
      if k>0 then Puiseux::_fconcat(
          Puiseux::create(1,1,n,Series::gen["sin"](n),x),t)
      elif k=0 then
         a:=lcoeff(t);
         # sin(a+t)=sin(a)*cos(t)+cos(a)*sin(t) #
         t:=subs(expand(f-a),0.0=0);
         sin(a)*series(cos(t),x,n)+cos(a)*series(sin(t),x,n)
      else FAIL
      end_if
   end_if
end_proc):

Series::gen["sin"]:=proc(n) local i,t;
begin
   t:=1;
   [1,(0,(t:=-t/(2*i)/(2*i+1)))$i=1..(n-2) div 2]
end_proc:
Series::gen["sin"](0):=[]:
Series::gen["sin"](1):=[]:

# end of file #
