
#-

 The MuPAD system function traperror returns only an error number, but
 not an error message. This file contains an enumeration of the error
 numbers and their meaning.

 The error numbers are divided into two parts: 
 1) PARI errors numbers  (1 - 999) 
 2) MuPAD errors numbers ( > 1000)

 ERROR::identification is an integer for all MuPAD error numbers,
 but a set for PARI error numbers. It's due to the fact, that PARI
 uses different error numbers for the same kind of error. (We are
 only interested in the kind of an error. PARI uses different 
 numbers to distinguish the functions in which the error occurs.)

 Example:

 if (errno := traperror(expr)) > 0 then
    if errno < 1000 then
       print("PARI error"):
       if contains(ERROR::COMPLEX_ARG_NOT_ALLOWED, errno) then
          ....
       end_if
    else
       print("MuPAD error"):
       if errno = ERROR::ILLEGAL_OPERAND then
          ...
       end_if
    end_if
 end_if

-#
 

ERROR := domain("ERROR"):

#- 

    PARI error numbers 1-999

-#

ERROR::DIVISION_BY_ZERO_DIV_MOD   :=  {36} :
ERROR::STACK_OVERFLOW             :=  {44} : # PARI stack overflow.     #
                                             # Doubling the stack size  #
ERROR::CAN_NOT_CONVERT_TO_DOUBLE  :=  {45} :
ERROR::IMPOSSIBLE_INVERSE_MODULO  := {103} :
ERROR::NOT_ENOUGH_PRIMES          := {118} :
ERROR::OUT_OF_MEMORY              := {363} : # No memory available for  #
                                             # expanding the PARI stack #
ERROR::POS_VALUE_EXPECTED         := {426} : 
ERROR::LOSS_OF_PRECISION          := {11,431} :
ERROR::COMPLEX_ARG_NOT_ALLOWED    := {315,325,323,282} :
ERROR::DIVISION_BY_ZERO_PARI      := {23,24,25,26,27,28,30,31,260,313} :
ERROR::OVERFLOW_UNDERFLOW         := {8,9,10,12,13,14,15,16,17,18,
                                      19,20,21,22,29,32,33,34} :


#-

   MuPAD error numbers 1000 - ...

-#

ERROR::ILLEGAL_OPERAND            := 1001 :
ERROR::STMT_IN_EXPR               := 1002 :
ERROR::CANT_EVAL_BOOL             := 1003 :
ERROR::WRONG_NUMBER_OF_ARGS       := 1004 :
ERROR::ILLEGAL_ARGUMENT           := 1005 :
ERROR::REAL_NUMBER_EXPECTED       := 1006 :
ERROR::IO_WRITE_ERROR             := 1007 :
ERROR::ERROR                      := 1008 :
ERROR::SIGN_ERROR                 := 1009 :
ERROR::RECURSIV_DEFINITION        := 1010 :
ERROR::INVALID_ASSIGNMENT         := 1011 :
ERROR::OUT_OF_RANGE               := 1012 :
ERROR::INTEGER_NUMBER_EXPECTED    := 1013 :
ERROR::SYSTEM_ERROR               := 1014 :
ERROR::OPERAND_DOES_NOT_EXIST     := 1015 :
ERROR::INVALID_RANGE              := 1016 :
ERROR::INVALID_INDEX              := 1017 :
ERROR::SUBSTITUTION_NOT_ALLOWED   := 1018 :
ERROR::INVALID_FUNCTION           := 1019 :
ERROR::STRING_TOO_LONG            := 1020 :
ERROR::IO_READ_ERROR              := 1021 :
ERROR::INDEX_RANGE                := 1022 :
ERROR::INDEX_TYP                  := 1023 :
ERROR::DIMENSION                  := 1024 :
ERROR::DIVISION_BY_ZERO           := 1025 :
ERROR::POS_INTEGER_EXPECTED       := 1026 :
ERROR::RESET_IN_USER_PROC         := 1027 :
ERROR::USER_DEFINED_ERROR         := 1028 :
ERROR::INTEGER_TOO_LARGE          := 1029 :
ERROR::UNKNOWN_OPTION             := 1030 :
ERROR::NO_INDETS                  := 1031 :
ERROR::ILLEGAL_INDET              := 1032 :
ERROR::NO_POLYNOMIAL              := 1033 :
ERROR::UNKNOWN_TYPE               := 1034 :
ERROR::NOT_IMPLEMENTED            := 1035 :
ERROR::MISSING_DOM_ATTR           := 1036 :
ERROR::CONTEXT_NOT_ALLOWED        := 1037 :
ERROR::RETURNVALUE_NOT_ALLOWED    := 1038 :
ERROR::ILLEGAL_COLOR              := 1039 :
ERROR::EXPONENT_OVERFLOW          := 1040 :
ERROR::WRONG_EXEC                 := 1041 :
ERROR::POSITIVE_VALUE_EXPECTED    := 1042 :
ERROR::BAD_UNKNOWN                := 1043 :
ERROR::WATCHDOG                   := 1044 :
ERROR::ARGUMENT_FAILED            := 1045 :
ERROR::WRITE_PROTECED_ASSIGNMENT  := 1046 :
ERROR::WRITE_PROTECED_LOCAL       := 1047 :
ERROR::NO_ATOMAR_TYPE             := 1048 :
ERROR::ALREADY_EXECUTED_ERROR     := 1050 :
ERROR::SYNTAX_ERROR_IN_READ       := 1051 :

ERROR::UNKNOWN_EXTERN_OBJECT      := 1100 :
ERROR::UNKNOWN_OPERATOR           := 1101 :
ERROR::INTERUPTED_BY_USER         := 1102 :
ERROR::INTERNAL_ERROR             := 1103 :
ERROR::ILLEGAL_CONTEXT            := 1104 :
ERROR::COEFF_RING                 := 1105 :
ERROR::FATAL_ERROR                := 1106 :
ERROR::SECURITY_ALERT             := 1107 :
ERROR::NON_NEG_INTEGER            := 1108 :
ERROR::DUPLICATE_DOMAIN_KEY       := 1109 :
ERROR::ILLEGAL_DOMAIN_KEY         := 1110 :
ERROR::INVALID_PASSWORD           := 1111 :
ERROR::CAN_NOT_REGISTER           := 1112 :

ERROR::PLOT_ERROR                 := 1201 :
ERROR::OWN_ERR_MESS               := 1202 :

ERROR::OUT_OF_MEMORY              := 1300 :
ERROR::DEMO_OUT_OF_MEMORY         := 1301 :

ERROR::TIME_EXEEDED               := 1320 :
