# $Date: 1997/07/23 09:39:31 $ $Author: zimmerma $ $Revision: 1.5 $ #

#--
	cos/expand -- the function attribut "expand" for cos

 cos(-x)     = cos(x)                                      
 cos(x +- y) = cos(x) * cos(y) -+ sin(x) * sin(y)           
              n/2                                           
              ---                                           
              \   (  n )                                    
 cos(n * x) = /   ( 2*i) cos(x)^(n-2*i)*sin(x)^(2*i)*(-1)^i 
              ---                                           
              i=0                                           
--#

cos := funcattr(cos, "expand", proc(x)
  local n, t, y, C, S;
begin
  y := expand(x);

  case type(y)

    of "_plus" do

       n := op(y, 1); y := subsop(y, 1=null());
       return(expand(cos(n)*cos(y)-sin(n)*sin(y)));

    of "_mult" do

       n := op(y, nops(y)); t := type(n);
       if t = DOM_INT or t = DOM_RAT then
          if n < 0 then
             return(expand(cos(-y)));
          else # n>0 #
             if t=DOM_RAT then n:=op(n,1) end_if;
             if n=1 then return(cos(y)) end_if; # avoids loop #
             y := y / n;
             # the following improvement is due to Francois Maltey #
             return(expand(subs(expand((C+I*S)^n/2+(C-I*S)^n/2),C=cos(y),S=sin(y))))
          end_if
       end_if

  end_case;

  cos(y)

end_proc):

# end of file #
