# $Date: 1995/08/12 16:08:45 $ $Author: frankp $ $Revision: 1.1 $ #

#--
	cosh/expand -- the function attribut "expand" for cosh

 cosh(-x)     = cosh(x)                                        
 cosh(x +- y) = cosh(x) * cosh(y) +- sinh(x) * sinh(y)         
                n                                              
               ---                                             
               \   (  n )                                      
 cosh(n * x) = /   ( 2*i) cosh(x)^(n-2*i)*sinh(x)^(2*i)*(-1)^i 
               ---                                             
               i=0                                             
--#

cosh := funcattr(cosh, "expand", proc(x)
  local n, t, y;
begin
  y := expand(x);

  case type(y)

    of "_plus" do

       n := op(y, 1); y := subsop(y, 1=null());
       return(expand(cosh(n)*cosh(y)+sinh(n)*sinh(y)));

    of "_mult" do

       n := op(y, nops(y)); t := type(n);
       if t = DOM_INT or t = DOM_RAT then
          if n < 0 then
             return(expand(cosh(-y)));
          elif t = DOM_INT and n > 0 then
             y := y / n;
             return(expand(2*cosh((n-1)*y)*cosh(y)-cosh((n-2)*y)));
          end_if
       end_if

  end_case;

  cosh(y)

end_proc):


# end of file #
