# $Date: 1997/07/23 09:39:32 $ $Author: zimmerma $ $Revision: 1.4 $ #

#--
	sin/expand -- the function attribut "expand" for sin

 sin(-x)     = -sin(x)                                                 
 sin(x +- y) = sin(x) * cos(y) +- sin(y) * cos(x)                      
               n/2                                                     
               ---                                                     
               \   (   n  )                                            
 sin(n * x)  = /   ( 2*i+1) cos(x)^(n-2*i-1)*sin(x)^(2*i+1)*(-1)^(i+1) 
               ---                                                     
               i=0  
--#

sin := funcattr(sin, "expand", proc(x)
  local n, t, y, C, S;
begin
  y := expand(x);

  case type(y)

    of "_plus" do

       n := op(y, 1); y := subsop(y, 1=null());
       return(expand(sin(n)*cos(y)+cos(n)*sin(y)));

    of "_mult" do

       n := op(y, nops(y)); t := type(n);
       if t = DOM_INT or t = DOM_RAT then
          if n < 0 then
             return(expand(-sin(-y)));
          elif t = DOM_INT and n > 0 then
             y := y / n;
	     return((if n=1 then sin(y)
             # the following improvement is due to Francois Maltey #
	     else subs(expand(((C+I*S)^n-(C-I*S)^n)/2/I),C=cos(y),S=sin(y))
             end_if))
          end_if
       end_if

  end_case;

  sin(y)

end_proc):

# end of file #
