
stdlib::floatpsi := proc(x, n)
   /* 
    * x - integer, rational, floating-point or complex number
    * n - integer, n > 0
    */
    local DIGITS, d, k, n1, old_d, s, shift, X;
begin
    x := float(x);
    if Re(x) < 1/2 then
        s := float(PI*subs(diff(cot(PI*X),X $ n), X = x));
        if Im(s) = 0.0 then s := Re(s) end_if;
        s := (-1)^n*stdlib::floatpsi(1 - x, n) - s; 
    else
        shift := DIGITS; n1 := n + 1;
        DIGITS := DIGITS + length(shift) + length(n1) + 1;
        d := 1/x^n1; old_d := 0.0; 
        for k from 1 to shift - 1 do
            if d = old_d then break end_if;
            old_d := d; d := d + 1/(x + k)^n1
        end_for;
        x := x + shift;
        s := stdlib::asymptpsi(x, n);
        s := s + (-1)^n1*n!*d
    end_if
end_proc:


stdlib::asymptpsi := proc(x, n)
   /* 
    * x - integer, rational, floating-point or complex number
    * n - integer, n >= 0
    */
    local DIGITS, f, g, k, k1, min_k, n1, old_s, s, t, x2;
begin
    DIGITS := DIGITS + length(DIGITS) + length(n) + 1;
    n1 := n - 1;
    x2 := 1/x^2;
    f := n!;
    t := 1/x^(n + 1);
    if n = 0 then s := 0.5*t - ln(x) else s := f*(x/n + 0.5)*t end_if; 
    old_s := s;
    f := f*(n + 1);
    g := 2.0;
    t := t/x;
    s := s + 1/6*f*t/g;
    min_k := trunc(6.28*abs(x) + 1 - n);
    for k from 4 to min_k step 2 do
        if s = old_s then break end_if;
        old_s := s;
        k1 := k - 1;
        f := f*(n1 + k)*(k1 + n1);
        g := g*k*k1;
        t := t*x2;
        s := s + bernoulli(k)*f*t/g
    end_for;
    // No convergence, if s <> old_s
    (-1)^n1*s
end_proc:
