# #
# $Date: 1999/09/13 16:16:58 $ $Author: frankp $ $Revision: 1.5.4.1 $ #

# zimmerma, 10/08/95 #

#++
        Si -- the Sine integral

	Si(x):= int(sin(t)/t,t=0..x)

	Reference: Abramowitz & Stegun, pages 231-233
++#

Si:=proc(x)
begin
   if x::Si <> FAIL then return(x::Si(args())) end_if;

   if args(0) <> 1 then error("wrong no of args") end_if;
 
   case type(x)
   of DOM_INT do
   of DOM_RAT do
      if x < 0 then return(-Si(-x)) end_if; break
   of DOM_FLOAT do return(funcattr(Si,"float")(x))
   end_case;
   procname(x)
end_proc:

Si(0):=0:
Si(infinity):=PI/2:


Si:= funcattr(Si,"print","Si"):
Si:= funcattr(Si,"type","Si"):
Si:= funcattr(Si,"info","Si(x) -- the sine integral int(sin(t)/t,t=0..x)"):

Si:= funcattr(Si, "diff", fun(( # e=Si(f) #
   op(args(1),1);
   sin(%)/%*diff(%,args(2))
))):

Si:= funcattr(Si, "discont", fun({})):

Si:= funcattr(Si, "float", proc(t) local x;
begin
   float(hold(int)(sin(x)/x,x=0..t))
end_proc):

Si:= funcattr(Si, "series",
    loadproc(funcattr(Si,"series"),pathname("SERIES"),"Si")
):

# end of file #
