# $Date: 1997/08/07 13:42:25 $ $Author: tonner $ $Revision: 1.15 $ #

# kg, 13/01/94 #

#++
acos -- the inverse cosine

acos(x)

x - expression
++#

acos:= proc(x)
    local f;
    name acos;
begin
    if x::acos <> FAIL then return(x::acos(args())) end_if;
    if args(0) <> 1 then error("wrong no of args") end_if;

    case type(x)
    of DOM_INT do
    of DOM_RAT do
	if x < 0 then return(PI - acos(-x)) end_if;
	break;
    
    of DOM_FLOAT do
	return(funcattr(acos,"float")(x));

    of DOM_COMPLEX do
	if domtype(op(x,1)) = DOM_FLOAT or
	   domtype(op(x,2)) = DOM_FLOAT then
	    return(funcattr(acos,"float")(x))
	end_if;
	if op(x,1) = 0 then return(PI/2 - asin(x)) end_if;
	break;

    of "_mult" do
	f:= op(x, nops(x));
	if testtype(f, Type::RealNum) then
	    if f < 0 then return(PI - acos(-x)) end_if;
	end_if;
	break;

    of "cos" do # acos : [-1..1] --> [PI..0] #
       if (is(op(x)>=0) and is(op(x)<=PI))=TRUE then return(op(x))
       elif type((f:=trunc(Re(op(x))/PI)))=DOM_INT then
          if f mod 2 = 0 then return(op(x)-f*PI) else return((f+1)*PI-op(x)) end_if
       end_if; break;
    end_case;

    procname(x)
end_proc:

acos(1):= 0:
acos((3^(1/2))/2):= PI/6:
acos((2^(1/2))/2):= PI/4:
acos(1/2):= PI/3:
acos(0):= PI/2:
acos(-1):= PI:
acos(infinity):= I*infinity:
acos(-infinity):= PI-I*infinity:
acos(I*infinity):= 1/2*PI-I*infinity:
acos(-I*infinity):= 1/2*PI + I*infinity:


acos:= funcattr(acos,"info","acos -- the inverse cosine"):
acos:= funcattr(acos,"print","acos"):
acos:= funcattr(acos,"type","acos"):

acos:= funcattr(acos,"diff",fun((
    op(args(1),1);
    -diff(%, args(2..args(0))) / sqrt(1-%^2)
))):

acos:=funcattr(acos,"series",proc(f,x,n)
  # formula 4.4.2 of Abr. & Stegun #
begin
    Series::Puiseux(PI/2-asin(f),x,n)
end_proc):

acos:= funcattr(acos,"rectform",
    loadproc(funcattr(acos,"rectform"),pathname("STDLIB","RECTFORM"),"acos")
):

# end of file #
