# $Date: 1997/08/07 13:42:26 $ $Author: tonner $ $Revision: 1.12 $ #

# kg, 13/01/94 #

#++
acosh -- the inverse hyperbolic cosine

acosh(x)

x - expression
++#

acosh:= proc(x)
    name acosh;
local k;
begin
    if x::acosh <> FAIL then return(x::acosh(args())) end_if;
    if args(0) <> 1 then error("wrong no of args") end_if;

    case type(x)
    of DOM_FLOAT do
	return(funcattr(acosh,"float")(x));

    of DOM_COMPLEX do
	if domtype(op(x,1)) = DOM_FLOAT or
	   domtype(op(x,2)) = DOM_FLOAT then
	    return(funcattr(acosh,"float")(x))
	end_if;
	break;

    of "cosh" do # acosh(cosh(x))=x when 0 <= Im x <= PI #
        k:=round(-Im(op(x))/2/PI);
        return((if type(k)=DOM_INT then
           k:=op(x)+2*k*PI*I;
           if sign(Im(k))=-1 then -k else k end_if;
        else procname(x) end_if))

    end_case;

    procname(x)
end_proc:

acosh(1):= 0:
acosh(0):=1/2*I*PI:

acosh:= funcattr(acosh,"print","acosh"):
acosh:= funcattr(acosh,"info","acosh -- the inverse hyperbolic cosine"):
acosh:= funcattr(acosh,"type","acosh"):

acosh:= funcattr(acosh,"diff",fun((
    op(args(1),1);
    diff(%, args(2..args(0))) / sqrt(%^2-1)
))):

acosh:=funcattr(acosh,"series",proc(f,x,n)
begin
   series(ln(f+sqrt(f^2-1)),x,n)
end_proc):

# end of file #
