
# ok, 27/01/94 #

#++
acot -- the inverse cotangens

acot(x)

x - expression
++#

acot:= proc(x)
    local f;
    name acot;
begin
    if x::acot <> FAIL then return(x::acot(args())) end_if;
    if args(0) <> 1 then error("wrong no of args") end_if;
 
    case type(x)
    of DOM_INT do
    of DOM_RAT do
        if x < 0 then return(-acot(-x)) end_if;
        break;
 
    of DOM_FLOAT do
        return(funcattr(acot,"float")(x));
 
    of DOM_COMPLEX do
	if x = I then
           error("singularity");
        elif domtype(op(x,1)) = DOM_FLOAT or
             domtype(op(x,2)) = DOM_FLOAT then
           return(funcattr(acot,"float")(x))
        elif op(x, 1) = 0 then
           return( -I*acoth(-I*x) );
	elif op(x, 1) < 0 and op(x, 2) < 0 then
	   return(-acot(-x));
	end_if;
        break;
 
    of "_mult" do
        f:= op(x, nops(x));
        if testtype(f, Type::RealNum) then
            if f < 0 then return(-acot(-x)) end_if;
        end_if;
        break;

    end_case;
 
    procname(x)
end_proc:

acot(0) := PI/2:

acot:= funcattr(acot,"type", "acot"):
acot:= funcattr(acot,"print", "acot"):
acot:= funcattr(acot,"info","acot -- the inverse cotangent"):

acot:= funcattr(acot,"diff",fun((
    op(args(1),1);
    diff(%, args(2..args(0))) * ( -1/(1+%^2) )
))):

acot:= funcattr(acot, "float", proc(e)
begin
  if e = 0.0 then
     float(PI/2)
  else
     funcattr(atan, "float")(1/e)
  end_if
end_proc):

acot:= funcattr(acot,"series",proc(f,x,n)
   local s,i;
begin
   s:=(if n=0 then [] elif n=1 then [PI/2]
   else s:=-1; [PI/2,s,(0,(s:=-s)/(2*i+1))$i=1..(n div 2)-1]
   end_if);
   s:=Puiseux::create(1,0,n,s,x);
   if f=x then s
   else
      Puiseux::_fconcat(s,Series::Puiseux(f,x,n))
   end_if
end_proc):

# end of file #
