# $Date: 1996/07/03 13:45:47 $ $Author: frankp $ $Revision: 1.11 $ #

# kg, 13/01/94 #

#++
asinh -- the inverse hyperbolic sine

asinh(x)

x - expression
++#

asinh:= proc(x)
    local f;
    name asinh;
begin
    if x::asinh <> FAIL then return(x::asinh(args())) end_if;
    if args(0) <> 1 then error("wrong no of args") end_if;

    case type(x)
    of DOM_INT do
    of DOM_RAT do
	if x < 0 then return(-asinh(-x)) end_if;
	break;
    
    of DOM_FLOAT do
	return(funcattr(asinh,"float")(x));

    of DOM_COMPLEX do
	if domtype(op(x,1)) = DOM_FLOAT or
	   domtype(op(x,2)) = DOM_FLOAT then
	    return(funcattr(asinh,"float")(x))
	end_if;
	break;

    of "_mult" do
	f:= op(x, nops(x));
	if testtype(f, Type::RealNum) then
	    if f < 0 then return(-asinh(-x)) end_if;
	end_if;
	break;
    of "sinh" do # asinh(sinh(x))=x when -PI/2 < Im x <= PI/2 #
        f:=round(-Im(op(x))/PI);   
        if type(f)=DOM_INT then return((-1)^f*(op(x)+f*I*PI)) end_if;
        break;
    end_case;

    procname(x)
end_proc:

asinh(0):= 0:

asinh:= funcattr(asinh, "print", "asinh"):
asinh:= funcattr(asinh,"info","asinh -- the inverse hyperbolic sine"):
asinh:= funcattr(asinh, "type", "asinh"):

asinh:= funcattr(asinh, "diff", fun((
    op(args(1),1);
    diff(%, args(2..args(0))) / sqrt(%^2+1)
))):

asinh:=funcattr(asinh,"series", proc(f, x, n)
begin
   # formula 4.6.20 of Abramowitz & Stegun #
   Series::Puiseux(ln(f+sqrt(f^2+1)),x,n)
end_proc):

# end of file #
