# $Date: 1997/08/07 13:42:29 $ $Author: tonner $ $Revision: 1.14 $ #

# kg, 13/01/94 #

#++
atanh -- the inverse hyperbolic tangens

atanh(x)

x - expression
++#

atanh:= proc(x)
    local f;
    name atanh;
begin
    if x::atanh <> FAIL then return(x::atanh(args())) end_if;
    if args(0) <> 1 then error("wrong no of args") end_if;

    case type(x)
    of DOM_INT do
    of DOM_RAT do
        if x = 1 then
           error("singularity encountered");
	elif x < 0 then return(-atanh(-x)) end_if;
	break;
    
    of DOM_FLOAT do
	return(funcattr(atanh,"float")(x));

    of DOM_COMPLEX do
	if domtype(op(x,1)) = DOM_FLOAT or
	   domtype(op(x,2)) = DOM_FLOAT then
	    return(funcattr(atanh,"float")(x))
	end_if;
	break;

    of "_mult" do
	f:= op(x, nops(x));
	if testtype(f, Type::RealNum) then
	    if f < 0 then return(-atanh(-x)) end_if;
	end_if;
	break;

    of "tanh" do # atanh(tanh(x))=x iff -PI/2 < Im(x) < PI/2 #
        f:=round(Im(op(x))/PI);
        if type(f)=DOM_INT then return(op(x)-f*I*PI) end_if;
        break;
    end_case;

    procname(x)
end_proc:

atanh(0):= 0:

atanh:= funcattr(atanh, "print", "atanh"):

atanh:= funcattr(atanh, "diff", fun((
    op(args(1),1);
    diff(%, args(2..args(0))) / (1-%^2)
))):

atanh:= funcattr(atanh, "series", proc(f,x,n)
   local s,i;
begin
   s:=(if n<2 then [] else [1,(0,1/(2*i+1))$i=1..(n div 2)-1] end_if);
   s:=Puiseux::create(1,1,n,s,x);
   if f=x then s
   else
      Puiseux::_fconcat(s,Series::Puiseux(f,x,n))
   end_if
end_proc):

# end of file #
