#++
        beta -- the Beta function

        beta( x, y ) := gamma( x ) * gamma( y ) / gamma( x + y )

++#

beta := proc(x,y) 
begin
    if x::beta <> FAIL then 
       x::beta(args())
    elif args(0) <> 2 then 
       error("wrong no of args")
    elif type(x) = DOM_INT and x <= 0 or type(y) = DOM_INT and y <= 0 then
       error("singularity encountered")
    elif type(x+y) = DOM_INT and x+y <= 0 then 
       sysassign(beta(x,y), 0)
    elif testtype(x, NUMERIC) and testtype(y, NUMERIC) then
       gamma(x)*gamma(y)/gamma(x + y)
    else
       procname(args())
    end_if
end_proc:


beta:= funcattr(beta, "print", "beta"):
beta:= funcattr(beta, "info",  "beta -- the Beta function: beta(x, y) := gamma(x)*gamma(y)/gamma(x+y)"):
beta:= funcattr(beta, "type",  "beta"):

beta := funcattr(beta, "diff", fun((
  args(2..args(0)); op(args(1), 2); op(args(1), 1);
  (diff(%1, %3)*psi(%1)+diff(%2, %3)*psi(%2)-diff(%1+%2, %3)*psi(%1+%2))*
  beta(%1, %2)
))):

beta := funcattr(beta, "expand", 
	fun(gamma(args(1))*gamma(args(2))/gamma(args(1)+args(2)))):
