# $Date: 1997/10/16 10:43:13 $ $Author: frankp $ $Revision: 1.27 $ #

# kg, 13/01/94 #

#++
cos -- the cosine

cos(x)

x - expression
++#

cos:= proc(x)
    local f;
    name cos;
begin
    if x::cos <> FAIL then return(x::cos(args())) end_if;
    if args(0) <> 1 then error("wrong no of args") end_if;

    case type(x)
    of DOM_INT do
    of DOM_RAT do
	if x < 0 then return(cos(-x)) end_if;
	break;

    of DOM_FLOAT do
	return(funcattr(cos,"float")(x));

    of DOM_COMPLEX do
	if domtype(op(x,1)) = DOM_FLOAT or
	   domtype(op(x,2)) = DOM_FLOAT then
	       return(funcattr(cos,"float")(x))
	   end_if;
	if op(x,1) = 0 then return(cosh(-x*I)) end_if;
	break;

    of "_mult" do
#--
due to performance reasons, remove this test 

        if is(x/(2*PI), Type::Integer)=TRUE then
		return(1)
        elif is(x/(2*PI), Type::Integer)=FALSE and is(x/PI,Type::Integer)=TRUE then
		return(-1)
	end_if;
--#
	f:= op(x, nops(x));
	if testtype(f, Type::RealNum) then
	    if f < 0 then return(cos(-x)) end_if;
	    if domtype(f) = DOM_FLOAT then break end_if;
	else
	    break
	end_if;

	if nops(x) = 2 then
	    if op(x,1) = PI then
		if f < 1/2 then break end_if;
		if f < 1 then return(-cos((1-f)*PI)) end_if;
		if f < 2 then return(cos((2-f)*PI)) end_if;
		return(cos((f-2*(floor(f) div 2))*PI));
	    end_if
	end_if;
	break;

    of "asin" do return(sqrt(1-op(x)^2));
    of "acos" do return(op(x));
    of "atan" do return(1/sqrt(1+op(x)^2));
    end_case;

    procname(x)
end_proc:

cos(0):= 1:
cos(PI/12):= (6^(1/2)+2^(1/2))/4: # simpler than ((2+3^(1/2))^(1/2))/2: #
cos(PI/8):= ((2+2^(1/2))^(1/2))/2:
cos(PI/6):= (3^(1/2))/2:
cos(PI/5):= 5^(1/2)/4+1/4:
cos(PI/4):= (2^(1/2))/2:
cos(PI/3):= 1/2:
cos(3*PI/8):= ((2-2^(1/2))^(1/2))/2:
cos(5*PI/12):= ((2-3^(1/2))^(1/2))/2:
cos(PI/2):= 0:
cos(PI):= -1:
cos(I):= cosh(1):

cos:= funcattr(cos, "print", "cos"):
cos:= funcattr(cos, "type", "cos"):
cos:= funcattr(cos, "info", "cos -- the cosine" ):

cos:= funcattr(cos, "expand",
    loadproc(funcattr(cos,"expand"),pathname("SPECFUNC","EXPAND"),"cos")
):

cos:= funcattr(cos, "conjugate",
    loadproc(funcattr(cos,"conjugate"),pathname("STDLIB","CONJ"),"cos")
):

cos:= funcattr(cos,"rectform",
    loadproc(funcattr(cos,"rectform"),pathname("STDLIB","RECTFORM"),"cos")
):

cos:= funcattr(cos, "series",
    loadproc(funcattr(cos,"series"),pathname("SERIES"),"cos")
):

cos:= funcattr(cos,"Re",
    loadproc(funcattr(cos,"Re"),pathname("STDLIB","RE"),"cos")
):

cos:= funcattr(cos,"Im",
    loadproc(funcattr(cos,"Im"),pathname("STDLIB","IM"),"cos")
):

cos:= funcattr(cos, "diff",
    loadproc(funcattr(cos,"diff"),pathname("SPECFUNC","DIFF"),"cos")
):

# end of file #
