# ok, 25/01/94 #

#++
The complementary error function

erfc(x) = 1 - erf(x)

x - an expression
++#

erfc := proc(x) 
local f;
begin
  if x::erfc <> FAIL then return(x::erfc(args())) end_if;
  if args(0) <> 1 then
     error("1 argument expected");
  end_if;
  
  case type(x)

    of DOM_FLOAT do
        return(funcattr(erfc,"float")(x));
    of DOM_INT do
    of DOM_RAT do return((if x<0 then 2-procname(-x) else procname(x) end_if))
    of "_mult" do
        f:= op(x, nops(x));
        if testtype(f, Type::RealNum) then
            if f < 0 then return(2-erfc(-x)) end_if;
            if domtype(f) = DOM_FLOAT then break end_if;
        else
            break
        end_if;

    end_case;
    procname(x) 
end_proc:

erfc(0) := 1:

erfc:= funcattr(erfc,"print","erfc"):
erfc:= funcattr(erfc,"info","erfc -- the complementary error function [try ?erf for details]"):
erfc:= funcattr(erfc,"type","erfc"):

erfc:= funcattr(erfc,"conjugate", 
    loadproc(funcattr(erfc,"conjugate"),pathname("STDLIB","CONJ"),"erfc")
):

erfc := funcattr(erfc,"diff",fun((
    op(args(1),1);
    -2/PI^(1/2) * exp(-%^2) * diff(%, args(2..args(0)))
))):

erfc:=funcattr(erfc,"series",
    loadproc(funcattr(erfc,"series"),pathname("SERIES"),"erfc")
):

# end of file #
