# $Date: 1996/09/20 08:45:39 $ $Author: cube $ $Revision: 1.24 $ #

# kg, 13/01/94 #

#++
exp -- the exponential function

exp(x)

x - expression
++#

exp:= proc(x)
    name exp;
    local y;
begin
    if x::exp <> FAIL then return(x::exp(args())) end_if;
    if args(0) <> 1 then error("wrong no of args") end_if;

    case type(x)
    of DOM_FLOAT do
	return(funcattr(exp,"float")(x));

    of DOM_COMPLEX do
	if domtype(op(x,1)) = DOM_FLOAT or
	   domtype(op(x,2)) = DOM_FLOAT then
	    return(funcattr(exp,"float")(x))
        end_if;
	break;

    of "_mult" do
        # exp(y*PI/2/I) = I^(-y) #
        y:=x*I*2/PI;
        if testtype(y, DOM_INT) then
           # exp( I*PI*n/2) = I^n , n an integer #
           return(I^(-y));
        end_if;
        # exp(ln(x)*Constant) = x^Constant #
        if nops(x)=2 then
           if type(op(x,1))="ln" and testtype(op(x,2),Type::Constant) then
              return(op(op(x,1))^op(x,2))
           end_if
        end_if;
        break;

    of "ln" do return(op(x,1));
    end_case;

    procname(x)
end_proc:

# standard simplifications #

exp(0):= 1:

#-- Not used anymore, because E is only an alias of exp(1)

exp(1):= E:
exp(-1):= 1/E:

--#


# function attributes #

exp:= funcattr(exp,"print","exp"):
exp:= funcattr(exp,"info","exp -- the exponential function" ):
exp:= funcattr(exp,"type","exp"):

exp:= funcattr(exp,"abs",fun( exp(Re(args(1))) )):

exp:= funcattr(exp,"sign",
    loadproc(funcattr(exp,"sign"),pathname("SPECFUNC","SIGN"),"exp")
):

exp:= funcattr(exp,"expand",
    loadproc(funcattr(exp,"expand"),pathname("SPECFUNC","EXPAND"),"exp")
):

exp:= funcattr(exp,"conjugate",
    loadproc(funcattr(exp,"conjugate"),pathname("STDLIB","CONJ"),"exp")
):

exp:= funcattr(exp,"rectform",
    loadproc(funcattr(exp,"rectform"),pathname("STDLIB","RECTFORM"),"exp")
):

exp:= funcattr(exp,"series",
    loadproc(funcattr(exp,"series"),pathname("SERIES"),"exp")
):

exp:= funcattr(exp,"Re",
    loadproc(funcattr(exp,"Re"),pathname("STDLIB","RE"),"exp")
):

exp:= funcattr(exp,"Im",
    loadproc(funcattr(exp,"Im"),pathname("STDLIB","IM"),"exp")
):

exp := funcattr(exp,"diff",
    loadproc(funcattr(exp,"diff"),pathname("SPECFUNC","DIFF"),"exp")
):

# end of file #
