
# ok, 20/04/94 #

#++
The Gamma function

gamma(x)

x - an expression
++#

gamma := proc(x)
begin
	if x::gamma <> FAIL then return(x::gamma(args())) end_if;

	if args(0) <> 1 then
           error("1 argument expected");
	end_if;

	case domtype(x)

	  of DOM_FLOAT do

         if x <= 0 and frac(x) = 0.0 then
            error("singularity encountered.");
         end_if;
	     return( funcattr(gamma, "float")(x) );

	  of DOM_INT do

             if x <= 0 then
                error("singularity encountered.");
	     elif x < 1000 then
	        # gamma(x) = (x-1)! ,                 #
                # but compute (x-1)! only if x < 1000 #
		return( fact(x-1) )
             end_if;
	     break;

	   of DOM_COMPLEX do
 
              if domtype(op(x, 1)) = DOM_FLOAT or 
                 domtype(op(x, 2)) = DOM_FLOAT then
                 return( funcattr(gamma, "float")(x) );
              end_if;
              break;
	   
	   of DOM_RAT do

	      if 1 < x and x <= 500 then
		 # compute (x-1)*gamma(x-1) only if x <= 500 #
                 return( (x-1) * gamma(x-1) )
	      elif x < 1/2 and 
                   (domtype(4*x) = DOM_INT or domtype(6*x) = DOM_INT) then
		 return( level( PI * csc(PI*x) / gamma(1-x) ) )
              end_if;
	      break;
                 
	end_case;

	procname(x)
end_proc:

gamma(1/2) := PI^(1/2):

gamma:= funcattr(gamma,"print","gamma"):
gamma:= funcattr(gamma,"info","gamma -- the Gamma function [try ?gamma for details]"):
gamma:= funcattr(gamma,"type","gamma"):

gamma:= funcattr(gamma,"diff",fun((
    op(args(1),1);
    diff(%, args(2..args(0))) * psi(%) * gamma(%)
))):

gamma:= funcattr(gamma, "conjugate",
    loadproc(funcattr(gamma,"conjugate"),pathname("STDLIB","CONJ"),"gamma")
):

gamma:= funcattr(gamma, "expand", 
    loadproc(funcattr(gamma,"expand"),pathname("SPECFUNC","EXPAND"),"gamma")
):

gamma:= funcattr(gamma,"rectform",
    loadproc(funcattr(gamma,"rectform"),pathname("STDLIB","RECTFORM"),"gamma")
):

gamma:= funcattr(gamma, "series",
    loadproc(funcattr(gamma,"series"),pathname("SERIES"),"gamma")
):

# end of file #
