# $Date: 1996/07/03 13:46:00 $ $Author: frankp $ $Revision: 1.25 $ #

# kg, 13/01/94 #

#++
ln -- the natural logarithm

ln(x)

x - expression
++#

ln:= proc(x)
    name ln;
local k;
begin
    if x::ln <> FAIL then return(x::ln(args())) end_if;
    if args(0) <> 1 then error("wrong no of args") end_if;

    if x = 0 then error("singularity") end_if;

    case type(x)

    of DOM_FLOAT do
	return(funcattr(ln,"float")(x))

    of DOM_COMPLEX do
	if domtype(op(x,1)) = DOM_FLOAT or
	   domtype(op(x,2)) = DOM_FLOAT 
	then
	    return(funcattr(ln,"float")(x))
	end_if;
	break

    of DOM_RAT do
        if op(x,1)=1 then return(-ln(op(x,2))) end_if

    of "exp" do
	if testtype( op(x), NUMERIC ) then
	    k:=round( -Im(op(x))/2/PI );
	    return( op(x)+2*k*PI*I )
	end_if
    end_case;

    procname(x)
end_proc:

ln(1):= 0:
ln(E):= 1:
ln(1/E):= -1:
ln(-1):= I*PI:
ln(I):=1/2*I*PI:
ln(-I):=-1/2*I*PI:

ln:= funcattr(ln,"type","ln"):
ln:= funcattr(ln,"print","ln"):
ln:= funcattr(ln,"info","ln -- the natural logarithm"):

ln:= funcattr(ln,"expand",
    loadproc(funcattr(ln,"expand"),pathname("SPECFUNC","EXPAND"),"ln")
):

ln:= funcattr(ln,"simplify",
    loadproc(funcattr(ln,"simplify"),pathname("STDLIB","SIMPLIFY"),"ln")
):

ln:= funcattr(ln,"sign",
    loadproc(funcattr(ln,"sign"),pathname("SPECFUNC","SIGN"),"ln")
):

ln:= funcattr(ln,"rectform",
    loadproc(funcattr(ln,"rectform"),pathname("STDLIB","RECTFORM"),"ln")
):

ln:= funcattr(ln,"series",
    loadproc(funcattr(ln,"series"),pathname("SERIES"),"ln")
):

ln:= funcattr(ln,"Re",
    loadproc(funcattr(ln,"Re"),pathname("STDLIB","RE"),"ln")
):

ln:= funcattr(ln,"Im",
    loadproc(funcattr(ln,"Im"),pathname("STDLIB","IM"),"ln")
):

ln:= funcattr(ln,"diff",
    loadproc(funcattr(ln,"diff"),pathname("SPECFUNC","DIFF"),"ln")
):

# end of file #
