# $Date: 1997/10/16 10:43:12 $ $Author: frankp $ $Revision: 1.31 $ #

# kg, 13/01/94 #

#++
sin -- the sine

sin(x)

x - expression
++#

sin:= proc(x)
    local f;
    name sin;
begin
    if x::sin <> FAIL then return(x::sin(args())) end_if;

    if args(0) <> 1 then error("wrong no of args") end_if;

    case type(x)
    of DOM_INT do
    of DOM_RAT do
	if x < 0 then return(-sin(-x)) end_if;
	break;

    of DOM_FLOAT do
	return(funcattr(sin,"float")(x));

    of DOM_COMPLEX do
        if domtype(op(x,1)) = DOM_FLOAT or
           domtype(op(x,2)) = DOM_FLOAT then
	       return(funcattr(sin,"float")(x))
	   end_if;
	if op(x,1) = 0 then return(sinh(-x*I)*I) end_if;
	break;

    of "_mult" do
#--
due to performance reasons, remove this test

       if nops(x)>nops(x/PI) then
        	if is(x/PI, Type::Integer)=TRUE then
			return(0)
		end_if
	end_if;
--#
	f:= op(x, nops(x));
	if testtype(f, Type::RealNum) then
	    if f < 0 then return(-sin(-x)) end_if;
	    if domtype(f) = DOM_FLOAT then break end_if;
	else
	    break
	end_if;

	if nops(x) = 2 then
	    if op(x,1) = PI then
		if f < 1/2 then break end_if;
		if f < 1 then return(sin((1-f)*PI)) end_if;
		if f < 2 then return(-sin((2-f)*PI)) end_if;
		return(sin((f-2*(floor(f) div 2))*PI));
	    end_if
	end_if;
	break;
    of "_plus" do
       if sysorder(-x,x)=TRUE then return(-sin(-x)) else break end_if
    of "asin" do return(op(x));
    of "acos" do return(sqrt(1-op(x)^2));
    of "atan" do return(op(x)/sqrt(1+op(x)^2));
    end_case;

    procname(x)
end_proc:

sin(0):= 0:
sin(PI/12):= (6^(1/2)-2^(1/2))/4: # simpler than ((2-3^(1/2))^(1/2))/2: #
sin(PI/8):= ((2-2^(1/2))^(1/2))/2:
sin(PI/6):= 1/2:
sin(PI/5):= 1/4*2^(1/2)*(5-5^(1/2))^(1/2):
sin(PI/4):= (2^(1/2))/2:
sin(PI/3):= (3^(1/2))/2:
sin(3*PI/8):= ((2+2^(1/2))^(1/2))/2:
sin(5*PI/12):= ((2+3^(1/2))^(1/2))/2:
sin(PI/2):= 1:
sin(PI):= 0:
sin(I):= sinh(1)*I:


sin:= funcattr(sin, "print", "sin"):
sin:= funcattr(sin, "info", "sin -- the sine" ):
sin:= funcattr(sin, "type", "sin"):

sin:= funcattr(sin, "expand",
    loadproc(funcattr(sin,"expand"),pathname("SPECFUNC","EXPAND"),"sin")
):

sin:= funcattr(sin, "conjugate",
    loadproc(funcattr(sin,"conjugate"),pathname("STDLIB","CONJ"),"sin")
):

sin:= funcattr(sin,"rectform",
    loadproc(funcattr(sin,"rectform"),pathname("STDLIB","RECTFORM"),"sin")
):

sin:= funcattr(sin, "series",
    loadproc(funcattr(sin,"series"),pathname("SERIES"),"sin")
):

sin:= funcattr(sin,"Re",
    loadproc(funcattr(sin,"Re"),pathname("STDLIB","RE"),"sin")
):

sin:= funcattr(sin,"Im",
    loadproc(funcattr(sin,"Im"),pathname("STDLIB","IM"),"sin")
):

sin:= funcattr(sin, "diff",
    loadproc(funcattr(sin,"diff"),pathname("SPECFUNC","DIFF"),"sin")
):

# end of file #
