# #
# $Date: 1997/04/10 10:39:16 $ $Author: frankp $ $Revision: 1.5 $ #
# #
# frankp, 25.11.1994 #

#--
	rectform::_power  --  the function _power for rectform
--#

domattr(rectform,"_power") := proc(a,b)
    name rectform::_power;
    local t, ai, bi, l1, l2, i, tmp, r;
begin
    if domtype(a) = rectform then l1 := extop(a,4)
    else a := rectform::new(a); l1 := {}
    end_if;
    if domtype(b) = rectform then l2 := extop(b,4)
    else
        if testtype(sign(b),NUMERIC) then l2 := l1
        else l2 := {}
        end_if;
        b := rectform::new(b)
    end_if;
    if l1 <> l2 then
        a := rectform::new(a, l1 intersect l2);
        b := rectform::new(b, l1 intersect l2)
    end_if;

    l1 := l1 intersect l2;
    if extop(a,3) <> 0 or extop(b,3) <> 0 then
        return( new(rectform,0,0,
            _power(rectform::expr(a),rectform::expr(b)),l1)
        )
    end_if;
    ai := extop(a,2); a := extop(a,1);
    bi := extop(b,2); b := extop(b,1);
    t := b+I*bi;
    if domtype((a+I*ai)^t) = DOM_COMPLEX then
        return( rectform::new((a+I*ai)^t,l1) )
    elif domtype(t) = DOM_INT then
        if iszero(ai) then
            return( new(rectform,a^b,0,0,l1) )
        elif iszero(a) then
            return( new(rectform,0,ai^b*(-1)^(modp(b,4) div 2),0,l1) )
        elif b = 1 then
            return( new(rectform,a,ai,0,l1) )
        elif b = -1 then
            t := a^2+ai^2;
            return( new(rectform,a/t,-ai/t,0,l1) )
        elif b < -1 then
            t := rectform::new(expand((a+I*ai)^(-b)),l1);
            a := extop(t,1); ai := extop(t,2);
            t := a^2+ai^2;
            return( new(rectform,a/t,-ai/t,0,l1) )
        else
            return( rectform::new(expand((a+I*ai)^b),l1) )
        end_if
    elif domtype(t) = DOM_RAT then
        tmp := [];
        l2 := l1 union rectform::globalRealSet;
        (r:=op(l2,1);tmp:=tmp.[[Re(r),Im(r)]];sysassign(Re(r),r);sysassign(Im(r),0))
            $ i=1..nops(l2);
        if t = 1/2 then
	    if iszero(ai) then
		if sign(a) = -1 then t:= new(rectform,0,(-a)^(1/2),0,l1)
	        else 
		    t:= abs(a)^(1/2);
		    t:= new(rectform,1/2*t*(1+sign(a)),1/2*t*(1-sign(a)),0,l1)
		end_if
	    else
	        t:= sqrt(a^2+ai^2)/2;
		b:= 1;
	        if sign(ai)=-1 or iszero(ai) and sign(a)=1 then b:= -1 end_if; # csign(ai-I*a)=-1 #
	        t:= new(rectform,sqrt(a/2+t),b*sqrt(-a/2+t),0,l1)
	    end_if
        elif iszero(ai) then
            t := abs(a)^b;
            ai := (1/2*abs(b)-1/2*abs(b)*sign(a))*PI;
            t := new(rectform,t*cos(ai),t*sin(ai)*sign(b),0,l1)
        elif iszero(a) then
            t := abs(ai)^b;
            ai := 1/2*sign(ai)*abs(b)*PI;
            t := new(rectform,t*cos(ai),t*sin(ai)*sign(b),0,l1)
        else
            t := sqrt(a^2+ai^2)^b;
            ai := abs(b)*atan(a,ai);
            t := new(rectform,t*cos(ai),t*sin(ai)*sign(b),0,l1)
        end_if;
        (r:=op(l2,i);sysassign(Re(r),tmp[i][1]);sysassign(Im(r),tmp[i][2]))
            $ i=1..nops(l2)
    else
        tmp := [];
        l2 := l1 union rectform::globalRealSet;
        (r:=op(l2,1);tmp:=tmp.[[Re(r),Im(r)]];sysassign(Re(r),r);sysassign(Im(r),0))
            $ i=1..nops(l2);

        t := funcattr(exp,"rectform")(t*ln(a+I*ai),l1);

        (r:=op(l2,i);sysassign(Re(r),tmp[i][1]);sysassign(Im(r),tmp[i][2]))
            $ i=1..nops(l2)
    end_if;
    t
end_proc:

# end of file #
