# $Date: 1997/08/07 13:42:58 $ $Author: tonner $ $Revision: 1.3 $ #

#--
	acos/rectform -- the function attribut "rectform" for atan
--#

atan:= funcattr( atan, "rectform", proc(x,y)
        local atan2, a, b, rl, s;
    begin
	atan2:= bool( (args(0) = 2 and domtype(y) <> DOM_SET) or args(0) = 3 );
	case args(0)
	of 1 do
	    x:= rectform::new( x );
	    break
	of 2 do 
	    if atan2 then
                x:= rectform::new( x );
		y:= rectform::new( y )
	    else
		x:= rectform::new( x,y )
	    end_if;
	    break
	of 3 do
	    x:= rectform::new( x,args(3) );
	    y:= rectform::new( y,args(3) )
	end_case;
	    
        rl:= extop(x,4); # same as extop(y,4) if atan2 = TRUE #

	if atan2 then
	    if extop(x,3) <> 0 or extop(y,3) <> 0 then
		new(rectform,0,0,hold(atan)(rectform::expr(x),rectform::expr(y)),rl)
	    else
		a:= extop(x,1);
		s:= extop(y,1);
		if not iszero(extop(x,2)) or not iszero(extop(y,2)) then
		    error("two-argument atan expects real quantifiers");
		else
		    new( rectform,atan(a,s),0,0,rl )
		end_if
	    end_if
	elif extop(x,3) <> 0 then
            new( rectform,0,0,hold(atan)(rectform::expr(x)),rl )
        else
            a:= extop(x,1);
            b:= extop(x,2);
            if domtype(a+I*b) = DOM_COMPLEX
               and (domtype(a) = DOM_FLOAT or domtype(b) = DOM_FLOAT)
	    then
		rectform::new(atan(a+I*b))
            elif iszero(b) then
		new( rectform,atan(a),0,0,rl )
	    elif iszero(a) and iszero(abs(b)-1) then
		error("singularity")
	    else
		s:= (a^2+(b+1)^2)/(a^2+(b-1)^2);
		new( rectform,1/2*atan(a,1-b)-1/2*atan(-a,b+1),1/4*ln(s),0,rl )
            end_if
        end_if
    end_proc
):
 
# end of file #
