# $Date: 1997/08/07 13:43:03 $ $Author: tonner $ $Revision: 1.4 $ #

#--
	ln/rectform -- the function attribut "rectform" for ln
--#

ln:= funcattr( ln, "rectform", proc(x)
        local a, b, t, rl;
    begin
        if args(0) = 2 then
            x:= rectform::new(x,args(2))
        else
            x:= rectform::new(x)
        end_if;
        rl:= extop(x,4);
        if extop(x,3) <> 0 then
            new(rectform,0,0,hold(ln)(rectform::expr(x)),rl)
        else
            a:= extop(x,1);
            b:= extop(x,2);
            if domtype(a+I*b) = DOM_COMPLEX
            and (domtype(a) = DOM_FLOAT or domtype(b) = DOM_FLOAT)
            then
                rectform::new(ln(a+I*b))
            elif iszero(a+I*b) then
                error("singularity")
            elif iszero(b) then
                new(rectform,ln(abs(a)),(1/2-1/2*sign(a))*PI,0,rl)
            else
                t:= a^2+b^2;
                if iszero(a) then
                    if testtype( sqrt(t),NUMERIC ) then
                        new(rectform,ln(sqrt(t)),1/2*sign(b)*PI,0,rl)
                    else
                        new(rectform,1/2*ln(t),1/2*sign(b)*PI,0,rl)
                    end_if
                elif testtype( sqrt(t),NUMERIC ) then
                    new(rectform,ln(sqrt(t)),atan(a,b),0,rl)
                else
                    new(rectform,1/2*ln(t),atan(a,b),0,rl)
                end_if
            end_if
        end_if
    end_proc
):

# end of file #
