# $Date: 1996/10/02 13:18:00 $ $Author: zimmerma $ $Revision: 1.4 $ #

#--
	simplify/exp -- the function attribut "exp" for simplify

	simplifies expressions containing exponentials
        with algebraic dependencies, for example exp(x)
        and exp(x/2), by substituting with new variables,
        calling normal, and substituting back.
--#

simplify:=funcattr(simplify,"exp",proc(a)
   local l,e,i,m,j,found,s;
begin
   l:=[]; # list of arguments of exponentials #
   m:=[]; # list of substituted variables #
   s:=[]; # list of substitutions #
   for e in indets(a,RatExpr) do
      if type(e)="exp" then
         found:=FALSE;
         for j from 1 to nops(l) do
            i:=op(e)/l[j];
            if contains({DOM_INT,DOM_RAT},type(i)) then
               if abs(i)>1 then s:=append(s,e=m[j]^i)
               else
                  s:=subs(s,m[j]=m[j]^(1/i));
                  s:=append(s,e=m[j]);
                  l[j]:=op(e);
               end_if;
               found:=TRUE; break
            end_if
         end_for;
         if not found then
            l:=append(l,op(e));
            j:=genident();
            m:=append(m,j);
            s:=append(s,e=j);
         end_if
      end_if;
   end_for;
   a:=normal(subs(a,s));
   for j from 1 to nops(l) do a:=subs(a,m[j]=exp(l[j])) end_for;
   a
end_proc):

# end of file #
