# $Date: 1999/04/20 06:44:24 $ $Author: bij $ $Revision: 1.25.2.2 $ #

#--
	_power/simplify -- the function attribut "simplify" for _power
--#

_power:=funcattr(_power,"simplify",proc(e)
local c,q,l,i,p,t,aa,k,ok,_a,b;
begin
   _a:= simplify(op(e,1)); b:= op(e,2);
   # This case must be treated before sign(b)=-1, because #
   # we want to simplify exp(x)^(-y) -> exp(x*(-y))       #
   if testtype(_a, "exp") then return(simplify(exp(op(_a)*b))) end_if;
   if sign(b)=-1 then return(simplify(_a^(-b))^(-1)) end_if;
   # now b cannot be negative #
   if type(_a)="_mult" then
      if is(b,DOM_INT)=TRUE then
           return(map(map(_a,simplify),_power,b))
      elif type(b)=DOM_RAT then
           c := op(_a, nops(_a));
           if testtype(c, NUMERIC) then
              if (c < 0) then
                 t := trunc(b);
                 if (t <> 0) then
                    return(_a^t*_a^(b-t))
                 end_if
              end_if
           end_if;
      end_if;
      p:=1; aa:=1;
      for q in _a do
         if is(q>=0)=TRUE then p:=p*simplify(q^b)
         elif is(q<0)=TRUE and _a<>-q then p:=p*simplify((-q)^b); aa:=-aa
         else aa:=aa*q
         end_if;
      end_for;
      return(p*aa^b)
   elif type(_a)="_plus" then
      if type(b)=DOM_RAT then
         i:=trunc(b); b:=b-i;
         l:=expand(_a^i);
      else l:=1
      end_if;
      # result is l*_a^b #
      # try to simplify the fractional part #
      aa:=rationalize(_a,NIL,NIL,{"_power"});
      q:=sqrfree(numer(aa[1])); p:=sqrfree(denom(aa[1]));
      ok:=bool(nops(q)<>3 or nops(p)<>1); # to avoid loops #
      if sign(b)=1 and ok then
         for i from nops(q) div 2 downto 1 do
            if q[2*i+1]<>1 then
               if is(q[2*i]^q[2*i+1]>=0)=TRUE then
                  l:=l*simplify((q[2*i]^q[2*i+1])^b); 
                  unassign(q[2*i+1], q[2*i]); ok:=TRUE
               end_if
            end_if
         end_for;
      elif sign(b)=1 and nops(q)=3 and q[3]=2 then
         # (x^2)^b = x*(y*b) if sign(b)=1 and Re(x)>=0 #
         subs(q[2],aa[2]);
         if is(%>=0)=TRUE then return(l*%^(2*b))
         elif is(%<=0)=TRUE then return(l*(-%)^(2*b))
         elif is(Re(%)>=0)=TRUE then return(l*%^(2*b)) 
         elif is(Re(%)<=0)=TRUE then return(l*(-%)^(2*b)) end_if
      end_if;
      q:=_mult(q[1],q[2*i]^q[2*i+1]$hold(i)=1..nops(q) div 2);
      p:=_mult(p[1],p[2*i]^p[2*i+1]$hold(i)=1..nops(p) div 2);
      q:=subs(q/p,aa[2]);
      _a:=q^b;
      if type(l)="_plus" then p:=map(l,_mult,_a) else p:=l*_a end_if;
      return(p)
   elif type(_a)=DOM_INT and type(b)=DOM_RAT then
      if _a < 0 then
         return( (-1)^b * simplify((-_a)^b) )
      end_if;
      q:=op(b,2); # denominator #
      # first tries to decompose the exponent #
      l:=ifactor(q);
      # invariant: result = _a^b #
      _a:=_a^op(b,1); b:=1/q;
      for i from 1 to nops(l) div 2 do
         p:=l[2*i]; k:=l[2*i+1];
         repeat
            # is _a^(1/p) an integer ? #
            aa:=round(_a^(1/p));
            if _a=aa^p then _a:=aa; b:=b*p; k:=k-1 else break end_if;
         until k=0 end_repeat;
      end_for;
      return(_a^b);
      # now tries to factor _a: removed PZ 8.1.99 since it can lead to
        infinite loops as simplify(2^(1/2)*3^(1/2)) -> 6^(1/2) #
      # if isprime(_a) then return(_a^b)
      else
         l:=ifactor(_a);
         _a:=l[1]^b; ## l[1] is either 1 or -1 ##
         for i from 1 to nops(l) div 2 do
            p:=l[2*i]; k:=l[2*i+1];
            _a:=_a*p^(k*b)
         end_for;
         return(_a)
      end_if; #
   elif testtype(_a,hold(_power)(Type::AnyType,Type::Rational)) 
    and type(b)=DOM_RAT then # (x^r)^(j/k) #
      p:=op(_a,1)^(op(_a,2)*b);
      if is(p>=0)=TRUE then return(p)
      elif b=1/2 then
         if is(Re(p)>0)=TRUE then return(p)
         elif is(p,Type::RealNum)=TRUE then return(p*sign(p))
         end_if
      end_if
   elif b = 1/2 and _a<>op(e,1) # otherwise it will loop !!! #
   then
      return(simplify(sqrt(_a)))
   end_if;

   e
end_proc):

# end of file #
