# $Date: 1996/12/04 13:44:24 $ $Author: zimmerma $ $Revision: 1.10 $ #

#--
	ln/simplify -- the function attribut "simplify" for ln
--#

ln := funcattr(ln, "simplify", proc(__x)
    local t, k, _y, _x;
begin
    _x:= op(__x);
    case type(_x)
    of DOM_RAT do 
	return(ln(op(_x,1))-ln(op(_x,2)))
    of "_power" do 
	# ln(x^n)=n*ln(x) when x is real nonnegative
          or if n=1/2, because if x = r*exp(I*t) with r>=0 
	  and -PI<t<=PI, then x^(1/2)=sqrt(r)*exp(I*t/2)
          and ln(x^(1/2))=1/2*ln(r)+I*t/2 = ln(x)/2.

          This is true in general for -1<n<1
          and for n=-1 if x is not real nonnegative 
	#
        if (is(op(_x,1)>=0) or is(-1<op(_x,2)) and is(op(_x,2)<1)
            or (bool(op(_x,2)=-1) and not is(op(_x,1)<0)))=TRUE 
	then
            return( 
		simplify(op(_x,2)) * 
		funcattr(ln,"simplify")(ln(simplify(op(_x,1))))
	    )
        end_if;
        break
    of "_mult"  do
        t:=simplify(_x);
        if type(t)="_mult" then
	    # CAUTION: ln(a*b) is not always ln(a)+ln(b),
              for example if a=b=-1, ln(a*b)=0 but ln(a)+ln(b)=2*I*PI #
            k:=1; for _y in t do
               if is(_y>0)=TRUE then k:=k*_y; t:=t/_y
               elif is(_y<0)=TRUE then k:=k*(-_y); t:=t/(-_y)
               end_if
            end_for;
            if type(k)="_mult" then k:=op(k) end_if;
            return( _plus( ln(t), op(map([k],simplify@ln)) ) )
        elif t <> _x then return( funcattr(ln,"simplify")(ln(t)) )
        else return( __x )
        end_if
    of "exp" do 
	# ln(exp(x))=x when x is real 
	  and more generally when -PI < Im x <= PI
	#
	t:= op(_x,1);
	if is( t,Type::RealNum ) = TRUE then 
	    return( t ) 
	else
	    k:= round( -Im(t)/2/PI );
            if type(k) = DOM_INT then 
		return( t+2*k*PI*I )
            elif contains({-1,0,1},sign(t)) then
		return( t )
	    end_if
	end_if;
    end_case;

    t:= simplify(_x);
    if t <> _x then funcattr(ln,"simplify")(ln(t)) else __x end_if
end_proc):

# end of file #
