# #
# $Date: 1999/04/20 15:38:28 $ $Author: stefanw $ $Revision: 1.16.2.1 $ #

simplify :=
proc(e,f)
  local _t, s, _e, p, Try;
begin
    # is overloaded ? #
  if (args(1))::simplify<>FAIL then
    return((args(1))::simplify(args()))
  end_if;

  case args(0)
    of 2 do
      f:=funcattr(simplify,expr2text(f));
      if f <> FAIL then return( f(e) )
      else
        error("invalid second argument");
      end_if;
    of 1 do break;
    otherwise error("wrong no of args")
  end_case;

  case domtype(e)
    of DOM_INT     do
    of DOM_RAT     do
    of DOM_FLOAT   do
    of DOM_COMPLEX do return( e )
    of DOM_POLY	   do return( mapcoeffs(e,simplify) )
    of Puiseux	   do return( map(e,simplify) )
    of DOM_LIST    do 
    of DOM_ARRAY   do
    of DOM_SET     do return( map(e,simplify) )
    of DOM_EXPR    do
	# try global simplifications first #
	Try:= TRUE;
	while Try  do
	    _e:= e;
     for _t in indets(e,RatExpr) do
       if (p:= funcattr(simplify,type(_t))) <> FAIL then
         e:= p( e );
         if e <> _e then break end_if
       end_if
     end_for;
     if e = _e then
       if testtype( e, NUMERIC ) then return( e )
       else Try:= FALSE
       end_if
     end_if
   end_while;

	if testtype( e,NUMERIC ) then return( e ) end_if;

        _t := op(e,0);
        if domtype(level(_t,2)) = DOM_FUNC_ENV and
           (s:= funcattr(level(_t,2),"simplify")) <> FAIL 
	then
           return( s(e) )
        end_if;
	e:=map(e,simplify);
    end_case;
    e
end_proc:

DOM_NIL::simplify:=fun(NIL):

DOM_EXEC::simplify:=fun(misc::mapFun(args(1),simplify)):

simplify:= funcattr(simplify, "function",
                    proc(e)
                      local l, i, _e;
                      
                    begin
                      l:=select([op(e)], fun(type(args(1))="function"));
                      l:=map(l, op, 0);
                      l:=map(l, type);
                      _e:=e;
                      for i in l do
                        funcattr(simplify, i);
                        if %<>FAIL then
                          _e:=%(e)
                        end_if;
                        if e<>_e then break; end_if;
                      end_for;
                      return(_e)
                    end_proc
                      ):

simplify:= funcattr(simplify, "D",
                    proc(e)
                    begin
                      rewrite(e, diff)
                    end_proc):

simplify:= funcattr(simplify,"sin",
    loadproc(funcattr(simplify,"sin"),pathname("STDLIB","SIMPLIFY"),
        "SIMPLsin")
):
simplify:= funcattr(simplify,"cos",
    loadproc(funcattr(simplify,"cos"),pathname("STDLIB","SIMPLIFY"),
        "SIMPLcos")
):

simplify:=funcattr(simplify,"sqrt",radsimp):

simplify:=funcattr(simplify,"exp",
    loadproc(funcattr(simplify,"exp"),pathname("STDLIB","SIMPLIFY"),
        "SIMPLexp")
):
exp:=funcattr(exp,"simplify",
    loadproc(funcattr(exp,"simplify"),pathname("STDLIB","SIMPLIFY"),
        "exp")
):

simplify:=funcattr(simplify,"ln",
    loadproc(funcattr(simplify,"ln"),pathname("STDLIB","SIMPLIFY"),
        "Sln")
):

_power:= funcattr(_power,"simplify",
    loadproc(funcattr(_power,"simplify"),pathname("STDLIB","SIMPLIFY"),
        "_power")
):

_mult:= funcattr(_mult,"simplify",
    loadproc(funcattr(_mult,"simplify"),pathname("STDLIB","SIMPLIFY"),
        "_mult")
):

max:=funcattr(max,"simplify",
    loadproc(funcattr(max,"simplify"),pathname("STDLIB","SIMPLIFY"),"max")):

min:=funcattr(min,"simplify",
    loadproc(funcattr(min,"simplify"),pathname("STDLIB","SIMPLIFY"),"min")):

simplify:=funcattr(simplify,"logic",
loadproc(logic::simplify,pathname("LOGIC"),"simplify")):

simplify:=funcattr(simplify,"relation",
loadproc(relation::simplify,pathname("STDLIB","SIMPLIFY"),"relation")):

_plus:= funcattr(_plus,"simplify",
    loadproc(funcattr(_plus,"simplify"),pathname("STDLIB","SIMPLIFY"),
        "_plus")
):

int:= funcattr(int,"simplify",
    loadproc(funcattr(int,"simplify"),pathname("STDLIB","SIMPLIFY"),
        "int")
):

simplify:=funcattr(simplify,"normal",normal):

# end of file #
