# #
# $Date: 1996/12/20 18:26:17 $ $Author: zimmerma $ $Revision: 1.13 $ #
# #
# zimmerma, 14/12/95 #

#--
	stdlib::solve_algebraic(sys,unk,dom) solves the algebraic
	system 'sys' with respect to the unknowns 'unk' over the
	coefficient field 'dom'.

	If 'unk' is a list, then it gives the elimination order.
--#

stdlib::solve_algebraic:=proc(sys,unk,dom) local g,args3,reord;
begin
   if type(unk)=DOM_SET then unk:=[op(unk)]; reord:=Reorder
   else reord:=null() end_if;
   args3:=bool(args(0)>=3); # because traperror does not restore args #
   userinfo(1,"entering solver for algebraic systems");
   if not args3 then 
      if map(sys,testtype,Type::PolyExpr(unk,Type::Rational))={TRUE}
      then dom:=Expr 
      else dom:=Dom::ExpressionField(normal)
      end_if
   end_if;
   sys:=map([op(sys)],poly,unk,dom);
   # first compute a basis wrt DegInvLexOrder #
   g:=groebner::gbasis(sys,DegInvLexOrder,reord);
   # then transform it in a LexOrder basis (the Grobner walk) #
   g:=groebner::gbasis(g,LexOrder,reord);
   userinfo(2,"Groebner basis is",map(g,expr));
   if nops(g)=1 and degree(g[1])=0 then null() # no solution #
   else
      g:=groebner::factor(g);
      g:=map(g,op@groebner::triangular_set);
      op(map(g,stdlib::allvalues,{op(unk)}))
   end_if
end_proc:

stdlib::allvalues := proc(g,unk) local x,sol,i,j,r,n,foo;
begin
      sol:=[[]];
      # foo(l,x,j) adds x=j in front of partial solution l #
      if stdlib::solveBackSubstitution=TRUE or BackSubstitution=TRUE then
         foo:=fun([args(2)=subs(args(3),op(args(1))),op(args(1))])
      else foo:=fun([args(2)=args(3),op(args(1))])
      end_if;
      if nops(g)=1 and op(g[1],1)=1 then return(null()) end_if;
      for i from nops(g) downto 1 do
         r:=g[i];
         x:=indets(op(r,1)) intersect unk;
         if nops(x)=0 then next end_if;
         # choose the largest unknown #
         for j in op(r,2) do if contains(x,j) then x:=j; break end_if end_for;
         unk:=unk minus {x};
         j:=stdlib::solve_poly(poly(op(r,1),[x]),x,MaxDegree);
         if (n:=nops([j]))=1 then sol:=map(sol,foo,x,j)
         else sol:=_concat(map(sol,foo,x,j[i])$hold(i)=1..n)
         end_if;
      end_for;
      op(sol)
end_proc:

sysassign(
allvalues,loadproc(allvalues,pathname("STDLIB","SOLVE"),"allvals")):

# end of file #
