# allvalues(s) returns all complex solutions of a polynomial
  system, where s is the symbolic solution.

Example:
>> s:=solve({x^4+x+1,y^4+x+1},{x,y}):
>> DIGITS:=3: allvalues(s);
# 

allvalues := proc(s) local eq,x,sol,v;
begin
   case type(s)
   of DOM_SET do return(_union(map(s,op@allvalues)))
   of DOM_LIST do
      if s=[] then return({[]}) end_if;
      eq:=s[nops(s)]; x:=op(eq,1); eq:=op(eq,2); s[nops(s)]:=NIL;
      eq:=[float(eq)];
      sol:={};
      for v in eq do
         sol:=sol union map(allvalues(subs(s,x=v)),append,x=v)
      end_for;
      return(sol)
   otherwise hold(float)(s)
   end_case
end_proc:

