# #
# $Date: 1997/08/07 13:43:10 $ $Author: tonner $ $Revision: 1.16 $ #
# #
# zimmerma, 14/12/95 #

#--
	The function attribute "float" for solve

        float(hold(solve)(eq)
	float(hold(solve)(eq,x)		solves over -infinity..infinity
	float(hold(solve)(eq,x=a..b)	solves over a..b
	float(hold(solve)(eq,x,All)	gives all solutions
	float(hold(solve)(eq,x=a..b,All)

Examples:
>> float(hold(solve)(x^2=2) );

                        {1.414213562, -1.414213562}

>> DIGITS:=3: float(hold(solve)({x^4+x+1,y^4+x+1},{x,y}));

{[y = - 0.727 + 0.934 I, x = 0.727 - 0.934 I],
   [y = - 0.727 - 0.934 I, x = 0.727 + 0.934 I],
   [y = - 0.43 + 0.727 I, x = - 0.727 - 0.43 I],
   [y = - 0.43 - 0.727 I, x = - 0.727 + 0.43 I],
   [y = 0.727 - 0.934 I, x = 0.727 - 0.934 I],
   [y = 0.727 + 0.934 I, x = 0.727 + 0.934 I],
   [y = 0.43 - 0.727 I, x = - 0.727 - 0.43 I],
   [y = 0.43 + 0.727 I, x = - 0.727 + 0.43 I],
   [y = 0.934 + 0.727 I, x = 0.727 - 0.934 I],
   [y = 0.934 - 0.727 I, x = 0.727 + 0.934 I],
   [y = 0.727 + 0.43 I, x = - 0.727 - 0.43 I],
   [y = 0.727 - 0.43 I, x = - 0.727 + 0.43 I],
   [y = - 0.934 - 0.727 I, x = 0.727 - 0.934 I],
   [y = - 0.934 + 0.727 I, x = 0.727 + 0.934 I],
   [y = - 0.727 - 0.43 I, x = - 0.727 - 0.43 I],
   [y = - 0.727 + 0.43 I, x = - 0.727 + 0.43 I]}

--#

solve:= funcattr(solve, "float",
proc(p) 
    local s,a,b,Arg,X;
begin
   case args(0)
   of 1 do X:=indets(p);
   of 2 do of 3 do of 4 do break # ok #
   otherwise error("wrong number of arguments")
   end_case;
 
   Arg:= [args()];
   Arg:= subs( Arg,hold(Multiple)=null(),hold(All)=null() );
   case domtype(p)
   of DOM_EXPR do
      if type(p)="_equal" then p:=op(p,1)-op(p,2) end_if;
      if nops(Arg)=1 then
         X:=indets(p) minus {E,PI,EULER};
         if nops(X)<>1 then error("more than one indeterminate") end_if;
         X:=op(X);
	 if testtype(p,Type::PolyExpr(X)) then 
	     p:=poly(p,[X]) 
	 end_if
      else
         X:= Arg[2];
         if domtype(X) = DOM_IDENT then
	    if testtype(p,Type::PolyExpr(X)) then 
               if indets(p) minus {E,PI,EULER}<>{X} then
                  error("only univariate equation allowed")
               end_if;
	       p:=poly(p,[X])
  	    end_if
          end_if
      end_if;
      break
   of DOM_POLY do
      if nops(op(p,2))<>1 then
	error("only univariate polynomial allowed") 
      end_if;
      X:=op(op(p,2));
      break;
   otherwise 
      return(allvalues(solve(args())))
   end_case;

   if domtype(p)=DOM_POLY then s:=numeric::fsolve_Sqrfpoly(p,DIGITS,X)
   else # non-polynomial equation #
      s:=FAIL;
      if args(0) >= 2 then
         if type(X)="_equal" then # range given #
	    a:= op(X,2); X:= op(X,1);
	    if domtype( X ) <> DOM_IDENT or type(a)<>"_range" then
		error("invalid arguments")
	    end_if;
	    b:= float(op(a,2)); a:= float(op(a,1));
            if (not testtype(a,NUMERIC)) and has(a,infinity)=FALSE or
               (not testtype(b,NUMERIC)) and has(b,infinity)=FALSE
	    then
		error("not a numeric range");
            else
               # first try an exact method #
               if traperror((s:=[numeric::fsolve(p,X,a,b,10.0^(-DIGITS))]))=0
               then s:=op(map(s,op,1))
               else s:=FAIL
               end_if
            end_if;
	    if args(0)>2 and args(3)<> hold(All) then
		error("invalid arguments")
	    end_if
	 elif domtype(X)=DOM_IDENT then 
	    a:=-infinity; b:=infinity;
            if args(0)>2 and args(3)<> hold(All) then
                error("invalid arguments")
            end_if
         elif X=hold(All) then
         else error("invalid arguments")
         end_if
      else
 	 a:=-infinity; b:=infinity
      end_if;
      userinfo(1,"trying Newton method, some solutions may be lost");
      if s=FAIL then
         if contains({args()},hold(All)) then return(FAIL) end_if;
         s:=numeric::newton(p,X=a..b)
      end_if;
   end_if;
   if contains({args()},hold(Multiple)) then Dom::Multiset(s) else {s} end_if
end_proc):

sysassign(
allvalues,loadproc(allvalues,pathname("STDLIB","SOLVE"),"allvals")):

# end of file #
