# #
# $Date: 1995/08/28 16:24:30 $ $Author: zimmerma $ $Revision: 1.2 $ #
# #
# zimmerma, 14/12/95 #

#--
	stdlib::solve_islinear

	Returns FALSE if sys is not a linear system with respect to 
	unk, otherwise sys where all equalities a=b have been replaced 
	by a-b and all 0 equations have been deleted.
--#

stdlib::solve_islinear := proc(sys,unk)
local eq,u,l,newsys;
begin
   l:=[op(unk)];
   newsys:={};
   for eq in sys do
      if type(eq)="_equal" then eq:=op(eq,1)-op(eq,2) end_if;
      for u in unk do
         if type(u)=DOM_FUNC_ENV then error("cannot solve for ".expr2text(u)) end_if;
         if not testtype(eq,Type::PolyExpr(u)) then return(FALSE) end_if
      end_for;
      if degree(eq,l)>1 then return(FALSE) end_if;
      newsys:=newsys union {eq};
   end_for;
   newsys
end_proc:

# end of file #
