# #
# $Date: 1997/05/16 09:26:25 $ $Author: zimmerma $ $Revision: 1.10 $ #
# #
# zimmerma, 14/12/95 #

#--
	stdlib::solve_poly_irred
--#

stdlib::solve_poly_irred := proc(p,x,lev) # p is irreducible #
local a,b,c,d;
begin
   d:=degree(p,x);
   userinfo(2,"solving irreducible polynomial of degree",d);
   if d=0 then if iszero(p) then x else null() end_if
   elif d=1 then -coeff(p,x,0)/coeff(p,x,1)
   elif d=2 and lev>=2 then
      a:=coeff(p,x,2); b:=coeff(p,x,1); c:=coeff(p,x,0);
      if op(p,2)<>[x] then a:=expr(a); b:=expr(b); c:=expr(c) end_if;
      d:=expand(b*b-4*a*c);
      # if d=k*a^2 we can choose d=k^(1/2)*a #
      if type(d)="_mult" and type(op(d,1))="_power" and op(d,[1,2])=2 then
	d:=op(d,[1,1])*sqrt(subsop(d,1=1)) else d:=sqrt(d) end_if;
      (-b+d)/2/a,(-b-d)/2/a
   elif d=3 and lev>=3 then stdlib::solve_poly3(p,x)
   else # d>=4 #
      userinfo(1,"trying polynomial decomposition");
      # do not try decomposition if lev=1 #
      if lev<2 or nops((a:=[decompose(p,x)]))=1 then # no decomposition #
         userinfo(1,"decomposition failed");
         if d=4 and lev>=4 then stdlib::solve_poly4(p,x)
         else
            if hastype((a:=expr(p)),DOM_FLOAT) then
		numeric::fsolve_Sqrfpoly(p,DIGITS,x)
            else RootOf(a,x)
            end_if
         end_if
      else
         userinfo(1,"decomposition succeeded");
         b:=[stdlib::solve_poly(a[1],x,lev)]; a[1]:=NIL;
         for c in a do
            # to avoid nested RootOf's #
            if contains(map(b,type),RootOf)<>0 
            then return(RootOf(expr(p),x)) end_if;
            b:=map(b,poly,[x]);
            b:=map(b,_plus,-c);
            b:=map(b,stdlib::solve_poly,x,lev);
         end_for;
         op(b)
      end_if
   end_if
end_proc:

# end of file #
