# #
# $Date: 1998/01/27 11:03:22 $ $Author: zimmerma $ $Revision: 1.9 $ #
# #
# zimmerma, 14/12/95 #

#--
	stdlib::solve_poly3
	Reference: "Handbook of mathematical functions"
		edited by M. Abramowitz and I. Stegun, Dover, New York,
		page 17.
  Thanks to Nicola Fabiano <mc8644@mclink.it>,<fabiano@vaxlnf.lnf.infn.it>
	from Laboratori Nazionali di Frascati I.N.F.N. , Frascati (Italy)
	and Physics Department, University of Perugia, Perugia (Italy)
  works now in all cases even with subs afterwards (no division by zero).
--#

stdlib::solve_poly3 := proc(p) 
    local a,b,c,d,q,sqrt3,r,s1,s2;
begin
   userinfo(2,"entering degree 3 routine");
   # input form a*x^3+b*x^2+c*x+d #
   a:=coeff(p,3); b:=coeff(p,2); c:=coeff(p,1); d:=coeff(p,0);
   # convert to x^3+b*x^2+c*x+d #
   b:=b/a; c:=c/a; d:=d/a;
   q:=expand(c/3-b^2/9);
   r:=expand(1/6*(c*b-3*d)-1/27*b^3);
   d:=expand(q^3+r^2);
   s1:=r+d^(1/2);
   if is(s1<0)=TRUE then s1:=-(-s1)^(1/3) else s1:=s1^(1/3) end_if;
   s2:=r-d^(1/2); 
   if is(s2<0)=TRUE then s2:=-(-s2)^(1/3) else s2:=s2^(1/3) end_if;
   if hastype(r,DOM_FLOAT) then sqrt3:=3.0^(1/2) else sqrt3:=3^(1/2) end_if;
   a:=(s1+s2)-b/3,
      -1/2*(s1+s2)-b/3+I*sqrt3/2*(s1-s2),
      -1/2*(s1+s2)-b/3-I*sqrt3/2*(s1-s2);
   # if 27*q^2+4*p^3<0 the three roots are real and distinct #
   if is(d<0)=TRUE then map(map(a,rectform),expr) else a end_if
end_proc:

# end of file #
