# #
# $Date: 1997/03/28 18:23:45 $ $Author: zimmerma $ $Revision: 1.4 $ #
# #
# zimmerma, 14/12/95 #

#--
	stdlib::solve_poly4
--#

stdlib::solve_poly4 := proc(P,x)
    local b,p,q,r,t1,t2,t3,t4,t5,t8,t11,t14,t15,t16,
          t17,t18,t19,t20,t21,t22,t23,t24,t25,t26,t27,t28,t29,t31,
          t33,t34,t36,t38,t39,t40,t42,t44,X1,X2,X3,X4,c,a;
begin
   if hastype(op(P,1),DOM_FLOAT) then
      P:=mapcoeffs(P,float); t15:=3.0^(1/2); t33:=6.0^(1/2);
   else t15:=3^(1/2); t33:=6^(1/2);
   end_if;
   # first make p monic #
   P:=multcoeffs(P,1/lcoeff(P)); # now P=x^4+b*x^3+c*x^2+d*x+e #
   # first try to recognize (x^2+(a+sqrt(b))*x+c)*(x^2+(a-sqrt(b))*x+c)
     = x^4+2*a*x^3+(a^2-b+2*c)*x^2+2*a*c*x+c^2 where a,b,c are rational #
   a:=coeff(P,3)/2;
   if coeff(P,1)^2=4*coeff(P,0)*a^2 then # it works #
      if a=0 then c:=sqrt(coeff(P,0)) else c:=coeff(P,1)/2/a end_if;
      b:=a^2+2*c-coeff(P,2);
      return(stdlib::solve_poly_irred(poly(x^2+(a+sqrt(b))*x+c,[x]),x,2),
	     stdlib::solve_poly_irred(poly(x^2+(a-sqrt(b))*x+c,[x]),x,2))
   end_if;
   b:=coeff(P,3)/4;
   P:=P(x-b); # make the change x=X-b/4 so that coeff of X^3 vanishes #
   p:=coeff(P,[x],2); q:=coeff(P,[x],1); r:=coeff(P,[x],0);
      # now P=X^4+p*X^2+q*X+r #

   t1:=r*p; t2:=q^2; t3:=p^2; t4:=t3*p; t5:=r^2; t8:=t3^2; t11:=t2^2;
   t14:=sqrt(128*t5*t3-256*t5*r-16*r*t8-144*t1*t2+27*t11+4*t2*t4);
   t16:=t14*t15; t17:=-4/3*t1+t2/2+t4/27+t16/18;
   t18:=t17^(1/3); t19:=p*t18; t20:=t18^2; t21:=-6*t19+9*t20+12*r+t3;
   t22:=sqrt(t21); t23:=t17^(1/6); t24:=1/t23; t25:=t22*t24; t26:=t19*t22;
   t27:=t22*t20; t28:=t22*r; t29:=t22*t3; t31:=sqrt(27*t2-72*t1+2*t4+3*t16);
   t34:=q*t31*t33; t36:=sqrt(-12*t26-9*t27-12*t28-t29-3*t34);
   t38:=t21^(1/4); t39:=1/t38; t40:=t36*t24*t39;
   t42:=sqrt(3*t34-12*t26-9*t27-12*t28-t29); t44:=t42*t24*t39;
   X1:=t25/6+t40/6; X2:=t25/6-t40/6;
   X3:=-t25/6+t44/6; X4:=-t25/6-t44/6;
   X1-b,X2-b,X3-b,X4-b
end_proc:

# end of file #
