# #
# $Date: 1997/09/25 13:06:35 $ $Author: root $ $Revision: 1.13 $ #
# #
# zimmerma, 14/12/95 #

#--
	stdlib::solve_sys
--#

# equations of degree up to degree stdlib::solveMaxDegree are made explicit #
if not testtype(stdlib::solveMaxDegree,Type::PosInt)
then stdlib::solveMaxDegree:=2
end_if:

if stdlib::solveBackSubstitution=FAIL
then stdlib::solveBackSubstitution:=FALSE
end_if:

stdlib::solve_sys := proc(sys,Unk)
   local newsys,eq,i,R,unk,Args;
begin
   unk:={op(Unk)}; Args:=args(3..args(0));
   if unk={} then
      sys:=map(sys,fun((if type(args(1))="_equal" then
	op(args(1),1)-op(args(1),2) else args(1) end_if)));
      if map(sys,iszero)={TRUE} then return({[0=0]}) else return({}) end_if
   end_if;
   # remove unknowns not appearing in equations #
   unk:=select(unk,fun(has(sys,args(1))));
   stdlib::sysblock([BackSubstitution,MaxDegree],(
   BackSubstitution:=subs(BackSubstitution,Args);
   if contains({TRUE,FALSE},BackSubstitution)=FALSE then
      BackSubstitution:=stdlib::solveBackSubstitution
   end_if;
   MaxDegree:=subs(MaxDegree,Args);
   if not testtype(MaxDegree,Type::PosInt) 
   then MaxDegree:=stdlib::solveMaxDegree end_if;
   eq:=select(unk,not testtype,DOM_IDENT);
   if eq<>{} then
      eq:=[op(eq,i)=genident() $ i=1..nops(eq)];
      newsys:=stdlib::solve_sys(subs(sys,eq),subs(Unk,eq));
      return(subs(newsys,op(eq,[i,2])=op(eq,[i,1])$i=1..nops(eq)))
   end_if;
   if unk={} then
      sys:=map(sys,fun((if type(args(1))="_equal" then op(args(1),1)-
	op(args(1),2) else args(1) end_if)));
      return((if sys={0} then {{}} else {} end_if))
   elif (newsys:=stdlib::solve_islinear(sys,unk))<>FALSE then
       # solve returns a set of solutions
         whereas linsolve always returns one solution #
       if has(newsys,{sin,cos}) then
          R:=Dom::ExpressionField(fun(combine(args(1),sincos)))
       else R:=null()
       end_if;
       i:=linsolve(newsys,unk,R);
       if i=FAIL then {} # no solution #
       else {i} end_if;
   elif (newsys:=stdlib::solve_isalgebraic(sys,unk))<>FALSE then
       {stdlib::solve_algebraic(newsys,Unk)}
   else
      if nops(sys)=1 then # only one equation #
         eq:=op(sys);
         if type(eq)="_equal" then eq:=op(eq,1)-op(eq,2) end_if;
         # look for the optimal unknown #
         if nops(unk)=1 then i:=1
         else
            for i from 1 to nops(unk) do 
               if Type::Linear(eq,[op(unk,i)])<>FALSE then break end_if
            end_for;
            if i>nops(unk) then i:=1 end_if
         end_if;
         newsys:=stdlib::solve_eq(eq,op(unk,i),1);
         if type(newsys)<>solve then
            return(map({newsys},fun({op(unk,i)=args(1)})))
         end_if
      end_if;
      userinfo(1,"non algebraic system");
      hold(solve)(sys,unk)
   end_if))
end_proc:

# end of file #
