# #
# $Date: 1996/07/05 14:39:56 $ $Author: snoo $ $Revision: 1.3 $ #
# #
# zimmerma, 14/12/95 #

#++
        algsolve  --  solve algebraic equations 

	algsolve(sys,vars <,domain>)

	sys   : set of algebraic equations
	vars  : set of unknowns
	domain: (optional) coefficient domain
++#

algsolve := proc(sys,unk,dom)
   local t;
begin
   if testargs() then
	if domtype(sys) <> DOM_SET then
            error("expecting set of equations")
        end_if;
	case args(0)
	of 1 do break
	of 2 do
	    if domtype(unk) <> DOM_SET and domtype(unk) <> DOM_DOMAIN then
		error("invalid second argument")
	    end_if;
	    break
	of 3 do
	    if domtype(unk) <> DOM_SET or domtype(dom) <> DOM_DOMAIN then
	        error("invalid arguments")
	    end_if;
	    break
	otherwise
	    error("wrong no of args")
	end_case
   end_if;

   if args(0) = 1 then
	dom:= null();
	unk:= indets(sys)
   elif args(0) = 2 then
	if domtype(unk) = DOM_SET then
	    t:= indets(sys);
	    if nops(unk) <> nops(t) then
		userinfo(1,"found ",t," as unknowns");
		error("wrong no of unknowns given")
	    end_if;
	    dom:= null()
	else
	    dom:= unk;
	    unk:= indets(sys)
	end_if
   end_if;

   sys:=map(sys,
      func((if type(x)="_equal" then op(x,1)-op(x,2) else x end_if),x)
   );

   stdlib::solve_algebraic(sys,unk,dom)
end_proc:

# end of file #
