# $Date: 1997/08/12 08:23:16 $  $Author: kg $  $Revision: 1.7 $ #
# kg, 08/07/93 #

#++
func -- create a function from an expression

func(e, [x1,...,xn])

e         - expression, a function of x1,...,xn
x1,...,xn - (optional) indeterminates

func views the expression e as a function of the indeterminates x1,...,xn
and returns a 'pure function' computing that function. If no
indeterminates are given, any indeterminates of e found by indets are
used.

(A pure function is a special form of procedure which evaluates in the
context of the caller and is faster than procedures.)

The arguments are not evaluated!
++#

func:= newpurefunc("func", NIL, hold((

    if testargs() then
	if args(0) = 0 then error("wrong no of args [func]") end_if;
	if args(0) > 1 then
	    { args(2..args(0)) };
	    if (nops(%) <> args(0) - 1) or (% <> indets(%)) then
		error("illegal indeterminates [func]")
	    end_if
	end_if
    end_if;

    # get indeterminates #
    case args(0)
    of 0 do   error("wrong no of args [func]");
    of 1 do   [ op(indets(args(1))) ]; break;
    otherwise [ args(2..args(0)) ];
    end_case;
    
    # generate 'pure' function #
    if nops(%) = 0 then
	newpurefunc(expr2text(hold(func)(args(1), op(%))), NIL, args(1))
    else
	misc::subsFreeVars(args(1), 
			   (op(%,i)=newfuncarg(i)) $ hold(i)=1..nops(%),
			   Unsimplified);
	newpurefunc(expr2text(hold(func)(args(1), op(%2))), NIL,
			   (if type(%) = "_exprseq" then
				hold(op)([%])
			    else
				%
			    end_if))
    end_if 
    
)), TRUE):

# end of file #
