# Friedrich Schwarz 28.3.1994 #

#--
ithprime(i) - calculates the ith prime
i - natural number

ithprime extends the kernel function ithprime

ithprime knows "MACOS", "UNIX" and "MSDOS"
--#


ithprime := proc(n)
  local builtin_maxIndex, builtin_maxPrime, maxIndex, p, i, j;
begin
  if testargs() then
    if args(0) <> 1 then
      error("expected one argument in function call")
    elif not testtype(n,NUMERIC) then
      return(procname(args()))
    elif domtype(n) <> DOM_INT or n < 1 then
            error("argument must be a natural number")
          end_if
  end_if;
  case sysname()
    of "MACOS" do
    of "MSDOS" do
       builtin_maxIndex :=  26017; 
       builtin_maxPrime := 300247;
       break;
    of "UNIX" do
       builtin_maxIndex :=   78519;
       builtin_maxPrime := 1000253;
       break;
    otherwise
       error("unknown machine")
  end_case;
  maxIndex := 1000000; 
  #-- from here to eternity use nextprime --#
  
  if n <= builtin_maxIndex then
    # use kernel function (see .mupadsysinit) #
    stdlib::ithprime(n)
  elif n <= maxIndex then
    if n < 500*ceil(builtin_maxIndex/500) then
      p := builtin_maxPrime;
      for i from builtin_maxIndex + 1 to n do
        p := nextprime(p+2)
      end_for
    else 
      p := numlib::thePrimes[(n - 26000) div 500];
      for i from 1 to modp(n,500) do
        p := nextprime(p+2)
      end_for  
    end_if
  else
     numlib::thePrimes; # to load numlib::theBigPrimes #
     i:=0; j:=nops(numlib::theBigPrimes);
     repeat
        p:=(i+j) div 2;
        if n<=numlib::theBigPrimes[p][1] then j:=p else i:=p end_if;
     until i+1=j end_repeat;
     # now choose the closest index between i and j #
     if i>=1 then
        if abs(n-numlib::theBigPrimes[i][1])<=
	   abs(n-numlib::theBigPrimes[j][1]) then j:=i end_if
     end_if;
     i:=numlib::theBigPrimes[j][1]; p:=numlib::theBigPrimes[j][2];
     # start from p=ithprime(i) #
     if n>i then repeat p:=nextprime(p+2); i:=i+1 until i=n end_repeat
     elif n<i then repeat p:=numlib::prevprime(p-2);i:=i-1 until i=n end_repeat
     end_if;
     p
  end_if
end_proc: 

