# 
Da in MuPAD generell erst alle Operanden evaluiert werden, werden auch alle 
Operanden des Operators and evaluiert. Dieses Verhalten ist bei der 
Programmierung aber oft st"orend. Hier sollen nur die Operanden evaluiert 
werden, solange die boolesche Auswertung TRUE liefert. Zudem soll die
Assoziativit"at unterbunden werden, also die Reihenfolge der Auswertung
strikt von links nach rechts ausgef"uhrt werden.

Beispiel:

l:=[TRUE]: i:=2: 

if (i < 2) &lazy_and l[i] then 1 else 2 end_if;
 
liefert 2, hingegen liefert 

if i < 2 and l[i] then 1 else 2 end_if;

Error: Invalid index [list]

lazy_and sollte nur in der Bedingung einer if-Anweisung oder in einer
while- oder repeat-Schleife benutzt werden.

Statt lazy_and(a, b) kann man auch schreiben a &lazy_and b schreiben.
Zu beachten ist allerdings die Bindungspriorit"at vo &, z.B. ist
i<2 &lazy_and l[i] gleichbedeutend mit i < (2 lazy_and l[i]).
Bei mehr als zwei Argumenten sollte man allerdings die Funktions-
schreibweise der Operastorschreibweise vorziehen, also lazy_and(a, b, c)
statt (a &lazy_and b) &lazy_and c .
#

lazy_and := proc()
  option hold;
  local i;
begin
  for i in args() do
      if not bool(context(i)) then
         return(FALSE)
      end_if
  end_for;
  TRUE
end_proc:
