# $Date: 1995/09/25 20:52:32 $ $Author: kg $ $Revision: 1.5 $ #

# kg, 19/01/94 #

#++
numer -- the numerator of a rational expression

numer(x)

x - expression
++#

numer:= proc(x)
begin
    if args(0) <> 1 then error("wrong no of args") end_if;
    if x::numer <> FAIL then return(x::numer(x)) end_if;
    if testargs() then 
        if not contains({DOM_INT, DOM_RAT, DOM_FLOAT, DOM_COMPLEX, 
                         DOM_IDENT, DOM_EXPR}, domtype(x)) then
            error("no rational expression") 
        end_if;           
    end_if;
    normal; denom; # force loading stdlib::normal and stdlib::denom #
    stdlib::numer(x);
end_proc:

stdlib::numer:= fun((
    case type(args(1))
    of DOM_INT do 
	args(1);
	break;
    of DOM_RAT do
	op(args(1),1);
	break;
    of DOM_COMPLEX do
        case domtype(op(args(1),1))
        of DOM_INT do
            case domtype(op(args(1),2))
            of DOM_INT do 
                args(1);
                break;
            of DOM_RAT do 
                op(args(1),1)*op(args(1),[2,2]) + I*op(args(1),[2,1]);
                break;
            otherwise
                args(1);
            end_case;
            break;
        of DOM_RAT do
            case domtype(op(args(1),2))
            of DOM_INT do 
                op(args(1),[1,1]) + I*op(args(1),2)*op(args(1),[1,2]);
                break;
            of DOM_RAT do 
                igcd(op(args(1),[1,2]), op(args(1),[2,2]));
                op(args(1),[1,1])*op(args(1),[2,2])/% + 
                    I*op(args(1),[2,1])*op(args(1),[1,2])/%;
                break;
            otherwise
                args(1);
            end_case;
            break;
        otherwise
            args(1);
        end_case;
        break;
    of "_mult" do
	map(args(1), stdlib::numer);
	break;
    of "_power" do
	if domtype(op(args(1),2)) = DOM_INT then
	    if op(args(1),2) > 0 then
		stdlib::numer(op(args(1),1)) ^ op(args(1),2)
	    else
		stdlib::denom(op(args(1),1)) ^ (-op(args(1),2))
	    end_if
	else
	    stdlib::normal(args(1))[1]
	end_if;
	break;
    otherwise
	stdlib::normal(args(1))[1];
    end_case
)):

# end of file #
