# rewrite the expression f to type typ #

rewrite := proc(_f,typ) local opt;
begin
   if _f::rewrite <> FAIL then return(_f::rewrite( args() )) end_if;

   if typ=exp then
      opt:=hold(Exp);
      # eval needed otherwise rewrite(sec(x),exp) is unsimplified #
      # intlib::subst(_f); eval(%); #
      intlib::subst(_f); subs(%, Simplified);
   elif typ=tan then
      # eval(subs(_f,hold(sin)=fun(2*tan(args(1)/2)/(1+tan(args(1)/2)^2)),
             hold(cos)=fun((1-tan(args(1)/2)^2)/(1+tan(args(1)/2)^2)))) #
      subs(_f,hold(sin)=fun(2*tan(args(1)/2)/(1+tan(args(1)/2)^2)),
             hold(cos)=fun((1-tan(args(1)/2)^2)/(1+tan(args(1)/2)^2)),
	     Simplified)
   elif typ=ln then
      # eval(subs(_f, #
      subs(_f,
                  # formulae 4.4.26-4.4.31 in Abramowitz and Stegun #
                  hold(asin)=func(-I*ln(I*x+sqrt(1-x^2)),x),
                  hold(acos)=func(-I*ln(x+I*sqrt(1-x^2)),x),
                  // hold(atan)=func(I/2*ln((I+x)/(I-x)),x),
                   hold(atan)=proc(x,y)
                             begin
                               if args(0)=1 then
                                 I/2*ln((I+x)/(I-x))
                               else
                                 -I * ln((x+I*y)/(abs(x+I*y)))
                               end_if
                             end_proc,
                  hold(acot)=func(I/2*ln((x-I)/(x+I)),x),
                  # formulae 4.6.20-4.6.25 in Abramowitz and Stegun #
                  hold(asinh)=func(ln(x+sqrt(x^2+1)),x),
                  hold(acosh)=func(ln(x+sqrt(x^2-1)),x),
                  hold(atanh)=func(1/2*ln((1+x)/(1-x)),x),
                  hold(acoth)=func(1/2*ln((x+1)/(x-1)),x)
      # )) #
      , Simplified)
   # elif typ=gamma then eval(subs(_f,hold(fact)=fun(gamma(args(1)+1)))) #
   elif typ=gamma then subs(_f,hold(fact)=fun(gamma(args(1)+1)), Simplified)
   # elif typ=fact then eval(subs(_f,hold(gamma)=fun(fact(args(1)-1)))) #
   elif typ=fact then subs(_f,hold(gamma)=fun(fact(args(1)-1)), Simplified)
   elif typ=diff then maprec(_f,{"function"}=stdlib::Dtodiff)
   elif typ=sign then maprec(_f,{"heaviside"}=fun((sign(op(args(1)))+1)/2))
   elif typ=heaviside then maprec(_f,{"sign"}=fun(2*heaviside(op(args(1)))-1))
   elif typ=sincos then maprec(_f,{"exp"}=fun(cos(op(args(1),1)/I)+
	I*sin(op(args(1),1)/I)),{"tan"}=fun(sin(op(args(1)))/cos(op(args(1)))))
   elif typ=sinhcosh then maprec(_f,{"exp"}=fun((cosh+sinh)(op(args(1),1))))
   else _f
   end_if
end_proc:

# D(f)(x) -> diff(f(x),x)
  D(D(f))(x) -> diff(f(x),x,x)
  D([1],f)(x) -> diff(f(x),x)
  D([1,2],f)(x,y) -> diff(f(x,y),x,y)
  D(f)(x,y) -> diff(f(x,y),x)+diff(f(x,y),y) [total derivative]
#
stdlib::Dtodiff:=fun((if nops(args(1))=1 and type(op(args(1),1))=DOM_IDENT
	and nops(op(args(1),0))=1 then stdlib::Dtodiff2(op(args(1),0..1))
        elif map({op(args(1))},type)={DOM_IDENT} then
           if nops(op(args(1),0))=2 then
              op(args(1),[0,1]); # list of indices #
              diff(subsop(args(1),0=op(args(1),[0,2])),
	         op(args(1),%[i])$hold(i)=1..nops(%))
           elif nops(op(args(1),0))=1 and op(args(1),[0,0])=hold(D) then
		# D(f)(x,y,...) -> diff(f(x,y,...),x)+diff(...,y)+... #
		subsop(args(1),0=op(args(1),[0,1]));
                _plus(diff(%,op(args(1),i))$hold(i)=1..nops(args(1)))
           else args(1)
           end_if
	else args(1)
	end_if)):

stdlib::Dtodiff2:=fun((if type(args(1))="D" and nops(args(1))=1 then
	diff(stdlib::Dtodiff2(op(args(1),1),args(2)),args(2))
	else args(1)(args(2)) end_if)):
