#
series -- series expansions

series(f,x)		f is an expression
series(f,x,n)		x is a variable
series(f,x=v,n)         n is an integer and v an expression independent of x
series(f,x=v,Right)
series(f,x=v,Left)
series(f,x=v,n,Right)
#

# not to redefine it #
if type(ORDER)<>DOM_INT then ORDER:=6 end_if: # default order #

series := proc(_f_,_p_,_ord_,_dir_) local Float, s;
begin
   if _f_::series<>FAIL then return(_f_::series(args())) end_if;
   case args(0)
   of 0 do
   of 1 do
      error("invalid arguments");
   of 2 do _ord_:=ORDER;
   of 3 do if _ord_=Right or _ord_=Left then _dir_:=_ord_; _ord_:=ORDER end_if
   end_case;
   s:={};
   _f_:=maprec(_f_,{DOM_FLOAT}=fun(sharelib::rational(args(1))));
   Float:=(if _f_=args(1) then id else float end_if);
   _f_:=Series::main(_f_,_p_,_ord_,_dir_);
   if _f_=FAIL then hold(series)(args()) else Float(_f_) end_if
end_proc:

series:= funcattr(series, "type", "series"):

Series::main := proc(_f_,p,ord,dir)
local __x,X,x0,xofX,n;
begin
   if type(p)=DOM_IDENT then x0:=0; __x:=p
   elif type(p)="_equal" and type(op(p,1))=DOM_IDENT then 
      __x:=op(p,1); x0:=op(p,2);
      if has(x0,__x) then error("invalid arguments")
      elif x0=infinity then # special case #
         xofX:=1/X; dir:=Right
      elif x0=-infinity then
         xofX:=-1/X; dir:=Right
      else xofX:=X+x0;
	 if dir=Right then assume(__x-x0>0); _f_:=simplify(_f_);unassume(__x-x0>0);
	 elif dir=Left then assume(__x-x0<0);_f_:=simplify(_f_);unassume(__x-x0<0);
	 end_if;
      end_if;
   else error("invalid arguments")
   end_if;
   if x0=0 then X:=__x else _f_:=subs(_f_,__x=xofX) end_if;
   if ord=infinity then
      sysassign(Series::expr2coeff,
	loadproc(Series::expr2coeff,pathname("SERIES"),"FPS"));
      p:=Series::expr2coeff(_f_,X,n);
      if p<>FAIL then p:=hold(sum)(p*__x^n,n=0..infinity) end_if;
      return(p)
   end_if;
   _f_:=Series::series(_f_,X,ord,(if dir=Left or dir=Right then dir else
	null() end_if));
   if _f_=FAIL then
      if traperror((_f_:=gseries::new(args(1..min(3,args(0))))))=0 
      then _f_ else FAIL end_if
   elif x0=0 then _f_ 
   else _f_::set_var(_f_,X,__x,x0)
   end_if
end_proc:

floor:= funcattr(floor,"series",
	loadproc(funcattr(floor,"series"),pathname("SERIES"),"floor")):

ceil:= funcattr(ceil,"series",
	loadproc(funcattr(ceil,"series"),pathname("SERIES"),"ceil")):

round:= funcattr(round,"series",
	loadproc(funcattr(round,"series"),pathname("SERIES"),"round")):
