# $Date: 1997/06/27 13:25:01 $ $Author: kraume $ $Revision: 1.8 $ #

# kg, 27/12/94 #

#++
setuserinfo -- set information level for procedure

setuserinfo(p [,lev])

p   - procedure, name of procedure, domain or 'Any'
lev - level of information (positive integer)

Sets the information level of the procedure or domain p to lev. If lev
is missing the level for p is set to 0.

If p is 'Any' then the global information level is set to lev
or to 0 resp.

See 'userinfo'.
++#

setuserinfo:= proc(pnam,lev,opt)
  option hold;
begin
    if testargs() then
    	if args(0) > 3 then error("wrong no of args") end_if;
    	if args(0) >= 2 then
    	    if domtype(level(lev,2)) <> DOM_INT then 
               error("illegal level")
            end_if;
    	    if level(lev,2) < 0 then error("illegal level") end_if;
    	end_if;
        if args(0) = 3 and not( opt=hold(Proc) ) then
           error("illegal option");
        end_if;
    end_if;
    
   
    # get proc name if argument is proc #
    if domtype(pnam) = DOM_PROC then
    	pnam:= op(pnam, 6)
    end_if;
  
    # store level for proc #
    case args(0)
      of 0 do   return(stdlib::userinfo_level); break;
      of 1 do   if domtype(args(1))=DOM_NIL
                  then sysassign(stdlib::userinfo_level,NIL);
                  else sysassign(stdlib::userinfo_level[pnam],NIL); sysassign(stdlib::userinfo_level[pnam, 1],NIL);
                       if nops(stdlib::userinfo_level)=0 then sysassign(stdlib::userinfo_level,NIL); end_if;
                end_if; break;
      otherwise sysassign(stdlib::userinfo_level[pnam],level(lev,2)); 
                if opt=hold(Proc)
                  then sysassign(stdlib::userinfo_level[pnam, 1],TRUE);
                  else sysassign(stdlib::userinfo_level[pnam, 1],FALSE);
                end_if;
    end_case;

    null();
end_proc:

# end of file #
