# $Date: 1997/09/17 16:05:39 $ $Author: tonner $ $Revision: 1.19 $ #

# kg, 27/12/94 #

#++
userinfo -- print information for user

userinfo(lev,epxr...)

lev  - level of information (positive integer)
expr - expression to print

'userinfo' prints its arguments 'expr...' to the screen if either the
"information level" of the procedure or domain calling 'userinfo' or
 the "global information level" is greater or equal to 'lev'.

The information level (of a procedure or domain or the global one) is defined 
via 'setuserinfo'. The default level is 0, ie. no information is printed.

The procedure calling 'userinfo' is determined via 'procname'. This
may cause problems is 'procname' does not contain the expected value.
++#

alias(doprintuinfo(index,pname,pretty_print,info_level)=(
    case type(info_level)
      of DOM_INT  do 
	if info_level <= stdlib::userinfo_level[index] then 
	  stdlib::printuserinfo(index, pname, pretty_print,context(args(arg1..args(0))));
        end_if; 
        break;
	      
      of "_range" do 
	if op(info_level,1) <= stdlib::userinfo_level[index] and 
	     op(info_level,2) >= stdlib::userinfo_level[index] then 
	  stdlib::printuserinfo(index, pname, pretty_print, context(args(arg1..args(0))));
        end_if; 
        break;
    end_case)):

userinfo:= fun((
  if stdlib::userinfo_level <> FAIL then
    if args(0)<2 then return(null()); end_if;
    block([pretty_print,arg1,info_level,pname], (
      pretty_print := bool(args(2)=hold(Pretty));
      if pretty_print then arg1 := 3; else arg1 := 2; end_if;
      info_level := context(args(1));
      if contains(stdlib::userinfo_level, procname) then 
	doprintuinfo(procname, procname, pretty_print, info_level);
	return(null());
      elif type(procname)="domattr" then
        pname:=op(procname,1); 
        while type(pname)="domattr" do 
          pname := op(pname,1); 
        end_while;
        if contains(stdlib::userinfo_level, pname) then 
	  doprintuinfo(pname, procname, pretty_print, info_level);
	  return(null());
        end_if;
      end_if;
      if contains(stdlib::userinfo_level, hold(Any)) then 
        doprintuinfo(hold(Any), procname, pretty_print, info_level);
      end_if
    ))
  end_if;
  null() ), hold):

stdlib::printuserinfo:=
  proc(index,pname,pretty_print)
    local PRETTY_PRINT;
  begin
    PRETTY_PRINT:=pretty_print;
    if stdlib::userinfo_level[index, 1] then
      print(Unquoted,pname,args(4..args(0)));
    else 
      print(Unquoted,      args(4..args(0)));
    end_if;
  end_proc:
    
unalias(doprintuinfo):
# end of file #
