#++
  frankp, 8/09/95

        student::isFree  --  test whether a set of vectors is free

        isFree( S )

	S: set or list of vectors

	isFree(S) returns either TRUE if S is free or FALSE if not.
++#

student::isFree:= proc(S)
    local v;
begin
    if testargs() then
	if domtype(S) = DOM_LIST then
	    if S = [] then return( TRUE ) end_if;
	    v:= S[1];
	    if v::hasProp( Cat::MatrixCat ) <> TRUE then
		error("list contains invalid vector(s)")
	    end_if;
	    if not testtype( S,Type::ListOf( 
		linalg::VectorOf(v::coeffRing,max(op(v::dimen(v)))) 
	    )) then
		error("list contains incompatible vectors")
	    end_if
        elif domtype(S) = DOM_SET then
            if S = {} then return( TRUE ) end_if;
            v:= op(S,1);
            if v::hasProp( Cat::MatrixCat ) <> TRUE then
                error("set contains invalid vector(s)")
            end_if;
            if not testtype( S,Type::SetOf( 
                linalg::VectorOf(v::coeffRing,max(op(v::dimen(v)))) 
            )) then
                error("set contains incompatible vectors")
            end_if
	else
	    error("expecting a set or list of vectors")
        end_if
    end_if;

    if nops(S) = 0 then
	TRUE 
    elif nops(S) = 1 then
	v:= op(S,1);
	not v::iszero(v)
    else
	bool( nops(S) = nops(linalg::freeSet(S)) )
    end_if
end_proc:

# end of file #
