# Dirk Mueller, olorien, 28/10/96, v1.0 #

alias( IntTrans = transform::IntTrans ):

_mult:=funcattr(_mult,"transform::ilaplace",
  proc(_fu, var1, var2) 
    local Num, Den, Num_L, Den_L, Num_code, Den_code,
          Num_nmb, Den_nmb, erg, _lin, _Lops ,_L,
          Num_ops, Den_ops, Num_match, Den_match, _spec, split_L, Num_pat,
          Den_code_rat, Den_code_nonrat, Den_pat_nonrat,
          _a, _b, _c, _d,  _e, _f, _g, _h, _w, _i, 
          _A, _B, _C, _D, _E, _F,
          _a2, _b2, _c2, _d2, _w2, _A2, _B2;
  begin

    Num:=numer(_fu); Den:=denom(_fu); 

    if type(Num)="_mult" then
      _lin:=select(Num, not has, var1);
      Num:=Num/_lin;
    elif not has(Num, var1) then
      _lin:=Num; Num:=1;
    else
      _lin:=1;
    end_if;

    Num_sp:=IntTrans::mult_split(Num, var1);
    Den_sp:=IntTrans::mult_split(Den, var1);


    if Num_sp[2]=1 and Den_sp[2]=1 then # Rat / Rat #
      Den_L:=IntTrans::anapol(Den, var1);
      Num_L:=IntTrans::anapol(Num, var1);
      Den_code:={op(Den_L[1])}; Den_nmb:=nops(Den_L[1]);
      Num_code:={op(Num_L[1])}; Num_nmb:=nops(Num_L[1]);

      case [Den_code, Den_nmb]
      of [{[2,3]}, 1] do # (...)/(a*s+b)^2 # 
        if Num_L[1]=[[1,2]] then # s/(a*s+b)^2 #
          _b:=Den_L[2][1][1]; _a:=Den_L[2][1][2];
          userinfo(10, "formula 10 from Heuser");
          return( _lin*(1-_b/_a*var2)*exp(-_b/_a*var2)/_a^2 );
        end_if;
        break;

      of [{[1,3]}, 2] do # (...)/(a*s+b)/(c*s+d) #
        case [Num_code, Num_nmb]
        of [{[1,1]}, 1] do # 1/(a*s+b)/(c*s+d) #
          _a:=Den_L[2][1][2]; _b:=Den_L[2][1][1];
          _c:=Den_L[2][2][2]; _d:=Den_L[2][2][1];
          userinfo(10, "formula 6 from Heuser"); 
          return( _lin*(exp(-_d/_c*var2)-exp(-_b/_a*var2))/(_c*_b-_a*_d) );
        break;

        of [{[1,2]}, 1] do # s/(a*s+b)/(c*s+d) #
          _a:=Den_L[2][1][2]; _b:=Den_L[2][1][1];
          _c:=Den_L[2][2][2]; _d:=Den_L[2][2][1];

          userinfo(10, "formula 11 from Heuser"); 
          return( _lin*(_b/_a*exp(-_b/_a*var2)-_d/_c*
                        exp(-_d/_c*var2))/(_b*_c-_d*_a));
        break;

        of [{[1,3]}, 1] do # (A*s+B)/(a*s+b)/(c*s+d) #
          _A:=Num_L[2][1][2]; _B:=Num_L[2][1][1];
          _a:=Den_L[2][1][2]; _b:=Den_L[2][1][1];
          _c:=Den_L[2][2][2]; _d:=Den_L[2][2][1];
          userinfo(10, "formula 12 from Heuser");
          return(  _lin*((_b/_a*_A-_B)*exp(-_b/_a*var2)
                   -(_d/_c*_A-_B)*exp(-_d/_c*var2))
                   /(_b*_c-_d*_a)  );
          break; # [{[1,3]}, 2] #
        end_case; # [Num_code, Num_nmb] #
        break;

      of [{[1,3]}, 3] do # (...)/(a*s+b)/(c*s+d)/(e*s+f) #
        case [Num_code, Num_nmb]
        of [{[1,1]}, 1] do # 1/(a*s+b)/(c*s+d)/(e*s+f) #
          _a:=Den_L[2][1][2]; _b:=Den_L[2][1][1]/_a;
          _c:=Den_L[2][2][2]; _d:=Den_L[2][2][1]/_c;
          _e:=Den_L[2][3][2]; _f:=Den_L[2][3][1]/_e;
          userinfo(10, "formula 24 from Heuser"); 
          return(  _lin*(exp(-_b*var2)/(_d-_b)/(_f-_b)
                  +exp(-_d*var2)/(_b-_d)/(_f-_d)
                  +exp(-_f*var2)/(_b-_f)/(_d-_f))/_a/_c/_e );
          break;

        of [{[1,2]}, 1] do # s/(a*s+b)/(c*s+d)/(e*s+f) #
          _a:=Den_L[2][1][2]; _b:=Den_L[2][1][1]/_a;
          _c:=Den_L[2][2][2]; _d:=Den_L[2][2][1]/_c;
          _e:=Den_L[2][3][2]; _f:=Den_L[2][3][1]/_e;
          userinfo(10, "formula 25 from Heuser"); 
          return(  _lin*(-_b*exp(-_b*var2)/(_d-_b)/(_f-_b)
                  -_d*exp(-_d*var2)/(_b-_d)/(_f-_d)
                  -_f*exp(-_f*var2)/(_b-_f)/(_d-_f))/_a/_c/_e );
          break;

        of [{[2,2]}, 1] do # s^2/(a*s+b)/(c*s+d)/(e*s+f) #
          _a:=Den_L[2][1][2]; _b:=Den_L[2][1][1]/_a;
          _c:=Den_L[2][2][2]; _d:=Den_L[2][2][1]/_c;
          _e:=Den_L[2][3][2]; _f:=Den_L[2][3][1]/_e;
          userinfo(10, "formula 26 from Heuser"); 
          return(  _lin*(_b^2*exp(-_b*var2)/(_d-_b)/(_f-_b)
                  +_d^2*exp(-_d*var2)/(_b-_d)/(_f-_d)
                  +_f^2*exp(-_f*var2)/(_b-_f)/(_d-_f))/_a/_c/_e );
          break;

        end_case; # [Num_code, Num_nmb] #
        break; # [{[1,3]}, 3] #

      of [{[1,5]}, 1] do # (...)/(a*s^2+b) #
        if Num_L[1]=[[1,2]] then # s/(a*s^2+b) #
          _a:=Den_L[2][1][3]; _b:=Den_L[2][1][1];
          _b:=_b/_a;
          if IntTrans::Minus(_b) then
            userinfo(10, "formula 14 from Heuser");
            return( _lin*cosh((-_b)^(1/2)*var2)/_a  );
          end_if;
          userinfo(10, "formula 13 from Heuser");
          return( _lin*cos(_b^(1/2)*var2)/_a  );
        end_if;
        break;
 
      of [{[1,5]}, 2] do # (...)/(a*s^2+b)/(c*s^2+d) #
        case [Num_code, Num_nmb]
        of [{[1,1]}, 1] do # 1/(a*s^2+b)/(c*s^2+d) #
          _a:=Den_L[2][1][3];
          _b2:=Den_L[2][1][1]; _b:=sqrt(_b2);
          _c:=Den_L[2][2][3];
          _d2:=Den_L[2][2][1]; _d:=sqrt(_d2);
          _A:=_b/sqrt(_a); _B:=_d/sqrt(_c);
          
          userinfo(10, "formula 33 from Heuser");
          return( _lin*( (_A*sin(_B*var2)-_B*sin(_A*var2))
                    /_A/_B/(_A^2-_B^2)   )/_a/_c );
          break;

        of [{[1,2]}, 1] do # s/(a*s^2+b)/(c*s^2+d) #
          _a:=Den_L[2][1][3]; _b:=Den_L[2][1][1]; _A:=sqrt(_b/_a); 
          _c:=Den_L[2][2][3]; _d:=Den_L[2][2][1]; _B:=sqrt(_d/_c);
          userinfo(10, "formula 37 from Heuser");
          return( _lin*(cos(_B*var2)-cos(_A*var2))/(_b*_c-_a*_d) );
          break;
        end_case;
        break;

      of [{[2,5]}, 1] do # (...)/(a*s^2+b)^2 #
        case [Num_code, Num_nmb]
        of [{[1,2]}, 1] do # s/(a*s^2+b)^2 #
          _a:=Den_L[2][1][3]; _b:=Den_L[2][1][1];
          if IntTrans::Minus(_b/_a) then
            _w:=sqrt(-_b/_a);
            userinfo(10, "formula 35 from Heuser");
            return( _lin*( var2*sinh(_w*var2))/_w/2/_a^2  );
          end_if;
          _w:=sqrt(_b/_a);
          userinfo(10, "formula 34 from Heuser");
          return( _lin*( var2*sin(_w*var2))/_w/2/_a^2 );
          break;

        of [{[2,2]}, 1] do # s^2/(a*s^2+b)^2 #
          _a:=Den_L[2][1][3]; _b:=Den_L[2][1][1];
          
          if IntTrans::Minus(_b/_a) then
            _w:=sqrt(-_b/_a);
            userinfo(10, "formula 40 from Heuser");
            return( _lin*( sinh(_w*var2)+_w*var2*cosh(_w*var2))/2/_w/_a^2);
          end_if;
          _w:=sqrt(_b/_a);
          userinfo(10, "formula 39 from Heuser");
          return( _lin*(sin(_w*var2)+_w*var2*cos(_w*var2))/2/_w/_a^2  );
          break;
  
        of [{[3,2]}, 1] do # s^3/(a*s^2+b)^2 #
          _a:=Den_L[2][1][3]; _b:=Den_L[2][1][1]; 
          if IntTrans::Minus(_b/_a) then
            _w:=sqrt(-_b/_a);
            userinfo(10, "formula 43 from Heuser");
            return( _lin*( cosh(_w*var2)+1/2*_w*var2*sinh(_w*var2) )/_a^2);
          end_if;
          userinfo(10, "formula 42 from Heuser");
          _w:=sqrt(_b/_a);
          return( _lin*( cos(_w*var2)-1/2*_w*var2*sin(_w*var2) )/_a^2  );
          break;
 
        of [{[1,5]}, 1] do # (A*s^2+B)/(a*s^2+b)^2 #
          _a:=Den_L[2][1][3];
          _b:=-Den_L[2][1][1]; 
          _A:=Num_L[2][1][3]; _B:=Num_L[2][1][1];
          _w:=sqrt(_b/_a);
          if is(_B=_b)=TRUE then
            userinfo(10, "formula 41 from Heuser");
            return( _lin*( var2*cosh(_w*var2) )*_A/_a^2 );
          end_if;
          break;

        end_case; # [Num_code, Num_nmb] #
        break;

      of [{[1,7]}, 1] do
        case [Num_code, Num_nmb]
        of [{[1,3]}, 1] do

          _a2:=Den_L[2][1][3]; _a:=sqrt(_a2);
          _b:=Den_L[2][1][2]/2/_a; 
          _c:=Den_L[2][1][1]-_b^2;
          _A:=Num_L[2][1][2]; _B:=Num_L[2][1][1];

          if is(_B/_A=_b/_a)=TRUE then
            if IntTrans::Minus(_c) then
              _w:=sqrt(-_c/_a2);
              userinfo(10, "formula 16 from Heuser");
              return(_lin*(exp(-_B/_A*var2)*cosh(_w*var2)*_A/_a2) );
            else
              _w:=sqrt(_c/_a2);
              userinfo(10, "formula 15 from Heuser");
              return( _lin*(exp(-_B/_A*var2)*cos(_w*var2)*_A/_a2) );
            end_if;
          else

            _a:=Den_L[2][1][3]; _b:=Den_L[2][1][2]; _b2:=_b^2;
            _c:=Den_L[2][1][1]; _c2:=_c^2;
            _A:=Num_L[2][1][2]; _B:=Num_L[2][1][1];
            _r:=_b/_a/2; _w:=sqrt(_c/_a-_r^2 );

            if is(_c/_a>_r^2)=TRUE then
      
              userinfo(10, "fromula 17 from Heuser");
              return( _lin*( exp(-_r*var2)* 
                         ( _A*cos(_w*var2)+(_B-_r*_A)/_w*sin(_w*var2)  )/_a)
                          );
            end_if;

            if is(_c/_a<_r^2)=TRUE then
              _w:=(_b2-_c2)^(1/2);
              userinfo(10, "fromula 17 from Heuser (modified)");
              return( _lin*( exp(-_r*var2)* 
                         ( _A*cosh(_w*var2)+(_B-_r*_A)/_w/I*sinh(_w*var2)  )/_a)
                          );
            end_if;
          end_if;

        end_case;
        break;

      of [{[1,17]}, 1] do # (...)/(a*s^4+b) #
        case [Num_code, Num_nmb]
        of [{[1,2]}, 1] do # s/(a*s^4+b) #
          _a:=Den_L[2][1][5]; _b:=Den_L[2][1][1]; 
          if IntTrans::Minus(_b) then
            _w:=(-_b/_a)^(1/4); 

            userinfo(10, "formula 36 from Heuser");
            return( _lin*( cosh(_w*var2)-cos(_w*var2) )/2/_a/_w^2  );
          end_if;
          userinfo(10, "formula 38 from Heuser");
          _w:=(_b/_a)^(1/4);
          return( _lin*( sin(_w*var2)*sinh(_w*var2)  )/2/_a/_w^2 );
          break;
        end_case;
        break;

      of [{[1,2], [1,3]}, 2] do # (...)/s/(a*s+b) #
        case [Num_code, Num_nmb]
        of [{[1,1]}, 1] do # 1/s/(a*s+b) #
          _p1:=contains(Den_L[1], [1,3]); 
          _a:=Den_L[2][_p1][2];
          _b:=Den_L[2][_p1][1];
          userinfo(10, "formula 5 from Heuser");
          return( _lin*(1-exp(-_b/_a*var2))/_b  );
          break;

        of [{[1,3]}, 1] do # (A*s+B)/s/(a*s+b) #
          _p1:=contains(Den_L[1], [1,3]); 
          _a:=Den_L[2][_p1][2];
          _b:=Den_L[2][_p1][1]/_a;
          _A:=Num_L[2][1][2]; _B:=Num_L[2][1][1]/_A;
          userinfo(10, "formula 1.3 from R&K");
          return( _lin*( _B/_b+(1-_B/_b)*exp(-_b*var2)  )  );
          break;

        end_case; # [Num_code, Num_nmb] #
        break;
 
      of [{[1,2], [1,3]}, 3] do # (...)/s/(a*s+b)/(c*s+d) #
        case [Num_code, Num_nmb]
        of [{[1,1]}, 1] do # 1/s/(a*s+b)/(c*s+c) #
          _p1:=contains(Den_L[1], [1,3]);
          _p2:=contains(Den_L[1], [1,3], _p1+1);
          _a:=Den_L[2][_p1][2]; _b:=Den_L[2][_p1][1]/_a;
          _c:=Den_L[2][_p2][2]; _d:=Den_L[2][_p2][1]/_c;
          userinfo(10, "formula 1.4 from R&K");
          return( _lin*(1/_b/_d+(_d*exp(-_b*var2)-_b*exp(-_d*var2))
                    /_b/_d/(_b-_d))/_a  );
          break;

        of [{[1,3]}, 1] do # (A*s+B)/s/(a*s+b)/(c*s+c) #
          _p1:=contains(Den_L[1], [1,3]);
          _p2:=contains(Den_L[1], [1,3], _p1+1);
          _a:=Den_L[2][_p1][2]; _b:=Den_L[2][_p1][1]/_a;
          _c:=Den_L[2][_p2][2]; _d:=Den_L[2][_p2][1]/_c;
          _A:=Num_L[2][1][2]; _B:=Num_L[2][1][1]/_A;
          userinfo(10, "formula 1.5 from R&K");
          return( _lin*(_B/_b/_d+(_d*(_B-_b)*exp(-_b*var2)
                        +_b*(_B-_d)*exp(-_d*var2))/_b/_d/(_b-_d))*_A/_a );
          break;

        of [{[1,7]}, 1] do # (A*s^2+B*s+C)/s/(a*s+b)/(c*s+c) #
          _p1:=contains(Den_L[1], [1,3]);
          _p2:=contains(Den_L[1], [1,3], _p1+1);
          _a:=Den_L[2][_p1][2]; _b:=Den_L[2][_p1][1]/_a;
          _c:=Den_L[2][_p2][2]; _d:=Den_L[2][_p2][1]/_c;
          _A:=Num_L[2][1][3]; _B:=Num_L[2][1][2]/_A; _C:=Num_L[2][1][1]/_A;
          userinfo(10, "formula 1.6 from R&K");
          return( _lin*(_C/_b/_d+( _d*(_b^2-_B*_b+_C)*exp(-_b*var2)
                   -_b*(_d^2-_b*_d+_C)*exp(-_d*var2))/_b/_d/(_b-_d))*_A/_a );
          break;

        end_case; # [Num_code, Num_nmb] #

      of [{[1,2], [1,5]}, 2] do # (...)/(s*(a*s^2+b)) #
        case [Num_code, Num_nmb]
        of [{[1,1]}, 1] do # 1/(s*(a*s^2+b)) #
          _p1:=contains(Den_L[1], [1,5]); 
          _a:=Den_L[2][_p1][3];
          _b:=Den_L[2][_p1][1]; _w:=_b/_a;
          if IntTrans::Minus(_w) then
            userinfo(10, "formula 21 from Heuser");
            return( -_lin*(cosh(sqrt(-_w)*var2)/_b-1/_b)  );
          end_if;
          userinfo(10, "formula 20 from Heuser");
          return( _lin*(1/_b-cos(sqrt(_w)*var2)/_b)  );
          break;

        of [{[1,5]}, 1] do # (A*s^2+B)/s/(a*s^2+b) #
          _p1:=contains(Den_L[1], [1,5]);
          _A:=Num_L[2][1][3]; _B:=Num_L[2][1][1];       
          _a:=Den_L[2][_p1][3]; _b:=Den_L[2][_p1][1];

          if is(_B/_A=_b/_a/2)=TRUE then
            userinfo(10, "formula 27 from Heuser");
            return( _lin*( cos( sqrt(_B/2/_A)*var2))^2/_a*_A );
          end_if;

        end_case; # [Num_code, Num_nmb] #
        break;

      of [{[1,2], [1,7]}, 2] do # (...)/s/(a*s^2+b*s+c) #
        case [Num_code, Num_nmb]
        of [{[1,1]}, 1] do # 1//s*/(a*s^2+b*s+c) #
          _p1:=contains(Den_L[1], [1,7]); 
          _a:=Den_L[2][_p1][3];
          _b:=Den_L[2][_p1][2];
          _c:=Den_L[2][_p1][1]; _c2:=sqrt(_c);
          _w:=_c/_a-(_b/_a/2)^2;
          erg:=is(_w>0);
          if erg=TRUE then
            _w:=sqrt(_w);
            userinfo(10, "formula 23 from Heuser, case 1");
            return( _lin*(1/_c-exp(-_b/_a*var2)/_w/_c*
                       (_b/_a/2*sin(_w*var2)+_w*cos(_w*var2))));
          end_if;

          erg:=is(_w<0);
          if erg=TRUE then
            _w:=(_b^2-_c2)^(1/2);
            userinfo(10, "formula 23 from Heuser, case 2");
            return( _lin*(1/_c-exp(-_b/_a*var2)/_w/_c*(_b/_a/2
                        *sinh(_w*var2)+_w*cosh(_w*var2))));
          end_if;

          erg:=is(_w=0);
          if erg=TRUE then
            userinfo(10, "formula 23 from Heuser, case 3");
            return( _lin*(1/_c-1/_c*exp(-_b/_a/2*var2)-
                      _b/_a/2*var2*exp(-_b/_a/2*var2)));
          end_if;
          return(FAIL);
          break;

        end_case; # [Num_code, Num_nmb] #
        break;

      of [{[2,2], [1,5]}, 2] do # (...)/s^2/(a*s^2+b) #
        case [Num_code, Num_nmb]
        of [{[1,1]}, 1] do # 1/s^2/(a*s^2+b) #
          _p1:=contains(Den_L[1], [1,5]);
          _a:=Den_L[2][_p1][3]; _b:=Den_L[2][_p1][1];
          _w2:=_b/_a; _w:=sqrt(_w2);
          userinfo(10, "formula 29 from Heuser");
          return(_lin*(var2/_b-sin(_w*var2)/_w^3));
          break;
        end_case;  # [Num_code, Num_nmb] #

        break;

      end_case; # [Den_code, Den_nmb] #

      return(FAIL);
   
    elif [Den_sp]=[1,1] then # Nonrat / 1 #
      return(FAIL);

    elif Num_sp[1]=1 and Den_sp[1]=1 then # Nonrat / Nonrat #

      if type(Num)<>"_mult" then
        Num_match:={type(Num)}, 1;
        Num_nmb:=1;
      else
        Num_L:=IntTrans::anatype(Num);
        Num_match:={op(Num_L)}, Num_nmb;
        Num_nmb:=nops(Num_L);
      end_if;

      if type(Den)<>"_mult" then
        Den_match:={type(Den)}, 1;
        Den_nmb:=1;
      else
        Den_L:=IntTrans::anatype(Den);
        Den_match:={op(Den_L)}, Den_nmb;
        Den_nmb:=nops(Den_L);
      end_if;

      case  [Num_match, Den_match]
      of [ {"ln"}, 1, {"_power"}, 1] do
        if op(Den, 1)=var1 then
          if is(op(Den, 2)>0)=TRUE then
            _n:=op(Den, 2)-1;
            _i:=genident();
            return(_lin*(hold(sum)(1/_i, _i=1.._n)
                        -ln(var2)-EULER)*var2^_n/fact(_n));
          end_if;
        end_if;
      end_case:

      return(FAIL);

    elif Num_sp[2]=1 and Den_sp[1]=1 then # Rat / NonRat #

      Num_L:=IntTrans::anapol(Num, var1);
      Num_code:={op(Num_L[1])}; Num_nmb:=nops(Num_L[1]);
      Den_code:=IntTrans::nonrat_ana(Den, var);
      return(FAIL);

    elif Num_sp[1]=1 and Den_sp[2]=1 then # NonRat / Rat #
      Den_L:=IntTrans::anapol(Den, var1);
      Den_code:={op(Den_L[1])}; Den_nmb:=nops(Den_L[1]);
      Num_code:=IntTrans::nonrat_ana(Num, var);

      Num_pat:=[Num_code[1], Num_code[2], Num_code[3]];

      case Den_code
      of {[1/2, 2]} do

        case Num_pat

        of ["_mult", ["exp"], [1]] do
          _a:=Num_code[4][1]*var1;
          if not has(_a,s) then
            if IntTrans::Minus(_a) then
              userinfo(10, "formula 55 from Heuser");
              return( _lin*((PI*var2)^(-1/2)*cos(2*sqrt(-_a*var2))) );
            else
              userinfo(10, "formula 56 from Heuser");
              return( _lin*( (PI*var2)^(-1/2)*cosh(2*sqrt(_a*var2))) );
            end_if;
          end_if;

          _a:=op(Num)/var1^(1/2);
          if not has(_a,s) then
            if is(_a<=0)=TRUE then
              userinfo(10, "formula 58 from Heuser");
              return( _lin*((PI*var2)^(-1/2)*exp(_a^2/4/var2)) );
            end_if;
            return(FAIL);
          end_if;
          break;
           
        end_case; # [Num_code] #
        break;

      of {[1,2]} do # [Den_code] #
        case Num_pat
        of ["_mult", ["ln"], [1]] do
          if Num_code[4][1]=var1 then
            userinfo(10, "formula 60 from Heuser");
            return(_lin*(-ln(var2)-EULER));
          end_if;
          break;

        end_case; # [Num_code] #

      of {[1,5]} do # [Den_code] #

        case Num_pat
        of ["_mult", ["exp"], [1]] do
          _c:=Num_code[4][1]/var1; 
          _a:=Den_L[2][1][3]; _b:=Den_L[2][1][1];
          userinfo(10, "formula from M&P");
          return( heaviside(var2+_c)*sin( sqrt(_b/_a)*(var2+_c))
                              /sqrt(_a*_b));
        end_case: # Num_pat #
      end_case: # Den_code #

      if Den_nmb=1 then 
        case Den_L[1][1][2]
        of 2 do
          case Num_pat
          of ["_mult", ["ln"], [1]]  do
            _n:=Den_L[3][1][1];
            if testtype(_n, Type::PosInt) then
              userinfo(10, "formula 61 from Heuser");
              return( _lin*((_plus( 1/i $ hold(i)=1.._n-1 )
                        -ln(var2)-EULER)*var2^(_n-1)/fact(_n-1)));
            end_if;
          end_case;
        end_case;
      end_if;

    elif Num_sp[2]=1 and Num_sp[1]<>1 and
         Den_sp[1]<>1 and Den_sp[2]<>1 then # RAT / (Nonrat * Rat) #
      Num_L:=IntTrans::anapol(Num, var1);

      Num_code:={op(Num_L[1])}; Num_nmb:=nops(Num_L[1]);

      Den_code_rat:=IntTrans::anapol(Den_sp[1], var1);
      Den_code_nonrat:=IntTrans::nonrat_ana(Den_sp[2], var1);
      Den_pat_nonrat:=[Den_code_nonrat[1], Den_code_nonrat[2], Den_code_nonrat[3]];

      case Num_code
      of {[1, 2]} do
        case Den_pat_nonrat
        of ["_mult", ["exp"], [1]] do
          case {Den_code_rat[1][1]}
          of {[1,5]} do
            _c:=Den_code_nonrat[4][1]/var1;
            if not has(_c, var1) then
              _a:=Den_code_rat[2][1][3];
              _b:=Den_code_rat[2][1][1];
              return( heaviside(var2-_c)*cos(sqrt(_b/_a)*(var2-_c))/
                         sqrt(_a*_b)  );
            end_if;
          end_case:
        end_case:
      end_case:
 
    elif Num=1 and
         Den_sp[1]<>1 and Den_sp[2]<>1 then # 1 / (Nonrat * Rat) #

      Den_code_rat:=IntTrans::anapol(Den_sp[1], var1);
      Den_code_nonrat:=IntTrans::nonrat_ana(Den_sp[2], var1);
      Den_pat_nonrat:=[Den_code_nonrat[1], Den_code_nonrat[2],
                             Den_code_nonrat[3]];

      case Den_pat_nonrat
      of ["_mult", ["exp"], [1]] do
        case {Den_code_rat[1][1]}
        of {[1,5]} do
          _c:=Den_code_nonrat[4][1]/var1;
          if not has(_c, var1) then
            _a:=Den_code_rat[2][1][3];
            _b:=Den_code_rat[2][1][1];
            userinfo(10, "formula from M&P");
	    # PZ: changed 'cos' to 'sin' because it gave
		a wrong result for ilaplace(1/exp(s)^2/(s^2+1),s,t) #
            return( heaviside(var2-_c)*sin(sqrt(_b/_a)*(var2-_c))/
                       sqrt(_a*_b)  );
          end_if;
        end_case:
      end_case:

    else # Num_sp[2]=? and Den_sp[2]=?, mixed #
      return(FAIL);
    end_if; # Num_sp[2]=? and Den_sp[2]=? #
    return(FAIL);
  end_proc):

unalias( IntTrans ):

# end of file #

