# Dirk Mueller, olorien, 28/10/96, v1.0 #

alias( IntTrans = transform::IntTrans ):

_power:=funcattr(_power,"transform::ilaplace", #transform d. IntTrans ersetzt#
  proc(_fu, var1, var2) 
    local Num, Den, Num_L, Den_L, Num_code, Den_code,
           Num_nmb, Den_nmb, erg, _w, _lin,
           _a, _b, _c, _d,  _e, _f, _g, _h, 
           _A, _B, _C, _D, _E, _F,
           _a2, _b2,_c2, _d2, _n, _number;
  begin
    case _fu

    of 1/var1 do
      userinfo(10, "formula 1 from Heuser");
      return(1);
      break;

    of 1/sqrt(var1) do
      userinfo(10, "formula 50 from Heuser");
      return(1/sqrt(PI*var2));
      break;
    end_case;

    _n:=op(_fu, 2); Den:=op(_fu, 1)^(-_n);

    Den_L:=IntTrans::anapol(Den, var1);
    if Den_L=FAIL then
      return(FAIL);
    end_if;

    Den_code:={op(Den_L[1])}; Den_nmb:=nops(Den_L[1]);

    case [Den_code, Den_nmb]
    of [{[1,5]}, 1] do # 1/(a*s^2+b) #
      _a:=Den_L[2][1][3]; _b2:=Den_L[2][1][1]/_a;
      if IntTrans::Minus(_b2) then
        _b:=(-_b2)^(1/2);
        userinfo(10, "formula 8 from Heuser");
        return(sinh(_b*var2)/_a/_b);
      end_if;
      _b:=_b2^(1/2);
      userinfo(10, "formula 7 from Heuser");
      return(sin(_b*var2)/_a/_b);

    of [{[2,5]}, 1] do # 1/(a*s^2+b)^2 #
      _a:=Den_L[2][1][3]; _b:=Den_L[2][1][1]/_a;
      if IntTrans::Minus(_b) then
        _b:=(-_b)^(1/2); 
        userinfo(10, "formula 31 from Heuser");
        return(( _b*var2*cosh(_b*var2)-sinh(_b*var2) )/_b^3/2);
      end_if;
      _b:=_b^(1/2);
      userinfo(10, "formula 30 from Heuser");
      return(( sin(_b*var2)-_b*var2*cos(_b*var2))/_b^3/2 );

    of [{[1,7]}, 1] do  # 1/(a*s^2+b*s+c) #
      _a:=Den_L[2][1][3]; _b:=Den_L[2][1][2]/_a/2;
      _c2:=Den_L[2][1][1]/_a; _c:=_c2^(1/2);
      if is(_c2>_b^2)=TRUE then
        _w:=sqrt(_c2-_b^2);
        userinfo(10, "formula 9 from Heuser, case 1");
        return(exp(-_b*var2)*sin(_w*var2)/_w/_a );
      elif is(_c2<_b^2)=TRUE then
        _w:=sqrt(_b^2-_c2);
        userinfo(10, "formula 9 from Heuser, case 2");
        return(exp(-_b*var2)*sinh(_w*var2)/_w/_a );
      elif is(_c2=_b^2)=TRUE then
        userinfo(10, "formula 9 from Heuser, case 3");
        return(var2*exp(-_b*var2));
      end_if;
      userinfo(1, "please specify constants");
      break;

    of [{[1,17]}, 1] do # 1/(s^4+b) #
      _a:=Den_L[2][1][5]; _b:=Den_L[2][1][1]/_a;
      if IntTrans::Minus(_b) then
        _b:=(-_b)^(1/4); 
        userinfo(10, "formula 32 from Heuser");
        return(( sinh(_b*var2)-sin(_b*var2) )/_b^3/2);
      end_if;
      _b:=(_b/4)^(1/4);
      userinfo(10, "formula 28 from Heuser");
      return(( sin(_b*var2)*cosh(_b*var2)-cos(_b*var2)*sinh(_b*var2))/_b^3/4);

    end_case; # [Den_code, Den_nmb] #

    if Den_nmb=1 then
      case Den_L[1][1][2]
      of 2 do 
        _n:=Den_L[3][1][1]; 
        if is(_n>0)=TRUE then
          userinfo(10, "formula 44 from Heuser");
          return(var2^(_n-1)/gamma(_n));
        end_if;
        break;

      of 3 do 
        _n:=Den_L[3][1][1];
        if is(_n>0)=TRUE then
          _a:=Den_L[2][1][2]; _b:=Den_L[2][1][1]/_a;
          userinfo(10, "formula 45 from Heuser");
          return( var2^(_n-1)*exp(-_b*var2)/gamma(_n)/_a^(_n ));
        end_if;
        break;

      end_case;
    end_if;

    return(FAIL);
  end_proc):


unalias( IntTrans ):

# end of file #
