
real := proc(complex)
begin
  if type(complex) = DOM_COMPLEX
  then 
    op(complex, 1):
  else
    complex:
  end_if:
end_proc:

imag := proc(complex)
begin
  if type(complex) = DOM_COMPLEX
  then
    op(complex, 2):
  else
    complex:
  end_if:
end_proc:
 
enn_x := proc(u,v)
local w;
begin
  w := u + I*v:
  real(0.5*(w-w^3/3)):
end_proc:

enn_y := proc(u,v)
local w;
begin
  w := u + I*v:
  real(0.5*I*(w+w^3/3)):
end_proc:

enn_z := proc(u,v)
local w;
begin
  w := u + I*v:
  real(0.5*(w^2)):
end_proc:

plot3d(Axes = None, Scaling = UnConstrained,
       [Mode = Surface, 
             [hold(enn_x(u,v)),
              hold(enn_y(u,v)),
              hold(enn_z(u,v))
             ],
             u = [-1,1], v = [-1,1],
             Grid = [30, 30],
             Color = [Height, [0.5,0,1],[1,0.5,0.8]],
             Style = [HiddenLine, Mesh]]);
