
U := proc(u, v)
begin
  v*sin(u):
end_proc:

V := proc(u, v)
begin
  v*cos(u):
end_proc:

real := proc(complex)
begin
  if type(complex) = DOM_COMPLEX
  then 
    op(complex, 1):
  else
    complex:
  end_if:
end_proc:

imag := proc(complex)
begin
  if type(complex) = DOM_COMPLEX
  then
    op(complex, 2):
  else
    complex:
  end_if:
end_proc:
 

ennr_x := proc(u,v,n)
local w;
begin
  w := u + I*v:
  real(0.5*(w-w^(2*n+1)/(2*n+1))):
end_proc:

ennr_y := proc(u,v,n)
local w;
begin
  w := u + I*v:
  real(0.5*I*(w+w^(2*n+1)/(2*n+1))):
end_proc:

ennr_z := proc(u,v,n)
local w;
begin
  w := u + I*v:
  real((w^(n+1))/(n+1)):
end_proc:

plot3d(Axes = None, Scaling = UnConstrained,
       [Mode = Surface, 
             [hold(ennr_x(U(u,v),V(u,v),3)),
              hold(ennr_y(U(u,v),V(u,v),3)),
              hold(ennr_z(U(u,v),V(u,v),3))
             ],
             u = [0,PI], v = [-1, 1],
             Grid = [40, 40],
             Color = [Height, [1,0,0],[0,1,0]],
             Style = [HiddenLine, ULine]]);
