
real := proc(complex)
begin
  if type(complex) = DOM_COMPLEX
  then 
    op(complex, 1):
  else
    complex:
  end_if:
end_proc:

imag := proc(complex)
begin
  if type(complex) = DOM_COMPLEX
  then
    op(complex, 2):
  else
    complex:
  end_if:
end_proc:
 

gaussn_x := proc(u,v,n)
local w;
begin
  w := u + I*v:
  2/(abs(w^n)^2+1)*real(w^n):
end_proc:

gaussn_y := proc(u,v,n)
local w;
begin
  w := u + I*v:
  2/(abs(w^n)^2+1)*imag(w^n):
end_proc:

gaussn_z := proc(u,v,n)
local w;
begin
  w := u + I*v:
  1/(abs(w^n)^2+1)*abs(w^n)^2-1:
end_proc:

number := 0:

for x from 0.1 to float(PI) step 0.1 do

  number   := number + 1:
  filename := "gaussn_image.".number:

  plot3d(PlotDevice = filename,
         Axes = None, Scaling = UnConstrained,
         [Mode = Surface, 
               [hold(gaussn_x(u,v,1)),
                hold(gaussn_y(u,v,1)),
                hold(gaussn_z(u,v,1))
               ],
               u = [-x, x], v = [-x, x],
               Grid = [30, 30],
               Color = [Height, [0.5,0,1],[1,0.5,0.8]],
             Style = [ColorPatches, AndMesh]]);
end_for:
