
#
A three-dimensional graph can be explecitly clipped within the plot3d
command by indicating a minimum and maximum threshold for the given
function. 

This example plots the real part of the complex values of the gamma
function and clips these values in order to eliminate the extreme
divergence of the gamma function.
(This example is taken from: AXIOM: the scientific computation system,
 R.D. Jenks, R.S. Stutor, Springer Verlag 1992, page 213)
#

plot3d(
  Ticks=0,AxesOrigin=[0,0,0],CameraPoint=[10,-17,9],FocalPoint= [0,0,-0.5],
  [Mode=Surface,[hold(u),hold(v),hold(max(min(op(gamma(u + v*I), 1), 4), -4))],
  u=[-PI,PI],v=[-PI,PI],Smoothness=[1,1]]
):
