
# A Simulation of Wave Interference when Two Pebbles are Dropped into Water #

pebbles := proc( amp1, amp2, dist, t)

begin

   plot3d( Title = "Wave Interference",
           Axes = None,
           [ Mode = Surface,
              [ 
		x, y, 
		sin(t+sqrt((x-dist)^2+y^2))*amp1/sqrt((x-dist)^2+y^2)+
                sin(t+sqrt((x+dist)^2+y^2))*amp2/sqrt((x+dist)^2+y^2)
              ],
              x = [-dist*2, 2*dist], y = [-10, 4*dist-10],
              Grid = [round(dist*5), round(dist*5)],
              Style = [HiddenLine, Mesh]
           ]
   )

end_proc:

pebbles(5, 10, 10, 0):

#
for t from 0 to 3 step 0.4 do
    pebbles(5, 10, 10, t)
end_for:
#
