#
  P. Prusinkiewicz and A. Lindenmayer, 
  The Algorithmic Beauty of Plants, Springer Verlag, 1990.

  P. Prusinkiewicz and J. Hanan,
  Lindenmayer Systems, Fractals and Plants, 
  Lecture Notes in Biomathematics 79, S.Levin (Editor),
  Springer Verlag, 1989.
#

#             Koch snowflake             #

l1 := Lsys(60, "+F--F--F", "F"="F+F--F+F"):
Lsys::plot(l1, 4): # plot 4th generation #

#             exterior snowflake         # 
 
l2 := Lsys(60, "F-F-F-F-F-F", "F"="F-F++F-F"):
Lsys::plot(l2, 4): # plot 4th generation #

#             Sierpinsky triangles       #

l3 := Lsys(120, "Y-F-F", "F"="FF", "Y"="F-Y+Y+Y-F"): 
Lsys::plot(l3, 4): # plot 5th generation #

#             Hilbert curve              #

l4 := Lsys(90, "Y", "X"="-YF+XFX+FY-", "Y"="+XF-YFY-FX+"): 
Lsys::plot(l4, 6): # plot 6th generation #

#----------------------------------------#

l5 := Lsys(90, "F-F-F-F", "F"="F-F+F+FF-F-F+F"):
Lsys::plot(l5, 4):

l6 := Lsys(90, "F-F-F-F", "F"="FF-F--F-F"):
Lsys::plot(l6, 4): 

l7 := Lsys(90, "F-F-F-F", "F"="FF-F+F-F-FF"):
Lsys::plot(l7, 4): 

#
l8 := Lsys(90, "L", "L"="L+R+", "R"="-L-R", "L"=line, "R"=line):
Lsys::plot(l8, 10): 

l9 := Lsys(60, "R", "L"="R+L+R", "R"="L-R-L", "L"=line, "R"=line):
Lsys::plot(l9, 7): 
#

l10 := Lsys(90, "F-F-F-F", "F"="F-FF--F-F"):
Lsys::plot(l10, 5):

l11 := Lsys(90, "F-F-F-F", "F"="F-F+F-F-F"): 
Lsys::plot(l11, 4):

l12 := Lsys(90, "F-F-F-F", "F"="FF-F-F-F-FF"):
Lsys::plot(l12, 4):

l13 := Lsys(90, "F-F-F-F", "F"="FF-F-F-F-F-F+F"): 
Lsys::plot(l13, 4):

l14 := Lsys(90, "F-F-F-F", "F"="F+FF-FF-F-F+F+FF-F-F+F+FF+FF-F"):  
Lsys::plot(l14, 3):

#
l15 := Lsys(90, "-F", "F"="F+F-F-F+F"):
Lsys::plot(l15, 5):

l16 := Lsys(90, "F+F+F+F", "F"="F+f-FF+F+FF+Ff+FF-f+FF-F-FF-Ff-FFF", 
                           "f"="ffffff"): 
Lsys::plot(l16, 3):

l17 := Lsys(60, "L", "L"="L+R++R-L--LL-R+", "R"="-L+RR++R+L--L-R", 
                     "L"=line, "R"=line):
Lsys::plot(l17, 5):

l18 := Lsys(90, "-R", "L"="LL-R-R+L+L-R-RL+R+LLR-L+R+LL+R-LR-R-L+L+RR-",
                      "R"="+LL-R-R+L+LR+L-RR-L-R+LRR-L-RL+L+R-R-L+L+RR",
                      "L"=line, "R"=line):
Lsys::plot(l18, 3):
#
