
karazuba:=proc(f,g)
local a,b,c,d,n,p1,p2,p3,x,i, res, high,low, task,
 resqu,  st, aplusb, cplusd;

begin
resqu:=genident("result");
if nops(f)<40 or nops(g)<40 then
	userinfo(5, "Calling multiplication of the kernel");
	poly(zip(f,[$0..nops(f)-1], DOM_LIST),[hold(x)]),
	poly(zip(g,[$0..nops(g)-1], DOM_LIST),[hold(x)]);
	_mult(%);
	[coeff(%,i) $hold(i)=0..degree(%)]
elif nops(f)<400 or nops(g)<400 then #sequential karazuba #
   userinfo(4,"Starting sequential Karazuba with input degrees ".
		expr2text(nops(f)-1)." and ".expr2text(nops(g)-1)); 
   n:=max(nops(f), nops(g)) div 2;
   if nops(f)<=n then
	   karazuba(f,[op(g,n+1..nops(g))]);
	   karazuba(f,[op(g,1..n)]);
	   zip([0$n].%2, %, _plus, 0)
   elif nops(g)<=n then
	   karazuba(g,[op(f,n+1..nops(f))]);
	   karazuba(g,[op(f,1..n)]);
	   zip([0$n].%2, %, _plus, 0)
   else
	   a:=[op(f,n+1..nops(f))];
	   b:=[op(f,1..n)];
	   c:=[op(g,n+1..nops(g))];
	   d:=[op(g,1..n)];
	   zip(a,b,_plus,0);
	   zip(c,d,_plus,0);
	   p1:=karazuba(%,%2);
	   p2:=karazuba(a,c);
	   p3:=karazuba(b,d);
	   zip(p1,p2,_subtract,0);
	   p1:=zip(%,p3,_subtract,0);
	   p3.[0 $ 2*n-nops(p3)].p2;
	   zip(%, [0 $n].p1, _plus, 0)
   end_if
else
	# parallel karazuba #
    userinfo(4, "Starting parallel karazuba with input degrees ".
	expr2text(nops(f)-1)." and ".expr2text(nops(g)-1));
    n:=max(nops(f), nops(g)) div 2;
    if nops(f)<=n then
	st:=rtime():
    high:=net::gjob(1, hold(karazuba) (f,[op(g,n+1..nops(g))]));   
	userinfo(1, "Time for accessing problem heap: ".expr2text(rtime()-st));
	st:=rtime():
	userinfo(4, "Doing low part");  
	low:=karazuba(f, [op(g,1..n)]);
   while bool(net::gstatus(1, high) = 0) do
          if topology(Cluster)<>1 then net::gprocess() end_if;
   end_while;
   high:= net::gresult(1, high);
   zip([0$n].high, low, _plus, 0)
  elif nops(g)<=n then
      karazuba(g,f)
  else 
      a:=[op(f,n+1..nops(f))];
      b:=[op(f,1..n)];
      c:=[op(g,n+1..nops(g))];
      d:=[op(g,1..n)];
      userinfo(4,"Computing sums");
      aplusb:=zip(a,b,_plus,0);
      cplusd:=zip(c,d,_plus,0);
	   # p1:=karazuba(%,%2); #
      userinfo(4,"Writing first product to problem heap");
      st:=rtime():
      

		p1:=net::gjob(1, hold(karazuba) (aplusb, cplusd));
	   # p2:=karazuba(a,c); #
      userinfo(1, "Time for accessing problem heap: ".expr2text(rtime()-st));
      userinfo(4, "Writing second product to problem heap");
      st:=rtime():
      p2:=net::gjob(1,hold(karazuba)(a, c));
      userinfo(1, "Time for accessing problem heap: ".expr2text(rtime()-st));
      userinfo(4, "Doing third product");
	   p3:=karazuba(b,d); 
      userinfo(4, "Two results are still missing");      

      while bool(net::gstatus(1,p1)=0) do
         if topology(Cluster)<>1 then net::gprocess() end_if;
      end_while;
      while bool(net::gstatus(1,p2)=0) do
         if topology(Cluster)<>1 then net::gprocess() end_if;
      end_while;
      p1:= net::gresult(1, p1);
      p2:= net::gresult(1, p2);
                 
	   zip(p1,p2,_subtract,0);
	   p1:=zip(%,p3,_subtract,0);
	   p3.[0 $ 2*n-nops(p3)].p2;
	   zip(%, [0 $n].p1, _plus, 0)
   end_if
end_if
end_proc: 

karazmult:=proc(f,g)
local i,res;

begin
net::gmasterinit(); 
for i from 2 to topology() do
   # broadcasts #
   writequeue("work", i, hold(_assign)(hold(karazuba), karazuba));
   userinfo(2, "Getting cluster ".expr2text(i)." to work");
   makework(i)
end_for; 
res:=karazuba([coeff(f,i) $hold(i)=0..degree(f)], 
	 [coeff(g,i) $hold(i)=0..degree(g)]);
net::gmasterquit();
poly(zip(res,[$0..nops(res)-1],DOM_LIST),op(f,2..3))
end_proc:


makework:=proc(clusternr)

begin
writequeue("work", clusternr, hold(net::gslaveinit(1)))  
end_proc:


