# parallel search method for unsorted list #

searchlist:=proc(l, f, offset)
local i;

begin
for i from 1 to nops(l) do
	if net::global(found)<>FAIL then
		break
	end_if;
	if bool(f(l[i]))=TRUE then
		net::global(found, i+offset);
		break
	end_if
end_for;
net::global(ready, net::global(ready)+1)
end_proc:

parsearch:= proc(l, f)
# l: a list #
# f: a function mapping list elements to TRUE or FALSE #
# returns some index i such that f(l[i]) = TRUE, or FAIL
  if no such index exists #
local i, tasksize;

begin
tasksize:=nops(l) div topology();
net::global(found, FAIL);
net::global(ready, 0);
for i from 2 to topology() do
	writequeue("work", i, hold(fp::apply)(searchlist, 
		[op(l, (i-2)*tasksize+1..(i-1)*tasksize)], f,
		(i-2)*tasksize))
end_for;  
searchlist([op(l,(topology()-1)*tasksize+1..nops(l))], f,
	(topology()-1)*tasksize);
while net::global(ready) < topology() do #nothing# end_while;
net::global(found)	
end_proc:
