/*  LAST EDIT: Mon Nov  7 14:31:53 1994 by Holger Naundorf (snoo)  */
/* $Date: 1997/08/29 14:17:19 $  $Author: kg $  $Revision: 1.7 $ */

/**************************************************************************
**                           MAM_ass_mem.h                               **
** In diesem File sind Konstanten und Makros definiert, die von den      **
** Funktionen fuer assoziativen Speicher benoetigt werden.               **
** Erstellungsdatum  : 22/08/91                                          **
** Letzte Aenderung  : 16/07/92                                          **
** Autor             : Holger Naundorf                                   **
**************************************************************************/

#ifndef __MAM_ass_mem__
#define __MAM_ass_mem__


#ifndef false
#   define false 0L
#   define true  1L
#endif

/**************************************************************************
** Im folgenden sind die Makros definiert, die die Funktionsaufrufe      **
** durchfuehren.                                                         **
**************************************************************************/
#define MAM_init() \
        MAMF_init ()
#define MAM_exit() \
        MAMF_exit ()
#define MAM_type(aM) \
        MAMF_type(aM)
#define MAM_create(art) \
        MAMF_create_Mem1 (art)
#define MAM_create_Mem1(art,size) \
        MAMF_create_Mem1_size(art,size)
#define MAM_free(aM) \
        {if ((*aM) != MMMNULL) MAMF_free_Mem1(aM) ; }
#define MAM_content(aM) \
        ((aM)!=MMMNULL?MAMF_content_Mem1(aM) : MMMNULL)
#define MAM_in(aM,arg,erg) \
        ((aM)!=MMMNULL ? MAMF_in_Mem1(aM,arg,erg) : false )
#define MAM_s_in(aM,arg,erg) \
        ((*aM)!=MMMNULL ? MAMF_s_in_Mem1(aM,arg,erg) : false)
#define MAM_delete(aM,arg) \
        ((*aM)!=MMMNULL ? MAMF_delete_Mem1(aM,arg) : false)
#define MAM_insert(aM,arg,erg) \
        ((*aM)!=MMMNULL ? MAMF_insert_Mem1(aM,arg,erg) : false)
#define MAM_cond_insert(aM,arg,erg) \
        {if ((*aM)!=MMMNULL) MAMFcond_insert(aM,arg,erg);}
#define MAM_r_insert(aM,arg,erg) \
        {if ((*aM)!=MMMNULL) MAMF_r_insert_Mem1(aM,arg,erg);}
#define MAM_in_search(aM,arg,erg) \
        ((aM)!=MMMNULL?MAMF_in_Mem1(aM,arg,erg) : false)
#define MAM_number_of_entries(aM) \
        MMMsignature(aM) /* MAMF_number_of_entries(aM)*/
#define MAM_compute_size(n) \
        MAMF_compute_size(n)
#define MAM_rehash(aM) \
        MAMF_rehash(aM)
#define MAM_filter(aM,f,d) \
	MAMF_filter(aM,f,d)

/**************************************************************************
** Im folgenden werden die Funktionen deklariert, die vom assoziativen   **
** Speicher als Schnittstelle bereitgestellt werden.                     **
**************************************************************************/
void      MAMF_init             ( VOID) ;
void      MAMF_exit             ( VOID) ;
long      MAMF_number_of_entries( S_Pointer  aM );
long      MAMF_compute_size     ( long n );
void      MAMF_rehash           ( S_Pointer *aM );
long      MAMF_type             ( S_Pointer  aM );
S_Pointer MAMF_create_Mem1      ( unsigned long art );
S_Pointer MAMF_create_Mem2      ( unsigned long art );
S_Pointer MAMF_create_Mem1_size ( unsigned long art, long size );
S_Pointer MAMF_create_Set1      ( unsigned long art );
void      MAMF_free_Mem1        ( S_Pointer *aM );
void      MAMF_free_Set1        ( S_Pointer *aM );
MUPbool   MAMF_in_Mem1          ( S_Pointer  aM, S_Pointer arg, S_Pointer  *erg );
MUPbool   MAMF_in_Mem2          ( S_Pointer  aM, S_Pointer arg, S_Pointer  *erg );
MUPbool   MAMF_in_Set1          ( S_Pointer  aM, S_Pointer arg, S_Pointer  *erg );
MUPbool   MAMF_s_in_Mem1        ( S_Pointer *aM, S_Pointer arg, S_Pointer **erg );
MUPbool   MAMF_s_in_Mem2        ( S_Pointer *aM, S_Pointer arg, S_Pointer **erg );
MUPbool   MAMF_s_in_Set1        ( S_Pointer *aM, S_Pointer arg, S_Pointer **erg );
MUPbool   MAMF_insert_Mem1      ( S_Pointer *aM, S_Pointer arg, S_Pointer   erg );
MUPbool   MAMF_insert_Mem2      ( S_Pointer *aM, S_Pointer arg, S_Pointer   erg );
MUPbool   MAMF_insert_Set1      ( S_Pointer *aM, S_Pointer arg, S_Pointer   erg );
MUPbool   MAMF_delete_Mem1      ( S_Pointer *aM, S_Pointer arg );
MUPbool   MAMF_delete_Set1      ( S_Pointer *aM, S_Pointer arg );
S_Pointer MAMF_content_Mem1     ( S_Pointer  aM );
S_Pointer MAMF_content_Set1     ( S_Pointer  aM );
void      MAMFcond_insert       ( S_Pointer *aM, S_Pointer arg, S_Pointer erg );
void      MAMF_r_insert_Mem1    ( S_Pointer *aM, S_Pointer arg, S_Pointer erg );
MUPbool   MAMF_r_insert_Mem2    ( S_Pointer *aM, S_Pointer arg, S_Pointer erg );
void      MAMF_r_insert_Set1    ( S_Pointer *aM, S_Pointer arg, S_Pointer erg );
void	  MAMF_filter		( S_Pointer *aM, MUPbool (*)(S_Pointer, S_Pointer, void *), void *);

/**************************************************************************
** Es folgend die Konstanten fuer den search-Teil einer Art eines        **
** assoziativen Speichers.                                               **
**************************************************************************/
#define MAMC_no_search    0L
#define MAMC_pointers     0X0000100L
#define MAMC_contents     0X00000200L

#define MAMCsearch_part   0X00000f00L    /* Diese Konstante dient zum    */
                                         /* extrahieren des search-Teils */

/**************************************************************************
** Es folgen die Konstanten fuer den insert-Teil einer Art eines         **
** assoziativen Speichers.                                               **
**************************************************************************/
#define MAMC_no_insert    0L
#define MAMC_all          0X00000010L
#define MAMC_more         0X00000020L

#define MAMCinsert_part   0X000000f0L    /* Diese Konstante dient zum    */
                                         /* extrahieren des insert-Teils */
/**************************************************************************
** Es folgen die Konstanten fuer den internen Teil einer Art eines       **
** assoziativen Speichers.                                               **
**************************************************************************/
#define MAMC_no_Mem       0L
#define MAMC_Mem1         1L
#define MAMC_Set1         2L
#define MAMC_Mem2         3L
 
#define MAMCintern_part   0X0000000fL  /* Diese Konstante dient zum      */
                                       /* extrahieren des internen Teils */

 
/**************************************************************************
** Es folgen Konstanten, die als Wert des ersten Argumentes in der       **
** MAM_search1()-Funktion eine Rolle spielen.                            **
** Diese Konstanten steuern das Lesen und Schreiben in die internen      **
** Assoziativen Speicher des Evaluierers.                                **
**************************************************************************/
#define MAMC_DEFAULT       0L             /* LESEN und SCHREIBEN erlaubt */
#define MAMC_NO_WRITE_DOWN 1L 
#define MAMC_NO_READ_DOWN  2L  
#define MAMC_NO_WRITE_UP   4L

/* Verhindert das Lesen aus dem assoziativen Speicher und forciert die */
/* Ausfuehrung von 'Bef-Seq' bei der Verwendung von 'MAM_search1()'.   */

#define MAMC_NO_READ       MAMC_NO_READ_DOWN

/* Verhindert das Eintragen des Ergebnisses von 'Bef-Seq' bei der */
/* Verwendung von 'MAM_search1()'.                                */

#define MAMC_NO_WRITE      (MAMC_NO_WRITE_UP | MAMC_NO_WRITE_DOWN) 

/*************************************************************************/


/**************************************************************************
** Macros zur Steuerung des Eintrags in assoziative Speicher             **
**************************************************************************/

/**************************************************************************
** Es folgt die Definition von Makros, die fuer die Funktionen in        **
** MAM_ass_Mem.c wichtig sind.                                           **
**************************************************************************/

/**************************************************************************
** void MAM_change(S_Pointer *aM)                                        **
** Diese Funktion "uberpr"uft, wieviele S-Zeiger auf *aM verweisen.      **
** Sind dies mehr als einer, so wird auf diese "uberpr"uft, ob die       **
** Gr"o\3e des assoziativen Speichers in einem vern"unftigen Verh"altnis **
** zu der Anzahl der Eintr"age steht. Ist dies nicht der Fall, so wird   **
** ein rehash mit einem assoziativen Speicher der entsprechenden Gr"o\3e **
** durchgef"uhrt.                                                        **
**************************************************************************/
#ifndef MMMDREFSUNCERTAIN
#define MAM_change(aM) \
            {  if ( MMMrefs(*aM)>1 )    \
                  if ( MAM_number_of_entries(*aM)>MAMCfactor1*MMMcounter(*aM) \
                       || MMMcounter(*aM)>MAMCfactor2*MAM_number_of_entries(*aM)) \
                     MAM_rehash(aM) ; \
                   else \
                     MMMchange(aM) ; \
            }
#else /* MMMDREFSUNCERTAIN */
#define MAM_change(aM) \
            {  if ( MAMV_change \
                    && (MAM_number_of_entries(*aM)>MAMCfactor1*MMMcounter(*aM) \
                        || MMMcounter(*aM)>MAMCfactor2*MAM_number_of_entries(*aM)))\
                  MAM_rehash(aM) ; \
                else \
                  MMMchange(aM) ; \
            }
#endif /* MMMDREFSUNCERTAIN */
       
/**************************************************************************
** void MAM_search (S_Pointer *aM , arg , *erg ; Bef_Seq)                **
** Dieser Makro ueberprueft, ob arg in aM assoziiert ist. Falls ja setzt **
** er *erg auf den mit arg assoziierten Wert und kehrt zurueck.          **
** Falls nein, so fuehrt er die C-Befehlssequenz Bef_Seq aus, assoziiert **
** arg mit *erg in aM, falls dies die Art von aM entsprechend bestimmt   **
** und kehrt zurueck.                                                    **
**************************************************************************/
#define MAM_search(aM,arg,erg,Bef_Seq) \
            {  if (!MAM_in_search(*aM,arg,erg)) \
                  {  Bef_Seq ; \
                     MAM_cond_insert(aM,arg,*erg); \
                  } \
            }
 
/**************************************************************************
** void MAM_search1 (long status , S_Pointer *aM , arg , *erg ; Bef-Seq) **
** Dieser Makro ueberprueft, ob arg in *aM assoziiert ist. Falls ja, so  **
** setzt er *erg auf den mit arg assoziierten Wert und kehrt zurueck.    **
** Falls nein, so fuehrt er die C-Befehlssequenz Bef-Seq aus, assoziiert **
** arg mit *erg in *aM, falls dies die Art von *aM und der Wert von      **
** *status entsprechend bestimmt und kehrt zurueck.                      **
** Im Augenblick werden die Werte nur assoziiert, falls *status nicht    **
** den Wert MAC_NO_WRITE hat.                                            **
** Falls status den Wert MAMC_NO_READ hat, so wird nicht aus dem         **
** assoziativen Speicher gelesen, sondern auf jeden Fall Bef-Seq         **
** ausgef"uhrt.                                                          **
**************************************************************************/
#define MAM_search1(status,aM,arg,erg,Bef_Seq) \
           {   if ( ((status) & MAMC_NO_READ) || (!MAM_in_search(*aM,arg,erg)) ) \
                  {   Bef_Seq ; \
                      if (!(status & MAMC_NO_WRITE)) \
                         MAM_cond_insert(aM,arg,*erg) ; \
                  } \
           }
 
/**************************************************************************
** void MAM_search2 (long status , S_Pointer *aM , arg , *erg ; Bef-Seq1 **
**                         Bef-Seq2)                                     **
** Dieser Makro ueberprueft, ob arg in *aM assoziiert ist. Falls ja, so  **
** setzt er *erg auf den mit arg assoziierten Wert, f"uhrt Bef-Seq2 aus  **
** und kehrt zur"uck.                                                    **
** Falls nein, so fuehrt er die C-Befehlssequenz Bef-Seq1 aus, assoziiert**
** arg mit *erg in *aM, falls dies die Art von *aM und der Wert von      **
** *status entsprechend bestimmt und kehrt zurueck.                      **
** Im Augenblick werden die Werte nur assoziiert, falls *status nicht    **
** den Wert MAMC_NO_WRITE hat.                                           **
** Falls status den Wert MAMC_NO_READ hat, so wird nicht aus dem         **
** assoziativen Speicher gelesen, sondern auf jeden Fall Bef-Seq         **
** ausgef"uhrt.                                                          **
**************************************************************************/
#define MAM_search2(status,aM,arg,erg,Bef_Seq1,Bef_Seq2) \
           {   if ( ((status) & MAMC_NO_READ) || (!MAM_in_search(*aM,arg,erg)) ) \
                  {   Bef_Seq1 ; \
                      if (!(status & MAMC_NO_WRITE)) \
                         MAM_cond_insert(aM,arg,*erg) ; \
                  } \
                else \
                  {   Bef_Seq2 ; \
                  } \
           }

/**************************************************************************
** void MAMDtime_stamp ( S_Pointer *aM )                                 **
** Dieser Makro liefert den Speicherplatz, in dem der Zeitstempel von    **
** *aM gespeichert ist. Dieser Makro kann auch auf der linken Seite      **
** einer Gleichung vorkommen.                                            **
**************************************************************************/
#define MAMDtime_stamp(aM) (*MMMarr(aM,1L,unsigned long,MMMwrite))

/**************************************************************************
** MAMDhashvalue ( long hash , art ; S_Pointer arg )                     **
** Dieser Makro setzt die Variable hash auf den Wert, nach dem im        **
** assoziativen Speicher gehasht wird.                                   **
**************************************************************************/
#define MAMDhashvalue(hash,art,arg,aM) \
        { if (MAM_intern_part(art)==MAMC_pointers) \
             hash = ((long)arg) % MMMcounter(aM) ; \
           else \
             hash = MMMsignature(arg) % MMMcounter(aM) ; }

/**************************************************************************
** long MAM_search_part (long art)                                       **
** Dieser Makro gibt den search-Teil der Art art zurueck.                **
**************************************************************************/
#define MAM_search_part(art) ((art)&MAMCsearch_part)
 
/**************************************************************************
** long MAM_insert_part  (long art)                                       **
** Dieser Makro gibt den insert-Teil der Art art zurueck.                **
**************************************************************************/
#define MAM_insert_part(art) ((art)&MAMCinsert_part)
 
/**************************************************************************
** long MAM_intern_part (long art)                                       **
** Dieser Makro gibt den internen Teil der Art art zurueck.              **
**************************************************************************/
#define MAM_intern_part(art) ((art)&MAMCintern_part)
 

/**************************************************************************
** Es folgen allgemeie Konstanten                                        **
**************************************************************************/
#define MAMCfactor1  10L /* Diese Konstante  gibt,  wieviel mehr Eintraege
                            als Hashlisten ein assoziativer Speicher haben
                            kann, bevor er vergr"o\3ert wird */
                            
#define MAMCfactor2  5L  /* Diese Konstante gibt an,wieviel mehr Hashlisten
                            als Eintr"age ein assoziativer Speicher haben
                            kann, bevor er von MAM_change() verkleinert wird. */
#define MAMCdiv1     100L

#define MAMCdiv2     10L /* Diese beiden Konstanten werden in der Funktion
                            MAMF_compute_size() benoetigt. Sie geben in etwas
                            an, zu welcher Basis der Logarithmus von der
                            Funktion berechnet wird */

/**************************************************************************
** Es folgen Konstanten, die fuer den assoziativen Speicher vom Typ Mem1 **
** noetig sind.                                                          **
**************************************************************************/

#define MAMCmaxindex  5    /* MAMV_index_list hat MAMCmaxindex+1 Eintraege,
                              die angeben, wie viele Hashlisten der assoziative
                              Speicher mit diesem Index haben soll */

#define MAMCindex0    23
#define MAMCindex1    97
#define MAMCindex2    1009
#define MAMCindex3    10007
#define MAMCindex4    100003
#define MAMCindex5    1000003
 
/**************************************************************************
** Es folgen Konstanten, die fuer den assoziativen Speicher vom Typ Mem2 **
** noetig sind.                                                          **
**************************************************************************/
#define MAMCMem2count       47L
#define MAMC_hashsize_Mem2  10L


/**************************************************************************
** Es folgen Konstanten, die fuer den assoziativen Speicher vom Typ Set1 **
** noetig sind.                                                          **
**************************************************************************/
#define MAMCSet1length      8L /* Dies ist die Laenge des Mem-Teils des ass.
                                  Speichertyps Set1 */
#define MAMCSet1count      47L /* Dies ist die Anzahl der Hashlisten, die am
                                  ass. Speichertyp Set1 haengen */


#endif /* __MAM_ass_mem__ */
