#ifndef __MBC_not_implemented__
#define __MBC_not_implemented__

/* ------------------------------------------------------------------------
 *        MBC_not_implemented.h
 *
 *  Hier stehen Definements fuer alle Funktionen die auf einigen Systemen
 *  nicht implementiert sind.   Aendert sich das, muss das entsprechende
 *  Definement einfach nur entfernt werden.
 *
 *  Autor              :     Gerald Siek
 *  Erstellungsdatum   :     05/11/1996
 *  Letzte Aenderung   :     11/12/1996
 *
 * ------------------------------------------------------------------------ */

 
#ifdef MACINTOSH

		// Nicht definierte Funktionen auf dem Mac
#define asinh		MBC_TransFunc1_not_implemented		// 9
#define acosh		MBC_TransFunc1_not_implemented		// 10
#define atanh		MBC_TransFunc1_not_implemented		// 11
#define erf		MBC_TransFunc1_not_implemented		// 18
#define erfc		MBC_TransFunc1_not_implemented		// 19
#define rint		MBC_TransFunc1_not_implemented		// 20

#define hypot		MBC_TransFunc2_not_implemented		// 4
#define copysign	MBC_TransFunc2_not_implemented		// 7
#define fmod		MBC_TransFunc2_not_implemented		// 8
#define nextafter	MBC_TransFunc2_not_implemented		// 9
#define remainder	MBC_TransFunc2_not_implemented		// 10

#else
#ifdef MSDOS

		// Nicht definierte Funktionen unter Windows
#define asinh		MBC_TransFunc1_not_implemented		// 9
#define acosh		MBC_TransFunc1_not_implemented		// 10
#define atanh		MBC_TransFunc1_not_implemented		// 11
#define erf			MBC_TransFunc1_not_implemented		// 18
#define erfc		MBC_TransFunc1_not_implemented		// 19
#define rint		MBC_TransFunc1_not_implemented		// 20

#define copysign	MBC_TransFunc2_not_implemented		// 7
#define fmod		MBC_TransFunc2_not_implemented		// 8
#define nextafter	MBC_TransFunc2_not_implemented		// 9
#define remainder	MBC_TransFunc2_not_implemented		// 10

#else
#if defined ULTRIX
#define copysign        MBC_TransFunc2_not_implemented          // 7
#define nextafter       MBC_TransFunc2_not_implemented          // 9
#define remainder       MBC_TransFunc2_not_implemented          // 10

#else
#if defined NEXTX86
#define copysign        MBC_TransFunc2_not_implemented          // 7
#define nextafter       MBC_TransFunc2_not_implemented          // 9
#define remainder       MBC_TransFunc2_not_implemented          // 10

#else
#if defined __EMX__

// Nicht definierte Funktione auf EMX/GCC
#define asinh           MBC_TransFunc1_not_implemented          // 9
#define acosh           MBC_TransFunc1_not_implemented          // 10
#define atanh           MBC_TransFunc1_not_implemented          // 11
#define erf             MBC_TransFunc1_not_implemented          // 18
#define erfc            MBC_TransFunc1_not_implemented          // 19

#define remainder       MBC_TransFunc2_not_implemented          // 10

#else
#if defined __linux__ || defined SGI || defined HP || defined RS6000

	// Nicht definierte Funktionen unter Linux, SGI, HP, RS600
#define nextafter	MBC_TransFunc2_not_implemented		// 9
#define remainder	MBC_TransFunc2_not_implemented		// 10

#endif
#endif
#endif
#endif
#endif
#endif

#endif // __MBC_not_implemented__

