#ifndef __MCT_tar_list__
#define __MCT_tar_list__

#include "MCT_tarfile.h"
#include <time.h>


#define kDefaultNumArchives		4
#define kDefaultUsedStamp		300


class MCLT_TarEntry
{
public:
	MCLT_TarFile	*tarFile;
	char			*tarName;
	int				hasFastIndex;
	long			usedStamp;
	short			inUse;
	time_t			timeStamp;
	
	MCLT_TarEntry()		{ tarFile = NULL; tarName = NULL; hasFastIndex = 0; usedStamp = kDefaultUsedStamp; inUse = 0; timeStamp = 0; }
	~MCLT_TarEntry()	{ if( tarFile ) delete tarFile; if( tarName ) delete[] tarName; }
};



class MCLT_TarList
{
private:
	MCLT_TarEntry	*itsTarList;
	int				itsNumArchives;
	int				itsMaxListSize;
	
public:
	
	MCLT_TarList();
	~MCLT_TarList();
	
	MCLT_TarFile	*FindTar(char *tarName );
	void			AgeTarFiles();

private:
	MCLT_TarFile	*OpenNew(char *tarName );
	int				AddToList(MCLT_TarFile *aTarFile, char *tarName, int hasFastIndex);

	void			XAgeTarFiles();
	void			CloseTarFile(int slotNr, int forceClose);
};

#endif
