/* $Date: 1998/03/02 09:51:35 $  $Author: kg $  $Revision: 1.61.2.1 $ */

/**************************************************************************/
/* FILE:             MEV_evaluate.h                                       */
/* Autor:            Andreas Kemper, Andreas Sorgatz                      */
/* Erstellt:         25/04/91                                             */
/* Letzte Aenderung: 05/08/97                                             */
/*                                                                        */
/* Ab Revision 1.37 (31.10.96) gibt es das Preprocessor-Flag NO_SPEC_BITS */ 
/* Hiermit werden die Abfragen auf die Special-Bits MINUS_BIT, DIV_BIT    */ 
/* und nicht mehr durchgef"uhrt, da davon ausgegangen wird, das keine     */ 
/* Funktion, insbesondere der Parser und der Simplifier, mehr solche Bits */ 
/* generieren.  (Oliver Kluge)                                            */
/* Ab Revision 1.45 (3.3.97) gibt es nur noch die Version ohne Special-   */ 
/* Bits. Das Flag NO_SPEC_BITS wurde entfernt.                            */
/**************************************************************************/

#ifndef __MEV_evaluate___
#define __MEV_evaluate___


#ifdef DOS_FILENAMES
#  include "MUP_typ.h"
#  include "MEV_evah.h"
#else
#  include "MEV_evaluate_help.h"
#endif


/**************************************************************************/
/* MEVTstamp -- IST NUN IN `MUP_types.h' DEFINIERT                        */
/**************************************************************************/
/* typedef long MEVTstamp ; */

#define MEVC_stamp_never              -1
#define MEVC_stamp_start               0
#define MEVC_stamp_infinity           2^31

/**************************************************************************/
/* MEVTrefreshoption                                                      */
/**************************************************************************/
typedef long MEVTrefreshoption ;

#define MEVC_refreshoption_assign       0
#define MEVC_refreshoption_push         1
#define MEVC_refreshoption_pop          1

/**************************************************************************/
/* Optionen f"ur die domain-Funktionen                                    */
/**************************************************************************/
#define MEEC_domoption_ass_part            1   /*Interne Konstante*/
#define MEEC_domoption_ass                 1
#define MEEC_domoption_exec                0L
#define MEEC_domoption_quick               2
#define MEEC_domoption_non_EXT_only        4
#define MEEC_domoption_EXT_only            8
#define MEEC_domoption_standard            0

#define MEEC_answer_ext                    1  /*Es wurde ein EXT-Element */
                                              /*gefunden*/
#define MEEC_answer_non_ext                2  /*Es wurde ein nicht EXT-  */
                                              /*Element gefunden.        */

/**************************************************************************/
/* Optionen f"ur die func_env-Funktionen                                  */
/**************************************************************************/
#define MEEC_func_envoption_standard       0


/**************************************************************************/
/* Deklaration globaler Variablen des Evaluierers.                        */
/**************************************************************************/

#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA( S_Pointer, MEVV_ASS_MEM_EXPR )
#endif
GLOBAL_DECL( S_Pointer, MEVV_ASS_MEM_EXPR );
#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA( S_Pointer, MEVV_ASS_MEM_IDENT )
#endif
GLOBAL_DECL( S_Pointer, MEVV_ASS_MEM_IDENT );
#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA( S_Pointer, MEVV_ASS_MEM_DOMAINS )
#endif
GLOBAL_DECL( S_Pointer, MEVV_ASS_MEM_DOMAINS );

#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA( short, MEVV_ERROR )
#endif
GLOBAL_DECL( short,    MEVV_ERROR );
#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA( short, MEVV_STATUS )
#endif
GLOBAL_DECL( short,    MEVV_STATUS );
extern short    MEVV_LegalOpTab[MEVC_MAX_OPERATORS][MEVC_MAX_OPERANDS] ;
extern char *   MEVV_LegalOpNam[MEVC_MAX_OPERATORS] ;

#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA( char*, MEVV_ERROR_STR )
#endif
GLOBAL_DECL( char*,    MEVV_ERROR_STR );

#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA( long, MEVV_ASSIGNED )
#endif
GLOBAL_DECL( long,      MEVV_ASSIGNED );
#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA( S_Pointer, MEVV_EVAL_LAST );
#endif
GLOBAL_DECL( S_Pointer, MEVV_EVAL_LAST );
#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA( S_Pointer, MEVV_INTERPRETER );
#endif
GLOBAL_DECL( S_Pointer, MEVV_INTERPRETER ) ;
#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA( S_Pointer, MEVV_OVERLOADED );
#endif
GLOBAL_DECL( S_Pointer, MEVV_OVERLOADED ) ;
#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA( MEVTstamp, MEVV_actual_stamp );
#endif
GLOBAL_DECL( MEVTstamp, MEVV_actual_stamp ) ;

VALUE_DECL( S_Pointer, MEVV_DOMAIN_ASS_MINUS );
#define MEVC_DOMAIN_NUM_ASS_MINUS                        1
VALUE_DECL( S_Pointer, MEVV_DOMAIN_ASS_DIV );
#define MEVC_DOMAIN_NUM_ASS_DIV                          2
VALUE_DECL( S_Pointer, MEVV_DOMAIN_ASS_NOT );
#define MEVC_DOMAIN_NUM_ASS_NOT                          3
VALUE_DECL( S_Pointer, MEVV_DOMAIN_ASS_EVALUATE );
#define MEVC_DOMAIN_NUM_ASS_EVALUATE                     4
VALUE_DECL( S_Pointer, MEVV_DOMAIN_ASS_OP );
#define MEVC_DOMAIN_NUM_ASS_OP                           5
VALUE_DECL( S_Pointer, MEVV_DOMAIN_ASS_NOPS );
#define MEVC_DOMAIN_NUM_ASS_NOPS                         6
VALUE_DECL( S_Pointer, MEVV_DOMAIN_ASS_SUBSOP );
#define MEVC_DOMAIN_NUM_ASS_SUBSOP                       7
VALUE_DECL( S_Pointer, MEVV_DOMAIN_ASS_SUBS );
#define MEVC_DOMAIN_NUM_ASS_SUBS                         8
VALUE_DECL( S_Pointer, MEVV_DOMAIN_ASS_TYPE );
#define MEVC_DOMAIN_NUM_ASS_TYPE                         9
VALUE_DECL( S_Pointer, MEVV_DOMAIN_ASS_DOMTYPE );
#define MEVC_DOMAIN_NUM_ASS_DOMTYPE                     10
VALUE_DECL( S_Pointer, MEVV_DOMAIN_ASS_NAME );
#define MEVC_DOMAIN_NUM_ASS_NAME                        11
VALUE_DECL( S_Pointer, MEVV_DOMAIN_ASS_POSTEVAL );
#define MEVC_DOMAIN_NUM_ASS_POSTEVAL                    12
VALUE_DECL( S_Pointer, MEVV_DOMAIN_ASS_ELEMATTR );
#define MEVC_DOMAIN_NUM_ASS_ELEMATTR                    13
VALUE_DECL( S_Pointer, MEVV_DOMAIN_ASS_KEY );
#define MEVC_DOMAIN_NUM_ASS_KEY                         14

VALUE_DECL( S_Pointer, MEVV_DOMAIN_ASS_EVALUATEFUNCTION );

#define MEVC_NUMBER_OF_QUICK_VALUES                     14

VALUE_DECL( S_Pointer, MEVV_DOMAIN_ASS_INDEX );
VALUE_DECL( S_Pointer, MEVV_DOMAIN_ASS_SETINDEX ); 
VALUE_DECL( S_Pointer, MEVV_DOMAIN_ASS_SETFUNCCALL ); 
VALUE_DECL( S_Pointer, MEVV_DOMAIN_ASS_NEW_EXTELEMENT );
VALUE_DECL( S_Pointer, MEVV_DOMAIN_ASS_DOMATTR );
VALUE_DECL( S_Pointer, MEVV_DOMAIN_ASS_SUBSEX );
VALUE_DECL( S_Pointer, MEVV_DOMAIN_ASS_NEW );
VALUE_DECL( S_Pointer, MEVV_DOMAIN_ASS_INDETS );
VALUE_DECL( S_Pointer, MEVV_OUTPUT );

extern S_Pointer MEVV_DOMAIN_INDEXARRAY[MEVC_NUMBER_OF_QUICK_VALUES+1] ;
extern S_Pointer MEEV_domain_array ;


/**************************************************************************/
/* MuPAD-Preferences (Steuerung von Kern-Einstellungen)                   */
/*                                                                        */
/* Initialisierung der durch Kommandozeilenparameter veraenderbaren Werte */
/* geschieht in MUT_first_init_pref.                                      */
/* S_Pointer werden erst in MUT_init_pref initialisiert (nach der         */
/* Speicheverwaltung !!!)                                                 */
/**************************************************************************/
typedef struct MEVS_pref {
	char  *promptstrg;      /* Prompt-Zeichenkette als C-String  */
	short  prompt;          /* Ausgabe des Kernel-Prompt: 0/1    */
	short  echo;            /* Echo der Kernel-Eingabe  : 0/1    */
        short  keeporder;       /* interne Ordnung bei Ausgabe bei-  */
                                /* behalten :  0/1                   */
	short  resprint;        /* Periodische Ausgabe der benutzten */
	                        /* Resourcen: 0=aus,1=oft..9=selten .*/
	long   maxmem;          /* Abbruch bei berschreiben von Re. */
	                        /* von xxMB Speicher: 0=kein Test.   */
	long   maxtime;         /* Abbruch bei berschreiben der Be- */
	                        /* von xxSec Rechenz.: 0=kein Test.  */
	char   floatformat[2];  /* Ausgabe von Floatzahlen: 'g','f'  */
	                        /* oder 'e'.                         */
	short  secure;          /* no system call, no modules        */
	MTcell callback;        /* is called periodically            */
	MTcell evalonexit;      /* is called when MuPAD quits        */
	MTcell output;          /* this function will be used for    */
	                        /* output.                           */
	MTcell postoutput;      /* Nach-Ausgabe z.B. fuer Type-Info  */
	short  typecheck;       /* Typechecking in procedures        */
	MTcell postinput;       /* Nach-Eingabe z.B. fuer Type-Info  */
	MTcell noprocremtab;    /* Einfuegen in procedure remember   */
                                /* table global abschalten           */
        short  moduletrace;     /* Ein Tracemodus fuer Module        */
	MTcell useroptions;     /* UserOptionen an den MuPAD Kern.   */
        char   matrixSeparator[5];/* Trennzeichen in Matrizen.       */
	short  debugOnTheFly;   /* Sollen Debug-Infos automatisch    */
	                        /* eingefuegt werden ?               */
	short  trailingZeroes;  /* Nullen in Floats entfernen ?      */
	short  ignoreNoDebug;   /* noDebug-Option ignorieren ?       */  
	short  printTimesDot;   /* Mutiplikationszeichen \cdot ?     */
} MEVT_pref;

#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA( MEVT_pref, MEVV_pref )
#endif
GLOBAL_DECL( MEVT_pref, MEVV_pref) ;

/**************************************************************************/
/* MuPAD-Interrupts (synchron, angestossen durch MEV_eval)                */
/**************************************************************************/

#define MEVC_INTERRUPT_THRESHOLD  1000      /* Schwellwert fuer Interrupt */

/*** Verwaltung synchroner MuPAD-Interrupts: MEVV_interrupt ****/
#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA( unsigned long, MEVV_interrupt )
#endif
GLOBAL_DECL( unsigned long, MEVV_interrupt);

/*** Globale user-definierte callback routine: MEVV_callback ***/

typedef  void (*MEVT_cbfunc)();     /*** Typ der CB-Funktion ***/

#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA( MEVT_cbfunc, MEVV_callback )
#endif
GLOBAL_DECL( MEVT_cbfunc, MEVV_callback );

/*** Verwaltung eines einfachen watchdogs via  'traperror'. ****/
#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA( unsigned long, MEVV_watchdog_reset )
#endif
GLOBAL_DECL( unsigned long, MEVV_watchdog_reset);


/**************************************************************************/
/* Zeitmessung fuer die vom Parser angestossenen Evaluierungen            */
/**************************************************************************/
#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA( unsigned long, MEVV_calctime )
#endif
GLOBAL_DECL( unsigned long, MEVV_calctime );


/**************************************************************************/
/* Weitere Deklarationen                                                  */
/**************************************************************************/
#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA( S_Pointer, MEVV_ASS_MEM_TAB_ARR_NAMES )
#endif
GLOBAL_DECL( S_Pointer, MEVV_ASS_MEM_TAB_ARR_NAMES );
#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA( MCLT_iostream ,     MEVV_profile )
#endif
GLOBAL_DECL( MCLT_iostream ,     MEVV_profile );
#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA( MUPbool,     MEVV_first_data )
#endif   
GLOBAL_DECL( MUPbool,     MEVV_first_data );
#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA( long, MEVV_prof_stat )
#endif   
GLOBAL_DECL( long,  MEVV_prof_stat );
#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA( MUPbool,   MDBV_trace )
#endif
GLOBAL_DECL( MUPbool,   MDBV_trace );
#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA( S_Pointer, MEVV_ARGS )
#endif
GLOBAL_DECL( S_Pointer, MEVV_ARGS );
#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA( S_Pointer, MEVV_ARGS_OLD )
#endif
GLOBAL_DECL( S_Pointer, MEVV_ARGS_OLD );
#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA( S_Pointer, MPHVcreated_referenceitems )
#endif
GLOBAL_DECL(S_Pointer, MPHVcreated_referenceitems) ;
#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA( long, MPHVnumber_created_referenceitems )
#endif
GLOBAL_DECL(long, MPHVnumber_created_referenceitems) ;

/**************************************************************************/
/* Definition von Makros zum Evaluierer.                                  */
/**************************************************************************/

#define MEV_level_reached(depth) \
(depth > MEVC_LEVEL_INF ? 1L : (GLOBAL_READ(MEVV_MAXLEVEL) != MEVC_LEVEL_INF && depth >= GLOBAL_READ(MEVV_MAXLEVEL) ? MEV_set_error(MEVC_RECURSIV_DEFINITION, "See ?MAXLEVEL") : (depth >= GLOBAL_READ(MEVV_LEVEL) ? 1L : 0L)))


#define MEV_header(s, null_mode, prev_func, eval_type, exec, flat_args, flat_type, args_out, bit, typecheck, dom_mode, dom_start, dom_end, dom_num) \
if (MEV_header_func(s, null_mode, prev_func, eval_type, exec, flat_args, flat_type, args_out, bit, typecheck, dom_mode, dom_start, dom_end, dom_num) == 1) return(*args_out);


#define MEV_header_1(s, null_mode, prev_func, eval_type, exec, flat_args, flat_type, args_out, bit, typecheck, dom_mode, dom_start, dom_end, dom_num) \
        if (MEV_header_func_1(s, null_mode, prev_func, eval_type, exec, flat_args, flat_type, args_out, bit, typecheck, dom_mode, dom_start, dom_end, dom_num) == 1) return(*args_out);


#define MEV_header_2(s, null_mode, prev_func, eval_type, exec, flat_args, flat_type, bit, typecheck)           	    \
        { S_Pointer args_out;											    \
          if (MEV_header_func_2(s, null_mode, prev_func, eval_type, exec, flat_args, flat_type, &args_out,          \
			    bit, typecheck) == 1)                                          			    \
	    return(args_out); }


#define MEV_remember(s,prev_func,eval_type,exec,args_in,args_out)                       \
        if (MEV_remember_func(s,prev_func,eval_type,exec,args_in, args_out) == 1)       \
	   { MMMfree(args_in);                                                          \
	     return(*args_out); }

#define MEV_domain(args_in,prev_func,eval_type,exec,first_ext,dom_mode,dom_start,dom_end,dom_num,args_out)                          \
        if (MEV_domain_func(args_in,prev_func,eval_type,exec,first_ext,dom_mode,dom_start,dom_end,dom_num,args_out) == 1)           \
	   { MMMfree(args_in);                                                                                                      \
	     return(*args_out); }



#define MEV_set_mam_control(s) \
	GLOBAL_WRITE(MEVV_MAM_CONTROL, GLOBAL_READ(MEVV_MAM_CONTROL) | s);

#define MEV_reset_mam_control(s) \
	GLOBAL_WRITE(MEVV_MAM_CONTROL, s);

#define MEV_get_mam_control() \
	GLOBAL_READ(MEVV_MAM_CONTROL);

#define MEV_combine_mam_hold(eval_type,mam_control)\
	(eval_type & MEVC_HOLD_BIT) ? ( mam_control | MAMC_NO_READ_DOWN | MAMC_NO_WRITE_DOWN) : mam_control


/*************************************************************************/
/* Weist dem Parameter 'long p' den akuellen Stackpointer des Stacks     */
/* zur Steuerung der Substitutionstiefe zu.                              */
/*************************************************************************/
#define MEV_get_depth_stack_pointer(p) \
	{ p = *MMMZ(&GLOBAL_READ(MEVV_DEPTH_STACK),long,MMMread); \
	  MMMinactiv(&GLOBAL_READ(MEVV_DEPTH_STACK)); }


/*************************************************************************/
/* Setzt den akuellen Stackpointer des Stacks zur Steuerung der          */
/* Substitutionstiefe auf den Wert 'long p '                             */
/*************************************************************************/
#define MEV_set_depth_stack_pointer(p) \
	{ *MMMZ(&GLOBAL_READ(MEVV_DEPTH_STACK),long,MMMwrite) = p; \
	  MMMinactiv(&GLOBAL_READ(MEVV_DEPTH_STACK)); }
	

/*************************************************************************/
/* Weist dem Parameter 'long p' den akuellen Stackpointer des Stacks     */
/* zur Steuerung des Assoziativen Speichers des Evaluierers zu.          */
/*************************************************************************/
#define MEV_get_mam_stack_pointer(p) \
	{ p = *MMMZ(&GLOBAL_READ(MEVV_MAM_STACK),long,MMMread); \
	  MMMinactiv(&GLOBAL_READ(MEVV_MAM_STACK)); }


/*************************************************************************/
/* Setzt den akuellen Stackpointer des Stacks zur Steuerung des          */
/* Assoziativen Speichers des Evaluierers auf den Wert 'long p '         */
/*************************************************************************/
#define MEV_set_mam_stack_pointer(p) \
	{ *MMMZ(&GLOBAL_READ(MEVV_MAM_STACK),long,MMMwrite) = p; \
	  MMMinactiv(&GLOBAL_READ(MEVV_MAM_STACK)); }
	
	
/*************************************************************************/
/* BOOLEAN MEV_is_CAT_EXT(S_Pointer *s)                                  */
/* Makro, um zu testen, ob es sich um ein CAT_EXT-Element handelt. Es    */
/* darf nicht direkt auf CAT_EXT getestet werden, da es sonst Probleme   */
/* mit Special-Bits gibt. Das Makro liefert TRUE, wenn es sich bei dem   */
/* Parameter um ein CAT_EXT-Element handelt, sonst FALSE.                */
/* s ist nach dem Makro aktiv.                                           */
/*************************************************************************/
#define MEV_is_CAT_EXT(s) \
                (MMMZ(s, CATEGORY, MMMread)->cat == CAT_EXT && MMMZ(s, CATEGORY, MMMread)->spec == 0)

/*************************************************************************/ 
/* BOOLEAN MEV_is_CAT_EXT1(S_Pointer *s, int cat)                        */ 
/* Beim Aufruf mu\3 gelten: cat = MMMZ(s, CATEGORY, MMMread)->cat.       */
/* Dieser Aufruf hat die gleiche Semantik wie MEV_is_CAT_EXT(s).         */
/* s ist nach dem Makro aktiv.                                           */ 
/*************************************************************************/ 
#define MEV_is_CAT_EXT1(s,cat) \
                (cat==CAT_EXT && MMMZ(s, CATEGORY, MMMread)->spec == 0)


/**************************************************************************/
/* Deklaration der Prozeduren des Evaluierers.                            */
/**************************************************************************/

typedef S_Pointer MEVT_evalfunction(S_Pointer, long, long) ;
extern MEVT_evalfunction     *MEVV_JumpTab[100];

/* Funktionen im Modul MEV_evaluate.c */

S_Pointer	MEV_execute		( S_Pointer s );

S_Pointer       MEV_eval_any            ( S_Pointer      s,
                                          long           prev_func,
                                          long           eval_type);

FUNC_POINTER	MEV_get_eval_func	( S_Pointer fe, S_Pointer *ex );
void		MEV_callback		( VOID );
void		MEV_interrupt		( VOID );
S_Pointer	MEV_eval		( S_Pointer	 s,
					  long		 prev_func,
					  long		 eval_type);
S_Pointer	MEV_eval_expr		( S_Pointer	 s,
					  long		 prev_func,
					  long		 eval_type);
S_Pointer       MEV_eval_unknown_function ( S_Pointer    s,
                                          long           prev_func,
                                          long           eval_type,
					  S_Pointer      func);
S_Pointer	MEV_eval_args		( S_Pointer	 s,
				          long           null_mode,
					  long		 prev_func,
					  long		 flat_arg,
					  long		 eval_type,
					  long           *first_ext);
S_Pointer	MEV_eval_args_index	( S_Pointer	 s,
					  long		 prev_func,
					  long		 flat_arg,
					  long		 eval_type); 
S_Pointer	MEV_eval_index		( S_Pointer	 s,
					  long		 prev_func,
					  long		 eval_type,
					  S_Pointer	 exec );
S_Pointer	MEV_eval_index_val      ( S_Pointer	 s,
					  long		 prev_func,
					  long		 eval_type,
					  S_Pointer	 exec );
S_Pointer 	MEV_index              ( S_Pointer	 s,
					  long		 prev_func,
					  long		 eval_type,
					  S_Pointer	 exec,
					  MUPbool        eval );
S_Pointer	MEV_eval_not		( S_Pointer	 s,
					  long		 prev_func,
					  long		 eval_type,
					  S_Pointer	 exec );
S_Pointer	MEV_eval_ident		( S_Pointer	 s,
					  long		 prev_func,
					  long		 eval_type);
S_Pointer	MEV_eval_set		( S_Pointer	 s,
					  long		 prev_func,
					  long		 eval_type);
S_Pointer	MEV_eval_stat_list	( S_Pointer	 s,
					  long		 prev_func,
					  long		 eval_type);
S_Pointer	MEV_eval_table		( S_Pointer	 s,
					  long		 prev_func,
					  long		 eval_type);
S_Pointer	MEV_eval_dyn_list	( S_Pointer	 s,
					  long		 prev_func,
					  long		 eval_type);
S_Pointer	MEV_eval_procd		( S_Pointer	 s,
					  long		 prev_func,
					  long		 eval_type);
S_Pointer	MEV_eval_array		( S_Pointer	 s,
					  long		 prev_func,
					  long		 eval_type);
S_Pointer	MEV_eval_func_env	( S_Pointer	 s,
					  long		 prev_func,
					  long		 eval_type);
S_Pointer	MEV_eval_exec		( S_Pointer	 s,
					  long		 prev_func,
					  long		 eval_type);
S_Pointer	MEV_eval_debug		( S_Pointer	 s,
					  long		 prev_func,
					  long		 eval_type);
S_Pointer	MEV_eval_nil		( S_Pointer	 s,
					  long		 prev_func,
					  long		 eval_type);
S_Pointer	MEV_eval_null		( S_Pointer	 s,
					  long		 prev_func,
					  long		 eval_type);
S_Pointer	MEV_eval_failed		( S_Pointer	 s,
					  long		 prev_func,
					  long		 eval_type);
S_Pointer	MEV_eval_dom		( S_Pointer	 s,
					  long		 prev_func,
					  long		 eval_type);
S_Pointer	MEV_eval_ext		( S_Pointer	 s,
					  long		 prev_func,
					  long		 eval_type);
S_Pointer	MEV_eval_poly		( S_Pointer	 s,
					  long		 prev_func,
					  long		 eval_type);
void		MEV_init		( VOID );
void		MEV_re_init		( VOID );	/* MEV_reset gibts schon */
void		MEV_exit		( VOID );
S_Pointer	MEV_eval_overload	( S_Pointer	 s,
					  long		 prev_func,
					  long		 eval_type,
					  S_Pointer	 exec );
S_Pointer	MEV_eval_overloaded	( S_Pointer	 s,
					  long		 prev_func,
					  long		 eval_type,
					  S_Pointer	 exec );
S_Pointer	MEV_eval_interpreter	( S_Pointer	 s,
					  long		 prev_func,
					  long		 eval_type,
					  S_Pointer	 proc );
S_Pointer	MEV_eval_procdef	( S_Pointer	 s,
					  long		 prev_func,
					  long		 eval_type,
					  S_Pointer      exec);
S_Pointer	MEV_eval_sys_func_args	( S_Pointer	 s,
					  long		 prev_func,
					  long		 eval_type,
					  S_Pointer	 exec );
void     	MEV_check_local_formals     ( S_Pointer	 s);
void     	MEV_push_local_formals      ( S_Pointer 	proc, 
                                          S_Pointer 	formal_args,
                                          S_Pointer 	local_args,
                                          S_Pointer     funcname,
                                          MUPbool       DoTypeCheck);
S_Pointer	MEV_pop_local_formals       ( S_Pointer 	proc,  
                                          MUPbool 	read_local);
void		MEV_normalize_options       ( S_Pointer 	  *s );
void		MEV_check_options	        ( S_Pointer 	   s );
void		MEV_check_typ               (S_Pointer, 
                                         S_Pointer, 
                                         S_Pointer,
                                         S_Pointer  );
S_Pointer       MEV_eval_purefunc       ( S_Pointer        s,
                                          long             prev_func,
                                          long             eval_type,
                                          S_Pointer        exec ) ;
S_Pointer       MEV_eval_purefunc_hold ( S_Pointer        s,
                                          long             prev_func,
                                          long             eval_type,
                                          S_Pointer        exec ) ;
S_Pointer       MEV_eval_newpurefunc    ( S_Pointer        s,
                                          long             prev_func,
                                          long             eval_type,
                                          S_Pointer        exec ) ;
S_Pointer       MEV_eval_newfuncarg     ( S_Pointer        s,
                                          long             prev_func, 
                                          long             eval_type, 
                                          S_Pointer        exec ) ;
long		MEV_eval_bool		( S_Pointer s );
long            MEV_eval_bool1          (S_Pointer s, S_Pointer *result) ;
void		MEV_refresh_ass_mem	( MEVTrefreshoption	option,
					  MSTTinfo		info,
					  MEVTstamp		stamp,
					  long			procdepth );
void		MEV_clear_ass_mem	( VOID );
void		MEV_clear_ass_mem_simplifier	( VOID );
void		MEV_init_ass_mem_ident	( long mem_typ, long size );
void		MEV_init_ass_mem_expr	( long mem_typ, long size );
void		MEV_init_ass_mem_simplifier	( long mem_typ, long size );
void		MEV_delete_ass_mem_simplifier	( VOID );
void		MEV_init_LegalOpTab	( VOID );

long		MEV_set_error		( long err_nr, char *err_str Mva_arglist);

S_Pointer	MEV_eval_gprof		( S_Pointer	 root,
					  long		 prev_func,
					  long		 eval_type,
					  S_Pointer	 exec );
void		MEV_gen_prof_data	( S_Pointer name, 
					  long depth,
					  long total_time,
					  long args_time );
S_Pointer	MEV_func_env_in		( S_Pointer func, S_Pointer ass );
void		MEV_func_env_insert	( S_Pointer *func, 
					  S_Pointer ass, 
					  S_Pointer erg );

S_Pointer       MEV_eval_float_gen      ( S_Pointer	 s,
					  long		 prev_func,
					  long		 eval_type,
					  S_Pointer	 exec );

short MEV_header_func(   S_Pointer         s,               
	       		 long              null_mode,       
	      		 long              prev_func, 	   
	      		 long              eval_type,      
               		 S_Pointer 	   exec,           
	       		 long              flat_arg,	   
			 long              flat_type,      
	      		 S_Pointer         *args, 	   
	      		 long              bits,	   
	      		 long              type_check,      
			 long              dom_mode,
			 long              dom_start,
			 long		   dom_end,       
			 long              dom_num);     

short MEV_header_func_1(S_Pointer       s,                                                    
	 	        long            null_mode,      
	 	        long            prev_func, 	    
	   	        long            eval_type,       
          	        S_Pointer 	exec,            
	      	     	long            flat_arg,	    
			long            flat_type,       
	           	S_Pointer       *args, 	    
	           	long            bits,	   
	           	long            type_check,      
                  	long            dom_mode,        
		   	long            dom_start,       
		   	long            dom_end,        
                   	long            dom_num);       
 

short MEV_header_func_2(S_Pointer       s,                                                    
	 	        long            null_mode,      
	 	        long            prev_func, 	    
	   	        long            eval_type,       
          	        S_Pointer 	exec,            
	      	     	long            flat_arg,	    
			long            flat_type,       
	           	S_Pointer       *args, 	    
	           	long            bits,	   
	           	long            type_check);    



short MEV_remember_func(  S_Pointer       s,
	         	long              prev_func, 
	         	long              eval_type, 
                	S_Pointer 	  exec, 
	         	S_Pointer         args_in,
	         	S_Pointer         *args_out);


short 
MEV_domain_func (  S_Pointer        s,            
                   long             prev_func,    
                   long             eval_type,    
                   S_Pointer        exec,         
                   long             first_ext,     
                   long             dom_mode,
		   long             dom_start,
		   long             dom_end,    
                   long             dom_num,       
		   S_Pointer        *args);       


long MEV_first_ext(S_Pointer s, long mode); 

/* MAM-Control Steuerung */

void MEV_push_mam_stack(VOID);
void MEV_pop_mam_stack(VOID);
void MEV_init_mam_stack(VOID);
void MEV_reset_mam_stack(VOID);


/* DEPTH-Steuerung */

void MEV_push_depth_stack(unsigned long newitem);
void MEV_pop_depth_stack(VOID);
void MEV_init_depth_stack(VOID);
void MEV_reset_depth_stack(VOID);



/* Funktionen im Modul MEV_operator.c */

S_Pointer MEV_eval_op_plusmult(S_Pointer s, long prev_func, long eval_type, S_Pointer exec) ;
S_Pointer MEV_eval_op_power(S_Pointer s, long prev_func, long eval_type, S_Pointer exec) ;
S_Pointer MEV_eval_op_fconcat(S_Pointer s, long prev_func, long eval_type, S_Pointer exec) ;
S_Pointer MEV_eval_op_fconcatpower(S_Pointer s, long prev_func, long eval_type, S_Pointer exec) ;
S_Pointer
MEV_eval_domainfunccall( S_Pointer s, long prev_func, long eval_type, S_Pointer exec ) ;


/* Funktionen im Modul MEE_utils.c */

S_Pointer MEE_find_number_for_code(S_Pointer s) ;
S_Pointer MEE_find_code_for_number(S_Pointer s) ;
S_Pointer MEE_eval_func_env(S_Pointer s, long prev_func, long eval_type, S_Pointer exec) ;
S_Pointer MEE_eval_built_in(S_Pointer s, long prev_func, long eval_type, S_Pointer exec) ;
S_Pointer MEE_copy(S_Pointer s, S_Pointer arg1, S_Pointer arg2, S_Pointer eval_arg1, S_Pointer eval_arg2, MUPbool changes, MUPbool two_para) ;
S_Pointer MEE_eval_volatile(S_Pointer s, long prev_func, long eval_type, S_Pointer exec) ;
S_Pointer MEE_eval_unvolatile(S_Pointer s, long prev_func, long eval_type, S_Pointer exec) ;
S_Pointer MEE_eval_funcattr(S_Pointer s, long prev_func, long eval_type, S_Pointer exec) ;
S_Pointer MEE_func_env_ass_callm(long option, S_Pointer ass, S_Pointer fe, S_Pointer seq, long prev_func, long eval_type, long start, long end) ;
S_Pointer MEE_eval_context(S_Pointer s, long prev_func, long eval_type, S_Pointer exec) ;




/* Funktionen im Modul MEE_eval_expr.c */

S_Pointer MEE_eval_exprseq(S_Pointer s, long prev_func, long eval_type, S_Pointer exec);
S_Pointer MEE_eval_or(S_Pointer s, long prev_func, long eval_type, S_Pointer exec);
S_Pointer MEE_eval_and(S_Pointer s, long prev_func, long eval_type, S_Pointer exec);
S_Pointer MEE_eval_seqgen(S_Pointer s, long prev_func, long eval_type, S_Pointer exec);
S_Pointer MEE_eval_less(S_Pointer s, long prev_func, long eval_type, S_Pointer exec);
S_Pointer MEE_eval_leequal(S_Pointer s, long prev_func, long eval_type, S_Pointer exec);
S_Pointer MEE_eval_equal(S_Pointer s, long prev_func, long eval_type, S_Pointer exec);
S_Pointer MEE_eval_unequal(S_Pointer s, long prev_func, long eval_type, S_Pointer exec);
S_Pointer MEE_eval_range(S_Pointer s, long prev_func, long eval_type, S_Pointer exec);
S_Pointer MEE_eval_mod(S_Pointer s, long prev_func, long eval_type, S_Pointer exec);
S_Pointer MEE_eval_modp(S_Pointer s, long prev_func, long eval_type, S_Pointer exec);
S_Pointer MEE_eval_mods(S_Pointer s, long prev_func, long eval_type, S_Pointer exec);
S_Pointer MEE_eval_div(S_Pointer s, long prev_func, long eval_type, S_Pointer exec);
S_Pointer MEE_eval_union(S_Pointer s, long prev_func, long eval_type, S_Pointer exec);
S_Pointer MEE_eval_minus(S_Pointer s, long prev_func, long eval_type, S_Pointer exec);
S_Pointer MEE_eval_intersect(S_Pointer s, long prev_func, long eval_type, S_Pointer exec);
S_Pointer MEE_eval_plus(S_Pointer s, long prev_func, long eval_type, S_Pointer exec);
S_Pointer MEE_eval_mult(S_Pointer s, long prev_func, long eval_type, S_Pointer exec);
S_Pointer MEE_eval_power(S_Pointer s, long prev_func, long eval_type, S_Pointer exec);
S_Pointer MEE_eval_concat(S_Pointer s, long prev_func, long eval_type, S_Pointer exec);
S_Pointer MEE_eval_fconcat(S_Pointer s, long prev_func, long eval_type, S_Pointer exec);

S_Pointer MEE_eval_negate(S_Pointer s, long prev_func, long eval_type, S_Pointer exec);
S_Pointer MEE_eval_invert(S_Pointer s, long prev_func, long eval_type, S_Pointer exec);
S_Pointer MEE_eval_divex(S_Pointer s, long prev_func, long eval_type, S_Pointer exec);
S_Pointer MEE_eval_subtract(S_Pointer s, long prev_func, long eval_type, S_Pointer exec);




/* Funktionen im Modul MEE_domain.c */

S_Pointer MEE_get_domain(S_Pointer key, MUPbool *is_new) ;
S_Pointer MEE_read_domain(short cat) ;
void MEE_write_domain(short cat, S_Pointer domain) ;
S_Pointer MEE_eval_new_extelement(S_Pointer s, long prev_func, long eval_type, S_Pointer exec) ;
S_Pointer MEE_eval_new_domain(S_Pointer s, long prev_func, long eval_type, S_Pointer exec) ;
S_Pointer MEE_domain_inquick(S_Pointer dom, long count) ;
S_Pointer MEE_domain_in(S_Pointer dom, S_Pointer ass) ;
#ifdef DEADCODE
void      MEE_domain_insertquick(S_Pointer *dom, long count, S_Pointer value) ;
S_Pointer MEE_eval_domattrquick(S_Pointer s, long prev_func, long eval_type, S_Pointer exec) ;
#endif
void      MEE_domain_initialize_quickreference(S_Pointer result, MUPbool delet) ;
void      MEE_domain_actualize_quickreference(S_Pointer help, S_Pointer ass, S_Pointer value) ;
MUPbool   MEE_domain_insert(S_Pointer *dom, S_Pointer ass, S_Pointer value) ;
S_Pointer MEE_eval_domattr(S_Pointer s, long prev_func, long eval_type, S_Pointer exec) ;
S_Pointer MEE_domain_ass_call1(long option, S_Pointer ass, S_Pointer domelem, long prev_func, long eval_type) ;
S_Pointer MEE_domain_ass_call1quick(long option, long ass, S_Pointer domelem, long prev_func, long eval_type) ;
S_Pointer MEE_domain_ass_callm(long option, S_Pointer ass, S_Pointer seq, long prev_func, long eval_type, long start, long end, long domstart, long domend, long *answer) ;
S_Pointer MEE_domain_ass_callmquick(long option, long ass, S_Pointer seq, long prev_func, long eval_type, long start, long end, long domstart, long domend, long *answer) ;

void MEE_free_unused(VOID);


/*** Funktionen im Modul MEE_eval_arith.c ***********************/

S_Pointer MEE_mult_const(S_Pointer s, long prev_func);



/*** Konstanten und Funktionen im Modul MES_eval_stmt.c ***********************/

#define MESC_VALUE  1	
#define MESC_IDENT  2
#define MESC_INDEX  3
#define MESC_FUNC   4

void	  MES_eval		( S_Pointer s );
S_Pointer MES_eval_assign 	( S_Pointer	 s,
				  long		 prev_func,
				  long		 eval_type,
				  S_Pointer	 exec );
S_Pointer MES_eval_unassign 	( S_Pointer	 s,
				  long		 prev_func,
				  long		 eval_type,
				  S_Pointer	 exec );
S_Pointer MES_eval_sysassign    ( S_Pointer      s,
                                  long           prev_func,
                                  long           eval_type,
                                  S_Pointer      exec );
S_Pointer MES_assign_intern     ( S_Pointer      s,
                                  long           prev_func,
                                  long           eval_type,
                                  S_Pointer      exec,
                                  long           force );
S_Pointer MES_eval_if 		( S_Pointer	 s,
				  long		 prev_func,
				  long		 eval_type,
				  S_Pointer	 exec );
S_Pointer MES_eval_case 	( S_Pointer	 s,
				  long		 prev_func,
				  long		 eval_type,
				  S_Pointer	 exec );
S_Pointer MES_eval_for 		( S_Pointer	 s,
				  long		 prev_func,
				  long		 eval_type,
				  S_Pointer	 exec );
S_Pointer MES_eval_for_par	( S_Pointer	 s,
				  long		 prev_func,
				  long		 eval_type,
				  S_Pointer	 exec );
S_Pointer MES_eval_for_down	( S_Pointer	 s,
				  long		 prev_func,
				  long		 eval_type,
				  S_Pointer	 exec );
S_Pointer MES_eval_for_in	( S_Pointer	 s,
				  long		 prev_func,
				  long		 eval_type,
				  S_Pointer	 exec );
S_Pointer MES_eval_for_in_par	( S_Pointer	 s,
				  long		 prev_func,
				  long		 eval_type,
				  S_Pointer	 exec );
S_Pointer MES_eval_while	( S_Pointer	 s,
				  long		 prev_func,
				  long		 eval_type,
				  S_Pointer	 exec );
S_Pointer MES_eval_repeat	( S_Pointer	 s,
				  long		 prev_func,
				  long		 eval_type,
				  S_Pointer	 exec );
S_Pointer MES_eval_next		( S_Pointer	 s,
				  long		 prev_func,
				  long		 eval_type,
				  S_Pointer	 exec );
S_Pointer MES_eval_break	( S_Pointer	 s,
				  long		 prev_func,
				  long		 eval_type,
				  S_Pointer	 exec );
S_Pointer MES_eval_quit		( S_Pointer	 s,
				  long		 prev_func,
				  long		 eval_type,
				  S_Pointer	 exec );
S_Pointer MES_eval_parbegin	( S_Pointer	 s,
				  long		 prev_func,
				  long		 eval_type,
				  S_Pointer	 exec );
S_Pointer MES_eval_stmtseq	( S_Pointer	 s,
				  long		 prev_func,
				  long		 eval_type,
				  S_Pointer	 exec );
S_Pointer MES_eval_return	( S_Pointer	 s,
				  long		 prev_func,
				  long		 eval_type,
				  S_Pointer	 exec );

long      MES_is_proc            ( S_Pointer	 s );
S_Pointer MES_eval_domattr_lhs   ( S_Pointer	 s,
				   short	 ins_type,
				   S_Pointer	*list );
S_Pointer MES_new_formal_rem_proc( );
S_Pointer MES_eval_lhs		 ( S_Pointer	 s,
				   short	 ins_type, 
				   S_Pointer	*list,
                                   MUPbool      *change_it);
void      MES_assign_lhs_list	 ( S_Pointer	*list,
				   S_Pointer	 value,
                                   long          force,
                                   MUPbool       change_it);
S_Pointer MES_build_name         (S_Pointer	 list );



#endif /* __MEV_evaluate___ */
