/* $Date: 1997/09/01 13:24:52 $  $Author: olli $  $Revision: 1.33 $ */

/**************************************************************************/
/* FILE:             MEV_evaluate_help.h                                  */
/* Autor:            Andreas Kemper                                       */
/* Erstellt:         30/07/91                                             */
/* Letzte Aenderung: 03/03/97                                             */
/**************************************************************************/

#ifndef __MEV_evaluate_help__
#define __MEV_evaluate_help__


/*** Konstanten zur Identifikation der Systemoperatoren und Typen  *****/

#define MEVC_ANY           0
#define MEVC_EXPRSEQ       1
#define MEVC_OR            2
#define MEVC_AND           3
#define MEVC_SEQGEN        4
#define MEVC_LESS          5
#define MEVC_LEEQUAL       6
#define MEVC_EQUAL         7
#define MEVC_UNEQUAL       8
#define MEVC_RANGE         9
#define MEVC_MOD          10
#define MEVC_DIV          11
#define MEVC_UNION        12
#define MEVC_MINUS        13
#define MEVC_INTERSECT    14
#define MEVC_PLUS         15
#define MEVC_MULT         16
#define MEVC_POWER        17
#define MEVC_CONCAT       18
#define MEVC_FCONCAT      19
#define MEVC_POLY         20
#define MEVC_STMT         21
#define MEVC_UNKNOWN      22

#define MEVC_SIGN         23

#define MEVC_APM          24
#define MEVC_FLOAT        25
#define MEVC_INT          26
#define MEVC_RAT          27
#define MEVC_COMPLEX      28
#define MEVC_STRING       29
#define MEVC_BOOL         30
#define MEVC_IDENT        31
#define MEVC_SET          32
#define MEVC_DYN_LIST     33
#define MEVC_STAT_LIST    34
#define MEVC_ARRAY        35
#define MEVC_TABLE        36
#define MEVC_PROCDEF      37
#define MEVC_NULL         38
#define MEVC_NIL          39
#define MEVC_FUNC_ENV     40
#define MEVC_EXEC         41
#define MEVC_PROC         42
#define MEVC_DOM          43
#define MEVC_EXT          44
#define MEVC_FAILED       45
#define MEVC_POINT        46
#define MEVC_POLYGON      47
#define MEVC_FUNCARG      48
#define MEVC_NAMESPACE    49
#define MEVC_BYTECODE     50


#define MEVC_ASSIGN       60 
#define MEVC_IF           61
#define MEVC_CASE         62
#define MEVC_FOR          63
#define MEVC_FOR_PAR      64 
#define MEVC_FOR_DOWN     65 
#define MEVC_FOR_IN       66 
#define MEVC_FOR_IN_PAR   67 
#define MEVC_WHILE        68 
#define MEVC_REPEAT       69 


#define MEVC_NEXT         70 
#define MEVC_BREAK        71 
#define MEVC_QUIT         72 

#define MEVC_PARBEGIN     73 
#define MEVC_SEQBEGIN     74 
#define MEVC_STMTSEQ      75
#define MEVC_RETURN       76


#define MEVC_CONTINUE    100

#define MEVC_NO_TYPE_CHECK  100  /* Steuert die Typpr"ufung mit LegalOp  */
				 /* im Macro 'MEV_header()'              */


/************** Typen zur Evaluierung *******************/

#define MEVC_EVAL                	  0L
#define MEVC_TYPE_CHECK          	  1L
#define MEVC_SIMPLIFY           	  2L
#define MEVC_SIMPLIFY_ONE        	  4L

#define MEVC_FLOAT_BIT           	  8L
#define MEVC_BOOL_BIT           	 16L
#define MEVC_EVAL_BIT           	 32L
#define MEVC_HOLD_OPERATOR_BIT		 64L
#define MEVC_NO_EVAL_ARGS_BIT  		128L
#define MEVC_HOLD_BIT          		256L
#define MEVC_FUNC_BIT                   512L

/************** Modi fuer MEV_eval_args *****************/

#define MEVC_NULL_DEFAULT                 0L
#define MEVC_HOLD_NULL_BIT             2048L
#define MEVC_HOLD_LAST_NULL_BIT        4096L


/************* Modi fuer das Ueberladen *****************/

#define MEVC_NO_OVERLOAD                    0L
#define MEVC_OVERLOAD                       1L
#define MEVC_QUICK_DOM                      2L
#define MEVC_NO_OVERLOAD_ERROR              4L
#define MEVC_CHECK_BASE_DOMAINS             8L


/************* Modi beim Scannen von CAT_FAIL **********/

#define MEVC_SCAN_FAIL                    512L
#define MEVC_FAIL_DETECTED                 -1L


/***********************************************************************/
/* Macro zum Ausblenden der Argumente MEVC_BOOL_BIT und MEVC_FLOAT_BIT */
/* innerhalb des Evaluierers. Das Macro ist auf den Evaluierungstyp    */
/* anzuwenden.                                                         */
/***********************************************************************/

#define MEV_reset(s)  s &= (~(MEVC_BOOL_BIT | MEVC_FLOAT_BIT))
                     


/************** Weitere Konstanten **********************/

#define MEVC_STORAGE              MMMCglobal
#define MEVC_MAX_OPERANDS         50                   /* Gr"o"se der LegalOpTab */
#define MEVC_MAX_OPERATORS        24                   /* Gr"o"se der LegalOpTab */
#define MEVC_SIGN_OPERAND         MEVC_SIGN
#define MEVC_SIGN_OPERATOR        MEVC_MAX_OPERANDS-1
#define MEVC_LEGAL                 0
#define MEVC_MAX_TYPES            80   /* Maximale Anzahl von MEVC_TYPEN */

#define MEVC_MAM_STACK_SIZE       500
#define MEVC_DEPTH_STACK_SIZE     500


/******************** Abkuerzungen **********************/

#define MEVC_NO_SIGN_ALLOWED         (MINUS_BIT | DIV_BIT | NOT_BIT)
#define MEVC_STMT_SIGN_ALLOWED       (MINUS_BIT | DIV_BIT | NOT_BIT)
#define MEVC_NOT_SIGN_ALLOWED        (DIV_BIT | MINUS_BIT)
#define MEVC_MINUS_SIGN_ALLOWED      (NOT_BIT | DIV_BIT)
#define MEVC_MINUS_NOT_SIGN_ALLOWED  DIV_BIT
#define MEVC_ARITHM_SIGN_ALLOWED     NOT_BIT
#define MEVC_ALL_SIGN_ALLOWED        0


/***************** Fehlermeldungen **********************/

/* WICHTIG: Die MuPAD-Library-Datei SHARE/errmess.mu    */
/*          enthaelt ebenfalls diese Fehlernummern.     */
/*          Die bislang vergebenen Nummern sollten      */
/*          prinzipiell nicht geaendert werden!         */
/*          Neue Nummern sollten also auch in der       */
/*          Library-Datei nachgehalten werden.          */

#define MEVC_ILLEGAL_OPERAND  		1001
#define MEVC_STMT_IN_EXPR        	1002
#define MEVC_CANT_EVAL_BOOL      	1003
#define MEVC_WRONG_NUMBER_OF_ARGS  	1004
#define MEVC_ILLEGAL_ARGUMENT    	1005
#define MEVC_REAL_NUMBER_EXPECTED 	1006
#define MEVC_IO_WRITE_ERROR           	1007
#define MEVC_ERROR               	1008
#define MEVC_SIGN_ERROR         	1009
#define MEVC_RECURSIV_DEFINITION	1010
#define MEVC_INVALID_ASSIGNMENT		1011
#define MEVC_OUT_OF_RANGE		1012
#define MEVC_INTEGER_NUMBER_EXPECTED	1013
#define MEVC_SYSTEM_ERROR		1014
#define MEVC_OPERAND_DOES_NOT_EXIST	1015
#define MEVC_INVALID_RANGE		1016
#define MEVC_INVALID_INDEX              1017
#define MEVC_SUBSTITUTION_NOT_ALLOWED   1018
#define MEVC_INVALID_FUNCTION           1019
#define MEVC_STRING_TOO_LONG		1020
#define MEVC_IO_READ_ERROR           	1021
#define MEVC_INDEX_RANGE		1022
#define MEVC_INDEX_TYP			1023
#define MEVC_DIMENSION			1024
#define MEVC_DIVISION_BY_ZERO		1025
#define MEVC_POS_INTEGER_EXPECTED	1026
#define MEVC_RESET_IN_USER_PROC         1027
#define MEVC_USER_DEFINED_ERROR         1028
#define MEVC_INTEGER_TOO_LARGE		1029
#define MEVC_UNKNOWN_OPTION		1030
#define MEVC_NO_INDETS			1031
#define MEVC_ILLEGAL_INDET		1032
#define MEVC_NO_POLYNOMIAL		1033
#define MEVC_UNKNOWN_TYPE		1034
#define MEVC_NOT_IMPLEMENTED		1035
#define MEVC_MISSING_DOM_ATTR		1036
#define MEVC_CONTEXT_NOT_ALLOWED        1037
#define MEVC_RETURNVALUE_NOT_ALLOWED    1038
#define MEVC_ILLEGAL_COLOR              1039
#define MEVC_EXPONENT_OVERFLOW          1040
#define MEVC_WRONG_EXEC                 1041
#define MEVC_POSITIVE_VALUE_EXPECTED    1042
#define MEVC_BAD_UNKNOWN                1043
#define MEVC_WATCHDOG                   1044
#define MEVC_ARGUMENT_FAILED            1045
#define MEVC_WRITE_PROTECED_ASSIGNMENT  1046
#define MEVC_WRITE_PROTECED_LOCAL       1047
#define MEVC_NO_ATOMAR_TYPE             1048

#define MEVC_ALREADY_EXECUTED_ERROR     1050
#define MEVC_SYNTAX_ERROR_IN_READ       1051

#define MEVC_UNKNOWN_EXTERN_OBJECT      1100
#define MEVC_UNKNOWN_OPERATOR           1101
#define MEVC_INTERUPTED_BY_USER         1102
#define MEVC_INTERNAL_ERROR             1103
#define MEVC_ILLEGAL_CONTEXT            1104
#define MEVC_COEFF_RING			1105
#define MEVC_FATAL_ERROR		1106
#define MEVC_SECURITY_ALERT             1107
#define MEVC_NON_NEG_INTEGER            1108
#define MEVC_DUPLICATE_DOMAIN_KEY	1109
#define MEVC_ILLEGAL_DOMAIN_KEY		1110
#define MEVC_INVALID_PASSWORD		1111
#define MEVC_CAN_NOT_REGISTER		1112

#define MEVC_PLOT_ERROR                 1201
#define MEVC_OWN_ERR_MESS               1202

#define MEVC_OUT_OF_MEMORY		1300
#define MEVC_DEMO_OUT_OF_MEMORY         1301


#define MEVC_TIME_EXEEDED               1320


/***** Zu beachten ist der Kommentar zu Beginn ******/
/***** der Auflistung der Fehlernummern !!!!!! ******/


/*********** Warnungs- uns Messagenummern *************/

#define MEVC_NOT_FOUND                  2000
#define MEVC_INPUT_PROMPT               2001
#define MEVC_TEXTINPUT_PROMPT           2002



 
/***************** Funktions-Makros *********************/

#define MEV_LegalOp(s,f,pf)                                                 \
{                                                                           \
    GLOBAL_WRITE(MEVV_ERROR, MEVV_LegalOpTab[pf][f]) ;                      \
    if (GLOBAL_READ(MEVV_ERROR)) {                                          \
        GLOBAL_WRITE(MEVV_ERROR_STR, MEVV_LegalOpNam[pf]) ;                 \
        MEV_set_error(GLOBAL_READ(MEVV_ERROR),GLOBAL_READ(MEVV_ERROR_STR)); \
    }                                                                       \
}

#endif /* __MEV_evaluate_help__ */

