/* $Date: 1997/11/21 11:36:20 $  $Author: maradim $  $Revision: 1.25 $ */

/**************************************************************************
**                           MEX_extern.h                                **
** In diesem File werden alle externen Header, d.h. Header die nicht     **
** selbst zu MuPAD gehoeren, included. In keinem anderen File duerfen    **
** solche Header included werden.                                        **
** Ausserdem werden in desem File die externen Funktinen entsprechend    **
** deklariert oder definiert.                                            **
** Autor             : Holger Naundorf                                   **
** Erstellt          : 28/01/92                                          **
** Letzte Aenderung  : 21/11/97                                          **
**************************************************************************/

#ifndef __MEX_extern__
#define __MEX_extern__


#ifdef MEXDALL
#   ifndef MEXDSTANDARD
#      define MEXDSTANDARD
#   endif
#   ifndef MEXDGRAPHIC
#      define MEXDGRAPHIC
#   endif
#   ifndef MEXDSYSTEM
#      define MEXDSYSTEM
#   endif
#endif


#ifndef MEXDSTANDARD_yet
#ifdef  MEXDSTANDARD
#define MEXDSTANDARD_yet

/********* Standard-Header ***********************************************/

#if defined OSF
#   include <standards.h>
#endif

#include <stdio.h>
#include <signal.h>

#ifdef MMMDTHREAD
#   include <thread.h>
#endif /* MMMDTHREAD */

#ifndef C_PLUSPLUS
#   if !(defined MACINTOSH || defined sequent || defined __FreeBSD__ || defined __NetBSD__ || defined NEXTX86)
#      include <malloc.h>
#   endif
#else
#   include <stdlib.h>
#endif

/* #include <gdd.h> */

#ifndef MEXDsetjmp_yet
#   define MEXDsetjmp_yet

    /*** Dirty trick fuer HP: In den C++ inlcude gibt es dort ***/
    /*** einen Fehler, wodurch die Variable  __EH_JMPBUF_TEMP ***/
    /*** in header definiert  (statt deklariert) wird und der ***/
    /*** somit nich gelinkt werden kann.  Darum wird hier das ***/
    /*** ANSI-C include eingebunden.                          ***/
    #ifdef HP
    #include        "/usr/include/setjmp.h"
    #else
    #include        <setjmp.h>
    #endif

#   include <setjmp.h>
#endif

#if defined(__EMX__) && defined(_PRINT)
  #undef _PRINT
  #include <ctype.h>
  #undef _PRINT
  #define _PRINT 70
#else
  #include <ctype.h>
#endif

#if defined MACINTOSH || defined MSDOS
#   include <stdlib.h>
#   include <time.h>
#      ifdef MACINTOSH
#         include <unix.h>
#      else
#         include <dos.h>
#      endif
#elif defined __EMX__
#   include <sys/times.h>
#   include <sys/ioctl.h>
#   include <sys/termio.h>
#   include <sys/kbdscan.h>
#else /* UNIX */
#   include <errno.h>
#   include <unistd.h>
#   include <sys/time.h>
#   if defined RS6000
#      include <time.h>
#   endif
#endif

#ifdef sequent
#   include <strings.h>
#elif defined OSF
#   include <stdlib.h>
#else
#   include <stdlib.h>
#   include <string.h>
#endif

#endif /* MEXDSTANDARD */
#endif /* MEXDSTANDARD_yet */


#ifndef MEXDGRAPHIC_yet
#ifdef  MEXDGRAPHIC
#define MEXDGRAPHIC_yet
#ifndef MACINTOSH
/********* X-Header ******************************************************/
#include <xview/xview.h>
#include <xview/textsw.h>
#include <xview/panel.h>
#include <xview/server.h>
#include <xview/seln.h>
#include <xview/xview.h>
#include <xview/icon_load.h>
#include <xview/scrollbar.h>
#include <xview/svrimage.h>
#include <xview/termsw.h>
#include <xview/text.h>
#include <xview/tty.h>
#include <xview/xv_xrect.h>
#endif /* MACINTOSH */

#endif /* MEXDGRAPHIC */
#endif /* MEXDGRAPHIC_yet */


#ifndef MEXDSYSTEM_yet
#ifdef  MEXDSYSTEM
#define MEXDSYSTEM_yet
/********* sys-Header ****************************************************/
#ifndef MACINTOSH
#   ifndef MSDOS
#      ifndef ULTRIX
#         include <sys/stat.h>
#      endif /* ULTRIX */
#      include <sys/param.h>
#      include <sys/types.h>
#   endif /* MSDOS */
#endif /* MACINTOSH */

#endif /* MEXDSYSTEM */
#endif /* MEXDSYSTEM_yet */

/* Sollte sp"ater ven"unftig geschachtelt werden */
#ifdef MSDOS
#  include <sys\stat.h>
#  include <sys\types.h>
#endif


#ifndef MEXDPARALLEL_yet
#ifdef MEXDPARALLEL
#define MEXDPARALLEL_yet
/********* parallel-Header ***********************************************/
#ifdef sequent
#   include <parallel/parallel.h>
#endif
#ifdef SGI
#   include <ulocks.h>
#endif
#ifdef SPP1000
extern "C"
{
#include <sys/mman.h>
#include <sys/cnx_mman.h>
}
#else
#include <sys/mman.h>
#endif
#include <sys/types.h>
#include <sys/mman.h>
#include <unistd.h>
#include <sys/stat.h>
#include <fcntl.h>
#if ( defined SOLARIS || defined SOLARIS_i86 )
#   include <thread.h>
#   include <synch.h>
#endif
#endif
#endif


#if defined(MEXDMMMCMM) && !defined(MEXDMMMCMM_yet)
#  define MEXDMMMCMM_yet
#  include "cmm.h"
#endif /* MEXDMMMCMM */

#if defined(MEXDMMMBoehm) && !defined(MEXDMMMBoehm_yet) 
#  define MEXDMMMBoehm_yet 
#  include "gc.h" 
#endif /* MEXDMMMBoehm */

/********* Konstanten und Funktionsdeklarationen *************************/
#if DEADCODE
#ifdef sequent
#   define size_t long

    extern void	 free    ( void *ptr );
    extern void	*calloc  ( size_t n, size_t size );
    extern void	*malloc  ( size_t size );
    extern void	*realloc ( void *ptr, size_t size );
    
#   define strchr index
#   define memcpy(s,t,n) bcopy(t,s,n)
#   define memcmp(s,t,n) bcmp(s,t,n)

    extern long strcspn  ( char *cs, char *ct ) ;
#endif /* sequent */
#endif /* DEADCODE */


#if defined MACINTOSH || defined NEXTX86

char	*strdup(const char *s);		/* Gibts auf'm Mac nur "von Hand" */

#endif /* MACINTOSH */


#endif /* __MEX_extern__ */
