/* $Date: 1997/12/17 15:07:40 $  $Author: kg $  $Revision: 1.9 $ */

/**************************************************************************/
/* FILE:             MFO_open.h                                         */
/* Autor:            Klaus Gottheil                                       */
/* Erstellt:         30/11/92                                             */
/* Letzte Aenderung: 15/06/94                                             */
/**************************************************************************/

#ifndef __MFO_open__
#define __MFO_open__


/**************************************************************************/
/* Headerfile fuer die Routinen zum Oeffnen von Files                     */
/**************************************************************************/

#define MFOC_ERROR    0L
 
#define MFOC_READ     1L    /* Modus fuer File-Operationen */
#define MFOC_WRITE    2L
#define MFOC_APPEND   3L
 
#define MFOC_TEXT     1L    /* File-Typen */
#define MFOC_BIN      2L
#define MFOC_PLOT     4L
#define MFOC_UNKNOWN  8L
#define MFOC_CODE    16L

/* Magic Number zur Erkennung von M-Code Bianaer-Dateien. */

#define MFOC_BIN_MAGIC_1 '\003'
#define MFOC_BIN_MAGIC_2 '\001'
#define MFOC_BIN_MAGIC_3 '\001'
#define MFOC_BIN_MAGIC_4 '\001'

/* Magic Number zur Erkennung von M-Code Plot-Dateien. */

#define MFOC_PLOT_MAGIC_1 '\003'
#define MFOC_PLOT_MAGIC_2 '\002'
#define MFOC_PLOT_MAGIC_3 '\002'
#define MFOC_PLOT_MAGIC_4 '\001'

/* Magic Number zur Erkennung von verschluesselten Text-Dateien. */
 
#define MFOC_CODE_MAGIC_1 '\003'
#define MFOC_CODE_MAGIC_2 '\003'
#define MFOC_CODE_MAGIC_3 '\001'
#define MFOC_CODE_MAGIC_4 '\001'


/* Die mit fopen geoeffneten Files werden im ass. Speicher MFOV_OPEN_FILES
 * gespeichert. Die Werte der Eintraege in MFOV_OPEN_FILES sind S-Zeiger
 * vom Typ MMM_TMP, deren Mem-Teil aus einer Struktur vom Typ MFOT_finfo
 * besteht und die weiter einen S-Zeiger auf einen String mit dem vollen
 * Pfadnamen des Files enthalten. Die Indizes der Eintraege sind positive
 * ganze Zahlen (File-Deskriptoren). */
 
typedef struct _MFOT_finfo {
    MCLT_iostream fp;           /* File-Pointer */
    long mode;          /* Modus: read/write/append */
    long type;          /* Typ: Text,Binaer */
    long pos;           /* Scanner-Position bei MPA_parse_finput */
} MFOT_finfo;
 

MUPbool   MFO_open_read(S_Pointer name, S_Pointer *path,
                        MFOT_finfo *info);
MUPbool   MFO_open_write(S_Pointer name, S_Pointer *path,
                        MFOT_finfo *info, long overwrite_dialog);


#endif /* __MFO_open__ */

