/*
 * File:         MGR_check.h
 *
 * Inhalt:       Diese Datei enth"alt die Deklarationen aller Funktionen, die
 *               dazu dienen, irgendetwas zu "uberpr"ufen. Alle Funktionen wa-
 *               ren zuvor in der Datei MGR_sys_func.c gespeichert.
 *
 * Autor:        Gudrun Oevel, Thorsten Schulze
 *
 * Datum:        27.09.1994
 */

#ifndef __MGR_check__
#define __MGR_check__

/*
 * globale Funktionen
 */

#ifndef GRAPHIC

S_Pointer    MGR_check_scene
                (   S_Pointer        s, 
                    S_Pointer        sp_scene, 
                    MGRT_Defaults    *defaults, 
                    S_Pointer        *sp_plot, 
                    S_Pointer        *sp_command
                );

S_Pointer    MGR_check_object
                (   S_Pointer        list,
                    long             objnr, 
                    long             dimension, 
                    MGRT_Defaults    *defaults,
                    /*
                     * Abwaertskompatible Plot-Befehle und neue Objekt-Attribute. T.S. 16.08.95
                     */
                    MGRT_DrawStyle   *sce_drst
                );

void    MGR_check_file
           (   S_Pointer    sp_file
           );

long    MGR_check_polygon
           (   long         dimension,
               S_Pointer    sp_polygon
           );

long    MGR_check_parametric
           (   S_Pointer    *ex_1,
               S_Pointer    *ex_2,
               S_Pointer    *id_u,
               S_Pointer    *start_u, 
               S_Pointer    *end_u,
               S_Pointer    *point_u,
               S_Pointer    *smoo_u,
               S_Pointer    *id_v,
               S_Pointer    *start_v,
               S_Pointer    *end_v, 
               S_Pointer    *point_v, 
               S_Pointer    *smoo_v
           );

long    MGR_check_ident
           (   S_Pointer    s,
               S_Pointer    string
           );

long    MGR_check_bin_equation
           (   S_Pointer    s
           );

long    MGR_check_n_real_list
           (   S_Pointer    s,
               long         n
           );

#endif

void    MGR_check_string
           (   char    *string,
               long    max_length
           );

#endif /* __MGR_check__ */
