/* $Date: 1997/12/15 15:22:12 $  $Author: olli $  $Revision: 1.11 $ */

/*
 * Diese Datei enth"alt alle Konstanten, die das Grafiktool
 * VCam ben"otigt.
 *
 * Autor: Thorsten Schulze
 * Datum: 17.04.93
 * letzte "Anderung: T.S. Neue Konstanten f"ur die Befehle eingef"ugt.
 *                   16.06.1994
 */

#ifndef MGR_CONSTANTS_HEADER
#define MGR_CONSTANTS_HEADER


/*
 * Laden der Library limits.h zur Bestimmung von
 * LONG_MAX. Dieser Wert wird nun f"ur die maxi-
 * male Schranke f"ur Grid verwendet.
 */
#include <limits.h> 



/*
 * Definition der "Anderungskonstanten
 */

#define  MGRC_NO_CHANGES          0L
#define  MGRC_CHANGES             1L


/*
 * maximale String-L"ange und weitere String-Konstanten
 */

#define  MGRC_MAX_STRING_LENGTH    1028L
/*
 * Neue maximale String-L"angen
 */
#define  MGRC_STRLEN16               16L
#define  MGRC_STRLEN32               32L
#define  MGRC_STRLEN64               64L

#define  MGRC_STRLEN_TITLE           MGRC_STRLEN64
#define  MGRC_STRLEN_LABELS          MGRC_STRLEN64
#define  MGRC_STRLEN_FUNCTION        MGRC_STRLEN64
#define  MGRC_STRLEN_RANGE           MGRC_STRLEN32
#define  MGRC_STRLEN_VARIABLE        MGRC_STRLEN16
#define  MGRC_STRLEN_FONTNAME        MGRC_STRLEN64
#define  MGRC_STRLEN_FONTSTYLE       MGRC_STRLEN16
#define  MGRC_STRLEN_PERSPECTIVE     MGRC_STRLEN16

#define  MGRC_STRING_NOT_TOO_LONG     0
#define  MGRC_STRING_TOO_LONG         1

/*
 * Definition des Trennsymbols und des Fehlersymbols
 * f"ur das Auslesen der Daten aus der Pipe. Diese
 * beiden Konstanten verschwinden bei der "Ubertra-
 * gung der Daten mit Hilfe des MCodes.
 */

/*#define  MGRC_SEP_SYMBOL          '\0'
#define  MGRC_ERR_SYMBOL          'E'*/

/*
 * Anbindung an XMUPAD oder nicht.
 */

#define  MGRC_NO_XMUPAD            0L
#define  MGRC_XMUPAD               1L

/* 
 * Konstanten f"ur Ziel des Plot-Befehls
 */

#define  MGRC_XMUPAD_COMMAND       0L
#define  MGRC_KERNEL_COMMAND       1L
#define  MGRC_FILE_COMMAND         2L
#ifdef MSDOS
#  define  MGRC_KERNEL_DEFAULTS    3L
#endif

/*
 * Konstanten f"ur Farbe oder nicht.
 */

#define  MGRC_NO_COLOR             0L
#define  MGRC_COLOR                1L

/*
 * Konstanten der unterschiedlichen Achsenstile
 */

#define  MGRC_NO_AXES     0L
#define  MGRC_NORMAL_AXES 1L
#define  MGRC_FRAMED_AXES 2L
#define  MGRC_BOXED_AXES  3L

/*
 * Konstanten f"ur die Achsenpfeile
 */

#define  MGRC_NO_ARROWS   0L
#define  MGRC_ARROWS      1L

/*
 * Konstanten f"ur die Achsenbeschriftung
 */

#define  MGRC_NO_LABELS   0L
#define  MGRC_LABELS      1L

/*
 * Konstanten f"ur die Achsenmarkierungen
 */

#define  MGRC_MIN_TICKS   0L
#define  MGRC_MAX_TICKS   50L

#ifndef NO_TICKS_EXTENSION

#define  MGRC_NUM_XYZ    0L
#define  MGRC_NUM_X      1L
#define  MGRC_NUM_Y      2L
#define  MGRC_NUM_Z      4L
#define  MGRC_DELTA_X    8L      
#define  MGRC_DELTA_Y   16L      
#define  MGRC_DELTA_Z   32L      
#define  MGRC_LIST_X    64L
#define  MGRC_LIST_Y   128L
#define  MGRC_LIST_Z   256L

#define  MGRC_MIN_XYZ    0L
#define  MGRC_MIN_X      1L
#define  MGRC_MIN_Y      2L
#define  MGRC_MIN_Z      4L
#define  MGRC_MAX_X      8L
#define  MGRC_MAX_Y     16L
#define  MGRC_MAX_Z     32L

#define  MGRC_NO_TEXT   3    /* ASCII-Code fuer End of Text */

#define MGRC_STRLEN_TICKS MGRC_STRLEN16

#endif

/*
 * Konstanten f"ur die Zeichenstile
 */

#define  MGRC_MIN_POINT_WIDTH           1L
#define  MGRC_MAX_POINT_WIDTH           LONG_MAX

#define  MGRC_FILLED_SQUARE_POINT       0L
#define  MGRC_SQUARE_POINT              1L
#define  MGRC_FILLED_CIRCLE_POINT       2L
#define  MGRC_CIRCLE_POINT              3L

#define  MGRC_MIN_LINE_WIDTH            0L
#define  MGRC_MAX_LINE_WIDTH            LONG_MAX

#define  MGRC_LINE_SOLID                0L
#define  MGRC_LINE_DASHED               1L

#define  MGRC_FILL_SOLID                0L
#define  MGRC_FILL_STIPPLED             1L

/*
 * Konstanten f"ur die Fonts
 */


#define  MGRC_MIN_FONT_SIZE             7L
#define  MGRC_MAX_FONT_SIZE             36L


/*
 * Konstanten f"ur die Szene
 */

#define  MGRC_AUTOMATIC_UNKNOWN        -1L
#define  MGRC_AUTOMATIC                 0L    /* WICHTIG:  muss mit 0L vorbelegt sein */
#define  MGRC_MANUAL                    1L


#define  MGRC_SCENE_2D                  2L
#define  MGRC_SCENE_3D                  3L
#define  MGRC_DEFAULTS                  5L

#define  MGRC_SCAL_CONSTRAINED          0L
#define  MGRC_SCAL_UNCONSTRAINED        1L

#define  MGRC_AUTO_VIEWBOX              0L
#define  MGRC_MANU_VIEWBOX              1L

/* WICHTIG: Die Konstanten f"ur die Perspektive d"urfen nur ver"andert werden, wenn gleichzeitig 
   MGR_check_scene(), VIS_write_scene_option() und VGU_calc_auto_options_3d()
   angepasst werden.     */

#define  MGRC_AUTO_PERS                 0L
#define  MGRC_MANU_CP                   1L
#define  MGRC_MANU_FP                   2L   
#define  MGRC_MANU_PERS                 3L	/* muss MGRC_MANU_CP | MGRC_MANU_FP sein */

#define  MGRC_AUTO_ZOOM                 0L
#define  MGRC_IN_ZOOM                   1L
#define  MGRC_OUT_ZOOM                  2L
#define  MGRC_MANU_ZOOM                 3L

#define  MGRC_NO_LIGHTING               0L
#define  MGRC_LIGHTING                  1L


/*
 * Konstanten f"ur die Objekte
 */


/*
 * Definition der Anzahl der Farben, die bei Color=Heigth,
 * f"ur jedes Objekt angefordert werden.
 */
 
#define  MGRC_MAX_OBJECT_COLORS     28L



#define  MGRC_NOT_PLOTTED               0L
#define  MGRC_PLOTTED                   1L

#define  MGRC_MODE_CURVE_2D             0L
#define  MGRC_MODE_LIST_2D              1L

#define  MGRC_MODE_CURVE_3D             0L
#define  MGRC_MODE_LIST_3D              1L
#define  MGRC_MODE_SURFACE_3D           2L
#define  MGRC_MODE_CONTOUR_3D           3L

#define  MGRC_STYLE_POINTS              0L
#define  MGRC_STYLE_LINES               1L
#define  MGRC_STYLE_LINESPOINTS         2L
#define  MGRC_STYLE_IMPULSES            3L

#define  MGRC_STYLE_WIREFRAME           1L
#define  MGRC_STYLE_HIDDENLINE          2L
#define  MGRC_STYLE_COLORPATCHES        3L
#define  MGRC_STYLE_DEPTHCUEING         4L

#define  MGRC_MESH_ONLY                 0L
#define  MGRC_MESH_AND                  1L
#define  MGRC_MESH_ULINE                2L
#define  MGRC_MESH_VLINE                3L

#define  MGRC_COLO_FLAT                 0L
#define  MGRC_COLO_HEIGHT               1L
#define  MGRC_COLO_FUNC                 2L
#define  MGRC_COLO_PHYS                 3L
#define  MGRC_COLO_EXPLICIT             4L

#define  MGRC_NO_FINE                   0L
#define  MGRC_FINE                      1L

#define  MGRC_PARAMETRIC                0L
#define  MGRC_PARA_UV                   1L
#define  MGRC_PARA_UMV                  2L
#define  MGRC_PARA_MUV                  3L
#define  MGRC_PARA_MUMV                 4L

#define  MGRC_MIN_GRID                  2L
#define  MGRC_MAX_GRID            LONG_MAX
#define  MGRC_MIN_SMOOTH                0L
#define  MGRC_MAX_SMOOTH               20L

/*
 * Konstanten f"ur die Default-Werte
 */
#define  MGRC_NEW_CREATE_SCENE_2D       0L
#define  MGRC_NEW_CREATE_SCENE_3D       1L

#define  MGRC_SAVE_POPUP                0L
#define  MGRC_SAVE_RASTER               1L  
#define  MGRC_SAVE_GIF                  2L
#define  MGRC_SAVE_PS                   3L
#define  MGRC_SAVE_ASCII                4L
#define  MGRC_SAVE_MCODE                5L
#define  MGRC_SAVE_PLOT_COMMAND         6L
#define  MGRC_SAVE_PLOT_COMMAND_XMUPAD  7L

#define  MGRC_PRINT_LASERWRITER         0L
#define  MGRC_PRINT_NOTEBOOK            1L

#define  MGRC_ROUT_QUICKDRAW            0L
#define  MGRC_ROUT_QUALITYDRAW          1L


/*
 * Alle folgenden Konstanten werden f"ur das 
 * Setzen der Optionen in die S_Pointer ben"otigt.
 * Um diese Konstanten m"oglichst eindeutig und selbst-
 * erkl"arend zu w"ahlen, habe ich mir folgendes "uberlegt:
 *
 * Alle Konstanten zur Ver"anderung der Szene beginnen mit
 *
 * MGRC_OPTION_SCENE_...
 * 
 * Alle Konstanten zur Ver"anderung der Objekte beginnen mit
 *
 * MGRC_OPTION_OBJECT_...
 *
 * Alle Konstanten zur Ver"anderung der Default-Werte beginnen 
 * mit
 *
 * MGRC_OPTION_DEFAULT_...
 *
 * Alle Konstanten zur Ver"anderung der S_Pointer beginnen mit
 *
 * MGRC_OPTION_SPOINTER_...
 *
 */

/*
 * Konstanten zur Ver"anderung der Szene
 */

#define  MGRC_OPTION_SCENE_ALL           0L
#define  MGRC_OPTION_SCENE_BACK_INDEX    1L
#define  MGRC_OPTION_SCENE_FORE_INDEX    2L
#define  MGRC_OPTION_SCENE_ROUTINE       3L
#define  MGRC_OPTION_SCENE_AXES_STYLE    4L
#define  MGRC_OPTION_SCENE_PERS          5L
#define  MGRC_OPTION_SCENE_SCAL          6L
#define  MGRC_OPTION_SCENE_ZOOM          7L
#define  MGRC_OPTION_SCENE_LIGH          8L
#define  MGRC_OPTION_SCENE_ACOB          9L
#define  MGRC_OPTION_SCENE_NUOB          10L
#define  MGRC_OPTION_SCENE_TITLE         11L
#define  MGRC_OPTION_SCENE_POSX          12L
#define  MGRC_OPTION_SCENE_POSY          13L
#define  MGRC_OPTION_SCENE_CHANGES       14L
#define  MGRC_OPTION_SCENE_BACK          15L
#define  MGRC_OPTION_SCENE_FORE          16L

/*
 * Konstanten zur Ver"anderung der Objekte
 */

#define  MGRC_OPTION_OBJECT_ALL          20L
#define  MGRC_OPTION_OBJECT_STAR_INDEX   21L
#define  MGRC_OPTION_OBJECT_END_INDEX    22L
#define  MGRC_OPTION_OBJECT_MODE         23L
#define  MGRC_OPTION_OBJECT_STYLE        24L
#define  MGRC_OPTION_OBJECT_MESH         25L
#define  MGRC_OPTION_OBJECT_COLOR        26L
#define  MGRC_OPTION_OBJECT_TITLE        27L
#define  MGRC_OPTION_OBJECT_FUN1         28L
#define  MGRC_OPTION_OBJECT_FUN2         29L
#define  MGRC_OPTION_OBJECT_FUN3         30L
#define  MGRC_OPTION_OBJECT_CFUN         31L
#define  MGRC_OPTION_OBJECT_RUMIN        32L
#define  MGRC_OPTION_OBJECT_RUMAX        33L
#define  MGRC_OPTION_OBJECT_RVMIN        34L
#define  MGRC_OPTION_OBJECT_RVMAX        35L
#define  MGRC_OPTION_OBJECT_UGRID        36L
#define  MGRC_OPTION_OBJECT_VGRID        37L
#define  MGRC_OPTION_OBJECT_USMOOTH      38L
#define  MGRC_OPTION_OBJECT_VSMOOTH      39L
#define  MGRC_OPTION_OBJECT_POSX         40L
#define  MGRC_OPTION_OBJECT_POSY         41L
#define  MGRC_OPTION_OBJECT_CHANGES      42L
#define  MGRC_OPTION_OBJECT_STAR         43L
#define  MGRC_OPTION_OBJECT_END          44L

/*
 * Konstanten zur Ver"anderung der Default-Werte
 */

#define  MGRC_OPTION_DEFAULT_ALL         50L

/*
 * Konstanten zur Ver"anderung der S_Pointer
 */

#define  MGRC_OPTION_SPOINTER_ALL        0L





/*
 * Konstanten f"ur die Eventtypen
 */

#define  MGRC_EVENT_SELECT               1L
#define  MGRC_EVENT_RELEASED             2L
#define  MGRC_EVENT_LOC_DRAG             3L


/*
 * Konstanten f"ur die Befehl-S_Pointer
 * 
 * Es folgen nun Konstanten, die einen Befehl beschreiben, der an das Grafiktool
 * geschickt werden muss.
 */
#define MGRC_VCOMMAND_DISPLAY_GRAPHIC    0L
#define MGRC_VCOMMAND_SAVE_AS_RASTER     1L
#define MGRC_VCOMMAND_SAVE_AS_GIF        2L
#define MGRC_VCOMMAND_SAVE_AS_PS         3L
#define MGRC_VCOMMAND_DISPLAY_ERROR      4L

/*
 * Die folgende Konstante gibt die Anzahl der Indizes an, die in der Sprung-
 * tabelle des Grafiktools vorhanden sein m"ussen. Diese Anzahl ist immer die
 * Summe der obigen Konstanten.
 */
#define MGRC_NUMBER_OF_VCAM_COMMANDS     5L

/*
 * Es folgen nun die Befehlskonstanten, deren Befehle vom Kern abgearbeitet 
 * werden k"onnen. Die Werte dieser Konstanten d"urfen sich nicht mit denen
 * der Konstanten "uberschneiden, die an das Grafiktool geschickt werden.
 */
#define MGRC_KCOMMAND_NO_COMMAND         20L
#define MGRC_KCOMMAND_SAVE_AS_ASCII      21L
#define MGRC_KCOMMAND_SAVE_AS_MCODE      22L


/*
 * Konstanten f"ur minimalen und maximalen RGB-Wert
 */
#define  MGRC_MIN_RGB                     0L
#define  MGRC_MAX_RGB                 65535L

/*
 * Konstante f"ur Abfragen auf 0.0
 * Neu. 11.10.95
 */
#define MGRC_EPS                      1e-10

/*
 * Konstanten f"ur Achsenskalierung
 */
#define MGRC_LinXYZ                       0L
#define MGRC_LogX                         1L 
#define MGRC_LogY                         2L
#define MGRC_LogZ                         4L

#define MGRC_XMIN "XMin"
#define MGRC_YMIN "YMin"
#define MGRC_ZMIN "ZMin"
#define MGRC_XMAX "XMax"
#define MGRC_YMAX "YMax"
#define MGRC_ZMAX "ZMax"

#endif /* MGR_CONSTANTS_HEADER */
