/*
 * File:        MGR_global.h
 *
 * Inhalt:      Diese Datei enth"alt die Definition aller globalen Variablen
 *              die im MuPAD-Kern auf Grafikseite ben"otigt werden. Diese
 *              Variablen waren zuvor in MGR_sys_func.c definiert.
 *
 * Autor:       Gudrun Oevel, Thorsten Schulze
 *
 * Datum:       27.09.1994
 */

#ifndef __MGR_global__
#define __MGR_global__


/*
 * globale Variablen, hier nur noch die Deklaration. Die 
 * Definition steht in MGR_sys_func.c, T.S..
 */

extern S_Pointer       MGRV_SP_DEFAULTS;
extern long            MGRV_NO_DEFAULT_FILE;
extern MUPbool         MGRV_MACHINE_FLOAT;

extern S_Pointer	MSTR_Untitled;                
extern S_Pointer	MSTR_Var1;                
extern S_Pointer	MSTR_Var2;              
extern S_Pointer       MSTR_XMin;
extern S_Pointer       MSTR_XMax;
extern S_Pointer       MSTR_YMin;
extern S_Pointer       MSTR_YMax;
extern S_Pointer       MSTR_ZMin;
extern S_Pointer       MSTR_ZMax;
extern S_Pointer       MSTR_PlotDevice;
extern S_Pointer       MSTR_Screen;
extern S_Pointer	MSTR_Title;                
extern S_Pointer	MSTR_TitlePosition;        
extern S_Pointer	MSTR_Below;        
extern S_Pointer	MSTR_Above;
extern S_Pointer	MSTR_Axes;
extern S_Pointer	MSTR_NoAxes;
extern S_Pointer	MSTR_NormalAxes;
extern S_Pointer	MSTR_FramedAxes;
extern S_Pointer	MSTR_Boxed;
extern S_Pointer	MSTR_Ticks;
extern S_Pointer	MSTR_Arrows;
extern S_Pointer	MSTR_Labels;
extern S_Pointer	MSTR_Labeling;
extern S_Pointer       MSTR_AxesOrigin;
extern S_Pointer	MSTR_Scaling;
extern S_Pointer	MSTR_Constrained;
extern S_Pointer	MSTR_UnConstrained;
extern S_Pointer	MSTR_ViewingBox;
extern S_Pointer	MSTR_Automatic;
extern S_Pointer	MSTR_Routine;
extern S_Pointer	MSTR_Color;
extern S_Pointer	MSTR_Colormap;
extern S_Pointer	MSTR_CameraPoint;
extern S_Pointer	MSTR_FocalPoint;
extern S_Pointer	MSTR_Lighting;
extern S_Pointer	MSTR_Ambient;
extern S_Pointer	MSTR_Mode;
extern S_Pointer	MSTR_Mode2d;
extern S_Pointer	MSTR_Mode3d;
extern S_Pointer	MSTR_Curve;
extern S_Pointer	MSTR_Contour;
extern S_Pointer	MSTR_Surface;
extern S_Pointer	MSTR_List;
extern S_Pointer	MSTR_Grid;
extern S_Pointer	MSTR_Smoothness;
extern S_Pointer	MSTR_TitleOrientation;
extern S_Pointer	MSTR_Style;
extern S_Pointer	MSTR_Horizontal;
extern S_Pointer	MSTR_Vertical;
extern S_Pointer	MSTR_Points;
extern S_Pointer	MSTR_Lines;
extern S_Pointer	MSTR_LinesPoints;
extern S_Pointer	MSTR_Impulses;
extern S_Pointer	MSTR_Bottom;
extern S_Pointer	MSTR_Attached;
extern S_Pointer	MSTR_WireFrame;
extern S_Pointer	MSTR_Mesh;
extern S_Pointer	MSTR_ULine;
extern S_Pointer	MSTR_VLine;
extern S_Pointer	MSTR_HiddenLine;
extern S_Pointer	MSTR_ColorPatches;
extern S_Pointer	MSTR_Only;
extern S_Pointer	MSTR_AndMesh;
extern S_Pointer	MSTR_AndULine;
extern S_Pointer	MSTR_AndVLine;
extern S_Pointer	MSTR_DepthCueing;
extern S_Pointer	MSTR_Flat;
extern S_Pointer	MSTR_Height;
extern S_Pointer	MSTR_Physical;
extern S_Pointer	MSTR_Indexed;
extern S_Pointer	MSTR_Rgb;
extern S_Pointer	MSTR_QuickDraw;
extern S_Pointer	MSTR_QualityDraw;
extern S_Pointer       MSTR_Implicit;
extern S_Pointer       MSTR_Dimension;
extern S_Pointer       MSTR_PointWidth;
extern S_Pointer       MSTR_PointStyle;
extern S_Pointer       MSTR_LineWidth;
extern S_Pointer       MSTR_LineStyle;
extern S_Pointer       MSTR_FontFamily;
extern S_Pointer       MSTR_FontStyle;
extern S_Pointer       MSTR_FontSize;
extern S_Pointer       MSTR_FilledSquares;
extern S_Pointer       MSTR_Squares;
extern S_Pointer       MSTR_FilledCircles;
extern S_Pointer       MSTR_Circles;
extern S_Pointer       MSTR_SolidLines;
extern S_Pointer       MSTR_DashedLines;
extern S_Pointer       MSTR_ForeGround;
extern S_Pointer       MSTR_BackGround;
extern S_Pointer       MSTR_Function;
extern S_Pointer       MSTR_Closed;
extern S_Pointer       MSTR_Filled;
extern S_Pointer       MSTR_Ascii;
extern S_Pointer       MSTR_Binary;
extern S_Pointer       MSTR_Raster;
extern S_Pointer       MSTR_Gif;
extern S_Pointer       MSTR_Postscript;
extern S_Pointer       MSTR_Lin;
extern S_Pointer       MSTR_Log;
extern S_Pointer       MSTR_AxesScaling;
extern S_Pointer       MSTR_Shift;

#ifndef NO_TICKS_EXTENSION

extern S_Pointer MGRC_MIN_ID[3];
extern S_Pointer MGRC_MAX_ID[3];

#endif


#endif /* __MGR_global__ */
