/*
 * File:         MGR_makro.h
 *
 * Inhalt:       Diese Datei enth"alt alle Makros, die vom MuPAD-Kern auf Seiten
 *               der Grafikberechnungen ben"otigt werden. Diese Makros wurden 
 *               zuvor in MGR_sys_func.c definiert. Um die Makros besser von an-
 *               deren Funktionen unterscheiden zu k"onnen, beginnen sie nun mit
 *               der Buchstabenfolge 'MGRM'.
 *
 * Autor:        Gudrun Oevel, Thorsten Schulze
 *
 * Datum:        27.09.1994
 */

#ifndef __MGR_makro__
#define __MGR_makro__


#if (!defined MACINTOSH) && (defined OLDCOMMUNICATION)
 
#define MGRM_begin_output() \
        {   MGRV_old_file = MIOV_OUTPUT; MIOV_OUTPUT = MGRV_output_file; \
            MGRV_text_width = GLOBAL_READ(MEVV_TEXTWIDTH); \
            GLOBAL_WRITE(MEVV_TEXTWIDTH, LONG_MAX); \
            MIO_push_pretty_false(); \
        }

#define MGRM_end_output() \
        {   fflush(MGRV_output_file); MIOV_OUTPUT = MGRV_old_file; \
            GLOBAL_WRITE(MEVV_TEXTWIDTH, MGRV_text_width); \
            MIO_pop_pretty();  \
        }

#endif

#define MGRM_no_sign(s)        !(MMMZ(&s,CATEGORY,MMMread)->spec & (MINUS_BIT | DIV_BIT | NOT_BIT))

#define MGRM_cat(s)             MMMZ(&s,CATEGORY,MMMread)->cat

#define MGRM_set_error(s)       MEV_set_error(MEVC_PLOT_ERROR, "plot", (s))

#define MGRM_CHECK_ITEM(testnr) if ( testarray[testnr]==1 ) \
                                    MGRM_set_error("Twice specified"); \
				else \
                                    testarray[testnr]=1;

#define MGRM_MIN(A,B)           ( (A)<(B) ? (A):(B) )
#define MGRM_MAX(A,B)           ( (A)>(B) ? (A):(B) )

#ifndef NO_TICKS_EXTENSION

#define MGRM_cat2cstr(s) \
        MMMmvarr(MMMP(&(s),0L,MMMread), sizeof(STRSIZE), 0L, char, MMMread)

#endif

#endif /* __MGR_makro__ */

