/* $Date: 1995/07/21 09:34:16 $  $Author: andi $  $Revision: 1.4 $ */

/*
 * Filename:     MGR_option_management.h
 *
 * Inhalt:       Definition der Routinen, die die "Anderungen
 *               der Grafikoptionen in den S_Pointer graphic
 *               bzw. actual_graphic eintragen.
 *
 * Autor:        Thorsten Schulze
 *
 * Datum:        20.04.1993
 */

#ifndef __MGR_option_management__
#define __MGR_option_management__


#ifdef MACINTOSH
#include "VDM_draw_primitives.h"
#endif

/*
 * Funktionen
 */

void         MGR_resize_scene_spointer
                       (   MGRT_Scene    *scene,
                           S_Pointer     sp_graphic
                       );

S_Pointer    MGR_get_scene_adr
                       (   S_Pointer    sp_graphic
                       );

void         MGR_set_scene_options
                       (   MGRT_Scene    *scene, 
                           long          which_option, 
                           S_Pointer     sp_scene 
                       );

S_Pointer    MGR_get_obj_adr
                       (   S_Pointer    sp_scene, 
                           long         obj_no 
                       );

void         MGR_set_object_options
                       (   MGRT_Object    *object, 
                           long           which_option, 
                           S_Pointer      sp_object 
                       );

void         MGR_read_scene
                       (   S_Pointer     sp_scene,
                           MGRT_Scene    *scene
                       );

void         MGR_read_object
                       (   S_Pointer      sp_object,
                           MGRT_Object    *object
                       );

S_Pointer    MGR_get_obj_pointlist
                       (   S_Pointer    sp_object 
                       );

S_Pointer    MGR_init_spointer();

void         MGR_set_spointer_options
                       (   S_Pointer    sp_source,
                           long         which_option,
                           S_Pointer    sp_destination
                       );

S_Pointer    MGR_get_default_spointer
                       (   S_Pointer    sp_graphic
                       );

void         MGR_set_default_options
                       (   MGRT_Defaults    *defaults,
                           long             which_option,
                           S_Pointer        sp_defaults
                       );

void         MGR_read_defaults
                       (   S_Pointer        sp_defaults,
                           MGRT_Defaults    *defaults
                       );

#endif /* __MGR_option_management__ */
