/******************************************************************************/
/* DATEI:       MKT_func.h                                                    */
/* AUTOR:       Andreas Sorgatz                                               */
/* ERSTELLT:    18/07/95                                                      */
/* GEAENDERT:   28/01/98                                                      */
/* INHALT:      Toolbox - definiert eine Makrosprache zur Kernprogrammierung  */
/*                                                                            */
/* In dieser Datei muessen alle MuPAD Header-files (*.h) eingebunden werden.  */
/* Entgegen der Konvention tragen die Objekte dieses Moduls den Praefix 'MF'  */
/* anstatt 'MKT_'.    Sie stellen die Basis einer vereinfachten Programmier-  */
/* sprache zur Implementation von System- und Modulfunktionen dar. Variablen  */
/* tragen den Praefix 'MV', Konstanten (z.B zur Steuerung von MF-Funktionen)  */
/* tragen den Praefix 'MC'                                                    */
/******************************************************************************/

/*** V O R S I C H T -- Diese Funktionen duerfen nicht in Quelldateien ein- ***/
/*** gesetzt werden, die zu 'VCAM' gelinkt werden muessen. Andernfalls muss ***/
/*** durch einen Schneeball-Effekt der gesamte Kern gelinkt werden.         ***/

#ifndef __MKT_func__
#define __MKT_func__

#ifndef MEXDSTANDARD
#  define MEXDSTANDARD                     /*** Aktivieren von MEX_extern.h ***/
#endif
#ifndef MEXDSYSTEM
#  define MEXDSYSTEM   
#endif

#ifdef DOS_FILENAMES
#  include "MMMstora.h"
#  include "MUP_typ.h"
#  include "MUP_cons.h"
#  include "MEV_eval.h"
#  include "MST_stac.h"
#  include "MUT_util.h"
#  include "MSG_sign.h"
#  include "MCM_comp.h"
#  include "MPA_pars.h"
#  include "MPA_help.h"
#  include "MSC_scan.h"
#  include "MTR_tree.h"
#  include "MSU_eval.h"
#  include "MAM_ass_.h"
#  include "MAR_arra.h"
#  include "MGS_simp.h"
#  include "MTA_tabl.h"
#  include "MSR_stri.h"
#  include "MSE_set.h"
#  include "MGR_cons.h"
#  include "MGR_type.h"
#  include "MGR_makr.h"
#  include "MGR_glob.h"
#  include "MGR_exte.h"
#  include "MGR_colo.h"
#  include "MGR_file.h"
#  include "MGR_defa.h"
#  include "MGR_opti.h"
#  include "MGR_calc.h"
#  include "MGR_util.h"
#  include "MGR_chec.h"
#  include "MGR_comm.h"
#  include "MGR_init.h"
#  include "MGR_sys_.h"
#  include "MDF_diff.h"
#  include "MXP_expa.h"
#  include "MFO_open.h"
#  include "MFO_file.h"
#  include "MSY_sys_.h"
#  include "MSY_sysh.h"
#  include "MPL_para.h"
#  include "MTR_tree.h"
#  include "MSV_save.h"
#  include "MPH_prob.h"
#  include "MPO_poly.h"
#ifndef GRAPHIC
#  include "MPO_polh.h"
#endif /* GRAPHIC */
#  include "MUP_func.h"
#  include "MDB_debu.h"
#  include "MHI_hist.h"
#  include "MGH_mess.h"
#  include "MPR_prot.h"
#  include "MDM_kern.h"
#  include "MNS_name.h"
#  include "MPM_matc.h"
#  include "MUP_ext.h"
#  include "MIO_io.h"
#  include "MUT_debu.h"
#  include "MDI_face.h"
#  include "MBC_byte.h"
#ifndef GRAPHIC
#    include "MPM_ac.h"
#endif

#else /*** !DOS_FILENAMES *************************************************************/

#  include "MMMstorage.h"
#  include "MUP_types.h"
#  include "MUP_constants.h"
#  include "MCT_iostream.h"
#  include "MEV_evaluate.h"
#  include "MST_stack.h"
#  include "MUT_utils.h"
#  include "MSG_signature.h"
#  include "MCM_compare.h"
#  include "MPA_parser.h" 
#  include "MPA_parser_help.h"
#  include "MSC_scan.h"
#  include "MTR_tree.h"
#  include "MSU_eval_subs.h"
#  include "MAM_ass_mem.h"
#  include "MAR_array.h"
#  include "MGS_simplify.h"
#  include "MTA_table.h"
#  include "MSR_string.h"
#  include "MSE_set.h"
#  include "MGR_constants.h"
#  include "MGR_types.h"
#  include "MGR_makro.h"
#  include "MGR_global.h"
#  include "MGR_extern.h"
#  include "MGR_color.h"
#  include "MGR_file.h"
#  include "MGR_defaults.h"
#  include "MGR_option_management.h"
#  include "MGR_calc.h"
#  include "MGR_util.h"
#  include "MGR_check.h"
#  include "MGR_command.h"
#  include "MGR_init.h"
#  include "MGR_sys_func.h"
#  include "MDF_diff.h"
#  include "MXP_expand.h"
#  include "MFO_open.h"
#  include "MFO_fileop.h"
#  include "MSY_sys_func.h"
#  include "MSY_sys_func_help.h"
#  include "MPL_parallel.h"
#  include "MTR_tree.h"
#  include "MSV_save.h"
#  include "MPH_problemheap.h"
#  include "MPO_poly.h"
#ifndef GRAPHIC
#  include "MPO_poly_help.h"
#endif /* GRAPHIC */
#  include "MUP_funcs.h"
#  include "MDB_debug.h"
#  include "MHI_history.h"
#  include "MGH_message.h"
#  include "MLE_lineedit.h"
#  include "MDM_kern.h"
#  include "MNS_namespace.h"
#  include "MPM_match.h"
#  include "MUP_extern.h"
#  include "MIO_io.h"
#  include "MUT_debug.h"
#  include "MDI_debug_interface.h"
#  include "MBC_bytecode.h"
#ifndef GRAPHIC
#    include "MPM_acmatch.h"
#endif
#endif /* DOS_FILENAMES */

#ifdef MSDOS
#  include "MSW_int.h"
#endif

/******************************************************************************/
/*** Makros for internal usage ************************************************/
/******************************************************************************/

/*** Create a string from a given identifier **********************************/

#define MD_STRING(name)       #name

/******************************************************************************/
/*** Toolbox - constants ******************************************************/
/******************************************************************************/

/*** Length of character string buffer (refer to MFprintf) ********************/

#define MCbuflen    4*1024


/*** Boolean "C" constants ****************************************************/

#define MCtrue       ( (MTbool) MUPC_constants_CAT_BOOL_TRUE    )
#define MCfalse      ( (MTbool) MUPC_constants_CAT_BOOL_FALSE   )
#define MCunknown    ( (MTbool) MUPC_constants_CAT_BOOL_UNKNOWN )


/*** Storage type of all MAMMUT objects created with this toolbox *************/

#define MCstorage    MMMCglobal

/*** Access mode for MAMMUT objects *******************************************/

#define MCread       MMMread
#define MCwrite      MMMwrite


/*** Constants to control MF service functions ********************************/

#define MCall        -1                                  /* must be negative! */
#define MCnone       -2                                  /* must be negative! */
#define MCthis       -3                                  /* must be negative! */
#define MCcopy       -4
#define MCaddr       (-5)


/*** Function control: kind of evaluation, remember table, special options ****/

#define MCnop          0      /* No Operation / Option                  ----- */
#define MChold         1      /* No evaluation of Arguments             Bit-0 */
#define MCremember     2      /* Function uses remember table           Bit-1 */
#define MCnoeval       4      /*                                        Bit-2 */
#define MChidden       8      /* Hidden module function                 Bit-3 */
#define MCstatic      16      /* Unremovable module function            Bit-4 */

#define MCdefault      MCnop  /* Default options                        Bit-? */


/*** The NULL elemnet of the memory management ********************************/

#define MCnull          MMMNULL


/*** Constants for special type classes used for MFargCheck() *****************/

#define MCinteger       -1
#define MCnumber        -2
#define MCchar          -3


/*** Type Translation Table:  DOM_ <=> CAT_ ***********************************/

#define DOM_ANY         0                 /*** unbekannter Typ, vgl. MV_TTT ***/

#define DOM_APM         CAT_APM          
#define DOM_ARRAY       CAT_ARRAY        
#define DOM_BOOL        CAT_BOOL         
#define DOM_COMPLEX     CAT_COMPLEX       
#define DOM_DEBUG       CAT_DEBUG        
#define DOM_DOMAIN      CAT_DOM          
#define DOM_DYN_LIST    CAT_DYN_LIST     
#define DOM_ERROR       CAT_ERROR        
#define DOM_EXEC        CAT_EXEC         
#define DOM_EXPR        CAT_EXPR         
#define DOM_EXT         CAT_EXT          
#define DOM_FAIL        CAT_FAILED       
#define DOM_FLOAT       CAT_FLOAT        
#define DOM_FUNC        CAT_FUNC         
#define DOM_FUNCARG     CAT_FUNCARG      
#define DOM_FUNC_ENV    CAT_FUNC_ENV     
#define DOM_IDENT       CAT_IDENT        
#define DOM_INT         CAT_INT          
#define DOM_LIST        CAT_STAT_LIST    
#define DOM_MFLOAT      CAT_MFLOAT       
#define DOM_NAMESPACE   CAT_NAMESPACE    
#define DOM_NIL         CAT_NIL          
#define DOM_NULL        CAT_NULL         
#define DOM_POINT       CAT_POINT        
#define DOM_POLY        CAT_POLY         
#define DOM_POLYGON     CAT_POLYGON      
#define DOM_PROC        CAT_PROC         
#define DOM_RAT         CAT_RAT          
#define DOM_SET         CAT_SET_FINITE   
#define DOM_STRING      CAT_STRING       
#define DOM_TABLE       CAT_TABLE        
#define DOM_TASK        CAT_TASK         


/******************************************************************************/
/******************************************************************************/
/*** Global objects of MKT_func, must be declared at THIS location !!! ********/
/******************************************************************************/
/******************************************************************************/

/*** Variables defined and used by this toolbox *******************************/

#define      MKT_TTT_NUM      43
/*** Is not used yet: andi, 07.07.97
extern long  MKT_TTT[MKT_TTT_NUM];   Type Translation Table: DOM_ to MEVC_ 
***/

extern long    MV_errnum;
extern char   *MV_errstr;
extern MTcell  MV_result;

/*** Prototypes of toolbox functions defined in 'MKT_func.c' ******************/

extern int     MFprintf1  ( char *format, va_list args );
#ifndef GRAPHIC
extern char   *MFstring1  ( MTcell s, long option );
#endif /*** GRAPHIC ***/
extern MTcell  MFnewExpr1 ( MTcell s, long n );
extern MTcell  MFnewExpr2 ( long n, va_list args );
extern MTcell  MFnewSeq2  ( long n, va_list args );
extern MTcell  MFvalue1   ( MTcell s, MTcell t, long opt );
#ifndef GRAPHIC
extern MTcell  MFcall1    ( MTcell s, long n, va_list args );
#endif /*** GRAPHIC ***/

/******************************************************************************/
/*** Load module declarations and definitions. This is needed to reference ****/
/*** toolbox objects correctly, if dynamic linking is switched of !!!      ****/
/******************************************************************************/
#if defined ISMODULE || defined MD_MODULE
#   include "MDM_mod.h"
#endif


/******************************************************************************/
/******************************************************************************/
/*** Declaration and definiton of system and module functions *****************/
/******************************************************************************/
/******************************************************************************/

/******************************************************************************/
/*** Basic interface (for internal use only!) *********************************/
/******************************************************************************/

/*** The prototype of any system or module function ***************************/

#define MD_PROTOTYPE(MD_name) MTcell MD_name ( MTcell   MV_args,               \
                                               long     MV_prev_func,          \
                                               long     MV_eval_type,          \
                                               MTcell   MV_exec     )

/*** Macros to create names of system and module function. 'MD_SF_NAME' is ****/
/*** used for system functions.  'MD_KF_NAME' is used for module functions ****/
/*** that were moved into the kernel sources. Furthermore the module gene- ****/
/*** rator defined 'MD_MF_NAME' to name module functions within modules.   ****/

#define MD_SF_NAME(MD_name)        MD_name
#define MD_KF_NAME(MD_name)        MFeval_ ## MD_name
#define MD_HIDDEN(MD_name)         __ ## MD_name

/*** Macros for an implizit declaration of module and system functions. To ****/
/*** make it possible to include module functions into the kernel sources, ****/
/*** module functions should be named with the macro 'MD_FUNC_NAME'.       ****/

#if defined ISMODULE || defined MD_MODULE
#  define MD_FUNC_NAME(MD_name)    MD_MF_NAME(MD_name)
#else
#  define MD_FUNC_NAME(MD_name)    MD_KF_NAME(MD_name)       
#endif
#define   MD_FUNC_DECL(MD_name)    MD_PROTOTYPE(MD_FUNC_NAME(MD_name))

/*** default init/exit code, macro to set remember table entries **************/

#define MD_INIT() {                                                            \
        if( !(MV_opt & MCnoeval) ) { /* for user-defined function headers */   \
            if( MV_opt & MChold ) {MV_eval_type |= MEVC_HOLD_BIT;}             \
            MEV_header( MV_args,                                               \
                    (long) MEVC_NULL_DEFAULT,                                  \
                    MV_prev_func, MV_eval_type, MV_exec,                       \
                    (long) MGSC_FLAT_ARG,                                      \
                    (long) MEVC_UNKNOWN,                                       \
                    &MVargs, 0L, MV_type,                                      \
                    (long) MEVC_NO_OVERLOAD, 0L, 0L, 0L                        \
            );                                                                 \
        } else {                                                               \
            MVargs = MV_args;                                                  \
            MMMcopy(MV_args);                                                  \
        }                                                                      \
        if( !(MV_opt & MCremember) ) {MEV_set_mam_control(MAMC_NO_WRITE_UP);}  \
}

#define MD_EXIT() {                                                            \
        {MMMfree(MVargs);}                                                     \
}

#define MD_REMTAB(MD_result) {                                                 \
        if( MV_opt & MCremember ) {	                                       \
          if(MMMequal(*MMMP(&MV_exec,3,MMMread),VALUE_READ(MUPV_CAT_NIL))){    \
             MMMfree(*MMMP(&MV_exec,3,MMMwrite));                              \
             *MMMP(&MV_exec,3,MMMwrite) = MTA_new_table(MMMCglobal);           \
             MMMinactiv(&MV_exec);                                             \
          }                                                                    \
          MTA_write_table(MMMP(&MV_exec,3,MMMread),MVargs,MTAC_FUNC,MD_result);\
	}                                                                      \
}

/*** The string  MD_MODSTR  contains the prefix of a function name. This is ***/
/*** "" for all kernel functions and something like "foo::" for module fun- ***/
/*** ctions. In the seconds case MD_MODSTR is defined by 'mmg'.             ***/

#ifndef MD_MODULE
#  define MD_MODSTR  ""
#endif

/*** Macro to define a module or system function, respectivly. The function ***/
/*** definiton consists of five parts:                                      ***/
/***                                                                        ***/
/***      MD_name     - basename of the function; the user's function name, ***/
/***                    also stored and used for error messages             ***/
/***      MD_options  - e.g.: MCdefault, MChold, MCremember,... to control  ***/
/***                    a special behaviour of the function.  Some options  ***/
/***                    may be dummies, only analysed and used by 'mmg'.    ***/
/***      MD_type     - CAT_ type of the function's result                  ***/
/***      MD_init     - name of the functions initialization code. This is  ***/
/***                    usually a macro, called with the arguments MD_name  ***/
/***                    MD_options and MD_ftype.                            ***/
/***      MD_body     - a {}-block, the body of the function                ***/
/***                                                                        ***/
#define MD_FUNC_HEADER( MD_name, MD_options, MD_type, MD_init )                \
        MD_FUNC_DECL(MD_name)                                                  \
        {                                                                      \
             jmp_buf      MV_jump;                                             \
             MTcell       MVargs;                         /* evaluated args */ \
             MTcell       MVdomkey = MFop(MV_exec,1);        /* mod. d. key */ \
             MTcell       MVdomain = MFnewDomain(MVdomkey);  /* mod. domain */ \
                  MFfree( MVdomain );                     /* no copy needed */ \
             long         MV_opt   = MD_options;          /* func. options  */ \
             long         MV_type  = MD_type;             /* result type    */ \
             const char*  MV_name  = MD_STRING(MD_name);                       \
                                                                               \
             {MD_init()}                                  /* initialization */ \
                                                                               \
             MV_errnum = 0;                                                    \
             MV_errstr = "unknown";                                            \
             memcpy((char*)MV_jump,(char*)MPAV_JumpLabel,sizeof(jmp_buf));     \
             if( setjmp(MPAV_JumpLabel) ) {               /* handle failure */ \
                 memcpy((char*)MPAV_JumpLabel,(char*)MV_jump,sizeof(jmp_buf)); \
                 if( MV_errnum > 0 ) {                                         \
                     char     buf[1024];                                       \
                     sprintf( buf, "%s [%s%s]", MV_errstr,MD_MODSTR,MV_name ); \
                     {MD_EXIT()}                                               \
                     MEV_set_error(MV_errnum,buf);                             \
                 } else if( MV_errnum < 0 ) {                                  \
                     MD_REMTAB(MV_result);                                     \
                     {MD_EXIT()}                                               \
                     return( MV_result );                                      \
                 } else {                                                      \
                     longjmp(MPAV_JumpLabel,1);                                \
                 }                                                             \
             } else {                                                          

#define MD_FUNC_FOOTER()                                                       \
             }                                                                 \
             return(MCnull);                                                   \
        }

#define MD_FUNC_DEF( MD_name, MD_options, MD_type, MD_init, MD_body )          \
        MD_FUNC_HEADER(MD_name,MD_options,MD_type,MD_init)                     \
        {MD_body}                                                              \
        MD_FUNC_FOOTER()                                                       

/******************************************************************************/
/*** Declaration and definiton of s & m functions (user interface) ************/
/******************************************************************************/

/*** Macros for explicit declarations of system or module functions. The ******/
/*** macro MD_MF_NAME is defined by 'mmg' accroding to the module name.  ******/

#define MF_SYS_FUNC(MD_name)     MD_PROTOTYPE(MD_name)
#define MF_MOD_FUNC(MD_name)     MD_PROTOTYPE(MD_MF_NAME(MD_name))

/*** Declaration/Definition of m functions with a standard initialization *****/

#define MF_FUNC_NAME(MD_name)                                                  \
        MD_FUNC_NAME(MD_name)
        
#define MF_FUNC_DECL(MD_name)                                                  \
        MD_FUNC_DECL(MD_name)
        
#ifdef MMG_NEW_STYLE
#  define MFUNC(MD_name, MD_options)                                           \
          MD_FUNC_HEADER( MD_name, MD_options, MEVC_NO_TYPE_CHECK, MD_INIT )
#  define MFEND                                                                \
          MD_FUNC_FOOTER()
#else
#  define MFUNC(MD_name, MD_options, MD_body)                                  \
          MD_FUNC_DEF(MD_name,MD_options,MEVC_NO_TYPE_CHECK,MD_INIT,MD_body)
#  define MFEND 
#endif

/******************************************************************************/
/******************************************************************************/
/*** Memory Management ********************************************************/
/******************************************************************************/
/******************************************************************************/

/*** Basic interface (for internal use only!!!) *******************************/

#define MFcat(s_)  (MMMZ(&(s_), CATEGORY, MMMread)->cat )
#define MFspec(s_) (MMMZ(&(s_), CATEGORY, MMMread)->spec)
#define MFext(s_)  ((CATEGORY_EXT*)(MMMZ(&(s_),char,MMMread)+sizeof(CATEGORY)))->ext


/******************************************************************************/
/* NAME:        MFmmmstring                                                   */
/* PARAMETER:   v = A character string (char*)                                */
/* FUNKTION:    Returns the address of the C string of the MMM_STRING 's'     */
/******************************************************************************/
inline char *MFmmmstring ( MTcell s )
{
    char *cstr = MMMmv(&s, sizeof(STRSIZE), char,  MMMread); 

    MMMinactiv(&s); 
    return(cstr); 
}


/*** User interface ***********************************************************/

/******************************************************************************/
/* NAME:        MFdom                                                         */
/* PARAMETER:   s = Any category (MTcell)                                     */
/* FUNKTION:    Returns the domain (basic type) of a category 's'.            */
/******************************************************************************/
inline short MFdom ( MTcell s )
{
    short c = MFcat(s);

    MMMinactiv(&s);
    return(c);
}

/******************************************************************************/
/* NAME:        MFcopy                                                        */
/* PARAMETER:   s = Any MuPAD value (MTcell)                                  */
/* FUNKTION:    Creates a logical copy (side-effect) of 's' and returns 's'.  */
/******************************************************************************/
inline MTcell MFcopy ( MTcell s )
{
    MMMcopy(s);
    return(s);
}

/******************************************************************************/
/* NAME:        MFchange                                                      */
/* PARAMETER:   s = Any MuPAD value (MTcell)                                  */
/* FUNKTION:    Creates a physical copy (side-effect) of 's' and returns it.  */
/******************************************************************************/
inline MTcell MFchange ( MTcell *s )
{
    MMMchange(s);
    return(*s);
}

/******************************************************************************/
/* NAME:        MFfree                                                        */
/* PARAMETER:   s = Any MuPAD value (MTcell)                                  */
/* FUNKTION:    Frees 's' (side-effect).                                      */
/******************************************************************************/
inline void MFfree ( MTcell s ) {
       MMMfree(s);
}

/******************************************************************************/
/* NAME:        MFnops                                                        */
/* PARAMETER:   s = Any MuPAD value (MTcell)                                  */
/* FUNKTION:    Returns the number of operands of 's'.                        */
/******************************************************************************/
inline long MFnops ( MTcell s ) {
       return( MMMcounter(s) );
}

/******************************************************************************/
/* NAME:        MFnops                                                        */
/* PARAMETER:   s = Any MuPAD value (MTcell)                                  */
/* FUNKTION:    Changes the number of operands of 's' to 'n'.                 */
/******************************************************************************/
inline void MFnops ( MTcell *s, long n ) {
       MMMnewcounter(s,n);
}

/******************************************************************************/
/* NAME:        MFopAdr                                                       */
/* PARAMETER:   s = Any MuPAD value (MTcell)                                  */
/*              n = Index in the range [0 .. MFnops(s)-1] (long)              */
/* FUNKTION:    Returns a pointer to the n-th operand of 's'.                 */
/******************************************************************************/
inline MTcell* MFopAdr ( MTcell s, long n )
{
    MTcell *son = MMMP(&s,n,MMMwrite);
    
    MMMinactiv(&s);
    return(son);
}

/******************************************************************************/
/* NAME:        MFopGet                                                       */
/* PARAMETER:   s = Any MuPAD value (MTcell)                                  */
/*              n = Index in the range [0 .. MFnops(s)-1] (long)              */
/* FUNKTION:    Returns the n-th operand of 's'.                              */
/******************************************************************************/
inline MTcell MFopGet ( MTcell s, long n ) {
       return( *MFopAdr(s,n) );
}

/******************************************************************************/
/* NAME:        MFopSet                                                       */
/* PARAMETER:   s = Any MuPAD value (MTcell)                                  */
/*              n = Index in the range [0 .. MFnops(s)-1] (long)              */
/*              t = Any MuPAD value (MTcell)                                  */
/* FUNKTION:    Sets the n-th operand of 's' to 't' and returns 't'.          */
/******************************************************************************/
inline MTcell MFopSet ( MTcell s, long n, MTcell t )
{
    *MMMP(&s,n,MMMwrite) = t;
    MMMinactiv(&s);
    return(t);
}

/******************************************************************************/
/* NAME:        MFop                                                          */
/* FUNKTION:    Refer to 'MFopGet'. 'MFop' should not be used in this file!   */
/******************************************************************************/
inline MTcell MFop ( MTcell s, long n ) {
       return( MFopGet(s, n) );
}
 
/******************************************************************************/
/* NAME:        MFop                                                          */
/* FUNKTION:    Refer to 'MFopSet'. 'MFop' should not be used in this file!   */
/******************************************************************************/
inline MTcell MFop ( MTcell s, long n, MTcell t ) {
       return( MFopSet(s, n, t) );
}
 
/******************************************************************************/
/* NAME:        MFopFree                                                      */
/* PARAMETER:   s = Any MuPAD value (MTcell)                                  */
/*              n = Index in the range [0 .. MFnops(s)-1] (long)              */
/* FUNKTION:    Frees the n-th operand of 's'.                                */
/******************************************************************************/
inline void MFopFree ( MTcell s, long n ) {
       MFfree( MFopGet(s,n) );
}

/******************************************************************************/
/* NAME:        MFopSubs                                                      */
/* PARAMETER:   s = Any MuPAD value (MTcell)                                  */
/*              n = Index in the range [0 .. MFnops(s)-1] (long)              */
/*              t = Any MuPAD value (MTcell)                                  */
/* FUNKTION:    Frees the n-th operand of 's' and sets it to 't'. 't' is      */
/*              NOT COPIED with this!                                         */
/******************************************************************************/
inline void MFopSubs ( MTcell *s, long n, MTcell t )
{
    MFcopy( *s ); 
    MFchange( s );
    MFopFree( *s, n );
    MFopSet( *s, n, t );
}

/******************************************************************************/
/* NAME:        MFsize                                                        */
/* PARAMETER:   s = Any MuPAD value (MTcell)                                  */
/* FUNKTION:    Returns the length of the memory part of 's'.                 */
/******************************************************************************/
inline long MFsize ( MTcell s ) {
       return( MMMsize(s) );
}

/******************************************************************************/
/* NAME:        MFsize                                                        */
/* PARAMETER:   s = Any MuPAD value (MTcell)                                  */
/*              n = New length of the mem part (long)                         */
/* FUNKTION:    Changes the length of the memory part of 's' to 'n' and       */
/*              returns the new length which may be larger than 'n'.          */
/******************************************************************************/
inline long MFsize ( MTcell *s, long n ) {
       MMMresize(s, n);
       return( MMMsize(*s) );
}

/******************************************************************************/
/* NAME:        MFmemGet                                                      */
/* PARAMETER:   s = Any MuPAD value (MTcell)                                  */
/* FUNKTION:    Returns a  'Read' Pointer to the memory part of 's'. Do not   */
/*              forget to use 'MFinactive' after using this Pointer!!!!!!!!   */
/******************************************************************************/
inline char* MFmemGet ( MTcell s, long offset=0 ) {
       return( ((char*) MMMZ(&s,char,MCread)) + offset );
}

/******************************************************************************/
/* NAME:        MFmemSet                                                      */
/* PARAMETER:   s = Any MuPAD value (MTcell)                                  */
/* FUNKTION:    Returns a 'Write' Pointer to the memory part of 's'. Do not   */
/*              forget to use 'MFinactive' after using this Pointer!!!!!!!!   */
/******************************************************************************/
inline char* MFmemSet ( MTcell s, long offset=0 ) {
       return( ((char*) MMMZ(&s,char,MCwrite)) + offset );
}

/******************************************************************************/
/* NAME:        MFinactive                                                    */
/* PARAMETER:   s = Any MuPAD value (MTcell**)                                */
/* FUNKTION:    Set a cell to state 'inactive' after accessing its operands.  */
/******************************************************************************/
#define MFinactive                                                            \
        MMMinactiv

/******************************************************************************/
/* NAME:        MFpoolInsert                                                  */
/* PARAMETER:   s = Any MuPAD value (MTcell**)                                */
/* FUNKTION:    Inserts '*s' into the pool of non-moveable memory.            */
/******************************************************************************/
#define MFpoolInsert                                                           \
        MMMpoolinsert

/******************************************************************************/
/* NAME:        MFpoolDelete                                                  */
/* PARAMETER:   s = Any MuPAD value (MTcell**)                                */
/* FUNKTION:    Removes '*s' from the pool of non-moveable memory.            */
/******************************************************************************/
#define MFpoolDelete                                                           \
        MMMpooldelete

/******************************************************************************/
/* NAME:        MFsig                                                         */
/* PARAMETER:   s = Any MuPAD value (MTcell**)                                */
/* FUNKTION:    Calculate the signature of cell 's'.                          */
/******************************************************************************/
inline void MFsig( MTcell s ) {
       MSG_sig(s);
}

/******************************************************************************/
/* NAME:        MFcmalloc                                                     */
/* PARAMETER:   n = Size of block to be allocated                             */
/* FUNKTION:    Allocated a memory block directly from the operating system.  */
/******************************************************************************/
inline void* MFcmalloc( size_t n ) {
       return( MMMEmalloc(n) );
}

/******************************************************************************/
/* NAME:        MFcfree                                                       */
/* PARAMETER:   -                                                             */
/* FUNKTION:    Frees a memory block allocated with 'MFcmalloc'.              */
/******************************************************************************/
inline void MFcfree( void* p ) {
       if( p != NULL ) MMMEfree((char*)p);
}


/******************************************************************************/
/******************************************************************************/
/*** Controlling of s/m functions defined with MF??? **************************/
/******************************************************************************/
/******************************************************************************/

/*** Accessing unevaluated and evaluated function arguments *******************/

/******************************************************************************/
/* NAME:        MV_nargs                                                      */
/* FUNKTION:    Number of arguments passed to the function (unevaluated!).    */
/******************************************************************************/
#define MV_nargs                                                               \
        ( MFnops(MV_args)-1 )

/******************************************************************************/
/* NAME:        MF_arg                                                        */
/* PARAMETER:   n = Index of a function argument (long).                      */
/* FUNKTION:    The 'n'-th argument passed to the function (unevaluated!).    */
/******************************************************************************/
#define MF_arg( n )                                                            \
        MFopGet(MV_args,n)

/******************************************************************************/
/* NAME:        MVnargs                                                       */
/* FUNKTION:    Number of arguments passed to the function (evaluated!).      */
/******************************************************************************/
#define MVnargs	( MFnops(MVargs)-1 )

/******************************************************************************/
/* NAME:        MFarg                                                         */
/* PARAMETER:   n = Index of a function argument (long).                      */
/* FUNKTION:    The 'n'-th argument passed to the function (evaluated!).      */
/******************************************************************************/
#define MFarg( n )                                                             \
        MFopGet(MVargs,n)

/******************************************************************************/
/* NAME:        MFnargsCheck                                                  */
/* PARAMETER:   n = Number of arguments that are allowed.                     */
/* FUNKTION:    Sets an error if the number of argument is unequal to 'n'.    */
/******************************************************************************/
#define MFnargsCheck( n ) {                                                    \
        if( MVnargs != n )                                                     \
            MFerror( "Wrong number of arguments" );                            \
}

/******************************************************************************/
/* NAME:        MFnargsCheckRange                                             */
/* PARAMETER:   n,m = Min/Max number of arguments that are allowed.           */
/* FUNKTION:    Sets an error if the number of argument is unequal to 'n'.    */
/******************************************************************************/
#define MFnargsCheckRange( n, m ) {                                            \
        if( MVnargs < n || MVnargs > m )                                       \
            MFerror( "Wrong number of arguments" );                            \
}

/******************************************************************************/
/* NAME:        MFargCheck                                                    */
/* PARAMETER:   n = Index of argument                                         */
/*              t = Expected type of argument                                 */
/* FUNKTION:    Sets an error if MFarg(n) is not of type 't'.                 */
/******************************************************************************/
#define MFargCheck( n, t ) {                                                   \
        switch( t ) {                                                          \
         case MCinteger:                                                       \
              if( !MFisInteger(MFarg(n)) ) MFerror( "Invalid argument" );      \
              break;                                                           \
         case MCnumber:                                                        \
              if( !MFisNumber(MFarg(n)) )  MFerror( "Invalid argument" );      \
              break;                                                           \
         case MCchar:                                                          \
              if( !MFisChar(MFarg(n)) )    MFerror( "Invalid argument" );      \
              break;                                                           \
         default:                                                              \
               if( MFdom(MFarg(n)) != t )  MFerror( "Invalid argument" );      \
        }                                                                      \
}

/*** Init and exit code for module functions **********************************/

/******************************************************************************/
/* NAME:        MF_exit                                                       */
/* PARAMETER:   -                                                             */
/* FUNKTION:    Free memory allocated by the standard initialization header   */
/******************************************************************************/
#define MF_exit                                                                \
        MD_EXIT

/******************************************************************************/
/* NAME:        MFreturn                                                      */
/* PARAMETER:   result = return value of the system/module function           */
/* FUNKTION:    Call exit code, update sign- bits and return function result  */
/******************************************************************************/
#define MFreturn( result )                                                     \
{                                                                              \
    MTcell   _xxxtmp = result;                                                 \
                                                                               \
    MD_REMTAB(_xxxtmp);                                                        \
    MF_exit();                                                                 \
    memcpy((char*)MPAV_JumpLabel,(char*)MV_jump,sizeof(jmp_buf));              \
    return( _xxxtmp );                                                         \
}

#define MFreturnAsync( result )                                                \
{                                                                              \
    GLOBAL_WRITE(MV_errnum, -1 );                                              \
    GLOBAL_WRITE(MV_errstr, "async" );                                         \
    GLOBAL_WRITE(MV_result, result );                                          \
    longjmp(MPAV_JumpLabel, 1);                                                \
}

/******************************************************************************/
/* NAME:        MFerror                                                       */
/* PARAMETER:   func = Name of the function in which this error occured.      */
/*              text = Error string.                                          */
/* FUNKTION:    Generates an error exception. (Only for use in MF_FUNC!)      */
/******************************************************************************/

/******************************************************************************/
/* NAME:        MFerror                                                       */
/* PARAMETER:   text = Error string.                                          */
/* FUNKTION:    Generates an error exception. (Only for use in MF_FUNC!)      */
/******************************************************************************/
#define MFerror( text )                                                        \
{                                                                              \
    GLOBAL_WRITE(MV_errnum, MEVC_USER_DEFINED_ERROR );                         \
    GLOBAL_WRITE(MV_errstr, text);                                             \
    longjmp(MPAV_JumpLabel, 1);                                                \
}


/******************************************************************************/
/******************************************************************************/
/*** Constant values **********************************************************/
/******************************************************************************/
/******************************************************************************/

/*** Boolean constants ********************************************************/

#define MVtrue           VALUE_READ( MUPV_CAT_BOOL_TRUE    )
#define MVfalse          VALUE_READ( MUPV_CAT_BOOL_FALSE   )
#define MVunknown        VALUE_READ( MUPV_CAT_BOOL_UNKNOWN )

/*** Some special arithmetic constants ****************************************/

#define MVi              VALUE_READ( MCAC_ci               )

#define MVzero           VALUE_READ( MCAC_zero             )
#define MVhalf           VALUE_READ( MCAC_half             )
#define MVone            VALUE_READ( MCAC_one              )
#define MVone_           VALUE_READ( MCAC_one_             )
#define MVtwo            VALUE_READ( MCAC_two              )
#define MVtwo_           VALUE_READ( MCAC_two_             )

/*** Other special constants **************************************************/

#define MVfail           VALUE_READ( MUPV_CAT_FAILED       )
#define MVnil            VALUE_READ( MUPV_CAT_NIL          )
#define MVnull           VALUE_READ( MUPV_CAT_NULL         )


/******************************************************************************/
/*** Convert basic types (MTbools,numbers,strings,identifiers) ***************/
/******************************************************************************/

/******************************************************************************/
/* NAME:        MFbool3                                                       */
/* PARAMETER:   s = An element of type DOM_BOOL (MTcell)                      */
/* FUNKTION:    According to 's' it returns MCtrue, MCfalse or MCunknown.     */
/******************************************************************************/
inline MTbool MFbool3( MTcell s )
{
    short e = MFext(s);
  
    MMMinactiv(&s);
    return( (MTbool) e );
}

/******************************************************************************/
/* NAME:        MFbool3                                                       */
/* PARAMETER:   v = One of the values MCtrue, MCfalse or MCunknown            */
/* FUNKTION:    According to 'v' it returns MVtrue, MVfalse or MVunknown.     */
/******************************************************************************/
inline MTcell MFbool3( MTbool v )
{
    switch( v ) {
      case MCtrue   : return( MFcopy(MVtrue   ) );
      case MCfalse  : return( MFcopy(MVfalse  ) );
      case MCunknown: return( MFcopy(MVunknown) );
      default       : return( MFcopy(MVfail   ) );
    }
}

/******************************************************************************/
/* NAME:        MFbool                                                        */
/* PARAMETER:   s = An element of type DOM_BOOL (MTcell)                      */
/* FUNKTION:    Converts TRUE to 1 (=true) and FALSE/UNKNOWN to 0 (=false).   */
/******************************************************************************/
inline MTbool MFbool ( MTcell s )
{
    short e = MFext(s);
   
    MMMinactiv(&s);
    if( e == MCtrue ) return( 1 );
    else              return( 0 );
}

/******************************************************************************/
/* NAME:        MFbool                                                        */
/* PARAMETER:   v = 0 (=false) or != 0 (=false)                               */
/* FUNKTION:    Converts 1 (=true) to TRUE and 0 (=false) to FALSE.           */
/******************************************************************************/
inline MTcell MFbool ( MTbool v )
{
    if( v ) return( MFcopy(MVtrue ) );
    else    return( MFcopy(MVfalse) );
}

#ifndef GRAPHIC
/******************************************************************************/
/* NAME:        MFdouble                                                      */
/* PARAMETER:   s = An element of type DOM_FLOAT (MTcell)                     */
/* FUNKTION:    Returns a C double of 's'.                                    */
/******************************************************************************/
inline double MFdouble ( MTcell s )
{
    return( MCA_cat_to_double(s) );
}

/******************************************************************************/
/* NAME:        MFdouble                                                      */
/* PARAMETER:   v = A floating point number (double)                          */
/* FUNKTION:    Returns a DOM_FLOAT of the value 'v'.                         */
/******************************************************************************/
inline MTcell MFdouble ( double v )
{
    return( MCA_new_cat_pari(MCstorage, MCA_double_to_pari(v)) );
}

/******************************************************************************/
/* NAME:        MFfloat                                                       */
/* PARAMETER:   Refer to MFdouble                                             */
/* FUNKTION:    Refer to MFdouble - for compatibility                         */
/******************************************************************************/
inline MTcell MFfloat ( float  v ) {
       return( MFdouble((double)v) );
}
inline float MFfloat ( MTcell  v ) {
       return( (float) MFdouble(v) );
}

/******************************************************************************/
/* NAME:        MFstring                                                      */
/* PARAMETER:   s = A character string (DOM_STRING)                           */
/*              option = MCaddr:address, MCcopy:copy the string               */
/* FUNKTION:    Returns the address of the C string of the DOM_STRING 's'     */
/******************************************************************************/
inline char *MFstring  ( MTcell s, long option=MCaddr) {
       return( MFstring1(s, option) );
}
#endif /*** GRAPHIC ***/

/******************************************************************************/
/* NAME:        MFstring                                                      */
/* PARAMETER:   v = A character string (char*)                                */
/* FUNKTION:    Returns a DOM_STRING of the value 'v'.                        */
/******************************************************************************/
inline MTcell MFstring ( char *v ) {
       return( MTR_new_cat_string(MCstorage,v) );
}

/******************************************************************************/
/* NAME:        MFident                                                       */
/* PARAMETER:   v = A character string (char*)                                */
/* FUNKTION:    Returns a DOM_IDENT of the value 'v'.                         */
/******************************************************************************/
inline MTcell MFident ( char *v ) {
       return( MTR_new_cat_ident(MCstorage,v) );
}

#ifndef GRAPHIC
/******************************************************************************/
/* NAME:        MFident                                                       */
/* PARAMETER:   v = A character string (char*)                                */
/* FUNKTION:    Returns a pointer to the C character string.                  */
/******************************************************************************/
inline char* MFident ( MTcell s, long option=MCaddr ) {
       return( MFstring1(s,option) );
}

/******************************************************************************/
/* NAME:        MFlong                                                        */
/* PARAMETER:   v = An integer (long)                                         */
/* FUNKTION:    Returns a DOM_INT of the value 'v'.                           */
/******************************************************************************/
inline MTcell MFlong ( long v ) {
       return( MCA_set_long(v) );
}

/******************************************************************************/
/* NAME:        MFlong                                                        */
/* PARAMETER:   v = An integer                                                */
/* FUNKTION:    Returns a DOM_INT of the value 'v'.                           */
/******************************************************************************/
inline MTcell MFlong ( int  v ) {
       return( MFlong((long)v) );
}

/******************************************************************************/
/* NAME:        MFlong                                                        */
/* PARAMETER:   s = An element of type DOM_FLOAT (MTcell)                     */
/* FUNKTION:    Returns a C long of 's'.                                      */
/******************************************************************************/
inline long MFlong ( MTcell s ) {
       return( MCA_cat_to_int(s) );
}

/******************************************************************************/
/* NAME:        MFint                                                         */
/* PARAMETER:   Refer to MFlong                                               */
/* FUNKTION:    Refer to MFlong - for compatibility                           */
/******************************************************************************/
inline MTcell MFint ( int  v ) {
       return( MFlong((long)v) );
}
inline int MFint ( MTcell  v ) {
       return( (int) MFlong(v) );
}

/******************************************************************************/
/* NAME:        MFrat                                                         */
/* PARAMETER:   numer = Numerator (DOM_INT), copy expected!                   */
/*              denom = Denominator  (DOM_INT), copy expected!                */
/* FUNKTION:    Returns the DOM_RAT 'numer/denom' and frees(!) the arguments. */
/******************************************************************************/
inline MTcell MFrat ( MTcell numer, MTcell denom ) {
       MTcell  r = MCA_calc(numer,denom,MCAC_DIV);
       MFfree(numer); MFfree(denom);
       if( MCM_equal(r,MVhalf) ) {
           MFfree(r);
           r = MFcopy(MVhalf);
       }
       return( r );
}

/******************************************************************************/
/* NAME:        MFrat                                                         */
/* PARAMETER:   numer = Numerator (long)                                      */
/*              denom = Denominator  (long)                                   */
/* FUNKTION:    Returns a DOM_RAT of the value 'numer/denom'.                 */
/******************************************************************************/
inline MTcell MFrat ( long numer, long denom ) {
    return( MFrat(MFlong(numer),MFlong(denom)) );
}

/******************************************************************************/
/* NAME:        MFratNum                                                      */
/* PARAMETER:   s = A rational number (DOM_RAT)                               */
/* FUNKTION:    Returns a copy of the numerator (DOM_INT) of the number 's'.  */
/******************************************************************************/
inline MTcell MFratNum ( MTcell s ) {
       return( MCA_new_cat_pari(MCstorage, numer(MCA_cat_to_pari(s))) );
}

/******************************************************************************/
/* NAME:        MFratDen                                                      */
/* PARAMETER:   s = A rational number (DOM_RAT)                               */
/* FUNKTION:    Returns a copy of the numerator (DOM_INT) of the number 's'.  */
/******************************************************************************/
inline MTcell MFratDen ( MTcell s ) {
       return( MCA_new_cat_pari(MCstorage, denom(MCA_cat_to_pari(s))) );
}

/******************************************************************************/
/* NAME:        MFcomplex                                                     */
/* PARAMETER:   re = Real part (INT/FLOAT/RAT), copy expected!                */
/*              im = Imaginary part  (INT/FLOAT/RAT), copy expected!          */
/* FUNKTION:    Returns the DOM_COMPLEX value 're+im*I' and frees(!) its      */
/*              argumemts.                                                    */
/******************************************************************************/
inline MTcell MFcomplex ( MTcell re, MTcell im ) {
       MTcell res = MCA_calc(im,MVi,MCAC_MULT); 
       MCA_calc_1(res,re,MCAC_PLUS);
       MFfree( re ); MFfree( im );
       return( res );
}

/******************************************************************************/
/* NAME:        MFcomplex                                                     */
/* PARAMETER:   re = Real part (long)                                         */
/*              im = Imaginary part  (long)                                   */
/* FUNKTION:    Returns a DOM_COMPLEX of the value 're+im*I'.                 */
/******************************************************************************/
inline MTcell MFcomplex ( long re, long im ) {
       return( MFcomplex(MFlong(re),MFlong(im)) );
}

/******************************************************************************/
/* NAME:        MFcomplex                                                     */
/* PARAMETER:   re = Real part (double)                                       */
/*              im = Imaginary part  (double)                                 */
/* FUNKTION:    Returns a DOM_COMPLEX of the value 're+im*I'.                 */
/******************************************************************************/
inline MTcell MFcomplex ( double re, double im ) {
       return( MFcomplex(MFdouble(re),MFdouble(im)) );
}

/******************************************************************************/
/* NAME:        MFcomplexRe                                                   */
/* PARAMETER:   s = A complex number (DOM_COMPLEX)                            */
/* FUNKTION:    Returns a copy of the real part of the number 's'.            */
/******************************************************************************/
inline MTcell MFcomplexRe ( MTcell s ) {
       return( MCA_complex_re(s) );
}

/******************************************************************************/
/* NAME:        MFcomplexIm                                                   */
/* PARAMETER:   s = A complex number (DOM_COMPLEX)                            */
/* FUNKTION:    Returns a copy of the imaginary part of the number 's'.       */
/******************************************************************************/
inline MTcell MFcomplexIm ( MTcell s ) {
       return( MCA_complex_im(s) );
}
#endif /* GRAPHIC */



/******************************************************************************/
/******************************************************************************/
/*** Types and Typechecking ***************************************************/
/******************************************************************************/
/******************************************************************************/

/*** User interface ***********************************************************/

#ifndef GRAPHIC
inline MTbool MFisApm       ( MTcell s ) { return( MFdom(s)==DOM_APM       ); }
#endif /* GRAPHIC */
inline MTbool MFisArray     ( MTcell s ) { return( MFdom(s)==DOM_ARRAY     ); }
inline MTbool MFisBool      ( MTcell s ) { return( MFdom(s)==DOM_BOOL      ); }
#ifndef GRAPHIC
inline MTbool MFisComplex   ( MTcell s ) { return( MFdom(s)==DOM_COMPLEX   ); }
#endif /* GRAPHIC */
inline MTbool MFisDebug     ( MTcell s ) { return( MFdom(s)==DOM_DEBUG     ); }
inline MTbool MFisDomain    ( MTcell s ) { return( MFdom(s)==DOM_DOMAIN    ); }
inline MTbool MFisExec      ( MTcell s ) { return( MFdom(s)==DOM_EXEC      ); }
inline MTbool MFisExt       ( MTcell s ) { return( MFdom(s)==DOM_EXT       ); }
inline MTbool MFisExpr      ( MTcell s ) { return( MFdom(s)==DOM_EXPR      ); }
inline MTbool MFisFail      ( MTcell s ) { return( MFdom(s)==DOM_FAIL      ); }
inline MTbool MFisFloat     ( MTcell s ) { return( MFdom(s)==DOM_FLOAT     ); }
inline MTbool MFisFunc      ( MTcell s ) { return( MFdom(s)==DOM_FUNC      ); }
inline MTbool MFisFuncArg   ( MTcell s ) { return( MFdom(s)==DOM_FUNCARG   ); }
inline MTbool MFisFuncEnv   ( MTcell s ) { return( MFdom(s)==DOM_FUNC_ENV  ); }
inline MTbool MFisIdent     ( MTcell s ) { return( MFdom(s)==DOM_IDENT     ); }
#ifndef GRAPHIC
inline MTbool MFisInt       ( MTcell s ) { return( MFdom(s)==DOM_INT       ); }
#endif /* GRAPHIC */
inline MTbool MFisList      ( MTcell s ) { return( MFdom(s)==DOM_LIST      ); }
inline MTbool MFisNamespace ( MTcell s ) { return( MFdom(s)==DOM_NAMESPACE ); }
inline MTbool MFisNil       ( MTcell s ) { return( MFdom(s)==DOM_NIL       ); }
inline MTbool MFisNull      ( MTcell s ) { return( MFdom(s)==DOM_NULL      ); }
inline MTbool MFisProc      ( MTcell s ) { return( MFdom(s)==DOM_PROC      ); }
inline MTbool MFisPoint     ( MTcell s ) { return( MFdom(s)==DOM_POINT     ); }
inline MTbool MFisPolygon   ( MTcell s ) { return( MFdom(s)==DOM_POLYGON   ); }
inline MTbool MFisPolynom   ( MTcell s ) { return( MFdom(s)==DOM_POLY      ); }
#ifndef GRAPHIC
inline MTbool MFisRat       ( MTcell s ) { return( MFdom(s)==DOM_RAT       ); }
#endif /* GRAPHIC */
inline MTbool MFisSet       ( MTcell s ) { return( MFdom(s)==DOM_SET       ); }
inline MTbool MFisString    ( MTcell s ) { return( MFdom(s)==DOM_STRING    ); }
inline MTbool MFisTable     ( MTcell s ) { return( MFdom(s)==DOM_TABLE     ); }
inline MTbool MFisTask      ( MTcell s ) { return( MFdom(s)==DOM_TASK      ); }


/*** Identify any type of a fun ***********************************************/
inline MTbool MFisFun       ( MTcell s ) 
{ FUNC *f=NULL; 
  return( MFdom(s)==DOM_EXEC &&  
	 (f=MTRC_CODE(MFopAdr(s, 0L), FUNC),1) && 
	 (f==MEV_eval_purefunc || f == MEV_eval_purefunc_hold)  ); 
}

/*** Identify any type of a number ********************************************/

#ifndef GRAPHIC
inline MTbool MFisInteger ( MTcell s ) { 
       return( MFisApm(s) || MFisInt(s) ); 
}
inline MTbool MFisNumber  ( MTcell s ) { 
       return( MFisInteger(s) || MFisComplex(s) || MFisFloat(s) || MFisRat(s) );
}
#endif /* GRAPHIC */

inline MTbool MFisChar  ( MTcell s ) { 
       return( MFisString(s) || MFisIdent(s) );
}

/*** Identify MTbool constants ***********************************************/

inline MTbool MFisTrue    ( MTcell s ) { 
       return( MFisBool(s) && MFbool3(s) == MCtrue   ); }
inline MTbool MFisFalse   ( MTcell s ) { 
       return( MFisBool(s) && MFbool3(s) == MCfalse  ); }
inline MTbool MFisUnknown ( MTcell s ) { 
       return( MFisBool(s) && MFbool3(s) == MCunknown); }

/*** Identify special arithmetic constants ************************************/

#ifndef GRAPHIC
inline MTbool MFisZero ( MTcell s ) {return( (MTbool) MCM_equal(s,MVzero) );}
inline MTbool MFisOne  ( MTcell s ) {return( (MTbool) MCM_equal(s,MVone ) );}
inline MTbool MFisHalf ( MTcell s ) {return( (MTbool) MCM_equal(s,MVhalf) );}
inline MTbool MFisOne_ ( MTcell s ) {return( (MTbool) MCM_equal(s,MVone_) );}
inline MTbool MFisTwo  ( MTcell s ) {return( (MTbool) MCM_equal(s,MVtwo ) );}
inline MTbool MFisTwo_ ( MTcell s ) {return( (MTbool) MCM_equal(s,MVtwo_) );}
inline MTbool MFisI    ( MTcell s ) {return( (MTbool) MCM_equal(s,MVi   ) );}
#endif /* GRAPHIC */

/*** Identify special expressions *********************************************/

#ifndef GRAPHIC
/******************************************************************************/
/* NAME:        MFisIdent                                                     */
/* PARAMETER:   s    = Any MuPAD Objects (DOM_...)                            */
/*              text = Name of identifier to check for                        */
/* FUNKTION:    Check if 's' is the idetifier 'text'.                         */
/******************************************************************************/
inline MTbool MFisIdent ( MTcell s, char *text )
{
    if( !MFisIdent(s) ) 
        return( _false_ );
    else if( strcmp(MFident(s),text) == 0 ) return( _true_ );
    else                                    return( _false_ );
}

/******************************************************************************/
/* NAME:        MFisString                                                    */
/* PARAMETER:   s    = Any MuPAD Objects (DOM_...)                            */
/*              text = Text of string to check for                            */
/* FUNKTION:    Check if 's' is the string 'text'.                            */
/******************************************************************************/
inline MTbool MFisString ( MTcell s, char *text )
{
    if( !MFisString(s) ) 
        return( _false_ );
    else if( strcmp(MFstring(s),text) == 0 ) return( _true_ );
    else                                     return( _false_ );
}

/******************************************************************************/
/* NAME:        MFisChar                                                      */
/* PARAMETER:   s    = Any MuPAD Objects (DOM_...)                            */
/*              text = Text of string to check for                            */
/* FUNKTION:    Check if 's' is the string or Identifier 'text'.              */
/******************************************************************************/
inline MTbool MFisChar  ( MTcell s, char *text ) { 
       return( MFisString(s,text) || MFisIdent(s,text) );
}

/******************************************************************************/
/* NAME:        MFisExpr                                                      */
/* PARAMETER:   s    = Any category (MTcell)                                  */
/*              type = type of expression (long), refer to MUP_constants.h    */
/* FUNKTION:    Returns _true_ if 's' is an expression of type 'type'. Refer  */
/*              to 'MUP_constants.h' "Systemfunktionen".                      */
/******************************************************************************/
inline MTbool MFisExpr ( MTcell s, long type )
{
    if( !MFisExpr(s) ) {
        return( _false_ );
    } else {
        MTcell   ident = MFop(s,0);

	if( MCM_compare_MMMstring_ident(MTRV_SYS_FUNC_LIST[type],ident) )
            return _true_;
	else
            return _false_;
    }
}

/******************************************************************************/
/* NAME:        MFisExpr                                                      */
/* PARAMETER:   s    = Any category (MTcell)                                  */
/*              type = A type of an expression (char*)                        */
/* FUNKTION:    Returns _true_ if 's' is an expression of type 'type'.        */
/******************************************************************************/
inline MTbool MFisExpr ( MTcell s, char *name ) 
{ 
    if( !MFisExpr(s) ) {
        return( _false_ );
    } else {
	if( strcmp(MFident(MFop(s,0)),name) == 0 ) return( _true_ );
        else                                       return( _false_ );
    }
}

/******************************************************************************/
/* NAME:        MFisExt                                                       */
/* PARAMETER:   s      = Any category (MTcell)                                */
/*              domain = A domain to be checked for                           */
/* FUNKTION:    Returns _true_ if 's' is an doomainelement of 'domain'        */
/******************************************************************************/
inline MTbool MFisExt ( MTcell s, MTcell domain )
{
    if( !MFisExt(s) ) {
        return( _false_ );
    } else {
        if( MCM_equal(MFop(s,0),domain) ) return( _true_ );
        else                              return( _false_ );
    }
}
#endif /* GRAPHIC */


/******************************************************************************/
/******************************************************************************/
/*** Further service functions ************************************************/
/******************************************************************************/
/******************************************************************************/

/******************************************************************************/
/*** Calling kernel built-in and library functions ****************************/
/******************************************************************************/

/******************************************************************************/
/* NAME:        MFcall                                                        */
/* PARAMETER:   s = Any MuPAD Objects (DOM_...)                               */
/*              n = Number of function arguments                              */
/* FUNKTION:    Call the MuPAD function 's' with the argument given.          */
/******************************************************************************/
#ifndef GRAPHIC

inline MTcell MFcall ( MTcell s, long n  Mva_arglist ) {
       MTcell  res;

       Mva_start( args, n );
       res = MFcall1( s, n, args );
       Mva_end( args );
       return( res );
}
inline MTcell MFcall ( char *cs, long n  Mva_arglist ) {
       MTcell  res;

       Mva_start( args, n );
       res = MFcall1( MFident(cs), n, args );
       Mva_end( args );
       return( res );
}
       

/******************************************************************************/
/******************************************************************************/
/*** Create non-atomic objects that cannot be converted from C objects ********/
/******************************************************************************/
/******************************************************************************/

/******************************************************************************/
/*** Numbers ******************************************************************/
/******************************************************************************/

#define MFnewInt     MFlong
#define MFnewApm     MFlong
#define MFnewFloat   MFdouble
#define MFnewComplex MFcomplex
#define MFnewRat     MFrat


/******************************************************************************/
/*** DOM_STRING/DOM_IDENT *****************************************************/
/******************************************************************************/
#define MFnewString  MFstring
#define MFnewIdent   MFident

inline long MFlenString ( MTcell s ) {
       return( strlen(MFstring(s)) );
}
inline long MFlenIdent ( MTcell s ) {
       return( strlen(MFident(s)) );
}


/******************************************************************************/
/*** DOM_EXPR *****************************************************************/
/******************************************************************************/

inline MTcell MFnewExpr ( MTcell s, long n=0 ) {
       return( MFnewExpr1(s, n) );
}
inline MTcell MFnewExpr ( long n  Mva_arglist ) {
       MTcell expr;

       Mva_start( args, n );
       expr = MFnewExpr2( n, args );
       Mva_end( args );
       return( expr );
}
inline MTcell MFnewExprSeq ( long n  Mva_arglist ) {
       MTcell expr;

       Mva_start( args, n );
       expr = MFnewSeq2( n, args );
       Mva_end( args );
       return( expr );
}
inline MTcell MFgetExpr( MTcell *s, long n ) {
       return( MFopGet(*s,n) );
}
inline void MFsetExpr( MTcell *s, long n, MTcell v ) {
       MFopSet( *s, n, v );
}
inline void MFfreeExpr( MTcell *s, long n ) {
       MFopFree( *s, n );
}
inline void MFsubsExpr( MTcell *s, long n, MTcell v ) {
       MFopSubs( s, n, v );
}
inline void MFnopsExpr( MTcell *s, long n ) {
       MFnops( s, n );
}
inline long MFnopsExpr( MTcell s ) {
       return( MFnops(s) );
}

/******************************************************************************/
/* NAME:        MFexpr2text                                                   */
/* PARAMETER:   s = Any MuPAD object (MTcell)                                 */
/* FUNKTION:    Convert 's' into a C string.                                  */
/******************************************************************************/
inline char *MFexpr2text ( MTcell s ) {
       MTcell tmp = MIO_expr2text(s);
       char   *cs = MMMmv(&tmp,sizeof(STRSIZE),char,MMMread);
       char   *rs = strdup((const char*)cs);
       MFfree( tmp );
       return( rs );
}

/******************************************************************************/
/* NAME:        MFtext2expr                                                   */
/* PARAMETER:   c = MuPAD expression given as a C character string.           */
/* FUNKTION:    Convert 'c' into a MuPAD expression (MTcell)                  */
/******************************************************************************/
inline MTcell MFtext2expr ( char *string, long ShowErrors=1 ) {
       MTcell tmp = MFstring(string);
       MTcell res = MPA_parse_string( MFop(tmp,0), ShowErrors );
       MFfree( tmp ); 
       return( res );
}
inline MTcell MF( char *string ) {
       return( MFtext2expr(string,1) );
}

/******************************************************************************/
/*** DOM_LIST *****************************************************************/
/******************************************************************************/

inline MTcell MFnewList ( long n ) {
       return( MTR_new_cat_stat_list(MCstorage, n) ); 
}
inline MTcell MFgetList( MTcell *s, long n ) {
       return( MFopGet(*s,n) );
}
inline void MFsetList( MTcell *s, long n, MTcell v ) {
       MFopSet( *s, n, v );
}
inline void MFfreeList( MTcell *s, long n ) {
       MFopFree( *s, n );
}
inline void MFsubsList( MTcell *s, long n, MTcell v ) {
       MFopSubs( s, n, v );
}
inline void MFnopsList( MTcell *s, long n ) {
       MFnops( s, n );
}
inline long MFnopsList( MTcell s ) {
       return( MFnops(s) );
}


/******************************************************************************/
/*** DOM_EXT ******************************************************************/
/******************************************************************************/

inline MTcell MFnewExt ( MTcell dom, long n ) {
       MTcell ext = MTR_new_cat_ext(MCstorage, n+1);
       MFopSet( ext, 0, dom );
       return( ext ); 
}
inline MTcell MFgetExt( MTcell *s, long n ) {
       return( MFopGet(*s,n) );
}
inline void MFsetExt( MTcell *s, long n, MTcell v ) {
       MFopSet( *s, n, v );
}
inline void MFfreeExt( MTcell *s, long n ) {
       MFopFree( *s, n );
}
inline void MFsubsExt( MTcell *s, long n, MTcell v ) {
       MFopSubs( s, n, v );
}
inline void MFnopsExt( MTcell *s, long n ) {
       MFnops( s, n ); 
}
inline long MFnopsExt( MTcell s ) {
       return( MFnops(s) );
}
inline MTcell MFdomExt( MTcell s ) {
       return( MFgetExt(&s,0) );
}


/******************************************************************************/
/*** DOM_SET ******************************************************************/
/******************************************************************************/

inline MTcell MFnewSet ( VOID ) {
       return( MSE_new_set(MCstorage) ); 
}
inline MTbool MFinSet( MTcell s, MTcell v ) {
       MTcell tmp, assmem = MFop(s,0);
       if( MAM_in(assmem,v,&tmp) ) return( _true_  );
       else                        return( _false_ );
}
inline void MFinsSet( MTcell s, MTcell v ) {
       MSE_insert( s, v );
}
inline MTcell MFunionSet( MTcell s, MTcell t ) {
       return( MSE_union(s,t) );
}
inline MTcell MFminusSet( MTcell s, MTcell t ) {
       return( MSE_minus(s,t) );
}
inline MTcell MFintersectSet( MTcell s, MTcell t ) {
       return( MSE_intersect(s,t) );
}
inline MTcell MFset2list ( MTcell v ) {
       return( MFcall(MF("(DOM_LIST@op)"), 1, MFcopy(v)) );
}
inline MTcell MFlist2set ( MTcell v ) {
       return( MFcall(MF("(DOM_SET@op)"), 1, MFcopy(v)) );
}
inline MTcell MFdelSet( MTcell s, MTcell v ) {
       MTcell  a = MFnewSet();
       MFinsSet( a, v );
       MTcell  b = MFminusSet( s, a );
       MFfree( s );
       MFfree( a );
       return( b );
}

/******************************************************************************/
/*** DOM_TABLE ****************************************************************/
/******************************************************************************/

inline MTcell MFnewTable ( VOID ) {
       return( MTA_new_table(MCstorage) ); 
}
inline void MFdelTable( MTcell *s, MTcell idx, long t=MTAC_ARG ) {
       MTA_write_table( s, idx, t, MVnil );
       MFfree( idx );
}
inline MTcell MFgetTable( MTcell *s, MTcell idx, long t=MTAC_ARG ) {
       MTcell  tmp;
       if( MTA_read_table(*s,idx,t,&tmp) ) 
           return( tmp );
       else
           return( MCnull );
}
inline MTbool MFinTable( MTcell *s, MTcell idx, long t=MTAC_ARG ) {
       MTcell  tmp = MFgetTable( s, idx, t );
       if( tmp == MCnull ) return( 0 );
       else { 
           MFfree( tmp );
           return( 1 );
       }
}
inline void MFinsTable( MTcell *s, MTcell idx, MTcell v, long t=MTAC_ARG ) {
       MTA_write_table( s, idx, t, v );
       MFfree( idx );
       MFfree( v );
}
inline MTcell MFtable2list ( MTcell v ) {
       return( MFcall(MF("(DOM_LIST@op)"), 1, MFcopy(v)) );
}
inline MTcell MFlist2table ( MTcell v ) {
       return( MFcall(MF("(table@op)"), 1, MFcopy(v)) );
}


/******************************************************************************/
/*** DOM_DOMAIN ***************************************************************/
/******************************************************************************/
inline void MFdelDomain( MTcell dom, MTcell idx ) {
       MEE_domain_insert( &dom, idx, MVnil );
       MFfree( idx );
}
inline MTcell MFgetDomain( MTcell dom, MTcell idx ) {
       return( MEE_domain_in(dom,idx) );
}
inline void MFinsDomain( MTcell dom, MTcell idx, MTcell val ) {
       MEE_domain_insert( &dom, idx, val );
       MFfree( idx );
       MFfree( val );
}
inline MTcell MFnewDomain ( MTcell key, MTbool *is_new ) {
       return( MEE_get_domain(key, is_new ) ); 
}
inline MTcell MFnewDomain ( MTcell key ) {
       MTbool is_new;
       return( MFnewDomain(key, &is_new ) ); 
}


/******************************************************************************/
/*** DOM_POLY *****************************************************************/
/******************************************************************************/
inline MTcell MFpoly2list( MTcell s, MTcell *u=NULL, MTcell *f=NULL ) {
       if( u != NULL ) *u = MFop(s,1);
       if( f != NULL ) *f = MFop(s,2);
       return( MFcall("poly2list",1,MFcopy(s)) );
}
inline MTcell MFlist2poly( MTcell s, MTcell u=MVnull, MTcell f=MVnull ) {
       return( MFcall("poly",3,MFcopy(s),MFcopy(u),MFcopy(f)) );
}
inline long MFdegPoly( MTcell s ){
       MTcell  dm = MFcall( "degree", 1, MFcopy(s) );
       long    dl = MFlong( dm );
       MFfree( dm );
       return( dl );
}

/******************************************************************************/
/*** DOM_ARRAY ****************************************************************/
/******************************************************************************/
inline MTcell MFarray2list( MTcell s ) {
       return( MFcall(MF("(DOM_LIST@op)"),1,MFcopy(s)) );
}
inline MTcell MFlist2array ( MTcell list, long a,long b=0,long c=0,long d=0 )
{  MTcell ra,rb,rc,rd;
   if( a ) ra=MFnewExpr(3,MFident("_range"),MFcopy(MVone),MFlong(a));
   else    ra=MFcopy(MVnull);
   if( b ) rb=MFnewExpr(3,MFident("_range"),MFcopy(MVone),MFlong(b));
   else    rb=MFcopy(MVnull);
   if( c ) rc=MFnewExpr(3,MFident("_range"),MFcopy(MVone),MFlong(c));
   else    rc=MFcopy(MVnull);
   if( d ) rd=MFnewExpr(3,MFident("_range"),MFcopy(MVone),MFlong(d));
   else    rd=MFcopy(MVnull);
   return(MFcall("array",5,ra,rb,rc,rd,MFcopy(list)));
}
inline long MFdimArray( MTcell a )
{
   MTcell tmp = MFcall( MFident("op"), 2, MFcopy(a), MFcopy(MVzero) );
   long   dim = MFlong( MFop(tmp,1) );
   MFfree(tmp);
   return( dim );
}
inline void MFrangeArray( MTcell a, long dim, long *l, long *r )
{
   MTcell tmp = MFcall( MFident("op"), 2, MFcopy(a), MFcopy(MVzero) );
   MTcell rng = MFop( tmp, dim+1 );
   *l = MFlong( MFop(rng,1) );
   *r = MFlong( MFop(rng,2) );
   MFfree( tmp );
}


/******************************************************************************/
/*** Othern data types ********************************************************/
/******************************************************************************/
inline MTcell MFnewDebug ( unsigned long value ) {
       return( MTR_new_cat_debug(MCstorage, value) ); 
}

inline MTcell MFnewExec ( long n ) {
       return( MTR_new_cat_exec(MCstorage, n) ); 
}

inline MTcell MFnewFuncArg ( long n ) {
       return( MTR_new_cat_funcarg(MCstorage, n) ); 
}

inline MTcell MFnewFuncEnv ( VOID ) {
       return( MTR_new_cat_func_env(MCstorage) ); 
}

inline MTcell MFnewPoint ( MTcell x, MTcell y, MTcell z, MTcell color=MVnil ) {
       return( MTR_new_cat_point(MCstorage, x, y, z, color) ); 
}

inline MTcell MFnewPolygon ( long n, MTcell *pv  = NULL, MTcell color = MVnil, 
                             MTcell closed = MVfalse, MTcell filled = MVnil ) {
       return( MTR_new_cat_polygon(MCstorage, n, pv, color, closed, filled) ); 
}

inline MTcell MFnewProc ( long n ) {
       return( MTR_new_proc(MCstorage, n) ); 
}

inline MTcell MFnewTask ( VOID ) {
       return( MTR_new_cat_task(MCstorage) ); 
}

/******************************************************************************/
/*** Get/Set identifiers ******************************************************/
/******************************************************************************/

inline MTcell MFgetVar( char* var ) {
       MTcell  tmp, ident = MFident( var );
       tmp = MFvalue1( ident, MCnull, 0 );
       MFfree( ident );
       return( tmp );
}
inline void MFsetVar( char* var, MTcell val ) {
       MFfree( MFcall("_assign",2,MFident(var),val) );
}
inline void MFdelVar( char* var ) {
       MFsetVar( var, MFcopy(MVnil) );
}

/******************************************************************************/
/*** Service functions and Creation of special objects ************************/
/******************************************************************************/

/******************************************************************************/
/* NAME:        MFdomtype/MFtype                                              */
/* PARAMETER:   s = Any MuPAD Objects (DOM_...)                               */
/* FUNKTION:    Call the MuPAD function (dom)type with argument 's'.          */
/******************************************************************************/

inline MTcell MFdomtype ( MTcell s ) {
       return( MFcall("domtype", 1, MFcopy(s)) );
}
inline MTcell MFtype ( MTcell s ) {
       return( MFcall("type", 1, MFcopy(s)) );
}
inline MTbool MFtesttype ( MTcell s, MTcell t ) {
       MTcell tmp = MFcall( "testtype", 2, MFcopy(s), MFcopy(t) );
       if( MFisTrue(tmp) ) { MFfree(tmp); return( 1 ); }
       else                { MFfree(tmp); return( 0 ); }
}

#if defined MD_SYSFUNC // Import functions calls for MuPAD builtin functions
#   include "MKT_msf.h"
#endif

/******************************************************************************/
/*** Compare ******************************************************************/
/******************************************************************************/

/******************************************************************************/
/* NAME:        MFequal                                                       */
/* PARAMETER:   s, t = Any MuPAD Objects (DOM_...)                            */
/* FUNKTION:    Check equality for any kind of MuPAD objects.                 */
/******************************************************************************/
inline MTbool MFequal ( MTcell s, MTcell t ) {
       return( (MTbool) MCM_equal(s,t) );
}

/******************************************************************************/
/* NAME:        MFcmp                                                         */
/* PARAMETER:   s, t = Any MuPAD Objects (DOM_...)                            */
/* FUNKTION:    Compare 's' with 't'. Return: -1(less), 0(equal), 1(greater). */
/******************************************************************************/
inline int MFcmp ( MTcell s, MTcell t ) {
       return( (int) MCM_compare_intern(s,t) );
}

/******************************************************************************/
/* NAME:        MFxxx - numerical comparations                                */
/* PARAMETER:   s, t = Any MuPAD Objects (DOM_...)                            */
/* FUNKTION:    Compare numerical data. 's' and 't' must be numbers.          */
/******************************************************************************/
inline MTbool MFeq ( MTcell s, MTcell t ) { return( (MTbool) MCA_eq (s,t) ); }
inline MTbool MFneq( MTcell s, MTcell t ) { return( (MTbool) MCA_neq(s,t) ); }
inline MTbool MFlt ( MTcell s, MTcell t ) { return( (MTbool) MCA_lt (s,t) ); }
inline MTbool MFle ( MTcell s, MTcell t ) { return( (MTbool) MCA_le (s,t) ); }
inline MTbool MFgt ( MTcell s, MTcell t ) { return( (MTbool) MCA_gt (s,t) ); }
inline MTbool MFge ( MTcell s, MTcell t ) { return( (MTbool) MCA_ge (s,t) ); }


/******************************************************************************/
/*** Arbitrary Precision Numbers **********************************************/
/******************************************************************************/

/******************************************************************************/
/* NAME:        MFpari                                                        */
/* PARAMETER:   s = MuPAD number (refer to MFisNumber())                      */
/* FUNKTION:    Returns the address of the embedded PARI number.              */
/******************************************************************************/
inline GEN    MFpari ( MTcell s ) {
       return( MCA_cat_to_pari(s) );
}

/******************************************************************************/
/* NAME:        MFpari                                                        */
/* PARAMETER:   s = PARI number                                               */
/* FUNKTION:    Creates a MuPAD number. The PARI number is copied for this.   */
/******************************************************************************/
inline MTcell MFpari ( GEN s ) {
       return( MCA_pari_to_cat(s) );
}


/******************************************************************************/
/*** Arithmetic ***************************************************************/
/******************************************************************************/

inline void MFsubto (MTcell*s, MTcell t) {
       MCA_calc_1(*s,t,MCAC_MINUS);
       MFfree(t);
}
inline void MFaddto (MTcell*s, MTcell t) {
       MCA_calc_1(*s,t,MCAC_PLUS);
       MFfree(t);
}
inline void MFmultto(MTcell*s, MTcell t) {
       MCA_calc_1(*s,t,MCAC_MULT);
       MFfree(t);
}
inline void MFdivto (MTcell*s, MTcell t) {
       MCA_calc_1(*s,t,MCAC_DIV);
       MFfree(t);
}
inline void MFinc (MTcell*s) { MFaddto(s,MFcopy(MVone)); }
inline void MFdec (MTcell*s) { MFsubto(s,MFcopy(MVone)); }

inline MTcell MFadd   (MTcell s, MTcell t) {
       MTcell tmp = MCA_calc(s,t,MCAC_PLUS);
       MFfree(s); MFfree(t);
       return( tmp );
}
inline MTcell MFsub   (MTcell s, MTcell t) {
       MTcell tmp = MCA_calc(s,t,MCAC_MINUS);
       MFfree(s); MFfree(t);
       return( tmp );
}
inline MTcell MFmult  (MTcell s, MTcell t) {
       MTcell tmp = MCA_calc(s,t,MCAC_MULT);
       MFfree(s); MFfree(t);
       return( tmp );
}
inline MTcell MFdiv   (MTcell s, MTcell t) {
       MTcell tmp = MCA_calc(s,t,MCAC_DIV);
       MFfree(s); MFfree(t);
       return( tmp );
}
inline MTcell MFdivInt(MTcell s, MTcell t) {
       MTcell tmp = MCA_calc(s,t,MCAC_DIVG);
       MFfree(s); MFfree(t);
       return( tmp );
}
inline MTcell MFpower (MTcell s, MTcell t) {
       MTcell tmp = MCA_calc(s,t,MCAC_POWER);
       MFfree(s); MFfree(t);
       return( tmp );
}
inline MTcell MFmod   (MTcell s, MTcell t) {
       MTcell tmp = MCA_calc(s,t,MCAC_MOD);
       MFfree(s); MFfree(t);
       return( tmp );
}
inline MTcell MFmods  (MTcell s, MTcell t) {
       MTcell tmp = MCA_calc(s,t,MCAC_MODS);
       MFfree(s); MFfree(t);
       return( tmp );
}

inline MTcell MFbinom (MTcell s, MTcell t) {return( MFcall("binomial",2,s,t) );}
inline MTcell MFexp   (MTcell s)           {return( MFcall("exp",1,s)   ); }
inline MTcell MFgcd   (MTcell s, MTcell t) {return( MFcall("gcd",2,s,t) ); }
inline MTcell MFlcm   (MTcell s, MTcell t) {return( MFcall("lcm",2,s,t) ); }
inline MTcell MFln    (MTcell s)           {return( MFcall("ln",1,s)    ); }
inline MTcell MFsqrt  (MTcell s)           {return( MFcall("sqrt",1,s)  ); }

inline MTbool MFisNeg (MTcell s) { return( MCA_is_neg(s) ); }
inline MTcell MFneg   (MTcell s) { return( MFmult(s,MFcopy(MVone_)) ); }
inline MTcell MFrec   (MTcell s) { return( MFdiv (MFcopy(MVone),s) ); }
inline MTcell MFabs (MTcell s) { 
       MTcell tmp;
       if( MFisComplex(s) ) { tmp = MCA_abs(s); MFfree(s); }
       else if(MFisNeg(s) ) tmp = MFmult(s,MFcopy(MVone_));
       else                 tmp = s;
       return( tmp );
}

/******************************************************************************/
/*** Boolean Operators ********************************************************/
/******************************************************************************/

inline MTcell MFnot( MTcell s ) {/*** must be a boolean constant ***/
       MTcell tmp;
       if     ( MFbool3(s) == MCtrue  ) tmp = MFcopy(MVfalse);
       else if( MFbool3(s) == MCfalse ) tmp = MFcopy(MVtrue);
       else                             tmp = MFcopy(MVunknown);
       MFfree(s);
       return(tmp);
}


/******************************************************************************/
/*** Input/Output *************************************************************/
/******************************************************************************/

/******************************************************************************/
/* NAME:        MFputs                                                        */
/* PARAMETER:   str = A character string                                      */
/* FUNKTION:    Print a unformatted character string in MuPAD.                */
/******************************************************************************/
inline void MFputs( char *str ) {
       MIO_print_string(str);
       MIO_print_string("\n");
}

/******************************************************************************/
/* NAME:        MFprintf                                                      */
/* PARAMETER:   str = A character string                                      */
/*              ... = Optional list of value (refer to 'printf')              */
/* FUNKTION:    Print a formatted character string in MuPAD.                  */
/******************************************************************************/
inline int MFprintf ( char *format Mva_arglist ) {
       int  res;

       Mva_start( args, format );
       res = MFprintf1( format, args );
       Mva_end( args );
       return( res );
}

/******************************************************************************/
/* NAME:        MFout                                                         */
/* PARAMETER:   s = Any MuPAD object (MTcell)                                 */
/* FUNKTION:    Print a MuPAD object                                          */
/******************************************************************************/
inline MTcell MFout ( MTcell s ) {
  MMMlock(MIOlock);
  MIO_out(s);
  MMMunlock(MIOlock);
  return( s );
}


/******************************************************************************/
/*** Evaluation ***************************************************************/
/******************************************************************************/

inline MTcell MFexec ( MTcell s ) {
       MTcell  tmp = MEV_execute(s);
       MFfree( s );
       return( tmp );
}

inline MTcell MFeval( MTcell s ) {
       MTcell  tmp = MEV_eval(s,MEVC_ANY,MEVC_EVAL);
       MFfree( s );
       return( tmp );
}

inline MTcell MFread( char* name ) {
       return( MFcall("read",1,MFstring(name)) );
}

inline MTcell MFtrap( MTcell s, long *error ) {
       MTcell var = MFident( "!trap?tmp!" );
       MTcell exp = MFnewExpr( 3, MFident("_assign"), MFcopy(var), s );
       MTcell res = MFcall( "traperror", 1, exp );
       *error = MFlong( res );
       MFfree( res );
       if( *error ) res = MFcopy(MVnull);
       else         res = MFvalue1( var, MCnull, 0 );
       MFdelVar( MFstring(var) );
       MFfree( var );
       return( res );
}

/******************************************************************************/
/*** Kernel-Management ********************************************************/
/******************************************************************************/
inline void MFterminate ( VOID ) {
       MUP_mainexit();
}

inline void MFglobal ( MTcell *s ) {
       MMMinsert_global( s );
}

inline char* MFuserOpt( VOID ) {
       return( MFstring(VALUE_READ(MEVV_pref).useroptions) );
}

/******************************************************************************/
/*** Module-Management ********************************************************/
/******************************************************************************/

inline MTbool MFdisplace( VOID ) {
       return( MDM_kick_out() );
}

inline MTbool MFstatic( CONST char *name, short mode=1 )
{
       MDM_mod_t *m = MDM_get_entry( name );
       if ( m == NULL ) return( 0 );
       else if( mode==1 ) { m->flags|= MDMC_NO_UNLOAD; return( 1 ); }
       else               { m->flags&=~MDMC_NO_UNLOAD; return( 1 ); }
}

#endif /*** GRAPHIC ***/

#endif /*** __MKT_func__ ***/
