/* $Date: 1995/07/21 09:34:34 $  $Author: andi $  $Revision: 1.2 $ */

/**************************************************************************
**                         MMMglobal.h                                   **
** In diesem File werden die globalen Variablen, die von der MuPAD       **
** Memory Management verwendet werden, definiert. Dieses File darf nur   **
** von MMMSpeicher.c aus, und von dort muss es muss es auch, included    **
** werden.                                                               **
**************************************************************************/

#ifndef __MMMglobal__
#define __MMMglobal__


long MMMV_new_header ; /*Diese Variable gibt an, wieviele header neu erzeugt
                        werden, wenn nicht mehr genuegend vorhanden sind*/
long MMMV_new_lheader ;/*Diese Variable gibt an, wiele freie lheader neu
                     erzeugt werden, wenn nicht mehr genuegend vorhanden sind*/
long *MMMV_mem ; /*In dieser globalen Variablen wird ein
                   Array von long-Werten gespeichert. Am Anfang zeigt
                   diese Variable auf das Array MMMV_mem_init[], waehrend des
                   Programmes zeigt es auf MMMV_mem_step[]. Naehere
                   Informationen siehe diese Variablen*/
long MMMVused_blocks ; /*In dieser Variablen wrid gespeichert, wieviele Bloecke
             zur Speicherung von Daten benutzt werden*/
long MMMVused_memory ; /*In dieser Variablen wird gespeichert, wieviele Bytes an
             Speicher benutzt werden */
long MMMVreserved_blocks ; /*In dieser Variablen wird gespeichert, wieviele
             Bloecke von der Speicherverwaltung reserviert sind */
long MMMVreserved_memory ; /*In dieser Variablen wird gespeichert, wieviele Bytes
             von der Speicherverwaltung reserviert sind. Nicht der ganze
             reservierte Speicher muss auch benutzt werden*/
long MMMVrealfrees ; /*In dieser Variablen wird die Anzahl der MMMfree()
             Aufrufe gezaehlt, die den Speicher wirklich freigegeben haben */
long MMMVfrees ; /*In dieser Variablen wird die Anzahl der MMMfree() Aufrufe
             gezaehlt, die nicht MMMNULL als Argument haben*/
long MMMVmallocs ; /*In dieser Variablen wird die Anzahl aller MMMmalloc()
             Aufrufe gezaehlt. Hierbei werden auch Aufrufe gezaehlt, die
             intern von der Speicherverwaltung durchgefuehrt werden, z.B. bei
             einem MMMresize(). */ 



struct MMMTBelegung MMMVBelegung [MMMCupper_index+1] ; /*In dieser Variablen werden
             die Listen der freien Speicherbloecke verschiedener Groesse verwaltet*/
MMMheader MMMVfreeheader ; /*Dieser header ist der erste header in der Liste
                             der header, die noch zu keinem Speicherbereich
                             gehoeren*/
long MMMVheaders ; /*Diese Variable gibt an, wieviele freie header sich noch
                     in der Liste, die mit MMMVfreeheader beginnt, befinden.
                     MMMVfreeheader ist dabei nicht mitgezaehlt*/
struct MMMSpeicher *MMMV_sp_header ; /*Dies ist ein Zeiger auf eine Liste der
                       Speicherbereiche, in denen header stehen*/
MMMlheader MMMVfreelheader ;/*Dieser lheader ist der erste lheader in der
                              Liste der lheader, die noch zu keinem
                              Speicherbereich gehoeren*/
long MMMVlheaders ; /*Diese Variable gibt an, wieviele freie header sich noch
                     in der Liste, die mit MMMVfreelheader beginnt, befinden.
                     MMMVfreelheader ist dabei nicht mitgezaehlt*/
struct MMMSpeicher *MMMV_sp_lheader ; /*Dies ist ein Zeiger auf eine Liste der
                       Speicherbereiche, in denen lheader stehen*/

void (*MMMVsystemfree)(/*S_Pointer p*/) ; /*Funktion die bei wirklicher
                     Freigabe von p aufgerufen wird, falls der Inhalt von p
                     in speicherverwaltungsfremden Speicher steht*/

#ifdef MMMMOVE
MMMTPoolHeader MMMVpool ;
MMMTMemList *MMMVMemList ;
long MMMVmoves ;
long MMMVactiv_pointers ;
#endif

#endif /* __MMMglobal__ */
