/* $Date: 1996/11/28 21:13:08 $  $Author: kg $  $Revision: 1.4 $ */

/**************************************************************************
**                        MMMSpeicherHilf.h                              **
** In diesem File werden die Funktionen deklariert, die im File          **
** MMMSpeicherHilf.c definiert sind. D.h. dieses File muss included      **
** werden, damit die dort definierten Funktionen benutzt werden koennen. **
** Erstellung      : 24/09/90                                            **
** Letzte Aenderung: 02/06/93                                            **
** Autor           : Holger Naundorf                                     **
**************************************************************************/

#ifndef __MMMstorage_help__
#define __MMMstorage_help__

#ifndef MMMDACTIV
#  define MMMactivate(p,art)
#else
   void MMMactivate( S_Pointer *p, long art );
#endif

long MMMblocklength ( S_Pointer p ) ;
void MMMDeclare_pointers ( S_Pointer p ) ;
void MMMFree_pointers ( S_Pointer p ) ;
void MMMfree_sp_list ( struct MMMSpeicher *s ) ;
void MMM_copy (S_Pointer p , S_Pointer q ) ;
void MMMlower_anz ( S_Pointer p ) ;
void MMMupper_anz ( S_Pointer p ) ;
long MMM_Bindex ( long l ) ;
long MMM_Bsize ( long i ) ;
void MMM_new_header ( long l ) ;
void MMM_new_lheader ( long l ) ;
void MMM_block_to_freelist ( S_Pointer p ) ;
void MMMadd_header ( long i , struct MMMSpeicher *s ) ;
void MMM_enlarge_freelist ( long i , long size ) ;
S_Pointer MMM_block_fro_freelist ( long size ) ;
void MMMensure ( S_Pointer *p ) ;
S_Pointer MMMMalloc ( long typ , long size , long count ) ;
S_Pointer MMMPalloc ( long typ , long size , long count ) ;
S_Pointer MMMCalloc ( long typ , long size , long count ) ;

/**************************************************************************
** Es folgen die Deklarationen von Funktionen, die von der               **
** Speicherverwaltung benoetigt werden.                                  **
** Ist MAC definiert, so werden andere Funktionen daclariert, als wenn   **
** MAC nicht definiert ist.                                              **
**************************************************************************/


/**************************************************************************
** Es folgen interne Makros fuer die Speicherverwaltung. Diese Makros    **
** sollten nicht von aeusseren Funktionen benutzt werden.                **
**************************************************************************/
/*************************************************************************
** void MMMifmmalloc (Zeiger z , long anz , Typ T)                      **
** Dieser Makro allociert Speicherplatz fuer anz Varaiblen vom Typ T.   **
** In z wird der Zeiger auf diesen Speicher zurueckgegeben. Der Makro   **
** ueberprueft dabei auch, ob es ihm gelungen ist den Speicher zu       **
** allocieren. Falls dies nicht der Fall ist, so gibt der Makro         **
** "no memory!!" aus und beendet das Programm.                          **
*************************************************************************/
#define MMMifmalloc(z,anz,T) if((z=(T *)malloc((anz)*sizeof(T)))==NULLL) {z=(T *)MMMVno_memory(_false_) ; } ;
 
/*************************************************************************
** long MMMmultipleofblock ( long size )                                **
** Dieser Makro ein n zurueck, welches folgende Bedingungen erfuellt:   **
** (1) n > size                                                         **
** (2) n ist Vielfaches von MMMCblocklength+1                           **
*************************************************************************/
#define MMMmultipleofblock(size) ((size + MMMCblocklength) & MMMCmultipleofblock)
 

/*************************************************************************
** Zahl MMMmin (Zahl a , b )                                            **
** Das Makro liefert das Minimum von a und b                            **
*************************************************************************/
#define MMMmin(a,b) ((a)<(b)?(a):(b))

/*************************************************************************
** Zahl MMMabs ( Zahl a )                                               **
** Das Makro liefert das Absolute der Zahl a                            **
*************************************************************************/
#define MMMabs(a) ((a)<0?-(a):(a))


/*************************************************************************
** Zahl MMMmax ( Zahl a , b )                                           **
** Das Makro liefert das Maximum der Zahln a und b                      **
*************************************************************************/
#define MMMmax(a,b) ((a)<(b)?b:a)

/*************************************************************************
** Es folgt eine Liste von Konstanten, die in der Speicherverwaltung    **
** benoetigt werden, die aber nicht an andere Programmme herausgereicht **
** werden.                                                              **
*************************************************************************/
#define MMMCmindestblock 2 /*2^MMMmindestblock ist die kleinste Groesse, die
                      ein Speicherbereich annehmen kann*/
#define MMMCblocklength 3L /*Dieser Wert muss 2^MMMmindextblock-1 sein*/
#define MMMCmaxblock 255L /*Gibt die groesste Groesse eines Blockes an, der noch
                      einen Index != 0 hat.
                      Der Wert ist (MMMCupper_index+1)*(MMMCblocklength+1) */
#define MMMCcountErw 255 /*Dies ist der Wert, der angibt, das es sich bei dem
                      Header um einen lheader handelt*/
#define MMMCmultipleofblock 0xfffffffcL  /*Dieser Wert muss in den letzten
                      MMMCmindestblock Bits Nullen enthalten, sonst Einsen.
                      Durch ihn werden Speichergroessen auf ein Vielfaches der
                      Blocklaenge gebracht */
#define MMMCtypErw 255 /*Dies ist der Wert der Angibt, dass am Ende des Speichers
                      eine long-Zahl steht, die den Typ des Bereiches angibt*/
#define MMMCsizeoflong 2 /*2^MMMCsizeoflong==sizeof(long)*/
#define MMMCunmoveable 0x7fffffff /*Mit dieser Maske wird das Bit aus-
                      geblendet, das in length angibt, ob der Speicher
                      des S-Zeigers verschiebbar ist*/
#define MMMCinactiv 3L /*Dies kennzeichnet, dass ein S-Zeiger-Inhalt
                      inaktiv ist*/
/*************************************************************************
** Es folgt eine Liste von fuer die Speicherverwaltung globalen         **
** Variablen. Die hier deklarierten globalen Variablen koennnen nur von **
** von Speicherverwaltung benutzt werden, sie werden nicht nach aussen  **
** gereicht.                                                            **
*************************************************************************/
#ifndef MMMDSpeicher
extern MMMheader MMMVfreeheader ; /*Dieser header ist der erste header in der Liste
                             der header, die noch zu keinem Speicherbereich
                             gehoeren*/
extern long MMMVheaders ; /*Diese Variable gibt an, wieviele freie header sich noch
                     in der Liste, die mit MMMVfreeheader beginnt, befinden.
                     MMMVfreeheader ist dabei nicht mitgezaehlt*/
extern struct MMMSpeicher *MMMV_sp_header ; /*Dies ist ein Zeiger auf eine Liste der
                       Speicherbereiche, in denen header stehen*/
extern MMMlheader MMMVfreelheader ;/*Dieser lheader ist der erste lheader in der
                              Liste der lheader, die noch zu keinem
                              Speicherbereich gehoeren*/
extern long MMMVlheaders ; /*Diese Variable gibt an, wieviele freie header sich noch
                     in der Liste, die mit MMMVfreelheader beginnt, befinden.
                     MMMVfreelheader ist dabei nicht mitgezaehlt*/
extern struct MMMSpeicher *MMMV_sp_lheader ; /*Dies ist ein Zeiger auf eine Liste der
                       Speicherbereiche, in denen lheader stehen*/

#endif /* MMMDSpeicher */

#endif /* __MMMstorage_help__ */
