
/*************************************************************************
**                         MMMstorage.h                                 **
**                       !!!! Achtung !!!!                              **
**                !!! Dieses File immer zuerst includen !!!             **
**                                                                      **
** In diesem File sind die Strukturen und Makros definiert, die von der **
** Speicherverwaltung benoetigt werden.                                 **
** Autor            :  Holger Naundorf                                  **
** Erstellungsdatum :  25/07/91                                         **
** Letzte Aenderung :  06/08/92 (kg)					**
**			MMMread_ulong: 2.ter Parameter fuer Fehlerm.    **
** Letzte Aenderung :  11/05/93 (jerry)					**
**			#pragme once Direktive fuer Mac                 **
*************************************************************************/

#ifndef __MMMstorage_seq__
#define __MMMstorage_seq__

#ifdef MACINTOSH
#pragma once
extern int 	MACV_EVENT_TIME;
extern Boolean	gfRegistered;
void   MAC_event(void);
#endif

#include <signal.h>
#include <stdio.h>
#define MEXDSTANDARD
#ifdef PARALLEL
#   define MEXDPARALLEL
#   define MMMDshared
#endif



#if (defined SGI) && (defined PARALLEL)
#   define MMMDLOCKSPACE
           /* Ist dieses Definement gesetzt, so werden die Locks in
              einem eigenen Speicherbereich verwaltet und m"ussen
              mit einer eigenen Allokierungsfunktion angefordert
              werden. Insgesamt mu"s eine Referenzierungsstufe mehr
              verwendet werden. */
#endif

#if (defined SPP1000) && (defined PARALLEL)
#   define MMMDLOCKSPACE
/* Locks werden zwar nicht in einem eigenen Speicherbereich gehalten,
   aber die Anfangsadresse eines Locks muss bestimmte Bedingung erfuellen.
*/
#endif

#ifdef __MDE_declare__
#error Das Headerfile MDE_declare.h darf an dieser Stelle noch nicht \
eingebunden worden sein. Deshalb wird ein Fehler erzeugt.
#endif
#ifdef __MEX_extern__
#error Das Headerfile MEX_extern.h darf an dieser Stelle noch nicht \
eingebunden worden sein. Deshalb wird ein Fehler erzeugt.
#endif

#ifdef DOS_FILENAMES
#  include "MDE_decl.h"
#  include "MEX_ext.h"
#else
#  include "MDE_declare.h"
#  include "MEX_extern.h"
#endif

#ifdef MMMDCOLLECTFREES
#   define MMMDREFSUNCERTAIN
#endif

/*************************************************************************
** Im folgenden Abschnitt werden Strukturen definiert, die im           **
** Zusammenspiel mit der Aussenwelt notwendig sind.                     **
*************************************************************************/

#ifdef MACINTOSH
typedef Handle		  MMMThandle;
#else
typedef MCLT_iostream MMMThandle ;
#endif

/************************************************************************* 
** Im folgenden Abschnitt werden die Strukturen definiert, die von      **
** der Speicherverwaltung benoetigt werden.                             **
*************************************************************************/

/*** andi: sonst gibt es Probleme mit den Modulen ***********************/
#ifdef HP              
typedef unsigned long ulong ;
typedef unsigned char uchar ;
#endif

#define ulong uns_long
#define ushort uns_short
#define uchar uns_char

#ifdef RS6000
typedef unsigned int ulong ;
#else
typedef unsigned long ulong ;
#endif

typedef unsigned short ushort; 
typedef unsigned char uchar ;
#ifdef MSDOS
typedef unsigned char MUPbool ;
#else
typedef long MUPbool ;
#endif
#define MTbool MUPbool   // Fuer Module

typedef ulong MMMulong; // ;-)

#ifdef PARALLEL
#   ifdef SOLARIS
      typedef struct 
      {
         long a ;
         long b ;
         long c ;
         long d ;
         long e ;
         long f ;
         long g ;
         long h ;
      } MMMTlock ;
      typedef char MMMTreallock ;
#   endif /* SOLARIS */
#   ifdef sequent
      typedef slock_t MMMTlock ;
      typedef slock_t MMMTreallock ;
#   endif /* sequent */
#   ifdef SGI
      typedef lockmeter_t MMMTlock ;
      typedef lockmeter_t MMMTreallock ;
#   endif /* SGI */
#   ifdef SPP1000
      typedef msemaphore MMMTlock ;
      typedef msemaphore MMMTreallock ;
#   endif /* SPP1000 */
#else /* PARALLEL */
   typedef char MMMTlock ;
#endif /* PARALLEL */

#ifdef sequent
#   ifndef MMMDshared
#      define shared
#   endif
#else /* sequent */
#   define shared
#endif /* sequent */



/*************************************************************************
** struct MMMSstatus                                                    **
** Diese Datenstruktur wird als Teil eines S-Zeigers verwendet. Die     **
** Eintraege werden platzsparend in einem Bitfeld untergebracht.        **
*************************************************************************/
struct MMMSstatus
{
   unsigned int type : 11 ;           /*Typ des entsprechenden Headers*/
   unsigned int system : 1 ;          /*Bit gesetzt folgt:Daten gehoeren nicht zur
                                 Speicherverwaltung */
   unsigned int unmoveable : 1 ;      /*Bit gesetzt folgt: Speicher nicht verschiebbar*/
   unsigned int memtype : 1 ;         /*Speichertyp des Speichers*/
   unsigned int lock : 1 ;            /*Lock fuer den Header*/
   unsigned int used : 1 ;            /* Wird bei einer garbage collection */
                                      /* ben"otigt. */
} ;


/*************************************************************************
** struct MMMSheader                                                    **
** Jeder S-Zeiger zeigt auf solch eine Struktur. In ihr sind alle fuer  **
** einen S-Zeiger relevanten Daten gespeichert.                         **
*************************************************************************/
struct MMMSheader
{
   struct MMMSheader **data ;   /*Adresse des zu diesem Header gehoerenden
                                 Datenbereiches */
   ulong signature ;           /*Signatur der Daten dieses Headers*/
   ulong size ;               /*Groesse des zu diesem Header gehoerenden
                                 Datenbereiches in Anzahl der S_Pointer*/
   ulong count ;              /*Anzahl der S-Zeiger, die im zu diesem
                                 Header gehoerenden Datenbereich gespeichert
                                 sind */
   ulong refs ;               /*Anzahl der S-Zeiger, die auf diesen Header
                                 zeigen */
   struct MMMSstatus status ;         /*siehe MMMSstatus */
}  ;

#ifndef MMMDnet
typedef struct MMMSheader *S_Pointer ;
#else
typedef struct
{
   ulong index1 : 10 ;  /*Index im ersten Array*/
   ulong index2 : 10 ;  /*Index im zweiten Array*/
   ulong comp   :  5 ;  /*Nummer, die gewaehrleistet, dass alle Prozesse
                          verschiedene S-Zeiger erzeugen*/
   MUPbool imported : 1 ; /*Ist dieses Flag true, so ist der S-Zeiger
                          importiert, d.h. von einem anderen Rechner
                          geholt. Ist das Flag false, so gehoert dieser
                          S-Zeiger auf diesen Rechner*/
} S_Pointer ;
#endif

/*************************************************************************
** struct MMMSheader_list                                               **
** Jeder S-Zeiger fuehrt ein "Doppelleben". Ist er von der Speicher-    **
** verwaltung vergeben, so ist er ein S-Zeiger. Ist er aber nicht       **
** vergeben, so haengt er in einer Liste, deren zweiter Eintrag auf das **
** naechste Listenelement zeigt. Um keine wichtigen Daten zu verlieren, **
** muss man darauf achten, dass sich der next-Eintrag mit keinen        **
** wichtigen Daten in struct MMMSheader ueberschneidet.                 **
*************************************************************************/
struct MMMSheader_list
{
   S_Pointer *data ;
   S_Pointer next ;
} ;

/*************************************************************************
** struct MMMSmemoryblock                                               **
** Mit dieser Datenstruktur werden alle von der Speicherverwaltung      **
** angeforderte Speicherbereiche in einer Liste gehalten.               **
*************************************************************************/
struct MMMSmemoryblock
{
   S_Pointer *data ;
   struct MMMSmemoryblock *next ;
   ulong size ;
} ;


/*************************************************************************
** MMMTindex_info                                                       **
** In diesem Datentyp werden alle Informationen gespeichert, die fuer   **
** einen Index wichtig sind, so z.B. die Liste der freien Speicher-     **
** bereiche mit dem entsprechenden Index, die Anzahl der Bloecke in     **
** dieser Liste, die Anzahl der Bloecke, die es von dieser Groesse gibt **
** an andere Informationen.                                             **
*************************************************************************/
typedef struct
{
   S_Pointer freelist ; /*Liste der freien Speicherbereiche dieser Greosse*/
   ulong freeblocks ;   /*Anzahl der Eintraege in freelist*/
   ulong enlarge ;      /*Anzahl der Bloecke, um die die freelist vergroessert
                          wird, falls sie leer ist und ein Block aus ihr
                          benoetigt wird*/
   ulong count ;        /*Anzahl der Listenelemente, die insgesamt zu dieser
                          Liste gehoeren*/
   ulong allocated ;    /*Gibt an, wie h"aufig eine Block dieser Gr"o\3e
                          allokiert worden ist.*/
#ifdef MMMDLOCKSPACE
   MMMTlock *lock ;     /*Bei einer SGI kann ein Lock nicht innerhalb eines
                          beliebigen Speicherbereichs liegen, sondern mu\3
                          mit einer gesonderten Funktion angefordert werden*/
#else /* MMMDLOCKSPACE */
   MMMTlock lock ;      /*Lock, um den parallelen Zugriff auf diese
                          Liste zu ordnen*/
#endif /* MMMDLOCKSPACE */
} MMMTindex_info ;



/************************************************************************* 
** MMMTheaderlist                                                       **
** Ein Objekt dieses Typs enth"alt einen Zeiger auf einen Speicher-     **
** bereich, in dem Header gespeichert sind, einen long-Wert, der        **
** angibt, wieviele Header in diesem Speicherbereich gespeichert sind   **
** und einen Zeiger auf ein weiteres Objekt dieses Typs.                **
*************************************************************************/
typedef struct MMMSheaderlist
{
   struct MMMSheader *header ;
   long number ;
   struct MMMSheaderlist *next ;
} MMMTheaderlist ;



/*************************************************************************
** MMMTheader_info                                                      **
** In diesem Typ wird, neben den Informationen, die in einer Objekt     **
** des Typs MMMTindex_info gehalten werden k"onnen, auch eine           **
** Liste aller Speicherbereiche gehalten, die f"ur Header benutzt       **
** werden. Dies ist f"ur die garbage collection n"otig.                 **
*************************************************************************/
typedef struct
{
   MMMTindex_info index_info ;
   MMMTheaderlist *headerlist ;
} MMMTheader_info ;



/*************************************************************************
** MMMTtobefreed                                                        **
** Eine Instanz dieses Typs ist ein Zeiger auf einen Speicherblock, der **
** S-Zeiger enth"alt, die freigegeben werden m"ussen.                   **
*************************************************************************/
typedef struct
{
   S_Pointer *start ;
   long maxsize ;
   long actualsize ;
 } MMMTtobefreed ;


/*************************************************************************
** MMMTbagentry                                                         **
*************************************************************************/
typedef struct
{
   S_Pointer pointer ;
   long refchange ;
 } MMMTbagentry ;



/*************************************************************************
** MMMTbag                                                              **
** In einer Instanz dieses Typs werden Aufforderungen zum Ver"andern    **
** der Referenzz"ahler von S-Zeigern gesammelt. Hat der bag eine        **
** bestimmte Anzahl von Eintr"agen, so werden die durch die Eintr"age   **
** repr"asentierten "Anderungen alle auf einmal durchgef"uhrt. Wird     **
** diese Technik verwendet, sind die Referenzz"ahler nat"urlich nicht   **
** immer auf dem neuesten Stand, so da\3 bei einem MMMchange() immer    **
** kopiert werden mu\3 (MMMDCHANGEALWAYS gesetzt).                      **
*************************************************************************/
typedef struct
{
   long numentries ;
   MMMTbagentry *actual_entry ;
   MMMTbagentry *start_entry ;
 } MMMTbagtype ;

typedef MMMTbagtype *MMMTbag ;


/************************************************************************* 
** Im folgenden Abschnitt werden die Makros definiert,mit deren Hilfe   **
** auf die Komponenten der Strukturen zugegriffen werden kann.          **
** Dabei ist zu beachten, dass dieselben Makros durchaus fuer ver-      **
** schiedene Speichertypen benutzt werden, in den Strukturdefinitionen  **
** muss dies beruecksichtigt werden.                                    **
*************************************************************************/
#ifdef MMMDnet
/************************************************************************* 
** ulong MMMDindex1(S_Pointer s)                                        **
** Liefert den Wert des index1-Eintrages von s.                         **
*************************************************************************/
#define MMMDindex1(s) ((s).index1)

/************************************************************************* 
** ulong MMMDindex2(S_Pointer s)                                        **
** Liefert den Wert des index2-Eintrages von s.                         **
*************************************************************************/
#define MMMDindex2(s) ((s).index2)

/************************************************************************* 
** ulong MMMDcomp (S_Pointer s)                                         **
** Liefert den comp-Eintrag von s.                                      **
*************************************************************************/
#define MMMDcomp(s) ((s).comp)

/************************************************************************* 
** MUPbool MMMDimported(S_Pointer s)                                    **
** Liefert den imported-Eintrag von s.                                  **
*************************************************************************/
#define MMMDimported(s) ((s).imported)
#endif
/************************************************************************* 
** struct MMMSheader *MMMDheader(S_Pointer s)                           **
** Die Funktion liefert einen Zeiger auf den zum S-Zeiger s gehoerenden **
** Header.                                                              **
*************************************************************************/
#ifndef MMMDnet
#   define MMMDheader(s) (s)
#else
#   define MMMDheader(s) (&(GLOBAL_READ(MMMVheaderarray)[MMMDindex1(s)][MMMDindex2(s)]))
#endif


/************************************************************************* 
** S_Pointer *MMMDdata (UNKNOWN *s)                                     **
** Dieser Makro dereferenziert auf den Zeiger auf die Daten, die in *s  **
** gespeichert werden.                                                  **
*************************************************************************/
#define MMMDdata(s) (MMMDheader(s)->data)

/************************************************************************* 
** ulong MMMDsize (UNKNOWN *s)                                          **
** Dieser Makro dereferenziert auf die Groesse von *s.                  **
*************************************************************************/
#define MMMDsize(s) (MMMDheader(s)->size)

/************************************************************************* 
** ulong MMMDcount (UNKNOWN *s)                                         **
** Dereferenziert auf den Eintrag count.                                **
*************************************************************************/
#define MMMDcount(s) (MMMDheader(s)->count)

/************************************************************************* 
** ulong MMMDrefs (UNKNOWN *s)                                          **
** Dereferenziert auf die Anzahl der Verweise auf *s.                   **
*************************************************************************/
#define MMMDrefs(s) (MMMDheader(s)->refs)

/*************************************************************************
** ulong MMMDsignature (UNKNOWN *s)                                     **
** Dereferenziert auf die Signatur von *s.                              **
*************************************************************************/
#   define MMMDsignature(s) (MMMDheader(s)->signature)

/*************************************************************************
** ulong MMMDsystem (UNKNOWN *s)                                        **
** Dereferenziert auf den Systemeintrag von *s.                         **
*************************************************************************/
#define MMMDsystem(s) (MMMDheader(s)->status.system)

/*************************************************************************
** ulong MMMDunmoveable (UNKNOWN *s)                                    **
** Dereferenziert auf den Unmoveableeintrag von *s.                     **
*************************************************************************/
#define MMMDunmoveable(s) (MMMDheader(s)->status.unmoveable)

/*************************************************************************
** ulong MMMDtype (UNKNOWN *s)                                          **
** Dereferenziert auf den type-Eintrag von *s.                          **
*************************************************************************/
#define MMMDtype(s) (MMMDheader(s)->status.type)

/*************************************************************************
** ulong MMMDmemtype (UNKNOWN *s)                                       **
** Derefenziert auf den memtype-Eintrag von *s.                         **
*************************************************************************/
#define MMMDmemtype(s) (MMMDheader(s)->status.memtype)

/*************************************************************************
** ulong MMMDlock(UNKNOWN *S)                                           **
** Dereferenziert auf den lock-Eintrag.                                 **
*************************************************************************/
#define MMMDlock(s) (MMMDheader(s)->status.lock)

/*************************************************************************
** ulong MMMDused(UNKNOWN *s)                                           **
*************************************************************************/
#define MMMDused(s) (MMMDheader(s)->status.used)

/*************************************************************************
** S_Pointer MMMDnext (UNKNOWN *s)                                      **
** Dereferenziert nach dem next-Eintrag in *s.                          **
*************************************************************************/
#define MMMDnext(s) (((struct MMMSheader_list *)MMMDheader(s))->next)

/*************************************************************************
** S_Pointer MMMDnextt (UNKNOWN *s)                                     **
** Dereferenziert nach dem next-Eintrag in *s.                          **
*************************************************************************/
#define MMMDnextt(s) (((struct MMMSmemoryblock *)(s))->next)






/*************************************************************************
** Im folgenden werden die Makros definiert, die f"ur die Benutzung     **
** eines Bags gebraucht werden.                                         **
*************************************************************************/
#define MMMHbag_for_pointer(s) (&(MMMVbagtable)[((unsigned long)(s)) % SHARED_READ(MMMVlockcount)])
#define MMMHput_really_into_bag(bag,s,num) \
		     {  bag->actual_entry->pointer = s ; \
                        bag->actual_entry->refchange = num ; \
                        bag->numentries++ ; \
                        bag->actual_entry++ ; \
		      }

#define MMMHbag_full(bag) \
		     ( (bag)->numentries > MMMVbagsize )

void MMMHempty_bag(MMMTbag bag) ;
void MMMHempty_all_bags(VOID) ;

#define MMMHput_into_bag(bag,s,num) \
                     {  MMMHput_really_into_bag(bag, s, num) ; \
                        if ( MMMHbag_full(bag) ) \
                           MMMHempty_bag(bag) ; \
		      }

/*************************************************************************
** Im folgenden werden Makros definiert, die zur Implementation eines   **
** Heaps ben"otigt werden.                                              **
*************************************************************************/
typedef struct MMMSheapMemList
{
   struct MMMSheapMemList *next ;
   long size ;
} MMMTheapMemList ;

typedef struct
{
   MMMTheapMemList *MemList ;
   MMMTlock *Lock ;
} MMMTheap ;

#define MMMCheapminsize sizeof(MMMTheapMemList)

#define MMMDheapMemList(heap) ((heap)->MemList)
#define MMMHheapnew(startt,sizee) (((MMMTheapMemList *)(startt))->size=(sizee)-sizeof(MMMTheapMemList), (MMMTheapMemList *)(startt))
#define MMMDheapstart(list)   (((char *)list) + sizeof(MMMTheapMemList))
#define MMMDheapnext(list)    ((list)->next)
#define MMMDheapsetnext(list,follow) (((list)->next) = (follow))
#define MMMDheapsize(list)    ((list)->size)
#define MMMDheapsetsize(list,sizee)  (((list)->size) = sizee)
#define MMMDMem2Heap(mem)     (((MMMTheapMemList *)mem) - 1)
#define MMMDheapcalcsize(size) ((size)+7 & 0xfffffff8)

/*************************************************************************
** Im folgenden Abschnitt werden die Makro definiert, die Funktionen in **
** der Speicherverwaltung ersetzen.                                     **
*************************************************************************/

/*************************************************************************
** ulong MMMHlength (S_Pointer s)                                       **
** Dieser Makro liefert die Laenge von Mem(s) in Bytes.                 **
*************************************************************************/
#define MMMHlength(s) ((((ulong)MMMDsize(s))-MMMDcount(s))<<MMMCS_Pointer_size_log)

/*************************************************************************
** TYPE MMMDmax(TYPE a , b )                                            **
** TYPE MMMDmin(TYPE a , b )                                            **
** Die Funktion gibt das Maximum von a und b zurueck. der Typ des       **
** zurueckgegebenen Datums haengt vom Typ von a und b ab.               **
*************************************************************************/
#define MMMDmax(a,b) (((a)>(b))?(a):(b))
#define MMMDmin(a,b) (((a)<(b))?(a):(b))

/*************************************************************************
** void MMMHcheck_size (ulong size)                                     **
** void MMMHcheck_count (ulong count)                                   **
** void MMMHcheck_type (ulong type)                                     **
** void MMMHcheck_memtype (ulong memtype)                               **
** Diese Funktionen dienen dazu, die uebergebenen Paramter darauf zu    **
** pruefen, ob sie eine fuer einen S-Zeiger angemessene Groesse haben.  **
*************************************************************************/
#define MMMHcheck_size(size) \
	    { if ( (size) > 0x02000000 ) SHARED_READ(GLOBAL_READ(MMMVno_memory))(_false_) ; }
#define MMMHcheck_count(count) \
	    { if ( (count) > 0x02000000 ) SHARED_READ(GLOBAL_READ(MMMVno_memory))(_false_) ; }
#define MMMHcheck_type(type)
#define MMMHcheck_memtype(memtype)

/*************************************************************************
**      MMMDcopy_init                                                   **
** void MMMHcopy (S_Pointer sour , dest)                                **
** MMMDcopy_init muss im Variablendeklarationsteil einer Funktion auf-  **
** gefuehrt werden, falls in dieser Funktion MMMHcopy verwendet wird.   **
** MMMHcopy kopiert den Inhalt von sour nach dest, wobei angenommen     **
** wird, dass beide S-Zeiger dieselbe Groesse haben.                    **
*************************************************************************/
#define MMMDcopy_init 
#define MMMHcopy(sour,dest) \
           { \
              ulong MMMVhelpl1; S_Pointer *MMMVhelpp1,*MMMVhelpp2; \
              for(MMMVhelpl1=MMMDsize(sour),MMMVhelpp1=MMMDdata(sour), \
                  MMMVhelpp2=MMMDdata(dest) ; \
                  MMMVhelpl1 > 0L ; MMMVhelpl1-- ) \
                     *MMMVhelpp2++ = *MMMVhelpp1++ ; \
           }


/*************************************************************************
** void MMMHdeclare_pointers (S_Pointer s)                              **
** Die Funktion meldet die S-Zeiger, die in Point(s) stehen, bei der    **
** Speicherverwaltung an.                                               **
*************************************************************************/
#define MMMHdeclare_pointers(s) \
           {\
              ulong MMMVhelpl1 ; S_Pointer *MMMVhelpp1 ; \
              for (MMMVhelpl1=MMMDcount(s),MMMVhelpp1=MMMDdata(s) ; \
                   MMMVhelpl1 > 0L ; MMMVhelpl1--,MMMVhelpp1++ ) \
                    MMMcopy ( *MMMVhelpp1 ) ; \
           }
/*************************************************************************
**      MMMDset_init                                                    **
** void MMMHset_pointers (S_Pointer s , t)                              **
** void MMMHset_mem (S_Pointer s , ulong w)                             **
** MMMDset_init muss im Variablendeklarationsteil einer Funktion auf-   **
** gefuehrt sein, falls in dieser Funktion MMMHset_pointers() oder      **
** MMMHset_mem() verwendet werden.                                      **
** MMMHset_pointers() initialisiert alle S-Zeiger von s mit dem Wert t  **
** vor.                                                                 **
** MMMHset_mem() initialisiert den gesamten Speicher mit dem Wert w vor.**
** Wird diese Funktion aufgerufen, so muss in Augenblick MMMset_pointers**
** vorher aufgerufen worden sein.                                       **
*************************************************************************/
#define MMMDset_init register ulong MMMVsetl1 ; register S_Pointer *MMMVsetp1 ;
#define MMMHset_pointers(s,t) \
            {   for(MMMVsetl1=MMMDcount(s),MMMVsetp1=MMMDdata(s) \
                        ; MMMVsetl1 > 0L ; MMMVsetl1-- ) \
                   *MMMVsetp1++ = t ; \
            }
#define MMMHset_mem(s,w) \
            {  for(MMMVsetl1=MMMDsize(s)-MMMDcount(s) \
                     ; MMMVsetl1 > 0L ; MMMVsetl1-- ) \
                  *MMMVsetp1++ = (S_Pointer) w ; \
            }

/*************************************************************************
** void MMMHmonitor_in (ulong func_number , S_Pointer s)                **
** void MMMHmonitor_out (ulong func_number , S_Pointer s)               **
** Die erste Funktion wird beim Eintritt in eine MMM...()-Funktion      **
** mit der entsprechenden func_number und einem S-Zeiger als Argument   **
** aufgerufen, die zweite Funktion direkt vor Verlassen der Funktion.   **
** Mit diesen Funktionen ist ein Monitoring der MMM...()-Funktionen     **
** moeglich.                                                            **
*************************************************************************/
#define MMMHmonitor_in(func_number,s)
#define MMMHmonitor_out(func_number,s)

 
/************************************************************************* 
**      MMMDtransfer_content_init                                       **
** void MMMHtransfer_content (S_Pointer sour , dest)                    **
** MMMDtransfer_init muss im Variablendeklarationsteil einer Funktion   **
** aufgefuehrt sein, falls in dieser Funktion MMMHtransfer() verwendet  **
** wird.                                                                **
** MMMHtransfer() kopiert soviele Daten von sour nach dest wie moeglich **
** ist. Hat dest mehr S-Zeiger als sour, so werden die ueberzaehligen   **
** mit MMMNULL initialisiert.                                           **
** Die Zeiger, die wirklich kopiert wurden, werden dem System als       **
** weitere S-Zeiger gemeldet.                                           **
*************************************************************************/
#define MMMDtransfer_content_init 
/*#define MMMHtransfer_content(sour,dest) { \
              for(MMMVtransferl1=MMMDmin(MMMDcount(sour),MMMDcount(dest)) , \
                  MMMVtransferp1=MMMDdata(sour),MMMVtransferp2=MMMDdata(dest) \
                  ; MMMVtransferl1 > 0L ; MMMVtransferl1-- ) \
                      { \
                         *MMMVtransferp2 = *MMMVtransferp1++ ; \
                         MMMcopy(*MMMVtransferp2++) ; \
                      } \
              for(MMMVtransferl1=MMMDcount(dest)-MMMDmin(MMMDcount(sour), \
                                                         MMMDcount(dest)) \
                 ; MMMVtransferl1 > 0L ; MMMVtransferl1-- ) \
                    *MMMVtransferp2++ = MMMNULL ; \
              MMMVtransferp1 += MMMDcount(sour)-MMMDmin(MMMDcount(sour), \
                                                        MMMDcount(dest)) ; \
              for(MMMVtransferl1=MMMDmin(MMMDsize(sour)-MMMDcount(sour) ,\
                                         MMMDsize(dest)-MMMDcount(dest) ) \
                  ; MMMVtransferl1 > 0L ; MMMVtransferl1-- ) \
                     *MMMVtransferp2++ = *MMMVtransferp1++ ; }
*/


/*************************************************************************
**      MMMDblock_fro_freelist_init                                     **
** void MMMHblock_fro_freelist (S_Pointer *s;ulong i,size)              **
** Der erste Makro muss im Variablendeklarationsteil einer Funktion     **
** aufgefuehrt sein, falls in deiser Funktion MMMHblock_fro_freelist()  **
verwendet wird.                                                         **
** Dieser Makro nimmt einen S-Zeiger aus der Liste der freien Speicher- **
** bereiche mit Index i. Ist diese Liste leer, so fordert der Makro     **
** einen neuen Speicherbereich mit Index i und Groesse size an.         **
************************************************************************/
#ifdef MMMDLOCKSPACE
/* Auf der SGI steht in SHARED_READ(MMMVmemory)[i].lock ein Zeiger auf ein
   Lock. */
#define MMMDblock_fro_freelist_init
#define MMMHblock_fro_freelist(s,i,size) \
            {  MMMElock((SHARED_READ(MMMVmemory)[i].lock) ) ;\
               if ( SHARED_READ(MMMVmemory)[i].freeblocks == 0L ) \
                  MMMFenlarge_freelist ( i , size ) ; \
               *(s) = (S_Pointer) SHARED_READ(MMMVmemory)[i].freelist ; \
               SHARED_READ(MMMVmemory)[i].freelist = (S_Pointer) MMMDnext(*(s)) ; \
               SHARED_READ(MMMVmemory)[i].freeblocks-- ; \
               SHARED_READ(MMMVmemory)[i].allocated++ ; \
               MMMEunlock((SHARED_READ(MMMVmemory)[i].lock) ) ;\
             }
#else /* MMMDLOCKSPACE */
/* In diesem Fall steht in SHARED_READ(MMMVmemory)[i].lock ein Lock. */
#define MMMDblock_fro_freelist_init
#define MMMHblock_fro_freelist(s,i,size) \
            {  MMMElock(&(SHARED_READ(MMMVmemory)[i].lock) ) ;\
               if ( SHARED_READ(MMMVmemory)[i].freeblocks == 0L ) \
                  MMMFenlarge_freelist ( i , size ) ; \
               *(s) = (S_Pointer) SHARED_READ(MMMVmemory)[i].freelist ; \
               SHARED_READ(MMMVmemory)[i].freelist = (S_Pointer) MMMDnext(*(s)) ; \
               SHARED_READ(MMMVmemory)[i].freeblocks-- ; \
               SHARED_READ(MMMVmemory)[i].allocated++ ; \
               MMMEunlock(&(SHARED_READ(MMMVmemory)[i].lock) ) ;\
             }
#endif /* MMMDLOCKSPACE */

                  
/*************************************************************************
**      MMMDblock_to_freelist_init                                      **
** void MMMHblock_to_freelist (S_Pointer s)                             **
** Der erste Makro muss im Variablendeklarationsteil einer Funktion     **
** aufgefuehrt sein, falls in dieser Funktion MMMHblock_to_freelist()   **
** verwendet wird.                                                      **
** Dieser Makro fuegt den S-Zeiger s wieder in die entsprechende Liste  **
** der freien Speicherbereiche ein.                                     **
*************************************************************************/
#ifdef MMMDLOCKSPACE
/* In SHARED_READ(MMMVmemory)[MMMVblock_to_freelistl1].lock steht ein
   Zeiger auf ein Lock. */
#define MMMDblock_to_freelist_init ulong MMMVblock_to_freelistl1 ;
#define MMMHblock_to_freelist(s) \
            { \
              MMMHindex (&MMMVblock_to_freelistl1,&MMMDsize(s)) ; \
	      MMMElock((SHARED_READ(MMMVmemory)[MMMVblock_to_freelistl1].lock) ) ; \
              if (MMMVblock_to_freelistl1 == 0L) \
                 { \
                    SHARED_READ(MMMVmemory)[MMMVblock_to_freelistl1].count-- ; \
                    SHARED_WRITE(MMMVreserved_memory, SHARED_READ(MMMVreserved_memory) - MMMDsize(s) ) ; \
                    MMMHffree (MMMDdata(s), MMMDsize(s)*sizeof(S_Pointer)) ; \
                    MMMHput_header(s) ; \
                 } \
               else \
                 { \
                    MMMDnext(s)=SHARED_READ(MMMVmemory)[MMMVblock_to_freelistl1].freelist;\
                    SHARED_READ(MMMVmemory)[MMMVblock_to_freelistl1].freelist=s ; \
                    SHARED_READ(MMMVmemory)[MMMVblock_to_freelistl1].freeblocks++ ; \
                 } \
               MMMEunlock ((SHARED_READ(MMMVmemory)[MMMVblock_to_freelistl1].lock) ) ;\
              }
#else /* MMMDLOCKSPACE */
/* In SHARED_READ(MMMVmemory)[MMMVblock_to_freelistl1].lock steht ein Lock */
#define MMMDblock_to_freelist_init ulong MMMVblock_to_freelistl1 ;
#define MMMHblock_to_freelist(s) \
            { \
              MMMHindex (&MMMVblock_to_freelistl1,&MMMDsize(s)) ; \
	      MMMElock(&(SHARED_READ(MMMVmemory)[MMMVblock_to_freelistl1].lock) ) ; \
              if (MMMVblock_to_freelistl1 == 0L) \
                 { \
                    SHARED_READ(MMMVmemory)[MMMVblock_to_freelistl1].count-- ; \
                    SHARED_WRITE(MMMVreserved_memory, SHARED_READ(MMMVreserved_memory) - MMMDsize(s) ) ; \
                    MMMHffree (MMMDdata(s), MMMDsize(s)*sizeof(S_Pointer)) ; \
                    SHARED_WRITE(MMMVreserved_blocks, SHARED_READ(MMMVreserved_blocks)-1); \
                    MMMHput_header(s) ; \
                 } \
               else \
                 { \
                    MMMDnext(s)=SHARED_READ(MMMVmemory)[MMMVblock_to_freelistl1].freelist;\
                    SHARED_READ(MMMVmemory)[MMMVblock_to_freelistl1].freelist=s ; \
                    SHARED_READ(MMMVmemory)[MMMVblock_to_freelistl1].freeblocks++ ; \
                 } \
               MMMEunlock (&(SHARED_READ(MMMVmemory)[MMMVblock_to_freelistl1].lock) ) ;\
              }
#endif /* MMMDLOCKSPACE */

/*************************************************************************
** void MMMHtake_header (S_Pointer *s)                                  **
** Dieser Makro nimmt einen Header aus der Liste                        **
** MMMVheaders.index_info.freelist und laesst *s auf diesen zeigen.     **
*************************************************************************/
#ifdef MMMDLOCKSPACE
/* In (SHARED_READ(MMMVheaders).index_info.lock) steht ein Zeiger auf
   ein Lock. */
#define MMMHtake_header(s) \
            { MMMElock ((SHARED_READ(MMMVheaders).index_info.lock)) ;\
              if ( SHARED_READ(MMMVheaders).index_info.freeblocks == 0L ) \
                 MMMFenlarge_headerlist ( 1L ) ; \
              *(s) = SHARED_READ(MMMVheaders).index_info.freelist ; \
              SHARED_READ(MMMVheaders).index_info.freelist = MMMDnext(*(s)) ; \
              SHARED_READ(MMMVheaders).index_info.freeblocks-- ; \
              SHARED_READ(MMMVheaders).index_info.allocated++ ; \
              MMMEunlock ((SHARED_READ(MMMVheaders).index_info.lock) ) ; \
            } 
#else /* MMMDLOCKSPACE */
/* In (SHARED_READ(MMMVheaders).index_info.lock) steht ein Lock. */
#define MMMHtake_header(s) \
            { MMMElock (&(SHARED_READ(MMMVheaders).index_info.lock)) ;\
              if ( SHARED_READ(MMMVheaders).index_info.freeblocks == 0L ) \
                 MMMFenlarge_headerlist ( 1L ) ; \
              *(s) = SHARED_READ(MMMVheaders).index_info.freelist ; \
              SHARED_READ(MMMVheaders).index_info.freelist = MMMDnext(*(s)) ; \
              SHARED_READ(MMMVheaders).index_info.freeblocks-- ; \
              SHARED_READ(MMMVheaders).index_info.allocated++ ; \
              MMMEunlock (&(SHARED_READ(MMMVheaders).index_info.lock) ) ; \
            } 
#endif /* MMMDLOCKSPACE */

/*************************************************************************
** void MMMHput_header (S_Pointer s)                                    **
** Dieser Makro fuegt den Header, auf den s zeigt, wieder in die Liste  **
** MMMVheaders.index_info.freelist der nicht benoetigten Header.        **
*************************************************************************/
#ifdef MMMDLOCKSPACE
/* In SHARED_READ(MMMVheaders).index_info.lock steht ein Zeiger auf 
   ein Lock. */
#define MMMHput_header(s) \
            { MMMElock ((SHARED_READ(MMMVheaders).index_info.lock)) ;\
              MMMDnext(s) = SHARED_READ(MMMVheaders).index_info.freelist ; \
              SHARED_READ(MMMVheaders).index_info.freelist = s ; \
              SHARED_READ(MMMVheaders).index_info.freeblocks++  ; \
              MMMEunlock ((SHARED_READ(MMMVheaders).index_info.lock) ) ; \
                          }
#else /* MMMDLOCKSPACE */
/* In SHARED_READ(MMMVheaders).index_info.lock steht ein Lock. */
#define MMMHput_header(s) \
            { MMMElock (&(SHARED_READ(MMMVheaders).index_info.lock)) ;\
              MMMDnext(s) = SHARED_READ(MMMVheaders).index_info.freelist ; \
              SHARED_READ(MMMVheaders).index_info.freelist = s ; \
              SHARED_READ(MMMVheaders).index_info.freeblocks++  ; \
              MMMEunlock (&(SHARED_READ(MMMVheaders).index_info.lock) ) ; \
                          }
#endif /* MMMDLOCKSPACE */


/*************************************************************************
** ulong MMMDneeded_size ( ulong length , count )                       **
** Die Funktion berechnet die Gesamtgroesse, die ein S-Zeiger haben     **
** muss, damit der Mem-Teil und der Point-Teil in einen Block dieser    **
** Groesse passt. Das Ergebnis wird in der Einheit S_Pointer zurueck-   **
** gegeben, d.h. es werden Ergebnis * sizeof(S_Pointer) Bytes           **
** benoetigt.                                                           **
*************************************************************************/
#define MMMDneeded_size(length,count) \
             ((((length)+sizeof(S_Pointer)-1L)>>MMMCS_Pointer_size_log) + (count))

/*************************************************************************
** void MMMHindex (long *index, *size)                                  **
** Dieser Makro berechnet den Index, den ein S-Zeiger der Groesse size  **
** hat. Falls es zu size keinen geeigneten Index gibt, so wird *size    **
** bis zum naechstgroesseren Index vergroessert.                        **
*************************************************************************/
#define MMMHindex(index,size) \
            {  if (*size > SHARED_READ(MMMVmaxindex)) \
                  *index = 0L ; \
                else \
                  *index = *size ; \
            }

/*************************************************************************
** MMMThandle MMMHopen_file (char *datei)                               **
** Dieser Makro oeffnet die Datei datei und gibt den entsprechenden     **
** Handle zurueck.                                                      **
*************************************************************************/
#define MMMHopen_file(datei) fopen ( datei , MUPC_READ_TEXT )

/*************************************************************************
** void MMMHclose_file (MMMThandle handle)                              **
** Dieser Makro schliesst den Strom handle.                             **
*************************************************************************/
#define MMMHclose_file(handle) fclose ( handle )


/*************************************************************************
** MMMHdeclare_lock_ptr(l)                                              **
** Dieses Macro deklariert l als Pointer auf einen Lock.                **
*************************************************************************/
#ifdef MMMDshared
#  define MMMHdeclare_lock_ptr(l) VOLATILE(MMMTlock*) l;
#else /* MMMDshared */
#  define MMMHdeclare_lock_ptr(l)
#endif /* MMMDshared */


/*************************************************************************
** MMMHlock_for_pointer ( MMMTlock *l, S_Pointer s )                    **
** Dieses Macro weist an l einen Zeiger auf einLock zu, dass benutzt    **
** wird, um Zugriffe auf den Inhalt des Headers zu sequentialisieren.   **
** Im Moment wird diese Funktion nur benutzt, um das Lock im Header     **
** eines S-Zeigers relisieren zu koennen.                               **
*************************************************************************/
#ifdef MMMDshared
#   ifdef MMMDLOCKSPACE
#      define MMMHlock_for_pointer(l,s) ((l) = ((SHARED_READ(MMMVlocktable)[((unsigned long)(s)) % SHARED_READ(MMMVlockcount)])))
#   else /* MMMDLOCKSPACE */
#      define MMMHlock_for_pointer(l,s) ((l) = (&(SHARED_READ(MMMVlocktable)[((unsigned long)(s)) % SHARED_READ(MMMVlockcount)])))
#   endif /* MMMDLOCKSPACE */
#else /* MMMDshared */
#  define MMMHlock_for_pointer(l,s)
#endif /* MMMDshared */


/*************************************************************************
** MMMDdecrease_refs(S_Pointer s, long refs)                            **
** Die Funktion erniedrigt den Referenzz"ahler von s um 1 und liefert   **
** den neuen Referenzz"ahler in refs zur"uck.                           **
*************************************************************************/
#define MMMDdecrease_refs(s,refs) \
            { MMMHdeclare_lock_ptr(MMMLdecrease_refs) ; \
              MMMHlock_for_pointer(MMMLdecrease_refs, s) ;\
              MMMElock ( MMMLdecrease_refs ) ; \
              refs = --MMMDrefs(s) ; \
              MMMEunlock ( MMMLdecrease_refs ) ; \
            }
           

/************************************************************************* 
** MMMDincrease_refs(S_Pointer s)                                       **
** Die Funktion erniedrigt den Referenzz"ahler von s um 1.              ** 
*************************************************************************/
#ifndef MMMDEBUG
#ifdef sequent
/* Auf der sequent ist die Erh"ohung eines Wertes eine atomare Operation.
   Deshalb kann das increase ohne Locks durchgef"uhrt werden. */
#define MMMDincrease_refs(s) \
            { \
               ++MMMDrefs(s) ; \
            }
#else /* sequent */
#define MMMDincrease_refs(s) \
            { MMMHdeclare_lock_ptr(MMMLincrease_refs) ; \
              MMMHlock_for_pointer(MMMLincrease_refs, s) ;\
              MMMElock ( MMMLincrease_refs ) ; \
              ++MMMDrefs(s) ; \
              MMMEunlock ( MMMLincrease_refs ) ; \
            }
#endif /* sequent */
#else /* MMMDEBUG */
#define MMMDincrease_refs(s) \
            { long refs ; \
              MMMHdeclare_lock_ptr(MMMLincrease_refs) ; \
              MMMHlock_for_pointer(MMMLincrease_refs, s) ;\
              MMMElock ( MMMLincrease_refs ) ; \
              refs = ++MMMDrefs(s) ; \
              if ( refs == 1 ) \
                 { \
                    char c ; \
                    printf("Es wurde ein bereits freigegebener S-Zeiger kopiert. Zum Fortfahren RETURN druecken.") ; \
                    scanf("%c",&c) ; \
                 } \
              MMMEunlock ( MMMLincrease_refs ) ; \
            }
#endif /* MMMDEBUG */


/*************************************************************************
** In diesem Abschnitt werden die Statistikmakros der einzelnen         **
** Funktionen definiert.                                                **
*************************************************************************/
#define MMMDmalloc_statistic { \
           SHARED_WRITE(MMMVmallocs, SHARED_READ(MMMVmallocs) + 1) ; \
           SHARED_WRITE(MMMVused_blocks, SHARED_READ(MMMVused_blocks)+1) ; \
           SHARED_WRITE(MMMVused_memory, SHARED_READ(MMMVused_memory) + size) ; }

#define MMMDpalloc_statistic 

#define MMMDcalloc_statistic 

#define MMMDfree_statistic { \
           SHARED_WRITE(MMMVrealfrees, SHARED_READ(MMMVrealfrees)+1) ; \
           SHARED_WRITE(MMMVused_blocks, SHARED_READ(MMMVused_blocks) -1) ; \
           SHARED_WRITE(MMMVused_memory, SHARED_READ(MMMVused_memory) - MMMDsize(s)) ; }

#define MMMDfree1_statistic { \
           SHARED_WRITE(MMMVrealfrees, SHARED_READ(MMMVrealfrees) + 1 ) ; \
           }


#define MMMDlfree_statistic { \
           SHARED_WRITE(MMMVrealfrees, SHARED_READ(MMMVrealfrees) + 1) ; \
           SHARED_WRITE(MMMVused_blocks, SHARED_READ(MMMVused_blocks) - 1) ; \
           SHARED_WRITE(MMMVused_memory, SHARED_READ(MMMVused_memory) - MMMDsize(s)) ; }

#define MMMDensure_statistic { \
           SHARED_WRITE(MMMVensures, SHARED_READ(MMMVensures) + 1) ; }

#define MMMDenlarge_freelist_statistic { \
           SHARED_READ(MMMVreserved_blocks) += SHARED_READ(MMMVmemory)[index].enlarge ; \
           SHARED_READ(MMMVreserved_memory) += SHARED_READ(MMMVmemory)[index].enlarge * size ; \
           if ( SHARED_READ(MMMVmax_reserved_memory) < SHARED_READ(MMMVreserved_memory) ) \
              SHARED_READ(MMMVmax_reserved_memory) = SHARED_READ(MMMVreserved_memory) ; \
        }

#define MMMDenlarge_headerlist_statistic

#define MMMDresize_statistic

#define MMMDnewcounter_statistic

#define MMMDrealloc_statistic

#define MMMDforce_data_statistic { \
           SHARED_WRITE(MMMVmallocs, SHARED_READ(MMMVmallocs) + 1) ; }

#define MMMDmmalloc_statistic 

#define MMMDffree_statistic

#define MMMDshift_statistic

#define MMMDtransfer_content_statistic

#define MMMDtype_statistic

/*************************************************************************
** Im folgenden Abschnitt werden die Funktionen, die in MMMstorage.c    **
** definiert sind, deklariert.                                          **
*************************************************************************/
S_Pointer MMMFmalloc (ulong use, ulong type, ulong length, ulong count) ;
#define MMMCmalloc 1
S_Pointer MMMFpalloc (ulong use, ulong type, ulong length, ulong count) ;
#define MMMCpalloc 2
S_Pointer MMMFcalloc (ulong use, ulong type, ulong length, ulong count) ;
#define MMMCcalloc 3
void MMMFfree (S_Pointer s) ;
#define MMMCfree 4
void MMMFlfree (S_Pointer s) ;
#define MMMClfree 5
void MMMFensure (S_Pointer *s) ;
#define MMMCensure 6
void MMMFenlarge_freelist (ulong index , ulong size) ;
#define MMMCenlarge_freelist 7
void MMMFenlarge_headerlist (ulong number) ;
#define MMMCenlarge_headerlist 8
void MMMFresize (S_Pointer *s , ulong length) ;
#define MMMCresize 9
void MMMFnewcounter (S_Pointer *s , ulong count) ;
#define MMMCnewcounter 10
void MMMFrealloc (S_Pointer *s , ulong length , ulong count) ;
#define MMMCrealloc 11
S_Pointer MMMFforce_data (ulong memtype, ulong type, char *data, ulong length) ;
#define MMMCforce_data 12
char *MMMHmmalloc (ulong size) ;
#define MMMCmmalloc 13
void MMMHffree (S_Pointer *p, ulong size) ;
#define MMMCffree 17
void MMMFshift ( S_Pointer sour, long spos, S_Pointer dest, long dpos, long count);
#define MMMCshift 20
void MMMFfirst_init(VOID) ;

void MMMFinit (char *datei) ;
#define MMMCinit 14
void MMMFexit (VOID) ;
#define MMMCexit 15 
ulong MMMHread_ulong (MMMThandle handle, char *datei) ;
#define MMMCread_ulong 16
void MMMHtransfer_content (S_Pointer sour, S_Pointer dest) ;
#define MMMCtransfer_content 18
ulong MMMFtype (S_Pointer s) ;
#define MMMCtype 19
void MMMFinsert_global( S_Pointer *variable) ;
void MMMFmark_globals( VOID );
void MMMFmark_tree(S_Pointer p);
MUPbool MMMFfree_unmarked(S_Pointer p);
void MMMFfree_unused( VOID ) ;
long MMMFbytes( S_Pointer s );
void MMMFprepare_sleep(VOID) ;
void MMMFsleep(VOID) ;
void MMMFwake_up(long son) ;

#ifdef MMMDOWNMALLOC
void *MMMFown_malloc(long size, MMMTheap *heap) ;
void MMMFown_free(void *mem, MMMTheap *heap) ;
#endif /*MMMDOWNMALLOC*/
/*************************************************************************
** Im folgenden Abschnitt werden Konstanten definiert.                  **
*************************************************************************/
#define NULLL 0L
#define MMMNULL ((S_Pointer)0L)
#if (defined POINTER_IS_64BIT)
#   define MMMCS_Pointer_size_log 3 /*Ist der 2-er Logarithmus von sizeof(S_Pointer)*/
#else
    /*Als Defaultfall werden 32Bit f"ur einen Pointer angenommen*/
#   define MMMCS_Pointer_size_log 2 /*Ist der 2-er Logarithmus von sizeof(S_Pointer)*/
#endif
#define MMMCone_ref 1L /*Ist MMMDrefs(s)==MMMCone_ref, so zeigt nur ein Zeiger
                auf s*/
#ifndef true
#   define true  1 /*Der Boolean-Wert true*/
#   define false 0 /*Der Boolean-Wert false*/
#endif
#define _true_  1
#define _false_ 0
#define MMMCwork 0L
#define MMMCglobal 1L
#define MMMClocal 2L
#define MMMread 0L
#define MMMwrite 1L
#define MMMlocked 1L
#define MMMunlocked 0L


#ifdef NEWMAMMUT
#   define MMMIresize                0
#   define MMMInewcounter            1
#   define MMMIrealloc               2
#   define MMMIchange                3
#   define MMMIfree                  4
#   define MMMIcalloc                5

#   define MMMCnumber_of_types     128
#   define MMMCnumber_of_methods     6

#   define MMMMresize               MMMFresize
#   define MMMMnewcounter           MMMFnewcounter
#   define MMMMrealloc              MMMFrealloc
#   define MMMMchange               MMMFensure
#   define MMMMfree                 MMMFfree
#endif /* NEWMAMMUT */


/*************************************************************************
** Im folgenden Abschnitt werden die globalen Variablen der Speicher-   **
** verwaltung deklariert.                                               **
*************************************************************************/



/*************************************************************************
** Im folgenden Abschnitt werden die Funktionen, die als Schnittstelle  **
** zur Speicherverwaltung dienen, definiert.                            **
*************************************************************************/
#define MMMfirst_init() \
        MMMFfirst_init()
#define MMMinit(datei) \
        MMMFinit (datei)
#define MMMexit() \
        MMMFexit ()
#define MMMmalloc(memtyp,typ,size,count) \
        MMMFmalloc (memtyp,typ,size,count)
#define MMMpalloc(memtyp,typ,size,count) \
        MMMFpalloc (memtyp,typ,size,count)
#define MMMcalloc(memtyp,typ,size,count) \
        MMMFcalloc (memtyp,typ,size,count)
#define MMMforce_data(memtyp,typ,data,size) \
        MMMFforce_data(memtyp,typ,(char *)data,size)
#ifndef NEWMAMMUT
#   ifndef MMMDCOLLECTFREES
#      define MMMfree(s) \
              { if ((s) != MMMNULL) \
                   { long MMMVfree_ref ; \
                     MMMDdecrease_refs(s, MMMVfree_ref) ; \
                     if ( MMMVfree_ref < MMMCone_ref ) \
                        { \
                           MMMFfree((S_Pointer) s) ; \
                        } \
                   } \
              }
#     else /* MMMDCOLLECTFREES */
#       define MMMfree(s) \
               {  MMMTbag bag ; \
                  if (s != MMMNULL) \
                     {  bag = MMMHbag_for_pointer(s);\
                        MMMHput_into_bag(bag, s,  -1) ; \
                     } \
		}
#   endif /* MMMDCOLLECTFREES */
# else /* NEWMAMMUT */
#   define MMMfree(s) \
	   {   MMMHdeclare_lock_ptr(MMMLfree) ; \
                 if (s!=MMMNULL) \
		 {  MMMHlock_for_pointer(MMMLfree, s) ;\
                    MMMElock ( MMMLfree ) ; \
                    if (MMMDrefs(s)<=MMMCone_ref) \
                       {  MMMEunlock ( MMMLfree ) ; \
                          MMMmethod(MMMtype(s), MMMIfree) ((S_Pointer) s); \
                       } \
                     else \
                       {  MMMDrefs(s)--; \
                          MMMEunlock ( MMMLfree ) ; \
                       } \
                 } \
           } 
#endif /* NEWMAMMUT */

#ifndef NEWMAMMUT
#   ifndef MMMDCOLLECTFREES
#      define MMMlfree(s) \
              { if ((s) != MMMNULL) \
                   { long ref ; \
                     MMMDdecrease_refs(s, ref) ; \
                     if ( ref < MMMCone_ref ) \
                        { \
                           MMMFlfree((S_Pointer) s) ; \
                        } \
                   } \
              }
#     else /* MMMDCOLLECTFREES */
#       define MMMlfree(s) \
               {  MMMTbag bag ; \
                  if (s != MMMNULL) \
                     {  bag = MMMHbag_for_pointer(s);\
                        MMMHput_into_bag(bag, s,  -2) ; \
                     } \
		}
#   endif /* MMMDCOLLECTFREES */

# else
#   define MMMlfree(s) \
	   {   MMMHdeclare_lock_ptr(MMMLfree) ; \
                 if (s!=MMMNULL) \
		 {  MMMHlock_for_pointer(MMMLfree, s) ; \
                    MMMElock ( MMMLfree ) ; \
                    if (MMMDrefs(s)<=MMMCone_ref) \
                       {  MMMEunlock ( MMMLfree ) ; \
                          MMMmethod(MMMtype(s), MMMIfree) ((S_Pointer) s); \
                       } \
                     else \
                       {  MMMDrefs(s)--; \
                          MMMEunlock ( MMMLfree ) ; \
                       } \
                 } \
           }
#endif /* NEWMAMMUT */

#ifndef NEWMAMMUT
#   define MMMresize(s,size) \
           MMMFresize((S_Pointer *)s,size)
# else /* NEWMAMMUT */
#   define MMMresize(s,size) \
           MMMmethod(MMMtype(*s), MMMIresize)((S_Pointer *)s,size)
#endif /* NEWMAMMUT */

#ifndef NEWMAMMUT
#   define MMMnewcounter(s,count) \
           MMMFnewcounter((S_Pointer *)s,count)
# else /* NEWMAMMUT */
#   define MMMnewcounter(s,count) \
           MMMmethod(MMMtype(*s), MMMInewcounter)((S_Pointer *)s,count)
#endif /* NEWMAMMUT */

#ifndef NEWMAMMUT
#   define MMMrealloc(s,size,count) \
           MMMFrealloc ((S_Pointer *)s,size,count)
# else /* NEWMAMMUT */
#   define MMMrealloc(s,size,count) \
           MMMmethod(MMMtype(*s), MMMIrealloc)((S_Pointer *)s,size,count)
#endif /* NEWMAMMUT */

#ifndef NEWMAMMUT
#   ifndef MMMDCHANGEALWAYS
#      define MMMchange(s) \
              {if ( (*(s) != MMMNULL) && (MMMDrefs(*(s)) != MMMCone_ref) )\
                  MMMFensure((S_Pointer *)s) ;}
#    else /* MMMDCHANGEALWAYS */
#      define MMMchange(s) MMMFensure(s)
#   endif /* MMMDCHANGEALWAYS */
# else
#   define MMMchange(s) \
           {if ( (*(s) != MMMNULL) && (MMMDrefs(*(s)) != MMMCone_ref) )\
               MMMmethod(MMMtype(*s), MMMIchange)((S_Pointer *)s) ;}
#endif /* NEWMAMMUT */

#define MMMnewtype(s,typ) \
        MMMDtype(s) = typ

#ifndef MACINTOSH
#   define MMMset(p,q) \
           { S_Pointer MMMVsetp1 ; \
             MMMVsetp1=(q) ; *(p)=MMMVsetp1 ; \
             if (MMMVsetp1 != MMMNULL) \
                {  MMMcopy(MMMVsetp1); } \
           }


#ifndef MMMDEBUG
#   ifndef MMMDCOLLECTFREES
#      define MMMcopy(s) \
           {  if ( s != MMMNULL ) \
                 { \
                    MMMDincrease_refs(s) ; \
                 } \
           }
#    else /* MMMDCOLLECTFREES */
#      define MMMcopy(s) \
           {  MMMTbag bag ;\
              if ( s != MMMNULL )\
		{   bag = MMMHbag_for_pointer(s) ; \
                    MMMHput_into_bag(bag, s, 1) ; \
	        } \
            }
#   endif /* MMMDCOLLECTFREES */
#else /*MMMDEBUG*/
#   ifndef MMMDCOLLECTFREES
#      define MMMcopy(s) \
           {  if ( s != MMMNULL ) \
                 { \
                    MMMDincrease_refs(s) ; \
                 } \
           }
#    else /* MMMDCOLLECTFREES */
#      define MMMcopy(s) \
           {  MMMTbag bag ;\
              if ( s != MMMNULL )\
		{   bag = MMMHbag_for_pointer(s) ; \
                    MMMHput_into_bag(bag, s, 1) ; \
	        } \
            }
#   endif /* MMMDCOLLECTFREES */
#endif /*MMMDEBUG*/

#else /* MACINTOSH */
#   define MMMset(p,q) \
        { S_Pointer MMMVsetp1 ; \
          MMMVsetp1=q ; *p=MMMVsetp1 ; \
          if (MMMVsetp1 != MMMNULL) \
             {  MMMcopy(MMMVsetp1); } \
          if (MACV_EVENT_TIME) MAC_event(); \
        }
#   define MMMcopy(s) \
        { if (s != MMMNULL) MMMDrefs(s)++ ; if (MACV_EVENT_TIME) MAC_event(); }
#endif /* MACINTOSH */

#define MMMP(s,i,use) \
        ((S_Pointer *)(&(MMMDdata(*s) [i])))
#define MMMZ(s,T,use) \
        ((T *)(MMMDdata(*(s)) + MMMDcount(*(s))))
#define MMMarr(s,i,T,use) \
        (MMMZ(s,T,use) + i)
#define MMMmvarr(s,mv,i,T,use) \
        ((T *)&(((char *)MMMarr(s,i,T,use))[mv]))
#define MMMmv(s,mv,T,use) \
        ((T *)(((char *)MMMZ(s,T,use))+mv))
#define MMMinactiv(s)
#define MMM(s) s
#define MMMequal(p,q) \
        ( (p) == (q) )
#define MMMcounter(s) \
        ((s)!=MMMNULL?MMMDcount(s):0L)
#define MMMsize(s) \
        (((unsigned long)(MMMDsize(s)-MMMDcount(s))) << MMMCS_Pointer_size_log )
#define MMMtype(s) \
        MMMFtype(s)
#define MMMunmoveable(s,m) \
        MMMDunmoveable(s) =  m 
#define MMMgarbage(time)
#define MMMnewdata(s)
#define MMMpoolinit()
#define MMMpoolinsert(p)
#define MMMpooldelete(p)
#define MMMshift(sour,spos,dest,dpos,count) \
        MMMFshift(sour,spos,dest,dpos,count)
#define MMMsignature(s) \
        MMMDsignature(s)
#define MMMnewsignature(s,l) \
        (MMMDsignature(s) = l)
#define MMMrefs(s) \
        MMMDrefs(s)
#define MMMreplace(s,value) \
           {  S_Pointer MMMVreplace = *s ; \
              MMMset (s , value) ; \
              MMMfree ( MMMVreplace ) ; \
           }
#define MMMread_lock(s) \
           MMMDlock(s)

#ifdef MMMDshared
#  define MMMlock(s) \
	   {  VOLATILE(S_Pointer) r = s ;\
              MMMHdeclare_lock_ptr(MMMVlock) ; \
	      MMMHlock_for_pointer(MMMVlock, r) ; \
              for ( ; true ; ) \
                 {  for ( ; MMMread_lock(r) == MMMlocked ; ) \
                       ; \
                    MMMElock ( MMMVlock ) ; \
                    if ( MMMread_lock(r) == MMMlocked ) \
                       MMMEunlock ( MMMVlock ) ; \
                     else \
                       {  MMMDlock(r) = MMMlocked ; \
                          MMMEunlock ( MMMVlock ) ; \
                          break ; \
                       } \
                 } \
            }
#else
#  define MMMlock(s) 
#endif /* MMMDshared */
         
#define MMMunlock(s) \
           {  MMMread_lock(s) = MMMunlocked ; \
           }
              
#define MMMprepare_sleep() \
           MMMFprepare_sleep()

#define MMMsleep()  \
           MMMFsleep()

#define MMMwake_up(son)  \
           MMMFwake_up(son)

#define MMMwrite_shared(number,value) \
           {  SHARED_WRITE(MMMVsharedh, value) ; }

#define MMMread_shared(number) \
           SHARED_READ(MMMVsharedh)

#define MMMwrite_local_shared(number,value) \
           {  SHARED_WRITE(MMMVlocal_sharedh , value) ; }

#define MMMread_local_shared(number) \
           SHARED_READ(MMMVlocal_sharedh)

#define MMMinsert_global(variable) \
           MMMFinsert_global(variable)

#ifdef MMMDGARBAGE

#   define MMMmark_globals() \
	    MMMFmark_globals()

#   define MMMmark_tree(p) \
	    MMMFmark_tree(p)

#   ifdef PARALLEL
#      define MMMfree_unmarked(p) _false_
#   else
#      define MMMfree_unmarked(p) \
	    (MMMequal((p), MMMNULL) ? _true_ : \
		(MMMDused(p) ? _false_ : \
		    MMMFfree_unmarked(p)))
#   endif /* ! PARALLEL */

#   define MMMfree_unused() \
              MMMFfree_unused()

#else /* ! MMMDGARBAGE */

#   define MMMmark_globals()
#   define MMMmark_tree(p)
#   define MMMfree_unmarked(p) _false_
#   define MMMfree_unused()

#endif /* ! MMMDGARBAGE */

#define MMMbytes(p) \
	   MMMFbytes(p)

#ifdef NEWMAMMUT
#   define MMMmethod(type,index) \
           (SHARED_READ(MMMVmethodref)[type * SHARED_READ(MMMVnumber_of_methods) + index])
#   define MMMnewmethod(type,index,method) \
           {  SHARED_READ(MMMVmethodref)[type*SHARED_READ(MMMVnumber_of_methods) + index] = method ; }
#endif /* NEWMAMMUT */
/*************************************************************************
** In diesem Abschnitt werden die globalen Variablen, die auch von      **
** nicht-Speicherverwaltungsfunktionen gelesen werden koennen,          **
** deklariert.                                                          **
*************************************************************************/
#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA( long, MMMVnetnode )
#endif
GLOBAL_DECL( long, MMMVnetnode );
#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA( long, MMMVnode )
#endif
GLOBAL_DECL( long, MMMVnode) ;
SHARED_DECL(S_Pointer, MMMVtopology) ;
#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA( ulong, MMMVson )
#endif
GLOBAL_DECL( ulong, MMMVson) ;
#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA( ulong, MMMVlocal_son )
#endif
GLOBAL_DECL( ulong, MMMVlocal_son ) ;
SHARED_DECL(ulong, MMMVnumber_of_processes) ;
#ifdef MMMDTHREAD
typedef thread_t MMMTpid ;
#else
typedef int MMMTpid ;
#endif /*MMMDTHREAD*/
SHARED_DECL(MMMTpid*, MMMVprocessid) ;
typedef void (*MMMTsystemfree)(S_Pointer) ;
SHARED_DECL(MMMTsystemfree, MMMVsystemfree) ;
typedef void (*MMMTsystemchange)(S_Pointer *) ;
SHARED_DECL(MMMTsystemchange, MMMVsystemchange) ;
typedef char *(*MMMTno_memory)(MUPbool) ;
SHARED_DECL(MMMTno_memory, MMMVno_memory) ;
#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA( char*, MMMVmalloc_help )
#endif
GLOBAL_DECL( char *, MMMVmalloc_help ) ;
SHARED_DECL(ulong, MMMVNULLtype) ;
SHARED_DECL(ulong, MMMVused_blocks) ;
SHARED_DECL(ulong, MMMVused_memory) ;
SHARED_DECL(ulong, MMMVreserved_blocks) ;
SHARED_DECL(ulong, MMMVreserved_memory) ;
SHARED_DECL(ulong, MMMVallocated_memory) ;
SHARED_DECL(ulong, MMMVmax_reserved_memory) ;
SHARED_DECL(ulong, MMMVfrees) ;
SHARED_DECL(ulong, MMMVrealfrees) ;
SHARED_DECL(ulong, MMMVmallocs) ;
SHARED_DECL(ulong, MMMVmaxindex) ;
SHARED_DECL(MMMTindex_info, *MMMVmemory) ;

#if (defined SGI) && (defined PARALLEL)
   SHARED_DECL(usptr_t, MMMVlockspace) ;
#else
   SHARED_DECL(long, MMMVlockspace) ;
#endif

SHARED_DECL(ulong, MMMVlockcount) ;

#ifdef MMMDLOCKSPACE
SHARED_DECL(MMMTlock**, MMMVlocktable) ;
#else /* MMMDLOCKSPACE */
SHARED_DECL(MMMTlock*, MMMVlocktable) ;
#endif /* MMMDLOCKSPACE */

extern MMMTbagtype *MMMVbagtable ;
extern long MMMVbagsize ;
SHARED_DECL(S_Pointer, MMMVsharedh) ;
SHARED_DECL(S_Pointer, MMMVlocal_sharedh) ;
#ifdef NEWMAMMUT
#ifdef C_PLUSPLUS
typedef void (*MMMTmethodfunction)(...) ;
#else
typedef void (*MMMTmethodfunction)() ;
#endif
SHARED_DECL(MMMTmethodfunction *, MMMVmethodref) ;
SHARED_DECL(ulong, MMMVnumber_of_methods) ;
SHARED_DECL(ulong, MMMVnumber_of_types) ;
#endif /*NEWMAMMUT*/

#ifdef MMMDOWNMALLOC
extern MMMTheap MMMVheap ;
#endif


/*************************************************************************
** In diesem Abschnitt werden die von der Speicherverwaltung verwendeten**
** externen Funktionen, die mit MMME beginnen definiert.                **
*************************************************************************/

// Allokation von Speicher unabhaengig von Mammutobjekten:
// MMMEmalloc: Es wird Speicher reserviert, von dem nicht definiert ist,
//             ob er im gemeinsamen Speicher liegt oder nicht. Sollte immer
//             benutzt werden, wenn es egal ist, wo der Speicher liegt.
// MMMEsharemalloc:  Reserviert Speicher im gemeinsamen Speicher. Sollte nur
//                   benutzt werden, wenn wirklich Speicher im gemeinsamen
//                   Speicher benoetigt wird.
//
// Bei dieser Implementation gilt: MMMEsharemalloc und MMMEmalloc sind
// synonym. Beide nehmen Speicher aus dem gemeinsamen Speicher!
//
// Keinesfalls darf in mit MMMEmalloc oder MMMEsharemalloc angefordertem
// Speicher ein Zeiger auf ein Mammutobjekt gespeichert werden.

#define MMMEsharemalloc MMMEmalloc
#define MMMEsharefree MMMEfree

#ifndef MMMDshared

#if (defined MACINTOSH) || (defined MSDOS)
    extern void *MMMEmalloc(long n);
    extern void MMMEfree(void *p);
#else
#  ifdef MMMDOWNMALLOC
#    define MMMEmalloc(n) MMMFown_malloc(n, &MMMVheap)
#    define MMMEfree(p) MMMFown_free(p, &MMMVheap)
#  else /* MMMDOWNMALLOC */
#    define MMMEmalloc(n)  (((long)(GLOBAL_WRITE(MMMVmalloc_help, (char *)malloc(n))) ? GLOBAL_READ(MMMVmalloc_help) : SHARED_READ(MMMVno_memory)(_false_)))
#    define MMMEfree(p)    free(p)
#  endif /* MMMDOWNMALLOC */
#endif /* MACINTOSH || MSDOS */

#   define MMMDsleep_signal                         SIGUSR1
#   define MMMEinit_lock(l)                      
#   define MMMElock(l)                           
#   define MMMEunlock(l)                         
#   define MMMEwait_for_signal()                 
#   define MMMEsend_signal()
#   define MMMEkill(processid)
#   define MMMEget_my_id()                        0L
#   define MMMEexit(i)                            
#   define MMMEsigblock()
#   define MMMEsigpause()
#   define MMMEwake_up(id)
#   define MMMEinitlockspace(file)               0
#   define MMMEdeletelockspace(file)             0
#   define MMMEnewlock()                         (MMMTlock *)MMMEmalloc(sizeof(MMMTlock))
#   define MMMEfreelock(l)

#else /* MMMDshared */

#   ifdef sequent

#      define MMMDsleep_signal                      SIGUSR1
#      ifdef MMMDOWNMALLOC
#         define MMMEmalloc(n)                      MMMFown_malloc(n, &MMMVheap)
#         define MMMEfree(p)                        MMMFown_free(p, &MMMVheap)
#      else
#         define MMMEmalloc(n)                      (char *)malloc(n)
#         define MMMEfree(p)                        free(p)
#      endif /*MMMDOWNMALLOC*/
#      define MMMEinit_lock(l)                      S_INIT_LOCK((slock_t*)l)
#      define MMMElock(l)                           S_LOCK((slock_t*)l)
#      define MMMEunlock(l)                         S_UNLOCK((slock_t*)l)
#      define MMMEwait_for_signal()
#      define MMMEsend_signal()
#      define MMMEkill(processid)                   kill(processid,SIGQUIT)
#      define MMMEget_my_id()                       0L
#      define MMMEexit(i)                           exit(i)
#      define MMMEsigblock()                        sighold(MMMDsleep_signal)
#      define MMMEsigpause()                        sigpause(MMMDsleep_signal)
#      define MMMEwake_up(id)                       kill(id,MMMDsleep_signal)
#      define MMMEinitlockspace(file)               0
#      define MMMEdeletelockspace(file)             0
#      define MMMEnewlock()                         (MMMTlock *)MMMEmalloc(sizeof(MMMTlock))
#      define MMMEfreelock(l)

#   elif defined MMMDTHREAD

#      define MMMDsleep_signal                      SIGUSR1
#      define MMMEmalloc(n)                         malloc(n)
#      define MMMEfree(p)                           free((void*)p)
#      define MMMEinit_lock(l)                      mutex_init(l, USYNC_THREAD, NULL)
#      define MMMElock(l)                           mutex_lock(l)
#      define MMMEunlock(l)                         mutex_unlock(l)
#      define MMMEwait_for_signal()
#      define MMMEsend_signal()
#      define MMMEkill(processid)                   thr_kill(processid,SIGQUIT)
#      define MMMEget_my_id()                       thr_self()
#      define MMMEexit(i)                           exit(i)
#      define MMMEsigblock()                        sighold(MMMDsleep_signal)
#      define MMMEsigpause()                        sigpause(0)
#      define MMMEwake_up(id)                       thr_kill(id,MMMDsleep_signal)
#      define MMMEinitlockspace(file)               0
#      define MMMEdeletelockspace(file)             0
#      define MMMEnewlock()                         (MMMTlock *)MMMEmalloc(sizeof(MMMTlock))
#      define MMMEfreelock(l)

#   elif defined SGI
 
#      define MMMDsleep_signal                      SIGUSR1
#      ifdef MMMDOWNMALLOC
#         define MMMEmalloc(n)                      MMMFown_malloc(n, &MMMVheap)
#         define MMMEfree(p)                        MMMFown_free(p, &MMMVheap)
#      else /*MMMDOWNMALLOC*/
#         define MMMEmalloc(n)                      (char *)malloc(n)
#         define MMMEfree(p)                        free(p)
#      endif /*MMMDOWNMALLOC*/
#      define MMMEinit_lock(l)                      usinitlock(l)
#      define MMMElock(l)                           ussetlock(l)
#      define MMMEunlock(l)                         usunsetlock(l)
#      define MMMEwait_for_signal()
#      define MMMEsend_signal()
#      define MMMEkill(processid)                   kill(processid,SIGQUIT)
#      define MMMEget_my_id()                       getpid()
#      define MMMEexit(i)                           exit(i)
#      define MMMEsigblock()                        sighold(MMMDsleep_signal)
#      define MMMEsigpause()                        sigpause(MMMDsleep_signal)
#      define MMMEwake_up(id)                       kill(id,MMMDsleep_signal)
#      define MMMEinitlockspace(file)               usinit(file)
#      define MMMEdeletelockspace(file)             unlink(file)
/*#      define MMMEnewlock()                         usnewlock(MMMVlockspace) */
#      define MMMEnewlock()                         MMMFnewlock() 
#      define MMMEfreelock(l)                       usfreelock(l, MMMVlockspace)

#   elif defined SPP1000

#      define MMMDsleep_signal                      SIGUSR1
#      ifdef MMMDOWNMALLOC
#         define MMMEmalloc(n)                      MMMFown_malloc(n, &MMMVheap)
#         define MMMEfree(p)                        MMMFown_free(p, &MMMVheap)
#      else /*MMMDOWNMALLOC*/
#         define MMMEmalloc(n)                      (char *)malloc(n)
#         define MMMEfree(p)                        free(p)
#      endif /*MMMDOWNMALLOC*/
#      define MMMEinit_lock(l)                      msem_init(l, MSEM_UNLOCKED)
#      define MMMElock(l)                           msem_lock(l,0)
#      define MMMEunlock(l)                         msem_unlock(l,0)
#      define MMMEwait_for_signal()
#      define MMMEsend_signal()
#      define MMMEkill(processid)                   kill(processid,SIGQUIT)
#      define MMMEget_my_id()                       0L
#      define MMMEexit(i)                           exit(i)
#      define MMMEsigblock()                        sigblock(MMMDsleep_signal)
#      define MMMEsigpause()                        sigpause(0)
#      define MMMEwake_up(id)                       kill(id,MMMDsleep_signal)
#      define MMMEinitlockspace(file)               0
#      define MMMEdeletelockspace(file)             0
#      define MMMEnewlock()                         MMMFnewlock()
#      define MMMEfreelock(l)                       MMMEfree(l)

#   else

#      define MMMDsleep_signal                      SIGUSR1
#      ifdef MMMDOWNMALLOC
#         define MMMEmalloc(n)                      MMMFown_malloc(n, &MMMVheap)
#         define MMMEfree(p)                        MMMFown_free(p, &MMMVheap)
#      else
#         define MMMEmalloc(n)                      (char *)malloc(n)
#         define MMMEfree(p)                        free(p)
#      endif /*MMMDOWNMALLOC*/
#      define MMMEinit_lock(l)                      (*((MMMTreallock *)l)=0)
extern "C" void MMMAlocklock(MMMTlock *) ;
#      define MMMElock(l)                           MMMAlocklock(l)
extern "C" void MMMAunlocklock(MMMTlock *) ;
#      define MMMEunlock(l)                         MMMAunlocklock(l)
#      define MMMEwait_for_signal()                 
#      define MMMEsend_signal()
#      define MMMEkill(processid)                   kill(processid,SIGQUIT)
#      define MMMEget_my_id()                       0L
#      define MMMEexit(i)                           exit(i)
#      define MMMEsigblock()                        sighold(MMMDsleep_signal)
#      define MMMEsigpause()                        sigpause(MMMDsleep_signal)
#      define MMMEwake_up(id)                       kill(id,MMMDsleep_signal)
#      define MMMEinitlockspace(file)               0
#      define MMMEdeletelockspace(file)             0
#      define MMMEnewlock()                         (MMMTlock *)MMMEmalloc(sizeof(MMMTlock))
#      define MMMEfreelock(l)
#   endif
#endif

#undef ulong
#undef ushort
#undef uchar

#endif /* __MMMstorage_seq__ */
