/* $Date: 1995/11/24 16:16:30 $  $Author: snoo $  $Revision: 1.6 $ */

/**************************************************************************
**                           MMMSpeicherType.h                           **
** In diesem File werden die Typen definiert, die in der Speicherver-    **
** waltung benutzt werden.                                               **
** Erstellung      : 02/11/90                                            **
** Letzte Aenderung: 06/05/91                                            **
** Autor           : Holger Naundorf                                     **
**************************************************************************/

#ifndef __MMMstorage_type__
#define __MMMstorage_type__


#include <time.h>
#define MMMclock_t int
/**************************************************************************
** Es folgen die Strukturdefinitionen fuer die Standardinformationen zu  **
** einem Speicherbereich                                                 **
**************************************************************************/
#ifdef MSDOS
struct MMMTstatus
{
	unsigned int anz ;/*: 15 ; Zaehler fuer die S-Zeiger, die auf Speicherbereich zeigen*/
	unsigned int system ;/*: 1 ; Ist dieses Bit 1, so wurde dieser Speicher nicht von der Verwaltung belegt*/
	unsigned int  typ ;/*: 8 ; Gibt den Typ der Daten im Speicherbereich an*/
   unsigned int  count ;/*: 8; Zaehler fuer die S-Zeiger, die im Speicherblock gespeichert sind*/
} ;
#else /* not MSDOS */
struct MMMTstatus
{
        unsigned int anz : 15 ; /* Zaehler fuer die S-Zeiger, die auf Speicherbereich zeigen*/
        unsigned int system : 1 ; /* Ist dieses Bit 1, so wurde dieser Speicher nicht von der Verwaltung belegt*/
        unsigned int  typ : 8 ; /* Gibt den Typ der Daten im Speicherbereich an*/
   unsigned int  count : 8; /* Zaehler fuer die S-Zeiger, die im Speicherblock
gespeichert sind*/
} ;
#endif /* not MSDOS */

/*Header fuer Statusinformationen von kurzen Speicherbereichen*/
#ifndef MMMDEBUG
struct MMMTheader
{
   char *inh ;  /*Zeiger auf den Block, in dem Daten selbst gespeichert sind*/
   union
   {
      struct MMMTstatus status ;
      struct MMMTheader *next ; /*Zeiger zur Verkettung von leeren Bereichen*/
   } un ;
   unsigned long signature ; /*Signatur des Speicherbereiches*/
   MMMclock_t check ;  
#ifdef DBX
   unsigned long debug;	     /* Debug-Information */
#endif
#ifdef MMMDACTIV
   short art ; /*Art des aktivseins*/
   short activ ; /*Anzahl der aktiven Zeiger auf dieses Datum*/
   struct MMMTactivPointers 
   {  struct MMMTactivPointers  *next ;
      struct MMMTheader        **activ ; 
   } *activPointers ;
#endif
   long length ; /*Laenge des zugehoerigen Speicherbereiches*/
} ;

#else /* MMMDEBUG */

/*In dieser Struktur sind next und status nicht in einer union, damit die
Speicherverwaltung erkennen kann, ob ein Speicherbereich schon freigegeben ist*/
struct MMMTheader
{
   char *inh ;  /*Zeiger auf den Block, in dem Daten selbst gespeichert sind*/
   union
   {
      struct MMMTstatus status ;
      struct MMMTheader *next ; /*Zeiger zur Verkettung von leeren Bereichen*/
   } un ;
   unsigned long signature ; /*Signatur des Speicherbereiches*/
   clock_t check ;
#ifdef DBX 
   unsigned long debug;      /* Debug-Information */ 
#endif
#ifdef MMMDACTIV
   short art ; /*Art des aktivseins*/
   short activ ; /*Anzahl der aktiven Zeiger auf dieses Datum*/
   struct MMMTactivPointers
   {  struct MMMTactivPointers  *next ;
      struct MMMTheader        **activ ; 
   } *activPointers ;
#endif
   long length ; /*Laenge des zugehoerigen Speicherbereiches*/
   long count ; /*Zaehler fuer im Bereich gespeicherte S-Zeiger*/
   struct MMMTheader *nextt ;
} ;

#endif /* MMMDEBUG */

typedef struct MMMTheader MMMheader ;


/*Header fuer Statusinformationen von langen Speicherbereichen*/

#ifndef MMMDEBUG
struct MMMTlheader
{
   char *inh ;  /*Zeiger auf den Block, in dem Daten selbst gespeichert sind*/
   union
   {
      struct MMMTstatus status ;
      struct MMMTheader *next ; /*Zeiger zur Verkettung von leeren Bereichen*/
   } un ;
   unsigned long signature ; /*Signatur des Speicherbereiches*/
   clock_t check ;
#ifdef DBX 
   unsigned long debug;      /* Debug-Information */ 
#endif
#ifdef MMMDACTIV
   short art ; /*Art des aktivseins*/
   short activ ; /*Anzahl der aktiven Zeiger auf dieses Datum*/
   struct MMMTactivPointers *activPointers ; 
#endif
   long length ; /*Laenge des zugehoerigen Speicherbereiches*/
   long count ; /*Zaehler fuer im Bereich gespeicherte S-Zeiger*/
} ;

#else /* MMMDEBUG */

/*In dieser Struktur sind next und status nicht in einer union, damit die
Speicherverwaltung erkennen kann, ob ein Speicherbereich schon freigegeben ist*/struct MMMTlheader
{ 
   char *inh ;  /*Zeiger auf den Block, in dem Daten selbst gespeichert sind*/ 
   union 
   { 
      struct MMMTstatus status ; 
      struct MMMTheader *next ; /*Zeiger zur Verkettung von leeren Bereichen*/ 
   } un ; 
   unsigned long signature ; /*Signatur des Speicherbereiches*/ 
   clock_t check ;
#ifdef DBX 
   unsigned long debug;      /* Debug-Information */ 
#endif
#ifdef MMMDACTIV 
   short art ; /*Art des aktivseins*/ 
   short activ ; /*Anzahl der aktiven Zeiger auf dieses Datum*/ 
   struct MMMTactivPointers *activPointers ; 
#endif 
   long length ; /*Laenge des zugehoerigen Speicherbereiches*/ 
   long count ; /*Zaehler fuer im Bereich gespeicherte S-Zeiger*/ 
   struct MMMTheader *nextt ; 
} ; 

#endif /* MMMDEBUG */


#if( defined MMMDACTIV && defined C_PLUSPLUS )
/**************************************************************************
** Es folgt ein Struktur, in denen Zeiger auf die aktiven S-Zeiger       **
** gespeichert werden.                                                   **
**************************************************************************/
struct MMMTactivPointers  
{
   struct MMMTactivPointers  *next ;  
   MMMTheader               **activ ; 
} ;
#endif


typedef struct MMMTlheader MMMlheader ;

typedef MMMheader *S_Pointer ;


/**************************************************************************
** Es folgen die Strukturdefinitionen, die die Speicherverwaltung fuer   **
** die Verwaltung der freien Speicherbereiche benoetigt.                 **
**************************************************************************/
struct MMMSpeicher
{
   char *anfang ; /*Anfang des zugehoerigen Speicherblockes*/
   struct MMMSpeicher *next ; /*Zeiger zur Verkettung der Speicherbloecke*/
   long length ; /*Groesse des zugehoerigen Speicherblockes*/
} ;

#ifndef MMMSTATISTIC
struct MMMTBelegung
{
   long anz ; /*Anzahl der Speicherbereiche, die von der entsprechenden Groesse
                insgesamt zur Verfuegung stehen*/
   long banz ; /*Anzahl der Speicherbereiche der entsprechenden Greosse, die im 
                 Augenblick belegt sind*/
   MMMheader *free ; /*Liste der freien Speicherbereiche dieser Greosse*/
   struct MMMSpeicher *speicher ; /*Zeiger auf Liste von Speicherbloecken, die zur
                 Speicherung von Bloecken der entsprechenden Groesse benutzt werden*/
} ;
#endif

#ifdef MMMSTATISTIC
struct MMMTBelegung
{
   long anz ; /*Anzahl der Speicherbereiche, die von der entsprechenden Groesse
                insgesamt zur Verfuegung stehen*/
   long banz ; /*Anzahl der Speicherbereiche der entsprechenden Greosse, die im 
                 Augenblick belegt sind*/
   MMMheader *free ; /*Liste der freien Speicherbereiche dieser Greosse*/
   struct MMMSpeicher *speicher ; /*Zeiger auf Liste von Speicherbloecken, die zur
                 Speicherung von Bloecken der entsprechenden Groesse benutzt werden*/
   long usedtogether ; /*Anzahl der jemals belgeten Speicherbereiche*/
   long usedmax ; /*Maximale Anzahl der Speicherbereiche, die zur gleichen Zeit
                    benutzt wurden*/
   long S_Pointertogether; /*Anzahl der S-Zeiger, die jemals auf einen Speicherbereich
                             dieser Groesse gezeigt haben*/
   long S_Pointerused ; /*Anzahl der S-Zeiger, die gerade auf Speicherbereiche dieser
                          Groesse zeigen*/
   long S_Pointermax ; /*Maximale Anzahl der S-Zeiger, die zur gleichen Zeit auf Bereiche
                         dieser Groesse gezeigt haben*/
} ;
#endif

#ifdef MMMMOVE
typedef struct MMMTPoolEintrag_t
{
   struct MMMTPoolEintrag_t *next ;
   char **inh ;
} MMMTPoolEintrag ;

typedef struct
{
   MMMTPoolEintrag *next ;
   long anz ;
   long max ;
} MMMTPoolHeader ;

typedef struct MMMTMemList_t
{
   struct MMMTMemList_t *next ;
   S_Pointer inh ;
} MMMTMemList ;
#endif

#endif /* __MMMstorage_type__ */
