/* $Date: 1996/11/22 16:04:54 $  $Author: olli $  $Revision: 1.12 $ */

/**************************************************************************/
/* FILE:             MPA_parser.h                                         */
/* Autor:            Andreas Kemper                                       */
/* Erstellt:         24/03/91                                             */
/* Letzte Aenderung: 04/10/93                                             */
/**************************************************************************/

#ifndef __MPA_parser__
#define __MPA_parser__ 


#define MPA_string_to_number(s) \
        MCA_new_cat_pari(MPAC_STORAGE, lisexpr(s))

/**************************************************************************/
/* Fehlermeldungen des Parsers                                            */
/**************************************************************************/

#define MPAC_NO_ERROR                   0

#define MPAC_MISSING_THEN               1
#define MPAC_MISSING_END_CASE           3
#define MPAC_MISSING_IDENT              4
#define MPAC_MISSING_END_FOR            5
#define MPAC_MISSING_SEMICOLON          6
#define MPAC_MISSING_END_WHILE          7
#define MPAC_MISSING_UNTIL              8
#define MPAC_MISSING_END_REPEAT         9
#define MPAC_MISSING_END_SEQ           10
#define MPAC_MISSING_ASSIGN            11
#define MPAC_MISSING_DO                12
#define MPAC_MISSING_OPARENT           13
#define MPAC_MISSING_CPARENT           14
#define MPAC_MISSING_END_IF            15
#define MPAC_MISSING_OF                16
#define MPAC_MISSING_RBRACK            18
#define MPAC_MISSING_IDENT_SEQ         19
#define MPAC_MISSING_END_PROC          20
#define MPAC_MISSING_BEGIN             21
#define MPAC_MISSING_RBRACE            22
#define MPAC_MISSING_TO                23
#define MPAC_MISSING_FROM              24
#define MPAC_MISSING_END_PAR           25

#define MPAC_SHRAP_EXPECTED            30
#define MPAC_UNEXPECTED_CHAR           31
#define MPAC_INVALID_SYSTEM_CALL       32
#define MPAC_MAX_IDENT_LENGTH_EXEEDED  33
#define MPAC_INVALID_BACKSLASH         34
#define MPAC_UNEXPECTED_EOF            35
#define MPAC_INVALID_NUMBER            36
#define MPAC_INVALID_SYSTEM_CMD        37
#define MPAC_INVALID_HELP_CMD          38
#define MPAC_SCANNER_ERROR             39
#define MPAC_INVALID_OPTION            40

#define MPAC_UNEXPECTED_SYMBOL         41
#define MPAC_IDENT_EXPECTED            42
#define MPAC_INVALID_HELP_CALL         43
#define MPAC_INVALID_ALIAS             44
#define MPAC_DIVISON_BY_ZERO           45
#define MPAC_TYPE_EXPECTED             46


#define MPAC_EOF                       51


/**************************************************************************/
/* Definition weiterer Konstanten des Parsers:                            */
/**************************************************************************/

#define MPAC_STORAGE MMMCglobal


/**************************************************************************/
/* Funktionen des Files 'MPA_parser.c                                     */
/**************************************************************************/

void	MPA_init ( VOID );
void	MPA_reset( VOID );
void	MPA_exit ( VOID );


/**************************************************************************/
/* Definition der Scanner - Symbole (ALT ZU LOESCHEN)                     */
/**************************************************************************/

#define MPAC_EXPRSEQ          1L
#define MPAC_OR               2L
#define MPAC_AND              3L 
#define MPAC_SEQGEN           4L
#define MPAC_LESS             5L
#define MPAC_LEEQUAL          6L
#define MPAC_EQUAL            7L
#define MPAC_UNEQUAL          8L
#define MPAC_RANGE            9L
#define MPAC_MOD             10L
/*  
#define MPAC_DIV             11L 
*/
#define MPAC_UNION           12L
#define MPAC_MINUS_SET       13L
#define MPAC_INTERSECT       14L
#define MPAC_PLUS            15L
#define MPAC_MULT            16L
#define MPAC_POWER           17L
#define MPAC_CONCAT          18L

#define MPAC_ASSIGN          34L
#define MPAC_IF              35L
#define MPAC_CASE            36L
#define MPAC_FOR             37L
#define MPAC_FOR_PAR         38L
#define MPAC_FOR_DOWN        39L
#define MPAC_FOR_IN          40L
#define MPAC_FOR_IN_PAR      41L
#define MPAC_WHILE           42L
#define MPAC_REPEAT          43L
#define MPAC_NEXT            44L
#define MPAC_BREAK           45L
#define MPAC_QUIT            46L
#define MPAC_PARBEGIN        47L
#define MPAC_SEQBEGIN        48L
#define MPAC_STMTSEQ         49L

#define MPAC_LAST            55L
#define MPAC_INDEX           56L
#define MPAC_HELP            57L

/**********************************/

#define MPAC_COLON          100L
#define MPAC_SEMICOLON      101L
#define MPAC_NOT            102L
#define MPAC_MINUS          103L
#define MPAC_DIV            104L
#define MPAC_GREQUAL        105L
#define MPAC_GREATER        106L


/*** Globale Variablen ********************************************************/

extern jmp_buf MPAV_JumpLabel;	/* Sprungmarke fuer Fehler */
				/* des Evaluierers.        */


/*** Prototypen ***************************************************************/

S_Pointer MPA_parse		( MCLT_iostream &file, char *filename );
S_Pointer MPA_exec_read		( MCLT_iostream &file, char *filename, MUPbool do_close);
S_Pointer MPA_parse_input	( S_Pointer prompt );
S_Pointer MPA_parse_textinput	( S_Pointer prompt );
S_Pointer MPA_parse_finput	( MCLT_iostream &file, S_Pointer *str, long *pos );
S_Pointer MPA_parse_ftextinput	( MCLT_iostream &file, S_Pointer *str, long *pos );
S_Pointer MPA_parse_string	( S_Pointer string, long show_error_mess );
char     *MPA_fgets		( char *buffer, int num, MCLT_iostream &stream);

#ifndef NO_PARSER_EXTENSION
S_Pointer MPA_is_user_op_str(char **input, MCLT_iostream &file, long *pos, short modus);
long MPA_scan_user_op(char *s);
#endif

#endif /* __MPA_parser__ */
