/* $Date: 1997/10/10 15:54:45 $  $Author: tonner $  $Revision: 1.18 $ */

/**************************************************************************/
/* FILE:             MPA_parser_help.h                                    */
/* Autor:            Andreas Kemper                                       */
/* Erstellt:         23/02/95                                             */
/* Letzte Aenderung: 23/02/95                                             */
/*                                                                        */
/**************************************************************************/

#ifndef __MPA_parser_help__
#define __MPA_parser_help__


#ifdef DOS_FILENAMES
#  include "MGH_mess.h"
#else
#  include "MGH_message.h"
#endif /* DOS_FILENAMES */


/**************************************************************************/
/* Diese Datei enth"alt die f"ur alle Source-Dateien des Parser g"ultigen */
/* Deklarationen.							  */
/**************************************************************************/

/*** Lokale Hilfsfunktionen des Parsers ***********************************/

S_Pointer MPA_stmt(char **input,MCLT_iostream &file,long *pos);
S_Pointer MPA_stmt_seq(char **input, MCLT_iostream &file, long *pos, short num, short next1, short next2, short next3);
S_Pointer MPA_if_stmt(char **input, MCLT_iostream &file, long *pos);
S_Pointer MPA_else_part(char **input, MCLT_iostream &file, long *pos);
S_Pointer MPA_case_stmt(char **input, MCLT_iostream &file, long *pos);
S_Pointer MPA_for_stmt(char **input, MCLT_iostream &file, long *pos);
S_Pointer MPA_private(char **input, MCLT_iostream &file, long *pos);
S_Pointer MPA_while_stmt(char **input, MCLT_iostream &file, long *pos);
S_Pointer MPA_repeat_stmt(char **input, MCLT_iostream &file, long *pos);
S_Pointer MPA_seqbegin(char **input, MCLT_iostream &file, long *pos);
S_Pointer MPA_parbegin(char **input, MCLT_iostream &file, long *pos);
S_Pointer MPA_assignment(char **input, MCLT_iostream &file, long *pos, short *assign);
S_Pointer MPA_expr(char **input, MCLT_iostream &file, long *pos);
S_Pointer MPA_single_expr(char **input, MCLT_iostream &file, long *pos);
S_Pointer MPA_and_expr(char **input, MCLT_iostream &file, long *pos);
S_Pointer MPA_seq_expr(char **input, MCLT_iostream &file, long *pos);
S_Pointer MPA_relation(char **input, MCLT_iostream &file, long *pos);
S_Pointer MPA_range(char **input, MCLT_iostream &file, long *pos);
S_Pointer MPA_union_expr(char **input, MCLT_iostream &file, long *pos);
S_Pointer MPA_minus_expr(char **input, MCLT_iostream &file, long *pos);
S_Pointer MPA_intersect_expr(char **input, MCLT_iostream &file, long *pos);
S_Pointer MPA_mod_div_expr(char **input, MCLT_iostream &file, long *pos);
S_Pointer MPA_math_expr(char **input, MCLT_iostream &file, long *pos);
S_Pointer MPA_sign_term(char **input, MCLT_iostream &file, long *pos);
S_Pointer MPA_term(char **input, MCLT_iostream &file, long *pos);
S_Pointer MPA_power(char **input, MCLT_iostream &file, long *pos);
S_Pointer MPA_new_op(char **input, MCLT_iostream &file, long *pos);
S_Pointer MPA_point_expr(char **input, MCLT_iostream &file, long *pos);
S_Pointer MPA_at_sign_expr(char **input, MCLT_iostream &file, long *pos);

S_Pointer MPA_non_com_prod_expr(char **input, MCLT_iostream &file, long *pos);

S_Pointer MPA_neg_factor(char **input, MCLT_iostream &file, long *pos);
S_Pointer MPA_factor(char **input, MCLT_iostream &file, long *pos);
S_Pointer MPA_name(char **input, MCLT_iostream &file, long *pos, S_Pointer first);
S_Pointer MPA_name_lhs(char **input, MCLT_iostream &file, long *pos, short *assign);
S_Pointer MPA_concat_ident(char **input, MCLT_iostream &file, long *pos, S_Pointer first);
S_Pointer MPA_set(char **input, MCLT_iostream &file, long *pos);
S_Pointer MPA_expr_seq(char **input, MCLT_iostream &file, long *pos, short type);
S_Pointer MPA_proc_def(char **input, MCLT_iostream &file, long *pos);
S_Pointer MPA_name_expr(char **input, MCLT_iostream &file, long *pos);
void      MPA_concat_ident_seq(S_Pointer *tmp1, S_Pointer tmp2);
S_Pointer MPA_ident_seq(char **input, MCLT_iostream &file, long *pos);
S_Pointer MPA_typified_ident_seq(char **input, MCLT_iostream &file, long *pos);
S_Pointer MPA_help_cmd(char **input, MCLT_iostream &file, long *pos);

void      MPA_error_handling(char *input, long pos);
S_Pointer MPA_exec_read(MCLT_iostream &file, char *filename, MUPbool do_close);
char     *MPA_out_of_memory(MUPbool);
char     *MPA_end_of_file(char *input, int length, MCLT_iostream &file);

#ifdef MACINTOSH
char	 *MacFgets(Boolean, char *);
#endif
#if (defined MACINTOSH) || (defined MSDOS)
char	 *MPA_get_from_dlg(char *, int, MCLT_iostream& );
#endif

void      MPA_alias(S_Pointer *s);

MUPbool MPA_noDebug_set(MTcell s);



/*** Wird MuPAD von xmupad aufgerufen, so wird kein Prompt    ***/
/*** ausgegeben. Es wird dann ein Signal an xmupad geschickt. ***/

#ifdef MDX
#  define MPA_deactivate_buttons() {if (MDB_connected()) MDB_show_buttons(OFF);}
#else
#  define MPA_deactivate_buttons()
#endif

#ifdef MACINTOSH
#	define MPA_print_prompt()       { MAC_print_prompt(); }
#	define MPA_prompt_no_signal()   { MAC_print_prompt(); }
#	define MPA_print_long_prompt()  { MAC_print_long_prompt(); }
#else

#ifdef MSDOS
#	define MPA_print_prompt()        { MSW_get_cmd(); }
#	define MPA_prompt_no_signal()    {}
#	define MPA_print_long_prompt()   {}
#else
#ifdef OLDCOMMUNICATION
#define MPA_print_prompt() \
	if( XMUPAD ) {				\
		MUP_fflush(stdout);		\
		MUP_send_signal();		\
	}					\
	else {					\
		if( MEVV_pref.prompt ) {	\
		    MIO_print_string(MEVV_pref.promptstrg);	\
		}				\
                MPA_deactivate_buttons();       \
		MUP_fflush(stdout);		\
                MSCV_cont_mode = _false_;       \
	}

#define MPA_print_long_prompt() \
	if( XMUPAD ) {				\
		MUP_fflush(stdout);		\
		MUP_send_signal();		\
	}					\
	else {					\
		if( MEVV_pref.prompt ) {	\
		    MIO_print_string("&> ");	\
		}				\
                MPA_deactivate_buttons();       \
		MUP_fflush(stdout);		\
                MSCV_cont_mode = _true_;        \
	}

#ifdef DEADCODE
// vgl. NEWCOMMUNICATION
#define MPA_prompt_no_signal() \
	if (XMUPAD) { 				\
		MUP_fflush(stdout); 		\
	}					\
	else {					\
		if( MEVV_pref.prompt ) {	\
		    MIO_print_string(">> ");	\
		}				\
		MUP_fflush(stdout);		\
	}
#endif   /* DEADCODE */
#endif   /* OLDCOMMUNICATION */

#ifdef NEWCOMMUNICATION
#define MPA_print_prompt() \
	if( XMUPAD ) {				\
		MGH_send_prompt();		\
	}					\
	else {					\
		if( MEVV_pref.prompt ) {	\
		    MIO_print_string(MEVV_pref.promptstrg);	\
		}				\
		MPA_deactivate_buttons();       \
		MUP_fflush(stdout);		\
                MSCV_cont_mode = _false_;        \
	}

#define MPA_print_long_prompt() \
	if( XMUPAD ) {				\
		MGH_send_lprompt();		\
	}					\
	else {					\
		if( MEVV_pref.prompt ) {	\
		    MIO_print_string("&> ");	\
		}				\
		MPA_deactivate_buttons();       \
		MUP_fflush(stdout);		\
                MSCV_cont_mode = _true_;        \
	}

#ifdef DEADCODE
// identisch zu OLDCOMMUNICATION
// Der gewuenschte Prompt kann selbst definiert werden.
// Kein Standard-Prompt wegen Verwechslungsgefahr mit Eingabe-Prompt !!
//
// tonner 12.2.97
#define MPA_prompt_no_signal() \
	if (XMUPAD) { 				\
		MUP_fflush(stdout); 		\
	}					\
	else {					\
		if( MEVV_pref.prompt ) {	\
		    MIO_print_string(">> ");	\
		}				\
		MUP_fflush(stdout);		\
	}
#endif   /* DEADCODE */
#endif   /* NEWCOMMUNICATION */

#define MPA_prompt_no_signal()    {MUP_fflush(stdout);}
 	
#endif /* MSDOS */
#endif

/************** Macros zur Beeinflussung des Scanners  ********************/

#ifdef MDX
#       define MPA_set_dbx()   old_last_dbx = last_dbx
#       define MPA_reset_dbx() last_dbx = old_last_dbx
#else
#       define MPA_set_dbx()
#       define MPA_reset_dbx()
#endif

#define MPA_reset_scan() \
{						\
	*pos = old;				\
	last_line_nr = old_last_line_nr;	\
	MPAV_LINE_NR = old_line;		\
	MPA_reset_dbx();			\
}

#define MPA_set_scan() \
{						\
	old = *pos;				\
	old_last_line_nr = last_line_nr;	\
	old_line = MPAV_LINE_NR;		\
	MPA_set_dbx();				\
}


/****************** Macro zum Setzen von Fehlern **************************/

#define MPA_set_error(a,b) \
{						\
	MPAV_ERROR = a;				\
	MPAV_ERROR_STRING = b;			\
}


#ifdef MACINTOSH

#define MPAC_MEMORY_RESERVE 50000L

void MAC_panic();

#endif

		    

/******************************  Externe Variablen ***********************/


extern S_Pointer MTRV_STRING_ASS_MEM; /* Assoziativer Speicher fuer alle  */
                                      /* bekannten Strings. (MMM_STRING)  */

extern unsigned long last_dbx;

extern short MSCV_SYM;                /* Zuletzt gelesenes Scannersymbol  */
extern short MSCV_ERROR;              /* Fehlerangaben des Scanners       */

#endif /* __MPA_parser_help__ */

