#if (!defined NO_ACMATCH && !defined GRAPHIC)

#include "term_types.h"
#include "functions.h"

#ifdef SPLIT_MATCH

S_Pointer MPM_eval_acm_build    (S_Pointer, long, long, S_Pointer);
S_Pointer MPM_eval_acm_solution (S_Pointer, long, long, S_Pointer);
S_Pointer MPM_eval_acm_release  (S_Pointer, long, long, S_Pointer);

S_Pointer MPM_next_solution(VOID);

#else

S_Pointer MPM_eval_ac_match     (S_Pointer, long, long, S_Pointer);
S_Pointer MPM_next_solution	(void*, TERM**, int, S_Pointer);
S_Pointer MPM_check_type_list	(S_Pointer, int);
MUPbool   MPM_testtype		(S_Pointer, S_Pointer); 
void      MPM_free_symtab       (VOID);

#endif

S_Pointer  MPM_acform_to_expr(TERM*);
S_Pointer  MPM_get_ident(int);
S_Pointer  MPM_get_const(int);
TERM_TYPE  MPM_func_type(S_Pointer, S_Pointer);
TERM*      MPM_expr_to_acform(S_Pointer, S_Pointer, S_Pointer);
TERM_LIST* MPM_operands_to_acform(S_Pointer*, int, S_Pointer, S_Pointer);

int        MPM_get_ident_id(S_Pointer);
int        MPM_get_const_id(S_Pointer, long);
void       MPM_ac_init(VOID);
void       MPM_ac_exit(VOID);

MDE_externCstart

extern TERM*      make_term(int, TERM_LIST*, TERM_TYPE, int);
extern TERM_LIST* make_term_list(TERM*, TERM_LIST*);
extern BOOL       extract_match(void*, TERM**);
extern void*      build_match(TERM*, TERM*, int);
extern void       destroy_term(TERM*);
extern void*      salloc(unsigned);
extern void       sfree(void *);

MDE_externCend

void print_term(TERM*);
void print_tlist(TERM_LIST*);

#endif /* NO_ACMATCH */
