/* $Date: 1997/12/01 11:37:34 $  $Author: kg $  $Revision: 1.20 $ */

/**************************************************************************/
/* FILE:             MSC_scan.h                                           */
/* Autor:            Andreas Kemper, Andreas Sorgatz, Oliver Kluge        */
/* Erstellt:         20/12/91                                             */
/* Letzte Aenderung: 21/11/96                                             */
/**************************************************************************/

#ifndef __MSC_scan__
#define __MSC_scan__

#ifdef DOS_FILENAMES
#  include "MGH_mess.h"
#else
#  include "MGH_message.h"
#endif /* DOS_FILENAMES */


#define MSCC_CONCAT  15         /* Sonderzeichen f"uer '\' in den Eingabestring */
                                /* eingefuegt wird, um die Zeilennummer richtig */
                                /* zu bestimmen.                                */
 
#define  MSCC_SKIP_CHARS " \t\r"       /* Zeichen, die vom Scanner ueber- */
                                       /* sprungen werden.                */ 

#define  MSCC_EOL       '\n'           /* Zeilenende                      */ 

#define MSCC_ILLEGAL_CHARS_IN_USER_OP " :;)([]{}#\t\n\r\0\\"

#define MSCC_NESTED_COMMENT '~'        /* Geschachtelte Kommentare: #~ ... ~# */
#define MSCC_EOL_COMMENT    '!'        /* Kommentar bis Zeilenende: #! ...... */

/* isdigit etc. hat auf einigen Platformen Probleme mit ANSI-Zeichen >= 156 */

#if defined MACINTOSH || defined NEXTX86
#define isascii(c) TRUE		// Kein isascii auf dem Macintosh
#endif

#define MSC_isdigit(c) (isascii(c) && isdigit(c))
#define MSC_isalpha(c) (isascii(c) && isalpha(c))
#define MSC_isalnum(c) (isascii(c) && isalnum(c))
#define MSC_isspace(c) (isascii(c) && isspace(c))

extern MUPbool MSCV_cont_mode;

S_Pointer  MSC_scan(char   **input, 
                    MCLT_iostream &file, 
                    long   *pos, 
                    long   create, 
                    short  modus);

S_Pointer  MSC_scan_ident_keyword(char   **input,
				  MCLT_iostream &file,
				  long   *pos,
				  long   create,
				  short  modus);

S_Pointer MSC_string_to_number(char *str);

char * MSC_get_input(char    **input, 
		     long    pos,
		     MCLT_iostream &file,
		     char    *(*func)(char *, int, MCLT_iostream& ) );
		     
char *MSC_fgets(char *buffer, int numChars, MCLT_iostream &stream );

S_Pointer MSC_get_newline(char **input, MCLT_iostream &file, long *pos, short modus);

#define MSCC_SCAN_LENGTH           512
#define MSCC_MAX_IDENT_LENGTH      512

/* Scannersymbole */ 

#define MSCC_NO_SYM	    0	

		
#define MSCC_PLUS           1
#define MSCC_MINUS          2
#define MSCC_MULT           3
#define MSCC_DIV            4
#define MSCC_POWER          5
#define MSCC_OPARENT        6
#define MSCC_CPARENT        7
#define MSCC_LBRACK         8
#define MSCC_RBRACK         9
#define MSCC_LBRACE        10
#define MSCC_RBRACE        11
#define MSCC_COMMA         12
#define MSCC_SEMICOLON     13
#define MSCC_DOLLAR        14
#define MSCC_DOUBLE_QUOTE  15
#define MSCC_AMPERSAND     16
#define MSCC_ELLIPSIS      17
#define MSCC_POINT         18

#define MSCC_LESS          19   /* Achtung Reihenfolge MPAC_LESS ... MPAC_EQUAL */
#define MSCC_UNEQUAL       20   /* unbedingt beibehalten. Reihenfolge wird in   */
#define MSCC_LEEQUAL       21   /* Prozedur 'MPA_relation' benutzt.             */
#define MSCC_GREATER       22
#define MSCC_GREQUAL       23
#define MSCC_EQUAL         24

#define MSCC_ASSIGN        25
#define MSCC_COLON         26
#define MSCC_QUESTION_MARK 27
#define MSCC_DOUBLE_SEMI   28
#define MSCC_AT_SIGN       29

#define MSCC_STRING        40
#define MSCC_IDENT         41
#define MSCC_NUMBER        42
#define MSCC_SYSTEM        43
#define MSCC_LAST          44
#define MSCC_DOT_NUMBER    45

#define MSCC_DOUBLE_MULT   47

#define MSCC_AND           49
#define MSCC_BEGIN         50
#define MSCC_BREAK         51
#define MSCC_CASE          52
#define MSCC_DIV_KEYWORD   53
#define MSCC_DO            54
#define MSCC_DOWNTO        55
#define MSCC_ELSE          56
#define MSCC_ELIF          57
#define MSCC_END_CASE      58
#define MSCC_END_FOR       60
#define MSCC_END_IF        61
#define MSCC_END_PAR       62
#define MSCC_END_PROC      63
#define MSCC_END_SEQ       64
#define MSCC_END_REPEAT    65
#define MSCC_END_WHILE     66
#define MSCC_FALSE         67
#define MSCC_FOR           68
#define MSCC_FROM          69
#define MSCC_IF            70
#define MSCC_INTERSECT     71
#define MSCC_IN            72
#define MSCC_LOCAL         73
#define MSCC_MOD           74
#define MSCC_MINUS_KEYWORD 75
#define MSCC_NOT           76
#define MSCC_NEXT          77
#define MSCC_NIL           78
#define MSCC_OF            79
#define MSCC_OR            80
#define MSCC_OTHERWISE     81
#define MSCC_OPTION        82
#define MSCC_PARALLEL      83
#define MSCC_PARBEGIN      84 
#define MSCC_PROC          85
#define MSCC_PRIVATE       86
#define MSCC_QUIT          87
#define MSCC_REPEAT        88
#define MSCC_SEQBEGIN      89
#define MSCC_STEP          90
#define MSCC_THEN          91
#define MSCC_TO            92
#define MSCC_TRUE          93
#define MSCC_UNION         94
#define MSCC_UNTIL         95
#define MSCC_UNKNOWN       96
#define MSCC_WHILE         97
#define MSCC_I             98
#define MSCC_FAILED        99
#define MSCC_NAME         100

#ifndef NO_PARSER_EXTENSION

#define MSCC_QUOTE	  101
#define MSCC_EXCL_MARK    102
#define MSCC_USER_OP      103

#endif

#define MSCC_EOF          104   /* beliebiges EOF */


#define MSCC_NO_ERROR                       0  /* Scanner Fehlerkodes */
#define MSCC_ERROR                        1101
#define MSCC_UNEXPECTED_EOF               1102  /* EOF nach Backslash */
#define MSCC_INVALID_BACKSLASH            1103
#define MSCC_UNEXPECTED_CHAR              1104
#define MSCC_MAX_IDENT_LENGTH_EXEEDED     1105
#define MSCC_INVALID_NUMBER               1106
#define MSCC_UNEXPECTED_END               1107
#define MSCC_INTERRUPTED                  1108


/* Besondere Flags, die im 'modus' - Eintrag des Scanners gesetzt werden k"onnen */

#define MSCC_DEFAULT        0    /* Generierung von Schluesselwoertern und Idents */
				 /* innerhalb 'MSC_scan_ident_keyword()'          */
            
#define MSCC_ONLY_IDENTS    1    /* Nur Generierung von Identifiern               */
				 /* innerhalb 'MSC_scan_ident_keyword()'          */ 

#define MSCC_INTERACTIV     2    /* Nur in diesem Modus k"onnen die Symbole '?'   */
				 /* und '!' sowie der Rest der jeweiligen Zeile   */
				 /* gelesen werden. In allen anderen F"allen      */
			         /* f"uhren diese Symbole zu einem Fehler.        */

#define MSCC_FIRST_SCAN     4    /* Ist dieses Bit gesetzt, so handelt es sich    */
				 /* um den Anfang einer neuen Eingabe und beim    */
				 /* Holen einer neuen Eingabe wird daher kein     */
				 /* 'MPA_print_long_prompt' verwendet.            */

#define MSCC_DOT_START      8    /* Auf dieses Flag reagiert nur die Funktion     */
				 /* 'MSC_scan_number'. Es signalisiert, da"s ein  */
				 /* Zahl vorliegt, die mit einem Punkt beginnt.   */


#define MSCC_STRING_CONTEXT  16  /* Der Scan-Vorgang befindet sich innerhalb eines */
				 /* Strings.					   */

#define MSCC_COMMENT_CONTEXT 32  /* Der Scan-Vorgang befindet sich innerhalb eines */
				 /* Kommentars.                                    */

#endif /* __MSC_scan__ */

