/*  LAST EDIT: Wed Apr 12 12:47:48 1995 by Holger Naundorf (snoo)  */
/* $Date: 1996/11/18 13:54:46 $  $Author: jerry $  $Revision: 1.8 $ */

/******************************************************************************/
/* FILE:             MSY_sys_func.h                                           */
/* Autor:            Andreas Kemper                                           */
/* Erstellt:         24/06/91                                                 */
/* Letzte Aenderung: 15/09/93                                                 */
/*                                                                            */
/* Dieses File enthaelt die Deklarationen des Modules `MSY_sys_func'.         */
/******************************************************************************/

#ifndef __MSY_sys_func__
#define __MSY_sys_func__


/*** Typen von Funktionen fuer MSY_indets *************************************/

#define MSYC_POLY_INDETS  1L    /* polynomiale Ausdruecke */
#define MSYC_RAT_INDETS   2L    /* rationale Ausdruecke */
#define MSYC_OPD_INDETS   3L    /* Operanden */
 


/*** Parallel-Status **********************************************************/

typedef struct
{
   long calls ;        /*Zahl der Tasks, die vom Problemheap genommen wurden*/
   long used_utime ;   /*Zeit die gebraucht wurde, um diese Tasks abzuarbeiten*/
   long user_time ;    /*Hilfsvariable*/
   long spins ;        /*Anzahl der Spin-Runden, die dieser Proze\3 vor einem
                         Lock durchgef"uhrt hat.*/
} MSYT_parallel_status ;

SHARED_DECL(MSYT_parallel_status *, MSYV_parallel_status) ;


/*** In diesem Array werden alle S-Zeiger gespeichert, die auf eine C-Funk- ***/
/*** tion zeigen, die an einen EXEC-Knoten gehaengt werden kann. Modulfunk- ***/
/*** tionen sind hiervon jedoch unabhaengig !                               ***/

extern S_Pointer MSYV_CODE_TAB ; 


/*** Exec-Knoten der Systemfunktionen _mod, modp und mods *********************/

extern S_Pointer MSYV_EXEC_MOD;
extern S_Pointer MSYV_EXEC_MODP;
extern S_Pointer MSYV_EXEC_MODS;


/*** Zustand der Funktion 'testargs' ******************************************/

extern MUPbool MSYV_TESTARGS;


/*** Optionen der Funktion 'indets'  ******************************************/

extern S_Pointer MSYV_STR_PolyExpr;
extern S_Pointer MSYV_STR_RatExpr;

/*** Prototypen ***************************************************************/

void	  MSY_init		  ( VOID );
void      MSY_init2               ( VOID );
S_Pointer MSY_read_string_ass_mem ( long mode, S_Pointer varname, MCLT_iostream &fp );
long      MSY_is_proc_def         ( S_Pointer value );
MUPbool   MSY_number_less         ( S_Pointer e1,
		                    S_Pointer e2,
		                    void *arg );
void      MSY_sort                ( S_Pointer *list, 
		                    long lb,
		                    long ub, 
		                    MUPbool ascending,
		                    MUPbool (*less)(S_Pointer, S_Pointer, void *),
		                    void *arg );
void      MSY_set_strings         ( VOID );
void      MSY_insert_code_objects ( VOID );

#endif /*__MSY_sys_func__ */
