/*  LAST EDIT: Wed Oct 12 16:54:57 1994 by Holger Naundorf (snoo)  */
/* $Date: 1997/05/16 07:34:25 $  $Author: kg $  $Revision: 1.19 $ */

/**************************************************************************/
/* FILE:             MTR_tree.h                                           */
/* Autor:            Andreas Kemper, Andreas Sorgatz                      */
/* Erstellt:         25/05/91                                             */
/* Letzte Aenderung: 28/12/95                                             */
/*                                                                        */
/* Dieses File deklariert alle zum Aufbau der Datenstrukturen noetigen    */
/* Prozeduren und Macros.                                                 */
/**************************************************************************/

#ifndef __MTR_tree__
#define __MTR_tree__


#ifdef DOS_FILENAMES
#  include "MUP_typ.h"
#else
#  include "MUP_types.h"
#endif


/******  Definition der Groesse der Systemfunktionen-Liste !!!  ***********/

#define MTRC_SYS_FUNC_LIST_SIZE 300L          /*** vgl. MUP_constants.h ***/


/*** Weitere Konstanten dieses Modules ************************************/

#define MTRC_STORAGE MMMCglobal


/* Makro zum Zugriff auf den Funktionszeiger in MMM_CODE Objekten */

#ifdef MMMC_INDIRECT_CODE

#define MTRC_CODE(s,T) ((T *) *MMMZ((s), T *, MMMread))

#else

#define MTRC_CODE(s,T) ((T *) MMMZ((s), T, MMMread))

#endif

/****** Makros zur Anforderung von Speicherplatz fuer Grundtypen **********/ 

/* Typ MMM_FLOAT mit 'n' Datenbloecken */
#define MTR_new_float(type,n) MMMmalloc(type,MMM_FLOAT,(long)(sizeof(short)*n+2*sizeof(long)),0L)


/* Typ MMM_APM mit 'n' Datenbloecken */
#define MTR_new_apm(type,n) MMMmalloc(type,MMM_APM,(long)(sizeof(short)*n+sizeof(long)),0L)


/* Typ MMM_INT zur Speicherung eines long Wertes */
#define MTR_new_int(type) MMMmalloc(type,MMM_INT,(long)sizeof(long),0L) 

/* Typ MMM_MFLOAT zur Speicherung eines double Wertes */
#define MTR_new_mfloat(type) MMMmalloc(type,MMM_MFLOAT,(long)sizeof(double),0L)


/* Typ MMM_LIST */
#define MTR_new_list(type) MMMmalloc(type,MMM_LIST,0L,2L)


/* Typ MMM_EXT_LIST */
#define MTR_new_ext_list(type) MMMmalloc(type,MMM_EXT_LIST,sizeof(short),3L)


/* Typ MMM_STRING */
#define MTR_new_string(type,n) MMMpalloc(type,MMM_STRING,(long)(sizeof(char)*n+sizeof(STRSIZE)),0L)


/* Typ MMM_Category mit 'n' Verweisen */
#define MTR_new_category(type,n) MMMmalloc(type,MMM_CATEGORY,(long)sizeof(CATEGORY),(long) n)


/* Typ MMM_Category mit 'n' Verweisen und einer Kategorieerweiterung */
#define MTR_new_extended_category(type,n) MMMmalloc(type,MMM_CATEGORY,(long)sizeof(CATEGORY)+(long)sizeof(CATEGORY_EXT),(long) n)


/* Typ MMM_STACK_ITEM */
#define MTR_new_stack_item(type) MMMmalloc(type,MMM_STACK_ITEM,sizeof(long)+sizeof(MSTTinfo)+sizeof(long),3L)


/* Typ MMM_REFENCE_ITEM */
#define MTR_new_reference_item(type) MMMmalloc(type,MMM_REFERENCE_ITEM,2*sizeof(long)+sizeof(S_Pointer),1L)

/* Typ MMM_DIST_POLY mit 'n' Termen in 'k' Unbestimmten */
#define MTR_new_dist_poly(type,n,k) MMMmalloc(type,MMM_DIST_POLY,(long)(sizeof(long)*((n)*(k))),(long)(n))



/*** Typen dieses Modules *************************************************/

typedef struct {
	long	 idx;
	char	*name;
} MTRT_sysfunc_name;


/*** Variablen dieses Modules *********************************************/

extern S_Pointer                 MTRV_STRING_ASS_MEM;
extern S_Pointer                *MTRV_SYS_FUNC_LIST;
extern MTRT_sysfunc_name	 MTRV_sysfunc_name[];
extern S_Pointer                 MTRV_system_namespace;


/******  Deklaration der im File MTR_tree.c definierten Prozeduren  *******/

void      MTR_init 		( VOID );
S_Pointer MTR_new_code 		( long type, FUNC_POINTER f, long num );
S_Pointer MTR_set_int 		( long type, long num );
S_Pointer MTR_new_cat_exec 	( long type, long n );
S_Pointer MTR_new_cat_int 	( long type, unsigned long value, short sign );
S_Pointer MTR_new_cat_bool 	( long type, long n );
S_Pointer MTR_new_cat_task 	( long type );
S_Pointer MTR_new_cat_null 	( long type );
S_Pointer MTR_new_cat_nil 	( long type );
S_Pointer MTR_new_cat_failed 	( long type );
S_Pointer MTR_new_cat_set_finite( long type );
S_Pointer MTR_new_cat_point     ( long       type, 
                                  S_Pointer  s1, 
			          S_Pointer  s2, 
			          S_Pointer  s3, 
			          S_Pointer  color); 

S_Pointer MTR_new_cat_polygon   ( long       type, 
				  long       num,
				  S_Pointer  *sp,
				  S_Pointer  color,
				  S_Pointer  closed,
				  S_Pointer  filled);
S_Pointer MTR_new_cat_stat_list ( long type, long n );
S_Pointer MTR_new_cat_dyn_list 	( long type );
S_Pointer MTR_new_cat_expr 	( long type, long n );
S_Pointer MTR_new_cat_func_env 	( long storage );
S_Pointer MTR_new_cat_poly 	( long type, long t, long u );
S_Pointer MTR_new_proc 		( long type, long num );
S_Pointer MTR_new_user_func 	( long		type, 
				  S_Pointer	name, 
				  long		num
				  Mva_arglist );
S_Pointer MTR_new_sys_expr_empty( long		storage,
				  long		type,
				  long		num );
S_Pointer MTR_new_sys_expr0     ( long		storage,
				  long		type,
				  long		num );
S_Pointer MTR_new_sys_expr 	( long		storage,
				  long		type,
				  long		num
				  Mva_arglist );
S_Pointer MTR_build_sys_expr 	( long		storage,
				  long		type,
				  long		num
				  Mva_arglist );
S_Pointer MTR_shift_sys_expr    ( long          storage, 
                                  long          type, 
                                  S_Pointer     args,
				  long          start,
				  long          end ); 
S_Pointer MTR_new_cat_ident_sys ( long storage, long type );
S_Pointer MTR_new_cat_string_sys( long storage, long type );
S_Pointer MTR_new_cat_ident 	( long storage, char *s );
S_Pointer MTR_new_cat_ident_MMMstring ( long storage, S_Pointer mmmstring ) ;
S_Pointer MTR_new_cat_string 	( long storage, char *s );
S_Pointer MTR_set_string 	( long type, char *s );
S_Pointer MTR_new_tmp_string    ( long type, char *s );
S_Pointer MTR_new_cat_dom 	( long type, long count );
S_Pointer MTR_new_cat_ext 	( long type, long count );
S_Pointer MTR_new_cat_funcarg   ( long type, long index );
S_Pointer MTR_new_cat_debug 	( long type, unsigned long value );
S_Pointer MTR_new_cat_bytecode  ( long type, S_Pointer s );

void      MTR_load_func_env     ( unsigned long func);

#endif /* __MTR_tree__ */
