/* $Date: 1997/10/11 12:39:25 $  $Author: drummer $  $Revision: 1.79 $ */

/**************************************************************************/
/* FILE:             MUP_constants.h                                      */
/* Autor:            Andreas Kemper                                       */
/* Erstellt:         25/04/91                                             */
/* Letzte Aenderung: 03/03/97                                             */
/*                                                                        */
/* Ab Revision 1.57 (31.10.96) gibt es das Preprocessor-Flag NO_SPEC_BITS */ 
/* Hiermit werden die Abfragen auf die Special-Bits MINUS_BIT, DIV_BIT    */ 
/* und nicht mehr durchgef"uhrt, da davon ausgegangen wird, das keine     */ 
/* Funktion, insbesondere der Parser und der Simplifier, mehr solche Bits */ 
/* generieren.  (Oliver Kluge)                                            */
/* Ab Revision 1.63 (3.3.97) gibt es nur noch die Version ohne Special-   */
/* Bits. Das Flag NO_SPEC_BITS wurde entfernt.                            */
/**************************************************************************/

#ifndef __MUP_constants__
#define __MUP_constants__


/**************************************************************************/
/* Dieses File enythaelt die Definition fuer alle Konstanten.             */
/**************************************************************************/

/* Jetzt geht's los .... */


#define NO_SYM_BIT             0
#define MINUS_BIT              1
#define DIV_BIT                2
#define NOT_BIT                4

#define OPTIONS_CHECKED_BIT    8
#define NO_DEBUG_BIT          16
#define HOLD_BIT              32
#define REMEMBER_BIT          64
#define TMP_BIT              128

#define MUPC_XOR_BITS          7

       

/************* Defintion der Datentypen der Speicherverwaltung ***********
 *
 * Bei MMM-Typen, von denen Signaturen berechnet werden, muss die zugehoerige
 * MMM_-Konstante kleiner als MUPC_MaxStorTypes sein.
 */

#define MMM_FLOAT        12L
#define MMM_APM          13L
#define MMM_INT          14L
#define MMM_LIST         15L
#define MMM_EXT_LIST     16L
#define MMM_CATEGORY     17L
#define MMM_STRING       18L
#define MMM_ASS_MEM      19L
#define MMM_POINT_ARRAY  20L
#define MMM_STACK_ITEM   21L
#define MMM_MFLOAT	 22L
#define MMM_REFERENCE_ITEM 23L 
#define MMM_NODESTACK1   24L
#define MMM_NODESTACK2   25L
#define MMM_LOCAL_STACK  26L
#define MMM_DOMAIN       27L
#define MMM_ARRAY        28L
#define MMM_STRING_HELP  29L /*Hilfstyp, der vom MCode benutzt wird*/
#define MMM_NAMESPACE    30L
#define MMM_BYTECODE     31L

#define MMM_EXEC         40L
#define MMM_CODE         41L
#define MMM_STACK        42L
#define MMM_PARI	 44L
#define MMM_DIST_POLY	 45L

#define MMM_GRAPHIC      50L
#define MMM_SCENE_3D     51L
#define MMM_SCENE_2D     52L
#define MMM_OBJECT_3D    53L
#define MMM_OBJECT_2D    54L
#define MMM_DEFAULTS     55L
#define MMM_PRIMLIST     56L
#define MMM_POINTLIST    57L
#define MMM_GRLIST       58L
#define MMM_POINT_3D     59L
#define MMM_POINT_2D     60L
#define MMM_LINE         61L
#define MMM_TRIANGLE     62L
#define MMM_RGB_COLOR    63L
#define MMM_PIXMAP       64L

/*
 * Neu f"ur Befehl-S_Pointer, der von MGR_eval_plot() berechnet und
 * gegebenenfalls an das Grafiktool geschickt wird.
 */
#define MMM_GRAPHIC_COMMAND 65L
/* 
 * Neu als interner Typ fuer Polygone
 */
#define MMM_POLYGON      66L
/*
** Typ fuer die Scene/Objekt-Titel in Vcam
*/
#define MMM_TITLE_RECTS  67L

#define MMM_TAB         101L
#define MMM_TMP         102L
#define MMM_HIDDEN	103L

#define MMM_OUT_NODE    110L
#define MMM_OUT_TEXT    111L
#define MMM_OUT_FIELD   112L

#define MMM_MAM_STACK   113L
#define MMM_DEPTH_STACK 114L


/****************** Defintion der Kategorietypen *************************/ 
/*
 * ACHTUNG: Bei Erweiterungen/Aenderungen muss auch die Tabelle der
 *	zugehoerigen Namen (MEVV_CAT_NAMES) angepasst werden!
 */

#define CAT_APM           1
#define CAT_FLOAT         2 
#define CAT_INT           3 
#define CAT_RAT           4
#define CAT_MFLOAT	  5
#define CAT_COMPLEX       6 


#define CAT_STRING       10
#define CAT_BOOL         11

#define CAT_NULL         13
#define CAT_NIL          14

#define CAT_IDENT        20
#define CAT_SET_FINITE   21
#define CAT_DYN_LIST     22
#define CAT_STAT_LIST    23
#define CAT_ARRAY        24
#define CAT_TABLE        25
#define CAT_EXPR         26
#define CAT_FUNC_ENV     27
#define CAT_FUNC         28
#define CAT_ERROR        29
#define CAT_TASK         30
#define CAT_EXEC         31
#define CAT_DEBUG        32
#define CAT_PROC         33
#define CAT_POLY	 34
#define CAT_DOM          35
#define CAT_EXT          36
#define CAT_FAILED       37
#define CAT_POLYGON      38
#define CAT_POINT        39
#define CAT_FUNCARG      40
#define CAT_NAMESPACE    41
#define CAT_BYTECODE     42

#define MUPC_MaxCatTypes 50

#define MUPC_real         5
#define MUPC_num          7
#define MUPC_copy        15
#define MUPC_simple	 20

#define MAX_IDENT_LENGTH 20


/****************** Definition der '_' - Systemfunktionen ****************/
/*                                                                       */
/*                   ACHTUNG !  ACHTUNG !  ACHTUNG!                      */
/*     Diese muessen zur Zeit mit den Konstanten MEVC_* und MPAC_*       */
/*                        unbedingt uebereinstimmen.                     */
/*************************************************************************/

#define _EXPRSEQ          1
#define _OR               2
#define _AND_             3 /* _AND kollidiert mit AMIGA */
#define _SEQGEN           4
#define _LESS             5
#define _LEEQUAL          6
#define _EQUAL            7
#define _UNEQUAL          8
#define _RANGE            9
#define _MOD             10
#define _DIV             11
#define _UNION           12
#define _MINUS           13
#define _INTERSECT       14
#define _PLUS            15
#define _MULT            16
#define _POWER_          17  /* _POWER kollidiert mit math.h */
#define _CONCAT          18
#define _FCONCAT         19

#define NEGATE           20
#define INVERT           21
#define DIVEX            22
#define SUBTRACT         23

#define _ASSIGN          34
#define _IF              35
#define _CASE            36
#define _FOR             37
#define _FOR_PAR         38
#define _FOR_DOWN        39
#define _FOR_IN          40
#define _FOR_IN_PAR      41
#define _WHILE           42
#define _REPEAT          43
#define _NEXT            44
#define _BREAK           45
#define _QUIT            46
#define _PARBEGIN        47
#define _SEQBEGIN        48
#define _STMTSEQ         49
#define _SYSASSIGN       50
#define _UNASSIGN        51


/*************************************************************************/
/* Definition aller weiteren '_' - Systemfunktionen. Diese werden als    */
/* 'MMM_STRING's in die Tabelle MTRV_SYS_FUNC_LIST eingetragen. Die      */
/* Funktionsnamen stimmen i.A. mit dem Definement ueberein.              */
/*************************************************************************/


/* Andere Datentypen */

#define _PROCDEF         60
#define _FUNC_ENV        61
#define _BUILT_IN        62
#define _ARRAY           63
#define _TABLE           64

#define _NULL_           65    /* _NULL kollidiert mit PowerMac */
#define _NEWPUREFUNC     66
#define _NEWFUNCARG      67
#define _OVERLOAD        68
#define _SPLIT		 69	/* unter 'Objektmanipulation' sind alle Konstanten vergeben :-( (kg) */

/* I/O - Routinen */

#if defined(__EMX__) && defined(_PRINT)
#undef _PRINT
#endif

#define _PRINT           70
#define _INPUT           71
#define _TEXTINPUT       72
#define _WRITE           73
#define _FILEREAD        74
#define _FCLOSE		 75
#define _FINPUT		 76
#define _FILEOPEN	 77	/* _FOPEN wird bereits durch einen
                                   Std-Header definiert */
#define _FPRINT		 78
#define _FTEXTINPUT	 79


/* Objektmanipulation */

#define _TYPE_           80 /* _TYPE ex. in math.h unter VC++ 4.2 */
#define _NOPS            82
#define _OP              83
#define _SUBS            84
#define _SUBSEX          85
#define _SUBSOP          86
#define _TESTTYPE        87
#define _VAL             88
#define _FUNCATTR        89
#define _EXTNOPS         90
#define _EXTOP           91
#define _EXTSUBSOP       92
#define _MAP		 93
#define _SORT		 94
#define _CONTEXT_        95  /* _CONTEXT kollidiert mit Visual C++ 4.0 */
#define _ID		 96
#define _DOMTYPE         97
#define _ZIP		 98
#define _SELECT		 99


/* Systemzustand - Analyse */

#define _TIME_          100   /* _TIME kollidiert mit PowerMac */
#define _RTIME          101
#define _PTIME          102
#define _HISTORY        103
#define _NOHISTORY      104
#define _LAST           105
#define _MEMORY         106
#define _RESET          107
#define _ASSMEM         108
#define _BYTES          109
#define _LOAD           110
#define _ANAMES         111
#define _SYSTEM         112
#define _PROTOCOL       113
#define _SYSNAME	114
#define _TESTARGS	115
#define _INPUT_FILTER   116
#define _SET_LENGTH	117
#define _REGISTER       118
#define _GETPID         119


/* Konvertierungsfunktionen */

#define _FLOAT          120
#define _BOOL           121
#define _NEW_EXTELEMENT 122
#define _NEW_DOMAIN     123
#define _DOMATTRQ       124
#define _DOMATTR        125
#define _NEW_IDENT      126
#define _NEW_NAMESPACE  127
#define _NEW_BYTECODE   128


/* Textmanipulation */

#define _SUBSTRING      130
#define _STRLEN         131
#define _TBL2TEXT       132
#define _TEXT2TBL       133
#define _TEXT2LIST      134
#define _STRMATCH       135 
#define _TEXT2EXPR      136
#define _EXPR2TEXT      137

#ifndef NO_ENHANCED_MATCH
#  define _SEARCH       138
#  define _REPLACE      139
#endif

/* Graphik */

#define _PLOT           140
#define _POINT          141
#define _POLYGON        142


/* Pari - Funktionen */

#define _ABSS           150
#define _ACOS           151
#define _ASIN           152
#define _ASINH          153
#define _ATAN           154
#define _ATANH          155
#define _COS            156
#define _COSH           157
#define _EXP            158
#define _LN             159
#define _SIN            160
#define _SINH           161
#define _SQRT           162
#define _TAN            163
#define _TANH           164
#define _ACOSH		165
#define _ZETA		166
#define _GAMMA		167
#define _PSI		168
#define _ERFC           169
#define _CEIL           170
#define _FLOOR          171
#define _FRAC           172
#define _ISPRIME        173
#define _NEXTPRIME      174
#define _FACT           175
#define _ROUND          176
#define _TRUNC          177
#define _IGCD           178
#define _ILCM           179
#define _SIGN           180
#define _RANDOM         181
#define _IFACTOR        182
#define _ITHPRIME       183
#define _PHI            184
#define _PRIMEDIVISORS  185
#define _NUMDIVISORS    186
#define _IGCDEX         187
#define _MODP		188
#define _MODS		189
#define _MAX		190
#define _MIN		191
#define _POWERMOD	192
#define _EINT		193
#define _IGAMMA		194
#define _ISQRT		195
#define _LLLINT         196


/* Verschiedenes */

#define _ASSIGN_ELEMS   198
#define _INDEX_VAL      199
#define _ARGS_          200   /* _ARGS kollidiert mit gcc 2.2.3 */
#define _RETURN         201
#define _TRAPERROR      202
#define _ERROR          203
#define _EVAL           204
#define _APPEND         205
#define _DIFF           206
#define _EXPAND         207
#define _INDEX          208
#define _HOLD           209
#define _HELP           210
#define _LEVEL          211
#define _NOT            212
#define _CONTAINS       213
#define _GPROF		214
#define _VOLATILE       215
#define _UNVOLATILE     216
#define _INDETS		217
#define _MATCH          218
#define _GENIDENT       219
#define _PROPERTIES     220
#define _HAS		221
#define _PREF		222
#define _ENCODE         223

/* Mikroparallele Konstrukte */

#define _WRITEQUEUE     224
#define _READQUEUE      225
#define _GLOBAL         226
#define _WRITEPIPE      227
#define _READPIPE       228
#define _TOPOLOGY       229

/* Polynom-Operationen */

#define _POLY		230
#define _EXPR		231
#define _DEGREE		232
#define _DEGREEVEC	233
#define _LTERM		234
#define _LCOEFF		235
#define _TCOEFF		236
#define _COEFF		237
#define _MAPCOEFFS	238
#define _DIVIDE		239
#define _PDIVIDE	240
#define _ICONTENT	241
#define _MULTCOEFFS	242
#define _NORM		243
#define _EVALP		244
#define _ISZERO		245
#define _GENPOLY	246
#define _NTHTERM	247
#define _NTHCOEFF	248
#define _NTERMS		249
#define _LMONOMIAL	250
#define _NTHMONOMIAL	251
#define _DPOLY		252
#define _LDEGREE	253


/* Dynamische Module */

#define _LOADMODUL      260
#define _UNLOADMODUL    261
#define _EXTERNAL       262

/* Verschiedenes II */

#define _SYSORDER	265
#define _BLOCK		266
#define _NOCOMPROD	267
#define _PROTECTED	268

#ifndef NO_PARSER_EXTENSION
#define _BIN_OP         269
#endif

/* Operator-Funktionen */

#define _OP_PLUSMULT    270
#define _OP_POWER       271
#define _OP_FCONCAT     272
#define _OP_FCONCATPOWER 273

#define _FLOAT_GEN      274
#define _DOMAINFUNCCALL 275

/* Debugger-Funktionen */

#define _TRACE		280
#define _DEBUG_         281	/* _DEBUG kollidiert mit Visual C++ 4.0 */
#define _GCOV           282
#define _ADD_DEBUG_INFO 283
#define _PREDECESSOR	284

/* Makroparallele Konstrukte */

#define _INIT_SEM       290
#define _SEMP           291
#define _SEMV           292

#define _LOCK           293
#define _UNLOCK         294

#ifndef NO_ACMATCH
#   define _ACM_BUILD		295
#   define _ACM_SOLUTION	296
#   define _ACM_RELEASE 	297
#   define _AC_MATCH    	298
#endif


/*** Achtung die Laenge dieser Liste ist durch 'MTRC_SYS_FUNC_LIST_SIZE' ***/
/*** in der Datei 'MTR_tree.h' beschraenkt.                              ***/


/********************* Konstanten ****************************************/

#define SET_HASH_SIZE      47L
#define TABLE_HASH_SIZE    47L
#define ARRAY_HASH_SIZE    47L
#define IDENT_HASH_SIZE    47L

#define HASHNUM            47L   /* Konstante zum Hashen                 */
#define NUM_OF_STACKS       4L   /* Anzahl der Stacks fuer jede Variable */

#define MUPC_MaxStorTypes  120   /* Maximale Anzahl der verschiedenen    */
                                 /* Speichertypen (MMM)                  */



/*********** Rechnerabhaengige Konstanten *******************************/

#define MAX_INT        2147483647
#define MIN_INT        2147483648

/************************************************************************/

#ifndef TRUE
#define TRUE		1
#endif

#ifndef FALSE
#define FALSE		0
#endif

/************************************************************************/

/* Modi fuer fopen() */

#ifdef MACINTOSH

#  define MUPC_READ_BIN		"rb"
#  define MUPC_READ_TEXT	"r"
#  define MUPC_WRITE_BIN	"wb"
#  define MUPC_WRITE_TEXT	"w"
#  define MUPC_APPEND_BIN	"ab"
#  define MUPC_APPEND_TEXT	"a"
#  define MUPC_READ_WRITE_BIN	"rb+"
#  define MUPC_READ_WRITE_TEXT	"r+"

#else
#ifdef MSDOS

#  define MUPC_READ_BIN		"rb"
#  define MUPC_READ_TEXT	"rt"
#  define MUPC_WRITE_BIN	"wb"
#  define MUPC_WRITE_TEXT	"wt"
#  define MUPC_APPEND_BIN	"ab"
#  define MUPC_APPEND_TEXT	"at"
#  define MUPC_READ_WRITE_BIN	"rb+"
#  define MUPC_READ_WRITE_TEXT	"rt+"

#else

#  define MUPC_READ_BIN		"r"
#  define MUPC_READ_TEXT	"r"
#  define MUPC_WRITE_BIN	"w"
#  define MUPC_WRITE_TEXT	"w"
#  define MUPC_APPEND_BIN	"a"
#  define MUPC_APPEND_TEXT	"a"
#  define MUPC_READ_WRITE_BIN	"r+"
#  define MUPC_READ_WRITE_TEXT	"r+"

#endif /* MSDOS */
#endif /* MACINTOSH */

/**************************  GLOBALE MACROS *****************************/

#ifdef MACINTOSH

#define MUP_exit(c) { MAC_CloseFrontend(); ExitToShell(); }
#define MUP_fflush(fp)
#define MUP_message(x)	{ MAC_message(x); }
#define MUP_fatal(x)	{ MAC_fatal(x); }

/* ACHTUNG: Auf dem Mac sind bei objektorientierter Programmierung die
 * Identifier "new" und "delete" Keywords. Daher die folgenden beiden
 * unsch"onen Makros. (kg) */

#else

#ifdef MSDOS

#define MUP_exit(n) { MSW_exit(n); }
#define MUP_fflush(fp) { if ( fp == stdout ) MIO_write('\0'); \
			 else fflush(fp); }
#define MUP_message(s) { MSW_message(s); }
#define MUP_fatal(s) { MSW_fatal(s); }

#else

#define MUP_exit(c) { exit(c); }
#define MUP_fflush(fp)  { if ( XMUPAD && fp == stdout ) MIO_write('\0'); \
			  fflush(fp); }
#define MUP_message(t) { fprintf(stderr, "\n%s\n", (t)); }
#define MUP_fatal(t) { fprintf(stderr, "\n%s\n", (t)); exit(1); }

#endif
#endif


/*********** Default - Werte veraenderbarer MuPAD - Systemvariablen *****/

#define MHIC_TOP_HISTORY_DEFAULT	 20L
#define MHIC_PROC_HISTORY_DEFAULT	  3L
#define MEVC_LEVEL_DEFAULT        	100L
#define MEVC_MAXLEVEL_DEFAULT     	100L
#define MEVC_MAXDEPTH_DEFAULT           500L
#define MEVC_TEXTWIDTH_DEFAULT		 75L
#define MEVC_PRINTLEVEL_DEFAULT     	  0L

#define MEVC_DQ_DEFAULT			"\""   /* Darf nicht ver"andert werden */

/* Assozialtive Speicher des Evaluators aussschalten, indem ihre
 * Groesse auf 0 gesetzt wird. (kg, 20/08/97) */

#define MEVC_DEFAULT_ASS_MEM_IDENT_TYP		MAMC_contents
#define MEVC_DEFAULT_ASS_MEM_IDENT_SIZE		0L /* 47L */

#define MEVC_DEFAULT_ASS_MEM_SIMP_TYP		MAMC_contents
#define MEVC_DEFAULT_ASS_MEM_SIMP_SIZE		0L /* 1009L */

#define MEVC_DEFAULT_ASS_MEM_EXPR_TYP		MAMC_contents
#define MEVC_DEFAULT_ASS_MEM_EXPR_SIZE		0L /* 47L */

/******************** Konstanten fuer ERRORLEVEL ************************/

#define MEVC_ERRORLEVEL_DEFAULT     	  0L

#define MEVC_NO_ERROR_DETECTION           0L

#define MEVC_FULL_ERROR_DETECTION         3L




/****************** Konstanten des Evaluierers **************************/

#define MEVC_LEVEL_INF		2147483647L	/* 2^31 - 1 */
#define MEVC_NO_SUBS		2147483648L	/* 2^31     */

/*********************** Konstante der HISTORY **************************/

#define MHIC_FACTOR                10L

#ifdef MSDOS

/* Dummy-Vereinbarungen */

#define kill(a,b)               0
#define getpid()                0
#define getppid()               0

#endif

/*****Groesse des MIOV_BUFFERS *******/
#define MIOV_BUFFER_LEN  512


/*****Konstanten f"ur den Aufbau von MMMVshared, MMMVlocal_shared*****/

#define MUPC_shared_count       8L      /*Anzahl Eintr"age auf oberster Ebene*/
#define MUPC_netnodes           0L      /*Daten, die sich zwischen Netzknoten unterscheiden*/
#define MUPC_pipes              1L      /*Die Pipes und Queues dieses Systems*/
#define MUPC_init_ready         2L      /*Anzeige, wann der F"uhrer mit der Initialisierung fertig ist*/
#define MUPC_constants          3L      /*Vom System ben"otigte Konstanten, die "uberall durch den gleichen S-Zeiger repr"asentiert werden sollen (m"ussen)*/
#define MUPC_variables          4L      /*Variablen, die sich mehrere Prozesse teilen m"ussen*/
#define MUPC_workpipes          5L      /*Die workpipes der Cluster*/
#define MUPC_namespaces         6L      /*Liste der Namespaces von MuPAD*/
#define MUPC_semaphores         7L      /*Array mit Listen von Semaphoren f"ur einzelne Cluster */


#define MUPC_constants_count            7L /* Anzahl der Konstanten */
#define MUPC_constants_sys_func_list    0L
#define MUPC_constants_CAT_NULL         1L
#define MUPC_constants_CAT_NIL          2L
#define MUPC_constants_CAT_BOOL_FALSE   3L /* FALSE < UNKNOWN < TRUE ! */
#define MUPC_constants_CAT_BOOL_UNKNOWN 4L
#define MUPC_constants_CAT_BOOL_TRUE    5L
#define MUPC_constants_CAT_FAILED       6L


#define MUPC_variables_count            4L /* Anzahl der Variablen */
#define MUPC_variables_string_ass_mem   0L
#define MUPC_variables_domain_array     1L
#define MUPC_variables_genident_ass_mem 2L
#define MUPC_variables_miolock          3L


#define MUPC_netnodes_shared_count 2L /*Anzahl der Daten, die sich zwischen den Clustern unterscheiden*/
#define MUPC_netnodes_shared_problemheap 0L
#define MUPC_netnodes_shared_runheap     1L /* chh_break: Runheap "laufender Tasks" */


#define MUPC_pipes_count        3L

#define MUPC_lshared_count      1L
#define MUPC_lshared_codetab    0L

#ifdef MSDOS
#	define MUPC_PATH_SEPARATOR '\\'	    /* Trennung von Directory-Namen */
#	define MUPC_CMD_MARK '/'	    /* Markierung von Kommandozeilen-Optionen */
#	define MUPC_MAX_PATH _MAX_PATH	    /* max. Pfadlaenge von Filenamen */
#else
#	define MUPC_PATH_SEPARATOR '/'
#	define MUPC_CMD_MARK '-'
#	define MUPC_MAX_PATH 512
#endif

#endif /* __MUP_constants__ */
