/* $Date: 1997/10/10 15:54:55 $  $Author: tonner $  $Revision: 1.50 $ */

/**************************************************************************/
/* FILE:             MUP_extern.h                                         */
/* Autor:            Andreas Kemper, Oliver Kluge, Karsten Morisse        */
/* Erstellt:         12/03/91                                             */
/* Letzte Aenderung: 18/02/97                                             */
/**************************************************************************/

#ifndef __MUP_extern__
#define __MUP_extern__


/**************************************************************************/
/* Dieses File enthaelt alle globalen Variablen des Programmes            */
/**************************************************************************/

#include <stdio.h>

class MCLT_iostream;

SHARED_DECL( MUPbool, MUP_READ_USERINIT );
SHARED_DECL( MUPbool, MUP_BUILD_STARTUP_FILE);

extern S_Pointer *MTRV_SYS_FUNC_LIST;       /* Globale Tabelle mit allen  */
				            /* Systemstrings (_....)      */

extern MUPbool *MGSV_flat_table;   /* Globale Tabelle, zeigt welche Kate- */
                                   /* gorien geflattetet werden d"urfen.  */

extern MUPbool MGSV_redo;

VALUE_DECL( short, MUPV_RMAJOR ); // Major Release Number
VALUE_DECL( short, MUPV_RMINOR ); // Minor Release Number
VALUE_DECL( short, MUPV_RPATCH ); // Patch Level

VALUE_DECL( S_Pointer, MIOV_S_PLUS    );
VALUE_DECL( S_Pointer, MIOV_S_MULT    );
VALUE_DECL( S_Pointer, MIOV_S_POWER   );
VALUE_DECL( S_Pointer, MIOV_S_EXPRSEQ );
VALUE_DECL( S_Pointer, MIOV_S_STMTSEQ );


/* Sprungtabelle zur Berechnung der Signaturen */

extern void (*MSGV_JumpTab[MUPC_MaxStorTypes])(S_Pointer);

                                     

VALUE_DECL( S_Pointer, MCAC_ci );       /* Die Komplexe Zahl I = sqrt(-1) */
                                        /* vom Typ CAT_COMPLEX            */

VALUE_DECL( S_Pointer, MCAC_one  );     /* Die Zahl  1  vom Typ CAT_INT   */
VALUE_DECL( S_Pointer, MCAC_one_ );     /* Die Zahl -1  vom Typ CAT_INT   */
VALUE_DECL( S_Pointer, MCAC_two  );     /* Die Zahl  2  vom Typ CAT_INT   */
VALUE_DECL( S_Pointer, MCAC_two_ );     /* Die Zahl -2  vom Typ CAT_INT   */
VALUE_DECL( S_Pointer, MCAC_zero );     /* Die Zahl  0  vom Typ CAT_INT   */
VALUE_DECL( S_Pointer, MCAC_half );     /* Die Zahl 1/2 vom Typ CAT_RAT   */

#if (! defined NO_TRANS_E_TO_EXP && ! defined ALIAS_CONV_E_TO_EXP )
VALUE_DECL( S_Pointer, MSTC_exp1);	/* Der Ausdruck exp(1)            */
#endif

extern long MCAV_DEC_DIGITS;   /* Anzahl der signifikanten Dezimalstellen */

VALUE_DECL( long, MCAV_STORAGE) ; /* Speichertyp fuer alle Routinen des   */
                                  /* Moduls MCA_calc.c                    */

GLOBAL_DECL( long, MCAV_avglob) ;               /* Beginn des PARI-Stacks */

extern S_Pointer MSTV_STACK;                  /* Aktueller Stack der Task */


/* Variable zur Angabe des aktuellen Arbeitsstatus des Parsers */

#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA( short, MUPV_INTERACTIV)
#endif
GLOBAL_DECL( short, MUPV_INTERACTIV);  

/* Variable zur Bestimmung der prozeduralen Schachtelungstiefe. Hier */
/* werden auch parallele Konstrukte, die Tasks erzeugen mitgez"ahlt. */ 
/* Verwendung im Stack.                                              */

#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA(long,  MUPV_PROC_DEPTH )
#endif
GLOBAL_DECL( long,  MUPV_PROC_DEPTH );   

/* Variable zur Speicherung der realen Substitutionstiefe. Parallele */
/* Konstrukte werden nicht ber"ucksichtigt.                          */

#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA(long, MUPV_REAL_PROC_DEPTH )
#endif
GLOBAL_DECL( long, MUPV_REAL_PROC_DEPTH );  

/* Variable zur Bestimmung der Prozedurtiefe f"ur den Profiler */

#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA(long, MUPV_PROF_PROC_DEPTH )
#endif
GLOBAL_DECL( long, MUPV_PROF_PROC_DEPTH );

/* Variable zur Bestimmung der prozeduralen Schachtelungstiefe am */
/* Anfang der Abarbeitung dieser Task.                            */

#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA(long, MUPV_IN_PROC_DEPTH )
#endif
GLOBAL_DECL( long, MUPV_IN_PROC_DEPTH ) ; 

/* Mit Hilfe dieser Variablen bekommt jede abgearbeitete Task eine */
/* eigene MUPV_PARALLEL_NUMBER-Zahl so dass die Tasks zu unter-    */
/* scheiden sind.                                                  */

#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA(long, MUPV_NEXT_PARALLEL_NUMBER )
#endif
GLOBAL_DECL( long, MUPV_NEXT_PARALLEL_NUMBER ) ; 

#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA(long, MUPV_PARALLEL_NUMBER )
#endif
GLOBAL_DECL( long, MUPV_PARALLEL_NUMBER ) ;

/* Parallele Umgebung der gerade ausgef"uhrten Task. Darin sind */
/* die Vorfahren mit einigen wichtigen Daten gespeichert.  Wird */
/* f"ur Stack ben"otigt.                                        */

#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA(long, MUPV_PARALLEL_ENV )
#endif
GLOBAL_DECL( S_Pointer, MUPV_PARALLEL_ENV );

//chh_break: Parallele Version: Aktuelle Task des Run-Heaps, die gerade bearbeitet wird
GLOBAL_DECL(S_Pointer, MUPV_actual_task_element);
//chh_break: Parallele Version: Kann die aktuell bearbeitete Task mit break abgebrochen werden?
GLOBAL_DECL(unsigned long, MUPV_break_impossible);

/* MUPV_no_history = _false_, falls innerhalb von MSY_eval_read  */
/* Ergebnisse in die History-Tabelle eingetragen werden sollen.  */                               /* _true_ , keine Eintr"age.                                     */

#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA( MUPbool, MUPV_no_history )
#endif
GLOBAL_DECL( MUPbool, MUPV_no_history ); 

/* Letzter in den History-Mechanismus als Wert eines 'nohistory'- */
/* Aufrufes eingetragener Wert.                                   */
				
#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA( S_Pointer, MUPV_LAST_HISTORY )
#endif
GLOBAL_DECL( S_Pointer, MUPV_LAST_HISTORY ); 


/*** Gloabale Verweise auf MuPAD-Konstanten ***********************************/

/*** Diese sind nun im Modul 'MTR_tree.c' defininiert, damit  ***/
/*** sie auch in VCAM (MSV_save.c) zur Verfuegung stehen.     ***/

VALUE_DECL( S_Pointer, MUPV_CAT_NULL         );
VALUE_DECL( S_Pointer, MUPV_CAT_NIL          );      
VALUE_DECL( S_Pointer, MUPV_CAT_BOOL_TRUE    );
VALUE_DECL( S_Pointer, MUPV_CAT_BOOL_UNKNOWN );
VALUE_DECL( S_Pointer, MUPV_CAT_BOOL_FALSE   );
VALUE_DECL( S_Pointer, MUPV_CAT_FAILED       );
SHARED_DECL(  MUPbool, MUPV_STARTUP          );
SHARED_DECL(  MUPbool, MUPV_INITIALIZING     );

GLOBAL_DECL( S_Pointer, MSYV_ASS_MEM_GENIDENT);

extern MCLT_iostream MIOV_OUTPUT;     /* Ausgabefile                            */

extern long    MIOV_PRETTY_PRINT;    /* Steuerung des Pretty - Printers */
extern long    MIOV_STRING_UNQUOTED; /* Steuerung der Stringausgabe */

extern MCLT_iostream MFOV_PROT_FILE; /* File-Pointer auf Protokoll-File */
	             /* Ist NULL, wenn kein Protokoll geschrieben wird. */

extern MUPbool MFOV_PROT_ALL; /* _true_ : Protokolliere Ein-/Ausgaben,Fehler */
                              /* _false_: Protokolliere nur Eingaben         */

extern long session_begin;	 /* Zeitpunkt des Beginns einer Sitzung */
extern unsigned long MEVV_sessionbegin_sec ;
extern unsigned long MEVV_sessionbegin_msec ;


/* Globale Strings 'MSTR' */

VALUE_DECL( S_Pointer, MSTR_remember ); 
VALUE_DECL( S_Pointer, MSTR_noDebug ); 
VALUE_DECL( S_Pointer, MSTR_LEVEL );
VALUE_DECL( S_Pointer, MSTR_PRINTLEVEL );
VALUE_DECL( S_Pointer, MSTR_PRETTY_PRINT );
VALUE_DECL( S_Pointer, MSTR_hold );
VALUE_DECL( S_Pointer, MSTR_procname );
VALUE_DECL( S_Pointer, MSTR_args );

VALUE_DECL( S_Pointer, MSTR_Bin );
VALUE_DECL( S_Pointer, MSTR_Write );
VALUE_DECL( S_Pointer, MSTR_Append );
VALUE_DECL( S_Pointer, MSTR_Unquoted );
VALUE_DECL( S_Pointer, MSTR_NoNL );

VALUE_DECL( S_Pointer, MSTR_IntMod );
VALUE_DECL( S_Pointer, MSTR_Expr );
VALUE_DECL( S_Pointer, MSTR_DegreeOrder );
VALUE_DECL( S_Pointer, MSTR_Rem );
VALUE_DECL( S_Pointer, MSTR_Quo );
VALUE_DECL( S_Pointer, MSTR_Exact );

VALUE_DECL( S_Pointer, MSTR_PI ); 
VALUE_DECL( S_Pointer, MSTR_E ); 
VALUE_DECL( S_Pointer, MSTR_EULER ); 
VALUE_DECL( S_Pointer, MSTR_EXP ); 

VALUE_DECL( S_Pointer, MSTR_simplify );
VALUE_DECL( S_Pointer, MSTR_eval );
VALUE_DECL( S_Pointer, MSTR_off );
VALUE_DECL( S_Pointer, MSTR_address );
VALUE_DECL( S_Pointer, MSTR_content );

VALUE_DECL( S_Pointer, MSTR_cyclic );

VALUE_DECL( S_Pointer, MSTR_Unsimplified );
VALUE_DECL( S_Pointer, MSTR_Simplified );
VALUE_DECL( S_Pointer, MSTR_type );

VALUE_DECL( S_Pointer, MSTR_Non ) ;
VALUE_DECL( S_Pointer, MSTR_Warning ) ;
VALUE_DECL( S_Pointer, MSTR_Error ) ;
VALUE_DECL( S_Pointer, MSTR_User ) ;
VALUE_DECL( S_Pointer, MSTR_protecterror ) ;

VALUE_DECL( S_Pointer, MHIC_name ) ;

VALUE_DECL( S_Pointer, MEVV_procname_IDENT ) ;
VALUE_DECL( S_Pointer, MEVV_LEVEL_IDENT ) ;
VALUE_DECL( S_Pointer, MEVV_HISTORY_IDENT ) ;

#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA( long,  MEVV_EVAL_STMT )
#endif
GLOBAL_DECL( long,  MEVV_EVAL_STMT );
#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA( short, MEVV_SUBSTITUTE )
#endif
GLOBAL_DECL( short, MEVV_SUBSTITUTE );

#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA( S_Pointer, MEVV_MAM_STACK )
#endif
GLOBAL_DECL( S_Pointer, MEVV_MAM_STACK );
#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA( long,      MEVV_MAM_CONTROL )
#endif
GLOBAL_DECL( long,      MEVV_MAM_CONTROL ); 
#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA( S_Pointer, MEVV_DEPTH_STACK )
#endif
GLOBAL_DECL( S_Pointer, MEVV_DEPTH_STACK ); 
#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA( long, MEVV_ACT_DEPTH )
#endif
GLOBAL_DECL( long, MEVV_ACT_DEPTH );
#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA( S_Pointer, MEVV_PROCNAME )
#endif
GLOBAL_DECL( S_Pointer, MEVV_PROCNAME );


#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA( S_Pointer, MHIV_TAB )
#endif
GLOBAL_DECL( S_Pointer, MHIV_TAB ) ;
#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA( long, MHIV_TAB_SIZE )
#endif
GLOBAL_DECL( long, MHIV_TAB_SIZE );	/* Aktuelle History - Tabellengroesse */
#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA( long, MHIV_ACT_POS )
#endif
GLOBAL_DECL( long, MHIV_ACT_POS );	/* Aktuelle Einfuegestelle            */
#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA( long, MHIV_HISTORY )
#endif
GLOBAL_DECL( long, MHIV_HISTORY );
#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA( long, MHIV_TOP_HISTORY )
#endif
GLOBAL_DECL( long, MHIV_TOP_HISTORY );
#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA( long, MHIV_PROC_HISTORY )
#endif
GLOBAL_DECL( long, MHIV_PROC_HISTORY );
#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA( long, MHIV_WRAP_AROUND )
#endif
GLOBAL_DECL( long, MHIV_WRAP_AROUND );
#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA( long, MHIV_TOP )
#endif
GLOBAL_DECL( long, MHIV_TOP );

#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA( long, MHIV_TOP_OLD )
#endif
GLOBAL_DECL( long, MHIV_TOP_OLD ) ;
#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA( long, MHIV_ACT_POS_OLD )
#endif
GLOBAL_DECL( long, MHIV_ACT_POS_OLD ) ;
#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA( long, MHIV_HISTORY_OLD )
#endif
GLOBAL_DECL( long, MHIV_HISTORY_OLD ) ;


/* MSYV_LEVEL_FUNC steuert den Wertebereich der Variablen 'LEVEL' */

#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA( MUPbool,   MSYV_LEVEL_FUNC )
#endif
GLOBAL_DECL( MUPbool,   MSYV_LEVEL_FUNC );   

#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA( long, MEVV_LEVEL )
#endif
GLOBAL_DECL( long,           MEVV_LEVEL );
#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA( long, MEVV_MAXLEVEL )
#endif
GLOBAL_DECL( long,           MEVV_MAXLEVEL );
#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA( long, MEVV_MAXDEPTH )
#endif   
GLOBAL_DECL( long,           MEVV_MAXDEPTH );
#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA( long, MEVV_TEXTWIDTH )
#endif
GLOBAL_DECL( long,           MEVV_TEXTWIDTH );
#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA( long, MEVV_PRINTLEVEL )
#endif
GLOBAL_DECL( long,           MEVV_PRINTLEVEL );
#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA( long, MEVV_ACT_PRINTLEVEL )
#endif
GLOBAL_DECL( long,           MEVV_ACT_PRINTLEVEL );

#ifdef ERRORLEVEL
#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA( long, MEVV_ERRORLEVEL )
#endif
GLOBAL_DECL( long,           MEVV_ERRORLEVEL );
#endif



#ifndef NO_LAZY_EVAL

#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA( MUPbool, MEVV_BOOL_CONTEXT )
#endif   
GLOBAL_DECL( MUPbool,           MEVV_BOOL_CONTEXT );

#endif

#ifndef NO_PARSER_EXTENSION

/* Liste, die benutzerdefinierte dyadische Operatoren verwaltet. */
/* Der (2*i)-te Eintrag ist vom Typ MMM_STRING, der (2*i+1)-te   */
/* Eintrag ist vom Type CAT_IDENT.                               */

#ifdef USE_PRAGMA
#pragma GLOBAL_PRAGMA( S_Pointer, MPAV_user_bin_op_list )
#endif
GLOBAL_DECL( S_Pointer, MPAV_user_bin_op_list );

#endif /* NO_PARSER_EXTENSION */


extern char* (*get_from_stdin)(char *, int, MCLT_iostream& );

extern char *MUT_PROG_NAME;
extern char *MUT_SYS_INIT_PATH;
extern char *MUT_USER_INIT_PATH;
extern char *MUT_LIB_INIT_PATH;
extern char *MUT_HELP_INDEX_PATH;
extern char *MUT_HELP_PATH;
extern char *MUT_MODUL_PATH;
extern char *MUT_USER_STRING;
extern char *MUT_BATCH_OUTPUT;

extern S_Pointer MUT_LIB_PATH;
extern S_Pointer MUT_READ_PATH;
extern S_Pointer MUT_WRITE_PATH;

extern S_Pointer MPAV_INPUT_FILTER;



/*
 * XMuPAD dependent stuff
 */
#ifndef MACINTOSH

#ifdef OLDCOMMUNICATION
extern int XMUPAD;
extern int PPID;
extern char confile[];
extern void MUP_send_signal();
#endif

#ifdef NEWCOMMUNICATION
extern int XMUPAD;
#endif

#endif

char *MUP_out_of_memory(MUPbool) ;

#ifndef MACINTOSH
void MUP_catch_alarm  ( VOID );
#endif
extern long MUPV_WATCHDOG_PURPOSE ;
#define MUPC_WATCHDOG_TERMINATE 0
#define MUPC_WATCHDOG_CATCH     1

void MUP_maininit     ( int argc, char *argv[] ) ;
int  MUP_mainexit     ( VOID ) ;
void MUP_mainexecute  ( VOID ) ;


#if !defined MSDOS || defined WIN95
long MUP_mainexecute1 ( char *stmt, MCLT_iostream &out ) ;
#endif

#endif /* __MUP_extern__ */

