/* $Date: 1997/10/10 15:54:56 $ $Author: tonner $ $Revision: 1.54 $ */

/***************************************************************************
** FILE:                   MUP_funcs.h                                    **
** In diesem File werden die Funktionsnummern f"ur die inneren            **
** C-Funktionen definiert.                                                **
** Autor:                  Holger Naundorf                                **
** Erstellt:               17/01/94                                       **
** Letzte Aenderung:       03/03/97                                       **
**                                                                        **
** Ab Revision 1.34 (31.10.96) gibt es das Preprocessor-Flag NO_SPEC_BITS **
** Hiermit werden die Abfragen auf die Special-Bits MINUS_BIT, DIV_BIT    ** 
** und nicht mehr durchgef"uhrt, da davon ausgegangen wird, das keine     ** 
** Funktion, insbesondere der Parser und der Simplifier, mehr solche Bits ** 
** generieren.  (Oliver Kluge)                                            **
** Ab Revision 1.40 (3.3.97) gibt es nur noch die Version ohne Special-   ** 
** Bits. Das Flag NO_SPEC_BITS wurde entfernt.                            **
***************************************************************************/

#ifndef __MUP_funcs__
#define __MUP_funcs__


#define MEVNeval_interpreter           100
#define MEVNeval_float_gen             101
#define MEVNeval_index                 102
#define MEVNeval_procdef               103
#define MEVNeval_gprof                 104
#define MEVNeval_not                   105
#define MEVNeval_sys_func_args         106
#define MEVNeval_op_plusmult           107
#define MEVNeval_op_power              108
#define MEVNeval_op_fconcat            109
#define MEVNeval_index_val             110
#define MEVNeval_domainfunccall        111
#define MEVNeval_purefunc              112
#define MEVNeval_newpurefunc           113
#define MEVNeval_newfuncarg            114
#define MEVNeval_purefunc_hold         115
#define MEVNeval_overloaded            116
#define MEVNeval_overload              117

#define MFONeval_fclose                300
#define MFONeval_finput                301
#define MFONeval_fopen                 302
#define MFONeval_fprint                303
#define MFONeval_ftextinput            304
#define MFONeval_protocol              305
#define MFONeval_fread                 306
#define MFONeval_write                 307

#define MPLNeval_global                400
#define MPLNeval_readpipe              401
#define MPLNeval_readqueue             402
#define MPLNeval_topology              403
#define MPLNeval_writepipe             404
#define MPLNeval_writequeue            405
#define MPLNeval_init_sem              406
#define MPLNeval_semP                  407
#define MPLNeval_semV                  408
#define MPLNeval_lock                  409
#define MPLNeval_unlock                410

#define MPONeval_coeff                 500
#define MPONeval_icontent              501
#define MPONeval_degree                502
#define MPONeval_degreevec             503
#define MPONeval_divide                504
#define MPONeval_evalp                 505
#define MPONeval_expr                  506
#define MPONeval_genpoly               507
#define MPONeval_iszero                508
#define MPONeval_lcoeff                509
#define MPONeval_lterm                 510
#define MPONeval_mapcoeffs             511
#define MPONeval_multcoeffs            512
#define MPONeval_norm                  513
#define MPONeval_nterms                514
#define MPONeval_nthcoeff              515
#define MPONeval_nthterm               516
#define MPONeval_pdivide               517
#define MPONeval_poly                  518
#define MPONeval_tcoeff                519
#define MPONeval_lmonomial             520
#define MPONeval_nthmonomial           521
#define MPONeval_Dpoly                 522
#define MPONeval_ldegree               523

#define MSUNeval_domtype               600
#define MSUNeval_extnops               601
#define MSUNeval_extop                 602
#define MSUNeval_extsubsop             603
#define MSUNeval_nops                  604
#define MSUNeval_op                    605
#define MSUNeval_subs                  606
#define MSUNeval_subsex                607
#define MSUNeval_subsop                608
#define MSUNeval_testtype              609
#define MSUNeval_type                  610

#define MSRNeval_strlen                700
#define MSRNeval_strmatch              701
#define MSRNeval_substring             702
#define MSRNeval_tbl2text              703
#define MSRNeval_text2list             704
#define MSRNeval_text2tbl              705

#ifndef NO_ENHANCED_MATCH
#  define MSRNeval_search              706
#  define MSRNeval_replace             707
#endif

#define MARNeval_array                2000
#define MARNeval_assign_elems         2001
#define MGRNeval_plot                 2020
#define MGRNeval_point                2021
#define MGRNeval_polygon              2022
#define MTANeval_table_call           2040
#define MXPNeval_expand               2060
#define MDBNeval_debug                2080
#define MDBNeval_trace                2081
#define MDBNeval_gcov                 2082
#define MDBNeval_predecessor          2084
#define MDFNeval_diff                 2090
#define MGSNeval_set_length	      2100

#define MSTNchange_digits             200
#define MSTNchange_e                  201
#define MSTNread_e                    202
#define MSTNchange_pi                 203
#define MSTNread_pi                   204
#define MSTNchange_euler              205
#define MSTNread_euler                206
#define MSTNchange_history            207
#define MSTNchange_level              208
#define MSTNchange_maxlevel           209
#define MSTNchange_errorlevel         210
#define MSTNchange_printlevel         211
#define MSTNchange_textwidth          212
#define MSTNchange_read_path          213
#define MSTNchange_write_path         214
#define MSTNchange_lib_path           215
#define MSTNchange_eval_stmt          216
#define MSTNchange_pretty_print       217
#define MSTNeval_properties           218
#define MSTNchange_maxdepth           219
#define MSTNchange_procname	      220
#define MSTNread_procname             221
#define MSTNchange_rounding           222

#define MEENeval_mod                  800
#define MEENeval_modp                 801
#define MEENeval_mods                 802
#define MEENeval_domattr              803
#define MEENeval_seqgen               804
#define MEENeval_and                  805
#define MEENeval_concat               806
#define MEENeval_fconcat              807
#define MEENeval_equal                808
#define MEENeval_exprseq              809
#define MEENeval_intersect            810
#define MEENeval_leequal              811
#define MEENeval_less                 812
#define MEENeval_minus                813
#define MEENeval_div                  814
#define MEENeval_mult                 815
#define MEENeval_or                   816
#define MEENeval_plus                 817
#define MEENeval_power                818
#define MEENeval_range                819
#define MEENeval_unequal              820
#define MEENeval_union                821
#define MEENeval_built_in             822
#define MEENeval_func_env             823
#define MEENeval_new_domain           824
#define MEENeval_new_extelement       825
#define MEENeval_funcattr             826
#define MEENeval_context              827

#define MEENeval_negate               828
#define MEENeval_invert               829
#define MEENeval_divex                830
#define MEENeval_subtract             831
  
#define MESNeval_assign               900
#define MESNeval_break                901
#define MESNeval_case                 902
#define MESNeval_for                  903
#define MESNeval_for_down             904
#define MESNeval_for_in               905
#define MESNeval_for_in_par           906
#define MESNeval_for_par              907
#define MESNeval_if                   908
#define MESNeval_next                 909
#define MESNeval_parbegin             910
#define MESNeval_quit                 911
#define MESNeval_repeat               912
#define MESNeval_stmtseq              913
#define MESNeval_while                914
#define MESNeval_return               915
#define MESNeval_sysassign            916
#define MESNeval_unassign             917

#define MSYNeval_arith_func          1000
#define MSYNeval_trans_func          1001
#define MSYNfact                     1002
#define MSYNround                    1003
#define MSYNtrunc                    1004
#define MSYNeval_map                 1005
#define MSYNeval_sort                1006
#define MSYNeval_anames              1007
#define MSYNeval_append              1008
#define MSYNeval_ass_mem             1009
#define MSYNeval_bool                1010
#define MSYNeval_bytes               1011
#define MSYNeval_contains            1012
#define MSYNeval_error               1013
#define MSYNeval_eval                1014
#define MSYNeval_float               1015
#define MSYNeval_help                1016
#define MSYNeval_history             1017
#define MSYNeval_hold                1018
#define MSYNeval_ifactor             1019
#define MSYNeval_indets              1020
#define MSYNeval_input               1021
#define MSYNeval_ithprime            1022
#define MSYNeval_last                1023
#define MSYNeval_level               1024
#define MSYNeval_load                1025
#define MSYNeval_memory              1026
#define MSYNeval_nohistory           1027
#define MSYNeval_null                1028
#define MSYNeval_phi                 1029
#define MSYNeval_print               1030
#define MSYNeval_ptime               1031
#define MSYNeval_reset               1032
#define MSYNeval_rtime               1033
#define MSYNeval_sysname             1034
#define MSYNeval_testargs            1035
#define MSYNeval_text2expr           1036
#define MSYNeval_textinput           1037
#define MSYNeval_time                1038
#define MSYNeval_traperror           1039
#define MSYNeval_val                 1040
#define MSYNigcd                     1041
#define MSYNigcdex                   1042
#define MSYNilcm                     1043
#define MSYNsign                     1044
#define MSYNeval_max                 1045
#define MSYNeval_min                 1046
#define MSYNeval_powermod            1047
#define MSYNeval_expr2text           1048
#define MSYNeval_input_filter        1049
#define MSYNeval_id                  1050
#define MSYNeval_igamma              1051
#define MSYNeval_isqrt               1052
#define MSYNeval_system              1053
#define MSYNeval_register            1054
#define MSYNeval_genident            1056
#define MSYNeval_zip                 1057
#define MSYNeval_select              1058
#define MSYNeval_getpid              1059
#define MSYNeval_has		     1060
#define MSYNeval_pref		     1061
#define MSYNeval_sysorder	     1062
#define MSYNeval_block		     1063
#define MSYNeval__no_com_prod__	     1064
#define MSYNeval_protected           1065

#ifndef NO_PARSER_EXTENSION
#define MSYNeval_bin_op              1066
#endif

#define MSYNeval_split               1067
#define MSYNeval_lllint              1068

#define MIONout_stand_op             1100
#define MIONout_stand_sys_func       1101
#define MIONout_assign               1102
#define MIONout_break                1103
#define MIONout_case                 1104
#define MIONout_domattr              1105
#define MIONout_for                  1106
#define MIONout_for_down             1107
#define MIONout_for_in               1108
#define MIONout_for_in_par           1109
#define MIONout_for_par              1110
#define MIONout_if                   1111
#define MIONout_index                1112
#define MIONout_next                 1113
#define MIONout_parbegin             1114
#define MIONout_quit                 1115
#define MIONout_repeat               1116
#define MIONout_seqbegin             1117
#define MIONout_seqgen               1118
#define MIONout_while                1119
#define MIONout_not                  1120
#define MIONout_invert               1121
#define MIONout_negate               1122
#define MIONout_subtract             1123
#define MIONout_divex                1124

#define MIONout_cat_debug	     1130
#define MIONout_cat_ident	     1131
#define MIONout_cat_string	     1132
#define MIONout_cat_bool	     1133
#define MIONout_cat_null	     1134
#define MIONout_cat_nil	  	     1135
#define MIONout_cat_failed	     1136
#define MIONout_cat_set	             1137
#define MIONout_cat_stat_list	     1138
#define MIONout_cat_table	     1139
#define MIONout_cat_exec 	     1140
#define MIONout_cat_func_env	     1141
#define MIONout_cat_point	     1142
#define MIONout_cat_polygon	     1143
#define MIONprint_number	     1144
#define MIONprint_complex_number     1145
#define MIONout_cat_array	     1146
#define MIONout_cat_funcarg	     1147                                      
#define MIONout_cat_namespace        1148

#define MDMNeval_exec                1200
#define MDMNeval_external            1201
#define MDMNeval_loadmod             1202
#define MDMNeval_unloadmod           1203

#define MPMNeval_match               1400

#ifndef NO_ACMATCH
#   define MPMNeval_acm_build        1410
#   define MPMNeval_acm_solution     1411
#   define MPMNeval_acm_release      1412
#   define MPMNeval_ac_match         1413
#endif

#define MNSNeval_new_ident           1500
#define MNSNeval_new_namespace       1501

#define MBCNeval_new_bytecode        1600
#define MBCNeval_apply_bytecode1     1601

#define MCONeval_encode              1700


#define Nbigprem                     1300
#define Ngabs                        1301
#define Ngceil                       1302
#define Ngfloor                      1303
#define Ngfrac                       1304
#define Nisprime                     1305
#define Ngach                        1306
#define Ngacos                       1307
#define Ngash                        1308
#define Ngasin                       1309
#define Ngatan                       1310
#define Ngath                        1311
#define Ngch                         1312
#define Ngcos                        1313
#define Ngexp                        1314
#define Nglog                        1315
#define Ngsh                         1316
#define Ngsin                        1317
#define Ngsqrt                       1318
#define Ngtan                        1319
#define Ngth                         1320
#define Ngzeta                       1321
#define Nggamma                      1322
#define Ngpsi                        1323
#define Nerfc                        1324
#define Neint1                       1325


#endif /* __MUP_funcs__ */
