/* $Date: 1996/10/08 19:32:47 $  $Author: kg $  $Revision: 1.5 $ */

/**************************************************************************/
/* FILE:             MUP_types.h                                          */
/* Autor:            Andreas Kemper, Andreas Sorgatz                      */
/* Erstellt:         25/04/91                                             */
/* Letzte Aenderung: 17/07/95                                             */
/**************************************************************************/

/**************************************************************************/
/* Dieses File enthaelt alle Typ - Definitionen                           */
/**************************************************************************/

#ifndef __MUP_types__
#define __MUP_types__

/*** Struktur zur Definition von Kategorien (MuPAD-Basis-Typen)        ***/

typedef struct {
	short cat;              /*** Enthaelt den Kategorietyp         ***/
	short spec;             /*** Die beruehmten MuPAD special-bits ***/
} CATEGORY ;


/*** Struktur zur Erweiterung einzelner Kategorien. Diese Daten werden ***/
/*** nicht in CATEGORY eingetragen, da sie nur in Einzelfaellen benoe- ***/
/*** tigt werden (z.B. CAT_BOOL) und so Speicherplatz gespart wird.    ***/

typedef struct {                
	short ext;             /*** Inhalt haengt von der Kategorie ab ***/
} CATEGORY_EXT ;


/*** Typdefinition fuer Zeiger auf MuPAD-Systemfunktionen MEV_eval_... ***/ 

typedef S_Pointer (FUNC)         ( S_Pointer s, 
                                   long      prev_func, 
                                   long      eval_type, 
                                   S_Pointer exec );

typedef S_Pointer (*FUNC_POINTER)( S_Pointer s, 
                                   long      prev_func, 
                                   long      eval_type, 
                                   S_Pointer exec );

/**************************************************************************/
/* MEVTstamp                                                              */
/**************************************************************************/
typedef long MEVTstamp ;


/**************************************************************************/
/* MSTTinfo                                                               */
/* In einer Variablen diesen Typs werden in jeder Schachtel eines Stacks  */
/* weitere Informationen gespeichert.                                     */
/**************************************************************************/
typedef long MSTTinfo ;


#endif /* __MUP_types__ */
