/* $Date: 1998/07/28 08:38:12 $  $Author: tom $  $Revision: 1.30.2.1 $ */

/**************************************************************************/
/* FILE:             MUT_utils.h                                          */
/* Autor:            Andreas Kemper, Oliver Kluge                         */
/* Erstellt:         25/04/91                                             */
/* Letzte Aenderung: 04/09/95                                             */
/**************************************************************************/

#ifndef __MUT_utils__
#define __MUT_utils__

#ifdef MSDOS
#define MUTC_PARI_STACK_SIZE (top-bot)
#define MUTC_PARI_RESERVED_SIZE (top-bot)
#else
#define MUTC_PARI_STACK_SIZE (avma-GLOBAL_READ(MCAV_avglob))
#define MUTC_PARI_RESERVED_SIZE MCAV_STACKSIZE
#endif

#ifdef MMMDLEAN

#define MUT_used_mem (MUTC_PARI_STACK_SIZE + MMMused_memory())
#define MUT_reserved_mem (MUTC_PARI_STACK_SIZE + MMMreserved_memory())

#else /* ! MMMDLEAN */

/*** Die folgenden Speicherangaben beruhen darauf, dass MAMMUT den ***/
/*** Speicher blockweise  und als ein Vielfaches der Groesse eines ***/
/*** anfordert.  Jeder reservierte Block wird ueber einen S-HEADER ***/
/*** verwaltet.                                                    ***/

#ifdef MMMGEN
#  define MUT_MMM_header  MMMheader
#elif defined(MMMDAUTO)
#  define MUT_MMM_header  MMMTheader
#else
#  define MUT_MMM_header  struct MMMSheader
#endif

#define MUT_used_mem ( MUTC_PARI_STACK_SIZE + \
        SHARED_READ(MMMVused_memory) * sizeof(S_Pointer) +    \
        SHARED_READ(MMMVused_blocks) * sizeof(MUT_MMM_header) )
                       
#define MUT_reserved_mem ( MUTC_PARI_RESERVED_SIZE + \
        SHARED_READ(MMMVreserved_memory) * sizeof(S_Pointer) +    \
        SHARED_READ(MMMVreserved_blocks) * sizeof(MUT_MMM_header) )

#endif /* ! MMMDLEAN */

/**************************************************************************/
/* Aus Kompatibilit"atsgr"unden (z.B. Macintosh) werden die Pfade mit NULL*/
/* und nicht mit "." initialisiert. NULL entspricht in den Routinen       */
/* MSY_write() und MSY_eval_read() aber gerade ".", also dem aktuellen	  */
/* Verzeichnis.								  */
/**************************************************************************/

#ifdef MSDOS

#define MUT_SYS_INIT_FILENAME           "SYSINIT.MU"
#define MUT_USER_INIT_FILENAME          "USERINIT.MU"
#define MUT_MMM_INIT_FILENAME           "MAMMUT.CFG"
#define MUT_HELP_INDEX_FILENAME         "MHELP.IDX"
#define MUT_HELP_INDEX_FILENAME_TTY     "MHELPTTY.IDX"
#define MUT_HELP_INDEX_PATH_DEFAULT	((char*) NULL)
#define MUT_LIB_INIT_PATH_DEFAULT	"\\LIB"

#else

#define MUT_MMM_INIT_FILENAME  		".MMMinit"

#  ifdef MACINTOSH
#    define MUT_SYS_INIT_FILENAME	":MuPAD Sysinit"
#    define MUT_USER_INIT_FILENAME  	":MuPAD Init"
#    define MUT_HELP_INDEX_PATH_DEFAULT	":Manuals:"
#    define MUT_LIB_INIT_PATH_DEFAULT	":lib"
#    define MUT_HELP_INDEX_FILENAME		"MuPAD Helpindex"
#    define MUT_HELP_INDEX_FILENAME_TTY	"MuPAD Helpindex TTY" 
#  else
#    define MUT_SYS_INIT_FILENAME	".mupadsysinit"
#    define MUT_USER_INIT_FILENAME  	".mupadinit"
#    define MUT_HELP_INDEX_PATH_DEFAULT	"help"
#    define MUT_LIB_INIT_PATH_DEFAULT	"lib"
#    define MUT_HELP_INDEX_FILENAME		".mupadhelpindex"
#    define MUT_HELP_INDEX_FILENAME_TTY	".mupadhelpindextty"
#  endif
#endif

#define MUT_LIB_PATH_DEFAULT		MMMNULL
#define MUT_READ_PATH_DEFAULT		MMMNULL
#define MUT_WRITE_PATH_DEFAULT		MMMNULL

#ifdef MACINTOSH

#  define MUT_USER_INIT_PATH_DEFAULT 	(char *) NULL
#  define MUT_full_filename(a, b, c)	sprintf(a, "%s%s", b, c)

#else
#ifdef MSDOS

#  define MUT_USER_INIT_PATH_DEFAULT 	(char *) NULL
#  define MUT_full_filename(a, b, c)    if (*b == '\0') \
					    sprintf(a, "%s", c); \
					else                     \
					    sprintf(a, "%s\\%s", b, c) \

#else
#  define MUT_USER_INIT_PATH_DEFAULT	(char *) getenv("HOME")
#  define MUT_full_filename(a, b, c)    if (*b == '\0') \
					    sprintf(a, "%s", c); \
					else                     \
					    sprintf(a, "%s/%s", b, c) \

#endif
#endif

/************************** globale Variablen *****************************/

extern char *MUTV_READ_FILENAME;	/* Name der gerade mit 'read'
					 * gelesenen Files */

extern MUPbool MUTV_NO_PRINT_ERROR;	/* TRUE, falls im Fehlerfall keine
					 * Meldung ausgegeben werden soll */


/**************************************************************************/
/* Dieses File enthaelt die Deklaration aller Hilfsprozeduren.            */
/**************************************************************************/
 
/***         MUT_fopen            siehe MDE_declare.h !!! ***/
int          MUT_system           ( char *cmd );

S_Pointer    MUT_unique_string    ( S_Pointer s) ;
S_Pointer    MUT_new_cat_ident    ( long type, S_Pointer s );
MUPbool	     MUT_ident_has_name   ( S_Pointer s, S_Pointer string );
MUPbool      MUT_is_ident         ( char *s );
int	     MUT_similcmp         ( char *, char * );
void	     MUT_tolower          ( char *, char * );

void         MUT_catch_watchdog   ( VOID );
int          MUT_set_alarm        ( long sec, void (*ifunc)(VOID) );
int          MUT_reset_alarm      ( VOID );

void         MUT_print_resources  ( VOID );
void         MUT_print_statistics ( VOID );
S_Pointer    MUT_get_message      ( long );
void	     MUT_print_error      (long, char *, Mva_list);
void         MUT_errorhandling    (VOID);

void 	     MUT_free_extern_data ( S_Pointer s );

long 	     MUT_clock            ( VOID );
#if ( defined SOLARIS || defined SOLARIS_i86 )
void         MUT_debugger         ( VOID );
#endif
long	     MUT_str_cmp          ( S_Pointer m_string, char *c_string );

void         MUT_ins_ext_list     ( S_Pointer *s, S_Pointer arg1, S_Pointer arg2, short type );
void         MUT_new_ext_list     ( S_Pointer *s, S_Pointer arg1, S_Pointer arg2, short type );

/*** Deadcode
S_Pointer    MUT_new_simple_list_one ( S_Pointer expr );
***/
S_Pointer    MUT_concat_list      ( S_Pointer list1, S_Pointer list2 );

long         MUT_is_exprseq       ( S_Pointer s );
S_Pointer    MUT_read_exprseq     ( S_Pointer  exprseq, S_Pointer args );
S_Pointer    MUT_replace_exprseq  ( S_Pointer *exprseq, S_Pointer args, S_Pointer value );

inline void  MUT_write_exprseq    ( S_Pointer *exprseq, S_Pointer args, S_Pointer value )
{
    S_Pointer elem;
    elem = MUT_replace_exprseq(exprseq, args, value);
    MMMfree(elem);
}

S_Pointer    MUT_read_list        ( S_Pointer  list, S_Pointer args );
S_Pointer    MUT_replace_list       ( S_Pointer *list, S_Pointer args, S_Pointer value, long offset );

inline void  MUT_write_list       ( S_Pointer *list, S_Pointer args, S_Pointer value, long offset )
{
    S_Pointer elem;
    elem = MUT_replace_list(list, args, value, offset);
    MMMfree(elem);
}

void         MUT_init_pref        ( VOID );
void         MUT_first_init_pref  ( VOID );
void 	     MUT_init             ( VOID );
void 	     MUT_exit             ( VOID );
void         MUT_read_init_file   ( char *path, char *filename, MUPbool sysinit );

const char*  MUT_user_option      ( VOID );
unsigned int MUP_sleep(unsigned int sec) ;

#endif /* __MUT_utils__ */
