/*******************************************************************
** DATEI   :  genpari.h
** MODUL   :  PARI
** INHALT  :  Architekturabhngige PARI Funktionen 
** SYSTEMS :  UNIX
** AUTOR   :  Andreas Sorgatz
** DATUM   :  11.12.1996
**
** Zur Zeit werden hier folgende Versionen unterschieden:
**
** GEN_68K, GEN_MAC, GEN_OTHER
** 
*******************************************************************/

/* Definitionen f"ur gerichtete Rundung */

#define ToZero          0L
#define ToNearest       1L
#define ToInfinity      2L
#define ToMinusInfinity 3L

extern long RoundingMode;

/*******************************************************************
** Setzen von PARI-Hilfekonstanten
*******************************************************************/

#if defined SUNOS4 || defined __FreeBSD__ || defined __NetBSD__ || defined MSDOS || defined NEXTX86
#   ifndef ULONG_NOT_DEFINED
#   define ULONG_NOT_DEFINED                    /* vgl. genpari.h */
#   endif
#endif


/*****************************************************************/
/*** Die neue C++-Konvention zur Uebergabe einer Funktion bzw. ***/
/*** der Adresse einer Funktion wird von 'Visual C++ 4.0' noch ***/
/*** nicht (korrekt?) unterstuezt.                             ***/
/*****************************************************************/

#if defined MSDOS
#   ifndef USE_OLD_FUNC_POINTER
#   define USE_OLD_FUNC_POINTER
#   endif
#endif


/*******************************************************************
** Welches PARI 'genpari*.h' file fr welche MuPAD version ?
*******************************************************************/

#if   defined MACINTOSH &&  defined POWERPC
#     define  GEN_MAC

#elif defined MACINTOSH && !defined POWERPC
#     define  GEN_MAC

#elif defined SUN3
#     define  GEN_68K

#else
#     if !defined GEN_OTHER
#         define  GEN_OTHER
#     endif
#endif

/*******************************************************************
** Einbinden der Systemabhngigen 'genpari*.h' files
*******************************************************************/

#if   defined GEN_MAC
#     include "genparimac.h"

#elif defined GEN_OTHER
#     include "genpariother.h"

#elif defined GEN_68K
#     include "genpari68k.h"

#else
#     include "genpariother.h"
#endif

